#include "Arrow.h"
#include "Engine.h"


void ArrowGenerator::Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u)
{
//	gLog.OutPut("Spawning ArrowGenerator\n");
	SetDefaultAttribs(p, f,r,u);
	mPos = mOPos = mPos;
	mMins = mPos - Vec3(0.25, 0.25, 0.25);
	mMaxs = mPos + Vec3(0.25, 0.25, 0.25);
	fTime = 0;
}
void ArrowGenerator::Update()
{
	mOPos = mPos;

	if(gpEng->mPlayer.mbTimeOut)
		return;

	if(!gpEng->mPlayer.mbLostBall)
	if(!mpPlatform || mpPlatform->bVisible)
	{
		fTime += TIME_STEP;
		if(fTime>=fStartDelay)
		{
			fTime = 0;
			//gLog.OutPut("Fire arrow\n");
			Arrow* arrow = new Arrow;
			arrow->Spawn(mPos,mForward, mRight, mUp);
			gpEng->mGameEnts.push_back(arrow);
			float DIST = Distance(mPos,gpEng->mCameraPos);
			if(DIST<10)
				SetSoundPosition(PlaySample(gpEng->mSnd[SND_ARROW],false), 0, (DIST+1)*50);

		}
	}

}
void ArrowGenerator::Render(const float interp, int pass)
{

}
void ArrowGenerator::RenderShadow(const float interp)
{

}
void ArrowGenerator::RenderDepth(const float interp)
{
}
Entity* ArrowGenerator::Clone() const
{
	return new ArrowGenerator(*this);
}
/*******************************************************/
/* Projectile										   */
/*******************************************************/
void Arrow::Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u)
{
	iBaseType = ENT_ARROW;
//	gLog.OutPut("Spawning Arrow\n");
	SetDefaultAttribs(p, f,r,u);
	mPos = mOPos = mPos + u* 0.5f;
	mMins = mPos - Vec3(0.25, 0.25, 0.25);
	mMaxs = mPos + Vec3(0.25, 0.25, 0.25);
	fLife = 5;
	mVel = u * 0.01f;

	mpStartBlock = gpEng->GetMapTile(p);
	mpHitBlock = NULL;

	PS_ProjectileDust* PS = new PS_ProjectileDust;
	PS->mRight = mRight;
	PS->mForward = mForward;
	PS->Spawn(mPos-mUp*0.2f,mUp,Vec2(16,16),Vec3(1,0.8f,0.2f),0,1,1);
	gpEng->mPartEng.InsertAlphaSystem(PS);

}
void Arrow::Update()
{
	mOPos = mPos;
	if(gpEng->mPlayer.mbTimeOut)
		return;

	fLife -= TIME_STEP;
	if(fLife<=0)
	{
		if(mpHitBlock)
		{
			float X = mUp.x!=0?
				(mUp.x<0?mpHitBlock->pos.x-0.75f:mpHitBlock->pos.x+0.75f):mPos.x;
			float Y = mUp.y!=0?
				(mUp.y<0?mpHitBlock->pos.y-0.75f:mpHitBlock->pos.y+0.75f):mPos.y;
			float Z = mUp.z!=0?
				(mUp.z<0?mpHitBlock->pos.z-0.75f:mpHitBlock->pos.z+0.75f):mPos.z;
			mPos = Vec3(X,Y,Z)-mUp*0.1f;//&/

			float DIST = Distance(mPos,gpEng->mCameraPos);
			if(DIST<10)
				SetSoundPosition(PlaySample(gpEng->mSnd[SND_HIT],false), 0, (DIST+1)*50);

		}
		bRemove = true;
		PS_ProjectileDust* PS = new PS_ProjectileDust;
		PS->mRight = mRight;
		PS->mForward = mForward;
		PS->Spawn(mPos,mUp,Vec2(16,16),Vec3(1,0.8f,0.2f),0,1,1);
		gpEng->mPartEng.InsertAlphaSystem(PS);
	}
	mVel += mUp * 0.001f;
	mPos -= mVel;
	Block* BLOCK = NULL;
	if((BLOCK=gpEng->GetMapTile(mPos)))
	if(BLOCK != mpStartBlock)
	{
		mpHitBlock = BLOCK;
		fLife =0;
	}

	mMins = mPos - Vec3(0.5, 0.5, 0.5);
	mMaxs = mPos + Vec3(0.5, 0.5, 0.5);
	if(gpEng->mPlayer.mbTimeOut || gpEng->mPlayer.mbStageWon)
		return;
	if(!gpEng->mPlayer.mbLostBall)
	if(gpEng->mPlayer.iDmgTime==0)
	if(!mpPlatform || mpPlatform->bVisible)
	if(gpEng->mPlayer.mPos.x >= mPos.x-1)
	if(gpEng->mPlayer.mPos.x <= mPos.x+1)
	if(gpEng->mPlayer.mPos.y >= mPos.y-1)
	if(gpEng->mPlayer.mPos.y <= mPos.y+1)
	if(gpEng->mPlayer.mPos.z >= mPos.z-1)
	if(gpEng->mPlayer.mPos.z <= mPos.z+1)
	if(Distance(mPos, gpEng->mPlayer.mPos)<0.35 || Distance(mPos+mUp*0.15f, gpEng->mPlayer.mPos)<0.35 || Distance(mPos-mUp*0.15f, gpEng->mPlayer.mPos)<0.35)//this could be slow, should do a bounds check first
	{
		Vec3 dir = (mPos-gpEng->mPlayer.mPos);
		//dir = Reflect(dir,mRight,0);
		dir = Normalize(Reflect(dir,mUp,0));
		gpEng->mPlayer.mJumpDir = Vec3((int)-gpEng->mPlayer.mMoveUp.x,(int)-gpEng->mPlayer.mMoveUp.y,(int)-gpEng->mPlayer.mMoveUp.z);
		if(Dot(gpEng->mPlayer.mMoveForward,dir)>0)
		{
			//gpEng->mPlayer.mJumpDir -= Vec3((int)-gpEng->mPlayer.mMoveForward.x,(int)-gpEng->mPlayer.mMoveForward.y,(int)-gpEng->mPlayer.mMoveForward.z);
			gpEng->mPlayer.mMove = -gpEng->mPlayer.mMoveForward * 0.05f;
		}
		else
		{
		//	gpEng->mPlayer.mJumpDir += Vec3((int)-gpEng->mPlayer.mMoveForward.x,(int)-gpEng->mPlayer.mMoveForward.y,(int)-gpEng->mPlayer.mMoveForward.z);
			gpEng->mPlayer.mMove = gpEng->mPlayer.mMoveForward * 0.05f;
		}

		if(gpEng->mPlayer.mpPlatform)
			gpEng->mPlayer.mpPlatform->mbPlayerIsRiding = false;
		

		gpEng->mPlayer.mpPlatform = NULL;
		gpEng->mPlayer.bJump = true;
		gpEng->mPlayer.iJumpCounter = 0;
		gpEng->mPlayer.mGravity = gpEng->mPlayer.mMoveUp*0.15f;
		gpEng->mPlayer.mJumpVel = -gpEng->mPlayer.mMoveUp*0.15f;
	//	gpEng->mPlayer.mJumpDir = -dir;
		gpEng->mPlayer.mPos += gpEng->mPlayer.mJumpVel;
		gpEng->mPlayer.bMoving = true;
		gpEng->mPlayer.mMove = -dir * 0.025f;
		gpEng->mPlayer.iTurnCounter = 1;
		gpEng->mPlayer.TakeDamage();
		//gpEng->mPlayer.bTurning = false;
		gpEng->mPlayer.bTurnCorner = false;
		//gpEng->mPlayer.bLanded = false;
		fLife = 0;
	}
}
void Arrow::Render(const float interp, int pass)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
/*	glBegin(GL_LINES);
	glColor3f(1,0,0);
	glVertex3fv((p).v);
	glVertex3fv((p+u*0.5f).v);
//	glColor3f(0,1,0);
//	glVertex3fv((p-r*0.5f).v);
//	glVertex3fv((p+r*0.5f).v);
//	glColor3f(0,0,1);
//	glVertex3fv((p).v);
//	glVertex3fv((p+f*0.5f).v);
	glEnd();
//*/
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	float alpha = 0.45;
	if(mpPlatform)
		alpha = mpPlatform->iFadeTime>=0?UTIL_Misc::TimeRamp(0,0.45,0,100,mpPlatform->iFadeTime):0;
	glMultMatrixf(mat);
	glRotatef(90,1,0,0);
	glRotatef(180,0,0,1);
	glScalef(0.15,0.15,0.15);

	glColor4f(mColor.x,mColor.y,mColor.z,alpha);




	gpEng->mObjects[MDL_ARROW].RenderBuffer(true);
//*/
	glColor4f(1,1,1,1);


	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);
	glPopMatrix();
}
void Arrow::RenderShadow(const float interp)
{

}
void Arrow::RenderDepth(const float interp)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glRotatef(90,1,0,0);
	glRotatef(180,0,0,1);
	glScalef(0.15,0.15,0.15);
	gpEng->mObjects[MDL_ARROW].RenderBuffer(false);
//*/
	glPopMatrix();

}
Entity* Arrow::Clone() const
{
	return new Arrow(*this);
}
