#pragma once
#include "Entity.h"
#include "Block.h"
class ArrowGenerator : public Entity
{
public:
	void Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u);
	void Update();
	void Render(const float interp, int pass);
	void RenderShadow(const float interp);
	void RenderDepth(const float interp);
	Entity* Clone() const;

	float fStartDelay;
	float fTime;
};

class Arrow : public Entity
{
public:
	void Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u);
	void Update();
	void Render(const float interp, int pass);
	void RenderShadow(const float interp);
	void RenderDepth(const float interp);
	Entity* Clone() const;

	float fLife;
	Vec3 mVel;
	//TODO: need to store the block the arrow starts inside, so we will not collide with it.
	Block* mpStartBlock, *mpHitBlock;
};