#include "Engine.h"

int iSelectedBall = 0;
int iSelectedOption = 0;
int iApplySticker = 0;
float fSceneRotation = 0,fOSceneRotation=0;
float fWorldRotation = 0,fOWorldRotation=0;
int iTurnTimer = 0;
bool gbTurn;
extern int giLastNameIdx;


const Vec3 BallColors[MAX_COLORS] = 
{
	//reds
	Vec3(1,0,0),		//0
	Vec3(0.8f,0,0),		//1
	Vec3(0.6f,0,0),		//2
	Vec3(0.4f,0,0),		//3
	Vec3(0.2f,0,0),		//4
	//greens
	Vec3(0,1,0),		//5
	Vec3(0,0.8f,0),		//6
	Vec3(0,0.6f,0),		//7
	Vec3(0,0.4f,0),		//8
	Vec3(0,0.2f,0),		//9
	//blues
	Vec3(0,0,1),		//10
	Vec3(0,0,0.8f),		//11
	Vec3(0,0,0.6f),		//12
	Vec3(0,0,0.4f),		//13
	Vec3(0,0,0.2f),		//14
	//purples
	Vec3(1,0,1),		//15
	Vec3(0.8f,0,0.8f),	//16
	Vec3(0.6f,0,0.6f),	//17
	Vec3(0.4f,0,0.4f),	//18
	Vec3(0.2f,0,0.2f),	//19
	//yellows
	Vec3(1,1,0),		//20
	Vec3(0.8f,0.8f,0),	//21
	Vec3(0.6f,0.6f,0),	//22
	Vec3(0.4f,0.4f,0),	//23
	Vec3(0.2f,0.2f,0),	//24
	//cyans
	Vec3(0,1,1),		//25
	Vec3(0,0.8f,0.8f),	//26
	Vec3(0,0.6f,0.6f),	//27
	Vec3(0,0.4f,0.4f),	//28
	Vec3(0,0.2f,0.2f),	//29
	//greys
	Vec3(1,1,1),		//30
	Vec3(0.8f,0.8f,0.8f),	//31
	Vec3(0.6f,0.6f,0.6f),	//32
	Vec3(0.4f,0.4f,0.4f),	//33
	Vec3(0.2f,0.2f,0.2f),	//34
	//orange
	Vec3(1,0.7f,0),			//35
	Vec3(0.8f,0.5f,0),	//36
	Vec3(0.6f,0.3f,0),	//37
	Vec3(0.4f,0.1f,0),	//38
	//pinks
	Vec3(1,0.7f,0.7f),			//39
	Vec3(0.8f,0.5f,0.5f),	//40
	Vec3(0.6f,0.3f,0.3f),	//41
	Vec3(0.4f,0.1f,0.1f),	//42
	//mints
	Vec3(0.7f,1,0.7f),			//43
	Vec3(0.5f,0.8f,0.5f),	//44
	Vec3(0.3f,0.6f,0.3f),	//45
	Vec3(0.1f,0.4f,0.1f),	//46
	//blue shades
	Vec3(0.7f,0.7f,1),			//47
	Vec3(0.5f,0.5f,0.8f),	//48
	Vec3(0.3f,0.3f,0.6f),	//49
	Vec3(0.1f,0.1f,0.4f)	//50

};
void Engine::StartDesigner()
{
	iSelectedBall = 1;
	iTurnTimer = 0;
	fSceneRotation = fOSceneRotation = 145;
	iSelectedOption = 0;
	iApplySticker = 0;
	iSelectedSticker = iPlayerStickerType = -1;

	PS_Fade1* PS = new PS_Fade1;
	PS->Spawn(Vec3(0,0,0),Vec3(0,0,0),Vec2(32,32),Vec3(1,1,1),0,1,1);
	mPartEng.InsertSystem(PS,true);
	FADE_Fade1* FS = new FADE_Fade1;
	FS->Spawn(1,Vec3(1,1,1));
	mFadeEng.InsertSystem(FS);//*/

/*	FADE_Star* FS2 = new FADE_Star;
	FS2->Spawn(1,Vec3(1,1,1));
	mFadeEng.InsertSystem(FS2);//*/
/*	FADE_Box* FS3 = new FADE_Box;
	FS3->Spawn(1,Vec3(1,1,1));
	mFadeEng.InsertSystem(FS3);//*/
/*	FADE_StarOut* FS4 = new FADE_StarOut;
	FS4->Spawn(1,Vec3(1,1,1));
	mFadeEng.InsertSystem(FS4);//*/

}
void Engine::UpdateDesigner()
{
/*	if(KEY_QUIT.state == JUST_PRESSED && !mbPaused && mFadeEng.mSystems.empty())
	{
		if(!mMenus.empty() && mMenus.back()->bFadingIn ||
			!mMenus.empty() && mMenus.back()->bFadingOut ||
			 !mMenus.empty() && !mMenus.back()->bFadingIn && !mMenus.empty() && !mMenus.back()->bFadingOut ||
			mMenus.empty())
		mbQuit =true;
	}
*/
	if(mFadeEng.mSystems.empty() && mMenus.empty())
	{
		if(iSelectedOption == 0)//selecting ball
		{
			if(iTurnTimer==0)
			{
				if(KEY_TURN_LEFT.state == JUST_PRESSED)
				{
					PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);
					gbTurn = false;
					iTurnTimer = 30;
				}
				if(KEY_TURN_RIGHT.state == JUST_PRESSED)
				{
					PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);
					gbTurn = true;
					iTurnTimer = 30;
				}
				if(KEY_JUMP.state == JUST_PRESSED)
				{
					if(iTurnTimer == 0)//can only change colors when the scene has stopped rotating
					{
						PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
						miPlayerBallIdx = iSelectedBall;
						iSelectedOption = 1;
						mPlayerType = mBallTypes[iSelectedBall];
						KEY_JUMP.state = JUST_RELEASED;
					}
				}
			}
			if(iTurnTimer == 1)
			{
				gbTurn?
					iSelectedBall--: iSelectedBall++;
				if(iSelectedBall<0)
					iSelectedBall+=10;
				if(iSelectedBall>=10)
					iSelectedBall-=10;
			}

			//cancelling go back to previous menu
			if(KEY_ACTION2.state == JUST_PRESSED)
			{
				SureMenu* menu = new SureMenu;
				menu->Spawn(Vec2(320,240));
				menu->iExternalCode = SureMenu::SURE_DESIGNER_CANCEL;
				strcpy(menu->szMessage,"ARE YOU SURE YOU WANT TO GO BACK?");
				gpEng->mMenus.push_back(menu);


				KEY_ACTION2.state = JUST_RELEASED;
				PlaySample(CHNL_UI_BACKUP,gpEng->mSnd[SND_UI_BACKUP],false);
			}

		}
		if(iApplySticker==0)
		if(iSelectedOption >= 1)//selecting colors
		{
			if(KEY_TURN_RIGHT.state == JUST_PRESSED)
			{
					PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);
				mPlayerType.iColLayers[iSelectedOption-1]++;
				if(mPlayerType.iColLayers[iSelectedOption-1]>=MAX_COLORS)
					mPlayerType.iColLayers[iSelectedOption-1] = 0;
			}
			if(KEY_TURN_LEFT.state == JUST_PRESSED)
			{
					PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);
				mPlayerType.iColLayers[iSelectedOption-1]--;
				if(mPlayerType.iColLayers[iSelectedOption-1]<0)
					mPlayerType.iColLayers[iSelectedOption-1]=MAX_COLORS-1;
			}
			if(KEY_BACK.state == JUST_PRESSED)
			{
				if(iSelectedOption< (int)mPlayerType.iColLayers.size())
					iSelectedOption++;
			}
			if(KEY_FORWARD.state == JUST_PRESSED)
			{
				iSelectedOption--;
				if(iSelectedOption ==0)
					iSelectedOption = 1;
			}
			if(KEY_ACTION2.state == JUST_PRESSED)
			{
				iSelectedOption = 0;
				PlaySample(CHNL_UI_BACKUP,gpEng->mSnd[SND_UI_BACKUP],false);
			}
			if(KEY_JUMP.state == JUST_PRESSED)
			{
				PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
				iApplySticker = 1;
				KEY_JUMP.state = JUST_RELEASED;

			}
		}
		if(iApplySticker==1)
		{
			if(KEY_TURN_RIGHT.state == JUST_PRESSED)
			{
				iSelectedSticker++;
				if(iSelectedSticker>(int)mStickers.size()-1)
					iSelectedSticker = -1;
				iPlayerStickerType = iSelectedSticker;
			}
			if(KEY_TURN_LEFT.state == JUST_PRESSED)
			{
				iSelectedSticker--;
				if(iSelectedSticker<-1)
					iSelectedSticker = (int)mStickers.size()-1;
					
				iPlayerStickerType = iSelectedSticker;
			}
			if(KEY_JUMP.state == JUST_PRESSED)
			{
				SureMenu* menu = new SureMenu;
				menu->Spawn(Vec2(320,240));
				menu->iExternalCode = SureMenu::SURE_DESIGNER_ACCEPT;
				strcpy(menu->szMessage,"ARE YOU SURE THIS IS THE BALL FOR YOU?");
				gpEng->mMenus.push_back(menu);
				KEY_JUMP.state = JUST_RELEASED;
				PlaySample(CHNL_UI_BACKUP,gpEng->mSnd[SND_UI_BACKUP],false);

			}
			if(KEY_ACTION2.state == JUST_PRESSED)
			{
				iApplySticker = 0;
				PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
			}
		}
	}


	fOSceneRotation = fSceneRotation;
	if(iTurnTimer>0)
	{
		iTurnTimer--;
		gbTurn?
			fSceneRotation += 36.0f/30.0f: fSceneRotation -= 36.0f/30.0f;
	}

	for(int n=0; n<10; n++)
	{
		mBallTypes[n].vOBallRotation = mBallTypes[n].vBallRotation;
		if(n==iSelectedBall)
		{
			mBallTypes[n].vBallRotation += Vec2(TIME_STEP, TIME_STEP * 1.5f)*50;
		}
		else
		{
			mBallTypes[n].vBallRotation += Vec2(TIME_STEP, TIME_STEP * 1.5f)*5;
		}
	}
	fOWorldRotation = fWorldRotation;
	fWorldRotation += TIME_STEP * 1.5f*5;
	mfOCloudScroll = mfCloudScroll;
	mfCloudScroll += 0.002f;

	if(!mMenus.empty())
	{
		mMenus.back()->Update();
		mMenus.remove_if(PruneMenus);
		if(this->iEngineState == STATE_STAGESELECT)
		{
			gpEng->RenderSceneToFadeBuffer();
			gpEng->LoadStageSelectData();
			gpEng->StartStageSelect();
		}
	}

	mPartEng.Update();
	mFadeEng.Update();
}
void Engine::RenderDesigner(const float interp)
{
	miBoundFBO = 0;
	BindFBO(mMainFBO,0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);


	static float PrevViewMat[16];
	static float PrevViewMatInverse[16];
	static float Proj[16];

	glClearColor(1,0.3f,0.3f,0);
//	if(!mbFallBackMode)
//		glClearDepth(1);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	UTIL_GL::GL3D::SetPerspective(70,1.3f,2,2048);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);

	//Vec3 eye = p - f * 2.7f - u * 2.7f;
	Vec3 eye(32,16,32);
	eye.x = UTIL_Misc::Clamp(eye.x, 0, MAP_DIMENSIONS);
	eye.y = UTIL_Misc::Clamp(eye.y, 0, MAP_DIMENSIONS);
	eye.z = UTIL_Misc::Clamp(eye.z, 0, MAP_DIMENSIONS);
//	gluLookAt(p.x,p.y,p.z, p.x+f.x,p.y+f.y,p.z+f.z, -u.x,-u.y,-u.z);
	Vec3 f(0,0,1);
	Vec3 u(0,-1,0);
	gluLookAt(eye.x,eye.y,eye.z, f.x,f.y,f.z, -u.x,-u.y,-u.z);
	float Rotation = UTIL_Misc::Interpolate(fWorldRotation,fOWorldRotation,interp);
//	glRotatef(Rotation*0.01, 1,0,0);
	glRotatef(Rotation, 0,1,0);

//	gluLookAt(0,0,0, f.x,f.y,f.z, -u.x,-u.y,-u.z);
	glScalef(1,0.5,1);
	glTranslatef(0,64,0);
	//skybox
	RenderWorld(miWorld,interp);

	glClearColor(0,0,0,0);
//	if(!mbFallBackMode)
//		glClearDepth(0.995f);
	glClear(GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);



	UTIL_GL::GL3D::SetPerspective(45,1.3f,0.1f,30);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	gluLookAt(0,-1.5f,0, 0,0,5, 0,-1,0);

	GLfloat tempMatrix[16];
	glGetFloatv(GL_MODELVIEW_MATRIX,tempMatrix);
	Vec3 camRight = Vec3(tempMatrix[0],tempMatrix[4],tempMatrix[8]);
	Vec3 camUp = Vec3(tempMatrix[1],tempMatrix[5],tempMatrix[9]);
	Vec3 camFwd = Vec3(tempMatrix[2],tempMatrix[6],tempMatrix[10]);
	glEnable(GL_CULL_FACE);



	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	Vec3 lp = Vec3(0,0,0) + camUp * 1 + camRight*5;
//	float LightPos[4]={-500,-1000.1f,500,1};
	float LightPos[4]={lp.x,lp.y,lp.z,0};
	float LightDir[4]={-camUp.x,-camUp.y,-camUp.z,0};
	float amb[4]={0.15f,0.15f,0.15f,1};
	float dif[4]={0.4f,0.4f,0.4f,1};
	float gldif[4]={0.7f,0.7f,0.7f,1};
	float glamb[4]={0.95f,0.95f,0.95f,1};
	float spec[4]={1,1,1,0};
	float blk[4]={0,0,0,1};
	glShadeModel(GL_SMOOTH);
//	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, amb);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0,  GL_POSITION, LightPos);
	glLightfv(GL_LIGHT0,  GL_SPOT_DIRECTION, LightDir);
	glLightfv(GL_LIGHT0,  GL_AMBIENT, dif);
	glLightfv(GL_LIGHT0,  GL_DIFFUSE, gldif);
	glLightfv(GL_LIGHT0,  GL_SPECULAR, glamb);
	glMaterialfv(GL_FRONT, GL_AMBIENT, dif);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, gldif);
	glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
	glMateriali(GL_FRONT, GL_SHININESS, 100);
	glEnable(GL_COLOR_MATERIAL);


	gpEng->mShdrMgr.BindProgram(gpEng->mShdrPBallLight);
	Vec2 mins(0,0), maxs(1,1);
//	mShdrMgr.BindProgram(mShdrPPDirLight);
	GLint AtLocmins = mShdrMgr.GetAttribLocation("inmins");
	GLint AtLocmaxs = mShdrMgr.GetAttribLocation("inmaxs");
//	mShdrMgr.PassUniform3fv("up",1,camUp.v);
	mShdrMgr.PassAttrib2fv(AtLocmins, mins.v);
	mShdrMgr.PassAttrib2fv(AtLocmaxs, maxs.v);

	mMatMgr.SetMaterialAttributes(mObjects[MDL_SPHERE].mMaterials[mObjects[MDL_SPHERE].mFaces.front().mattID].pMat,BASE_PASS,0);
	int n;
	float fx = -3;
	for(int i=0; i<10; i++)
	{

		glPushMatrix();
		float rot = UTIL_Misc::Interpolate(fSceneRotation,fOSceneRotation,interp);
		Vec3 c(sin(DEG2RAD(rot+(36*i)))*5,0, 5+cos(DEG2RAD(rot+(36*i)))*7);
		glTranslatef(c.x,c.y,c.z);
		glTranslatef(0,1.7,9);
		Vec2 ballRot = UTIL_Misc::Interpolate(mBallTypes[i].vBallRotation,mBallTypes[i].vOBallRotation,interp);
		glRotatef(ballRot.x, 1,0,0);
		glRotatef(ballRot.y, 0,1,0);
		for(n=0;n<(int)mBallTypes[i].iLayers.size();n++)
		{
			if(n>0)
				UTIL_GL::SetBlend(GL_ONE,GL_ONE);
			else glDisable(GL_BLEND);

//			mShdrMgr.PassSampler2D("bumpMap",1,mBallTypes[i].idBump);
			mShdrMgr.PassSampler2D("tex",0,mBallTypes[i].iLayers[n]);
			if(iSelectedBall==i && iSelectedOption>0)
				glColor3fv(BallColors[mPlayerType.iColLayers[n]].v);
			else
				glColor3fv(BallColors[mBallTypes[i].iColLayers[n]].v);
			mObjects[mBallTypes[i].iMdlType].RenderBuffer(false);
		}
		if(iSelectedBall==i && iSelectedOption>0)
		if(iApplySticker==1)
		{
			if(gpEng->iSelectedSticker>=0)
			{
				UTIL_GL::SetBlend(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
				glColor4f(1,1,1,1);
				mShdrMgr.PassSampler2D("tex",0,mStickers[iSelectedSticker]);
				mObjects[MDL_STICKER].RenderBuffer(false);
				glDisable(GL_BLEND);
			}
		}
		glPopMatrix();
		fx+=3;
	}

	mShdrMgr.BindProgram(0);
	glDisable(GL_COLOR_MATERIAL);
	glDisable(GL_LIGHTING);
	glDisable(GL_LIGHT0);
	glActiveTexture(GL_TEXTURE1);
	glDisable(GL_TEXTURE_2D);
	glActiveTexture(GL_TEXTURE0);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glDisable(GL_CULL_FACE);
	UnBindFBO();


	//render dOF
	if(!mbFallBackMode)
	if(mbDOF)
	{
		BindFBO(mMainFBO,0);
		glEnable(GL_DEPTH_TEST);
		glDepthMask(GL_TRUE);
		glColorMask(GL_FALSE,GL_FALSE,GL_FALSE,GL_FALSE);
		glBegin(GL_QUADS);
		glVertex3fv((eye-camFwd*20-camRight*50-camUp*50).v);
		glVertex3fv((eye-camFwd*20+camRight*50-camUp*50).v);
		glVertex3fv((eye-camFwd*20+camRight*50+camUp*50).v);
		glVertex3fv((eye-camFwd*20-camRight*50+camUp*50).v);
		glEnd();
		glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);
		UnBindFBO();
		float mul = 1;
		switch(iSuperSamples)
		{
		case 1: mul = 1.25f; break;
		case 2: mul = 1.5f; break;
		case 3: mul = 1.75f; break;
		case 4: mul = 2; break;
		}

		BindFBO(mMainFBO,1);
		float focalD = 12;// + (sin(mTimer.GetTime())*100);
		mShdrMgr.BindProgram(mShdrDOFH);
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSamplerRect("depth",1 ,mMainFBO.depthtexID);
		mShdrMgr.PassUniform1f("focalD",focalD);
		mShdrMgr.PassUniform1f("depthRange",30);
		mShdrMgr.PassUniform1f("blurFactor",0.05f*mul);
		glClear(GL_COLOR_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDepthMask(GL_FALSE);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		mShdrMgr.BindProgram(0);
		UnBindFBO();
		BindFBO(mMainFBO,0);
		mShdrMgr.BindProgram(mShdrDOFV);
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[1]);
		mShdrMgr.PassSamplerRect("depth",1 ,mMainFBO.depthtexID);
		mShdrMgr.PassUniform1f("focalD",focalD);
		mShdrMgr.PassUniform1f("depthRange",30);
		mShdrMgr.PassUniform1f("blurFactor",0.05f*mul);
		glClear(GL_COLOR_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDepthMask(GL_FALSE);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		mShdrMgr.BindProgram(0);
		UnBindFBO();
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		glDepthMask(GL_TRUE);

	}//*/


	BindFBO(mMainFBO,0);

	UTIL_GL::GL2D::SetOrtho(640,480);
	glClear(GL_DEPTH_BUFFER_BIT);
	glDisable(GL_DEPTH_TEST);

	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, MenuImgs[GFXMENU_CUSTOMIZE]);
	glColor4f(1,1,1,1);

	float fr1 = sin(Rotation) *0.1f;
	float fr2 = cos(Rotation) *0.5f;
	glBegin(GL_QUADS);
	glTexCoord2f(0,1); glVertex2f(fr1+(320-320),fr2-20);
	glTexCoord2f(1,1); glVertex2f(fr1+(320+320),fr2-20);
	glTexCoord2f(1,0); glVertex2f(fr1+(320+320),fr2+100);
	glTexCoord2f(0,0); glVertex2f(fr1+(320-320),fr2+100);
	glEnd();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);

	Vec2 sprUV, sprUVS;
	sprUVS = mSprites[SPR_UI].mUVsize;

	mFont1.EnableShadow();
	mFont1.SetAlignment(ALIGN_CENTER);
	mFont1.SetColor(1,1,1,1);
	mFont1.SetScale(0.75f,0.75f);
	if(iSelectedOption>=1)
	{
		glColor3f(0,0,0);
		glBegin(GL_QUADS);
		glVertex2f(320-35,445);
		glVertex2f(320+35,445);
		glVertex2f(320+35,475);
		glVertex2f(320-35,475);
		glColor3fv(BallColors[mPlayerType.iColLayers[iSelectedOption-1]].v);
		glVertex2f(320-30,450);
		glVertex2f(320+30,450);
		glVertex2f(320+30,470);
		glVertex2f(320-30,470);
		glEnd();

		glColor3f(1,1,1);
		UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		UTIL_GL::BindTexture(GL_TEXTURE_2D, mSprites[SPR_UI].mImg);
		sprUV = mSprites[SPR_UI].GetTileUV(0);
		glBegin(GL_QUADS);
		glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(320-67, 444);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(320-35, 444);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(320-35, 476);
		glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(320-67, 476);

		sprUV = mSprites[SPR_UI].GetTileUV(1);
		glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(320+35, 444);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(320+67, 444);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(320+67, 476);
		glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(320+35, 476);

		glEnd();
		glDisable(GL_BLEND);

		if(iApplySticker==1)
		mFont1.Print("SELECT STICKER",320,400);
		else
		mFont1.Print("SELECT COLOR",320,400);
	}
	else
	{
		glColor3f(1,1,1);
		UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		UTIL_GL::BindTexture(GL_TEXTURE_2D, mSprites[SPR_UI].mImg);
		sprUV = mSprites[SPR_UI].GetTileUV(0);
		glBegin(GL_QUADS);
		glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(320-37, 444);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(320-5, 444);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(320-5, 476);
		glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(320-37, 476);

		sprUV = mSprites[SPR_UI].GetTileUV(1);
		glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(320+5, 444);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(320+37, 444);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(320+37, 476);
		glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(320+5, 476);

		glEnd();
		glDisable(GL_BLEND);
		mFont1.Print("SELECT BALL",320,400);
	}
	mFont1.SetAlignment(ALIGN_LEFT);
	mFont1.SetScale(0.35f,0.5f);
	mFont1.Print("SELECT",582,417);
	mFont1.Print("BACK",582,449);

	glColor3f(1,1,1);
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, mSprites[SPR_UI].mImg);
	if(bJoystick)
	{
	glBegin(GL_QUADS);
	sprUV = mSprites[SPR_UI].GetTileUV(4);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 412);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(552, 412);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(552, 444);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 444);

	sprUV = mSprites[SPR_UI].GetTileUV(5);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 444);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(552, 444);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(552, 476);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 476);
	glEnd();
	}
	else
	{
	glBegin(GL_QUADS);
	sprUV = mSprites[SPR_UI].GetTileUV(29);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 404);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(584, 404);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(584, 452);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 452);

	//sprUV = mSprites[SPR_UI].GetTileUV(28);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 436);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(584, 436);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(584, 484);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 484);
	glEnd();
		mFont1.SetScale(0.35f,0.5f);
		mFont1.SetAlignment(ALIGN_LEFT);
		mFont1.Print("SPACE",530,417);
		mFont1.Print("ESC",535,449);
	}
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);

	RenderMenus(interp);

	UnBindFBO();


	//fade systems
	if(!mFadeEng.mSystems.empty())
	{
		BindFBO(mFadeFBO,0);
		UTIL_GL::GL2D::SetOrtho(640,480);
		glClearColor(0,0,0,0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDisable(GL_CULL_FACE);
		mFadeEng.Render(interp);
		UTIL_GL::SetBlend(GL_ONE, GL_ONE);
		mPartEng.Render2D(interp);
		glDisable(GL_BLEND);
		UnBindFBO();

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);

		//fade from the last frame
		glColor3f(1,1,1);
		UTIL_GL::GL2D::SetOrtho(gpEng->winWidth,gpEng->winHeight);
		if(!mbFallBackMode)
		{
		UTIL_GL::BindTexture(GL_TEXTURE_RECTANGLE_ARB, gpEng->mFadeFBO.colortexID[1]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,mFadeFBO.h);					glVertex2f(0,0);
		glTexCoord2f( mFadeFBO.w,mFadeFBO.h);	glVertex2f(gpEng->winWidth,0);
		glTexCoord2f( mFadeFBO.w,0);					glVertex2f(gpEng->winWidth,gpEng->winHeight);
		glTexCoord2f( 0,0);									glVertex2f(0,gpEng->winHeight);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		}
		else
		{
		UTIL_GL::BindTexture(GL_TEXTURE_2D, gpEng->mFadeFBO.colortexID[1]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,1);	glVertex2f(0,0);
		glTexCoord2f( 1,1);	glVertex2f(gpEng->winWidth,0);
		glTexCoord2f( 1,0);	glVertex2f(gpEng->winWidth,gpEng->winHeight);
		glTexCoord2f( 0,0);	glVertex2f(0,gpEng->winHeight);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		}
		glDisable(GL_TEXTURE_2D);

		//the new frame
		mShdrMgr.BindProgram(mShdrFadeFx1);
		UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glColor3f(1,1,1);
		if(!mbFallBackMode)
		{
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSamplerRect("fade",1 ,mFadeFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		glActiveTexture(GL_TEXTURE1);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		}
		else
		{
		mShdrMgr.PassSampler2D("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSampler2D("fade",1 ,mFadeFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,1); glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, 1,1); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, 1,0); glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0); glVertex2f(0,winHeight);
		glEnd();
		glActiveTexture(GL_TEXTURE1);
		glDisable(GL_TEXTURE_2D);
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_2D);
		}
		glDisable(GL_BLEND);
		mShdrMgr.BindProgram(0);

	}
	else //render the scene as normal
	{
		//render the scene
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glColor3f(1,1,1);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		if(!mbFallBackMode)
		{
		UTIL_GL::BindTexture(GL_TEXTURE_RECTANGLE_ARB, mMainFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,mMainFBO.h);		glVertex2f(0,0);
		glTexCoord2f( mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glTexCoord2f( mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glTexCoord2f( 0,0);				glVertex2f(0,winHeight);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		}
		else
		{
		UTIL_GL::BindTexture(GL_TEXTURE_2D, mMainFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,1);	glVertex2f(0,0);
		glTexCoord2f( 1,1); glVertex2f(winWidth,0);
		glTexCoord2f( 1,0);	glVertex2f(winWidth,winHeight);
		glTexCoord2f( 0,0);	glVertex2f(0,winHeight);
		glEnd();
		}
		glDisable(GL_TEXTURE_2D);
	}


}
