#include "Block.h"
#include "Platform.h"
#include "Engine.h"

bool UpdateSpecialBlocks(Block& b)
{
	if(b.iSpecial == SURF_BREAK)//once activated these blocks shrink
	{
		b.iScaleDelay--;
		if(b.iScaleDelay<=0)
		{
			b.scale -= TIME_STEP*3;
			if(b.scale<0.2f)
				b.bPass = true;
			if(b.scale <= 0)
			{
				if(!b.mbPlatform)
					gpEng->cMap[(int)(b.pos.z)*MAP_DIMENSIONS*MAP_DIMENSIONS+(int)(b.pos.y)*MAP_DIMENSIONS+(int)(b.pos.x)] = NULL;
				else
				{
					Platform* plat = b.pPlat;
					plat->mpBlocks[(int)(b.pos.z*plat->mSize.y)*(int)(plat->mSize.x+b.pos.y)*(int)(plat->mSize.x+b.pos.x)] = NULL;
				}
				return true;
			}
		}
	}

//	if(b.bColored)
//	{
		if(b.iColortime>0)
			b.iColortime--;
//	}

	return false;
}

bool RemoveTaggedBlock(Block b)
{
	if(b.bTagged)
		return true;
	return false;
}

bool BlockInBounds(Block b, Vec3 mins, Vec3 maxs)
{
	Vec3 p = b.pos;// + Vec3(0.5, 0.5, 0.5);

	if(p.x<mins.x || p.x>maxs.x)
		return false;
	if(p.y<mins.y || p.y>maxs.y)
		return false;
	if(p.z<mins.z || p.z>maxs.z)
		return false;
	return true;
}
unsigned int GetBlockFace(Block b, Vec3 ray)
{
	if(ray.z>0)
		return 0;
	else if(ray.z<0)
		return 1;
	else if(ray.y>0)
		return 2;
	else if(ray.y<0)
		return 3;
	else if(ray.x>0)
		return 4;
	else
		return 5;
}

bool SortSurfByImage(Surface s1, Surface s2)
{
	if(s1.faceID < s2.faceID)
		return true;
	return false;
}
bool SortSurfByType(Surface s1, Surface s2)
{
	if(s1.type < s2.type)
		return true;
	return false;
}
bool SortSurfByDistance(Surface s1, Surface s2)
{
	if(s1.distance > s2.distance)
		return true;
	return false;
}
Surface CreateSurface(Vec3 p1, Vec3 p2, Vec3 p3, Vec3 p4, Vec3 normal, unsigned int ID, unsigned int t, float d)
{
	Surface s;
	s.Pos[0] = p1;
	s.Pos[1] = p2;
	s.Pos[2] = p3;
	s.Pos[3] = p4;
	s.n = normal;
	s.faceID = ID;
	s.type = t;
	s.distance = d;
	s.pEnt = NULL;
	s.RampCol = 0;
	return s;
}
Surface CreateSurfaceEntity(Entity* e, unsigned int ID, unsigned int t, float d)
{
	Surface s;
	s.faceID = ID;
	s.type = t;
	s.distance = d;
	s.pEnt = e;
	s.RampCol = 0;
	return s;
}