#pragma once
#include "Vector.h"
#include "Entity.h"

class Platform;
struct Block
{
	Vec3 pos;
	unsigned int Faces[6];
	int iScaleDelay;
	float scale;

	bool bTagged;//if true it needs to be removed
	bool bSolid;

	bool mbPlatform;//this belongs to a platform
	Platform* pPlat;//the platform I belong too
	unsigned int iSpecial;// special code for the block
	bool bPass;//not effected by collision
	bool bColored;
	int iColortime;
};
bool UpdateSpecialBlocks(Block& b);

enum //certain tiles contain types
{
	SURF_BREAK = 8,
	SURF_JUMP = 9,
	SURF_FUR = 16,
	SURF_ICE = 13
};
enum //different rendering techniques for surfaces
{
	DRAW_SCROLL = 0,
	DRAW_FUR,
	DRAW_GLOW
};
struct Surface
{
	Vec3 Pos[4];
	Vec3 n;
	unsigned int faceID;//Image
	unsigned int type;//special render cases
	float distance;//distance to the camera

	//ok this is a bit of a hack, but it allows me to put entities into the render queue
	Entity* pEnt;
	int RampCol;
};

bool RemoveTaggedBlock(Block b);

bool BlockInBounds(Block b, Vec3 mins, Vec3 maxs);
unsigned int GetBlockFace(Block b, Vec3 ray);
bool SortSurfByImage(Surface s1, Surface s2);
bool SortSurfByType(Surface s1, Surface s2);
bool SortSurfByDistance(Surface s1, Surface s2);

Surface CreateSurface(Vec3 p1, Vec3 p2, Vec3 p3, Vec3 p4, Vec3 normal, unsigned int ID, unsigned int t, float d);
Surface CreateSurfaceEntity(Entity* e, unsigned int ID, unsigned int t, float d);
