#include "Engine.h"

extern float fWorldRotation,fOWorldRotation;
extern int iSplashPage;
extern int iSplashFade;
extern bool bSplashFade;
extern float fBushSlide, fOBushSlide;

int iFinishCreditsTime;
float fCreditsScroll, fOCreditScroll;
void Engine::StartCredits()
{
	if(miWorld!=0)
	{
		miWorld = 0;
		LoadWorldData();
	}
//	FADE_Star* FS2 = new FADE_Star;
//	FS2->Spawn(1,Vec3(0,1,1));
//	mFadeEng.InsertSystem(FS2);//*/
	BindFBO(gpEng->mMainFBO,0);
	miBoundFBO = 0;
	glClearColor(0,0,0,0);
	glClear(GL_COLOR_BUFFER_BIT);
	SDL_GL_SwapBuffers();
	UnBindFBO();
		FADE_Fade1* FS = new FADE_Fade1;
		FS->Spawn(1,Vec3(1,1,1));
		mFadeEng.InsertSystem(FS);//*/
//		(this->*pRenderFunc)(mInterp);
		RenderSceneToFadeBuffer();
	PS_Fade1* PS = new PS_Fade1;
	PS->Spawn(Vec3(0,0,0),Vec3(0,0,0),Vec2(32,32),Vec3(1,1,1),0,1,1);
	mPartEng.InsertSystem(PS,true);//*/

	mSplashBalls.clear();

	//if(!MusicIsPlaying())
	PlayMusic(mSplashMusic,false,false);

	fWorldRotation=fOWorldRotation=-150;
	iOption = 0;
	iSplashPage = 0;
	iSplashFade = 0;

	fBushSlide= fOBushSlide=620;
	bTutorialGame = false;
	iFinishCreditsTime = 0;
	fCreditsScroll= fOCreditScroll = 200;
}

void Engine::UpdateCredits()
{
	if(KEY_ACTION2.state == JUST_PRESSED && !mbPaused && mFadeEng.mSystems.empty())
	{
		if(!mMenus.empty() && mMenus.back()->bFadingIn ||
			!mMenus.empty() && mMenus.back()->bFadingOut ||
			 !mMenus.empty() && !mMenus.back()->bFadingIn && !mMenus.empty() && !mMenus.back()->bFadingOut ||
			mMenus.empty())
		{
			FADE_StarOut* FS = new FADE_StarOut;
			FS->Spawn(1,Vec3(1,1,1));
			gpEng->mFadeEng.InsertSystem(FS);//*/
			ChangeState(STATE_SPLASH, 125, &CALLBACK_StartSplash);
			MasterMusicFadeout(300);
		}
	}

	fOWorldRotation = fWorldRotation;
	fWorldRotation += TIME_STEP * 1.5f*5;
	fOBushSlide = fBushSlide;
	fBushSlide-=TIME_STEP * 10;
	if(fBushSlide<0)
		fBushSlide = 0;

	mPartEng.Update();
	mFadeEng.Update();

	if(iSplashFade>0)
	{
		iSplashFade--;
		if(iSplashFade == 75)
		{
			bSplashFade?
				iSplashPage++:
				iSplashPage--;
			iOption = 0;
		}
	}

	fOCreditScroll = fCreditsScroll;

	if(iFinishCreditsTime>700 && iFinishCreditsTime<2370 || iFinishCreditsTime>3300 && iFinishCreditsTime<4750)
		fCreditsScroll -= TIME_STEP * 30;

	iFinishCreditsTime++;

	if(iFinishCreditsTime==5200)
	{
		FADE_StarOut* FS = new FADE_StarOut;
		FS->Spawn(1,Vec3(1,1,1));
		gpEng->mFadeEng.InsertSystem(FS);//*/
		ChangeState(STATE_SPLASH, 125, &CALLBACK_StartSplash);
	}

}
void Engine::RenderCredits(const float interp)
{
	miBoundFBO = 0;
	BindFBO(mMainFBO,0);
	glClearColor(0,0,0.3f,0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	UTIL_GL::GL3D::SetPerspective(70,1.3f,2,2048);


	static float PrevViewMat[16];
	static float PrevViewMatInverse[16];
	static float Proj[16];
	float Rotation = UTIL_Misc::Interpolate(fWorldRotation,fOWorldRotation,interp);

	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);

	//Vec3 eye = p - f * 2.7f - u * 2.7f;
	Vec3 eye(32,16,32);
	eye.x = UTIL_Misc::Clamp(eye.x, 0, MAP_DIMENSIONS);
	eye.y = UTIL_Misc::Clamp(eye.y, 0, MAP_DIMENSIONS);
	eye.z = UTIL_Misc::Clamp(eye.z, 0, MAP_DIMENSIONS);
//	gluLookAt(p.x,p.y,p.z, p.x+f.x,p.y+f.y,p.z+f.z, -u.x,-u.y,-u.z);
	Vec3 f(0,0,1);
	Vec3 u(0,-1,0);
	gluLookAt(eye.x,eye.y,eye.z, f.x,f.y,f.z, -u.x,-u.y,-u.z);

	glRotatef(Rotation, 0,1,0);

//	gluLookAt(0,0,0, f.x,f.y,f.z, -u.x,-u.y,-u.z);
	glScalef(1,0.5,1);
	glTranslatef(0,54,0);
	//skybox
	float sinCol = (sin(Rotation*0.01f) +1)/2;
	if(sinCol>1)sinCol=1;
	if(sinCol<0.1f)sinCol=0.1f;
	glColor3f(0.1f,0.1f,1);
	RenderWorld(miWorld,interp);


//	if(!mbFallBackMode)
//		glClearDepth(0.995f);
	glClear(GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);



	UTIL_GL::GL3D::SetPerspective(45,1.3f,0.1f,60);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	gluLookAt(0,-1.5f,0, 0,0,5, 0,-1,0);

	GLfloat tempMatrix[16];
	glGetFloatv(GL_MODELVIEW_MATRIX,tempMatrix);
	Vec3 camRight = Vec3(tempMatrix[0],tempMatrix[4],tempMatrix[8]);
	Vec3 camUp = Vec3(tempMatrix[1],tempMatrix[5],tempMatrix[9]);
	Vec3 camFwd = Vec3(tempMatrix[2],tempMatrix[6],tempMatrix[10]);
	glEnable(GL_CULL_FACE);



	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	Vec3 lp = Vec3(0,0,0) + camUp * 1 + camRight*5;
//	float LightPos[4]={-500,-1000.1f,500,1};
	float LightPos[4]={lp.x,lp.y,lp.z,0};
	float LightDir[4]={-camUp.x,-camUp.y,-camUp.z,0};
	float amb[4]={0.15f,0.15f,0.15f,1};
	float dif[4]={0.4f*0.1f,0.4f*0.1f,0.4f,1};
	float gldif[4]={0.7f*0.1f,0.7f*0.1f,0.7f,1};
	float glamb[4]={0.95f,0.95f,0.95f,1};
	float spec[4]={1,1,1,0};
	float blk[4]={0,0,0,1};
	glShadeModel(GL_SMOOTH);
//	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, amb);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0,  GL_POSITION, LightPos);
	glLightfv(GL_LIGHT0,  GL_SPOT_DIRECTION, LightDir);
	glLightfv(GL_LIGHT0,  GL_AMBIENT, dif);
	glLightfv(GL_LIGHT0,  GL_DIFFUSE, gldif);
	glLightfv(GL_LIGHT0,  GL_SPECULAR, glamb);
	glMaterialfv(GL_FRONT, GL_AMBIENT, dif);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, gldif);
	glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
	glMateriali(GL_FRONT, GL_SHININESS, 100);
	glEnable(GL_COLOR_MATERIAL);

	gpEng->mShdrMgr.BindProgram(gpEng->mShdrPBallLight);
	Vec2 mins(0,0), maxs(1,1);
//	mShdrMgr.BindProgram(mShdrPPDirLight);
	GLint AtLocmins = mShdrMgr.GetAttribLocation("inmins");
	GLint AtLocmaxs = mShdrMgr.GetAttribLocation("inmaxs");
//	mShdrMgr.PassUniform3fv("up",1,camUp.v);
	mShdrMgr.PassAttrib2fv(AtLocmins, mins.v);
	mShdrMgr.PassAttrib2fv(AtLocmaxs, maxs.v);

	mMatMgr.SetMaterialAttributes(mObjects[MDL_SPHERE].mMaterials[mObjects[MDL_SPHERE].mFaces.front().mattID].pMat,BASE_PASS,0);
	int n;
	float fx = -3;
	std::list<SplashBall>::iterator it;
	for(it = mSplashBalls.begin(); it!=mSplashBalls.end(); it++)
	{

		glPushMatrix();
		Vec3 pos = UTIL_Misc::Interpolate((*it).mPos, (*it).mOPos, interp);
		glTranslatef(pos.x,pos.y,pos.z);
		glTranslatef(0,0,32);
		Vec3 ballRot = UTIL_Misc::Interpolate((*it).mRot,(*it).mORot,interp);
		glRotatef(ballRot.x, 1,0,0);
		glRotatef(ballRot.y, 0,1,0);
		glRotatef(ballRot.z, 0,0,1);
		glScalef(1.5f,1.5f,1.5f);
		for(n=0;n<(int)(*it).mType.iLayers.size();n++)
		{
			if(n>0)
				UTIL_GL::SetBlend(GL_ONE,GL_ONE);
			else glDisable(GL_BLEND);

//			mShdrMgr.PassSampler2D("bumpMap",1,mBallTypes[i].idBump);
			mShdrMgr.PassSampler2D("tex",0,(*it).mType.iLayers[n]);
			glColor3fv(BallColors[(*it).mType.iColLayers[n]].v);
			mObjects[(*it).mType.iMdlType].RenderBuffer(false);
		}
			//if(gpEng->iSelectedSticker>=0)
		{
			UTIL_GL::SetBlend(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
			glColor4f(1,1,1,1);
			mShdrMgr.PassSampler2D("tex",0,mStickers[(*it).miSticker]);
			mObjects[MDL_STICKER].RenderBuffer(false);
			glDisable(GL_BLEND);
		}
		glPopMatrix();
		fx+=3;
	}

	mShdrMgr.BindProgram(0);



	Vec3 newlp = Vec3(0,-5,-10);
	float LightPos2[4]={newlp.x,newlp.y,newlp.z,0};
	glLightfv(GL_LIGHT0,  GL_POSITION, LightPos2);
	//render stars
	glDisable(GL_BLEND);
	glPushMatrix();
	glTranslatef(0,-1.5f,15);
	glRotatef(-180,1,0,0);
	glRotatef(Rotation*15, 0,-1,0);
	glScalef(0.5f,0.5f,0.5f);

	glPushMatrix();
	mShdrMgr.BindProgram(0);
	glScalef(1.23,1.23,1.23);
	glDisable(GL_LIGHTING);
	glColor3f(0,0,0);
	glDepthMask(GL_FALSE);
	mObjects[MDL_STAR].RenderBuffer(false);
	glDepthMask(GL_TRUE);
	glDisable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	//glClear(GL_DEPTH_BUFFER_BIT);
	mShdrMgr.BindProgram(mShdrPPDirLight);
	glPopMatrix();

	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	glCullFace(GL_FRONT);

	glColor4f(1,1,0,0.5f);
	mObjects[MDL_STAR].RenderBuffer(true);
	glCullFace(GL_BACK);
	mObjects[MDL_STAR].RenderBuffer(true);
	glDisable(GL_CULL_FACE);
	glColor4f(1,1,1,1);
	UTIL_GL::SetBlend(GL_ONE,GL_ONE);
	glScalef(1.1,1.1,1.1);
	mObjects[MDL_STAR].RenderBuffer(true);

	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);
	glDepthMask(GL_TRUE);
	glEnable(GL_DEPTH_TEST);
	glPopMatrix();

	glDisable(GL_BLEND);
	mShdrMgr.BindProgram(0);


	glDisable(GL_COLOR_MATERIAL);
	glDisable(GL_LIGHTING);
	glDisable(GL_LIGHT0);
	glActiveTexture(GL_TEXTURE1);
	glDisable(GL_TEXTURE_2D);
	glActiveTexture(GL_TEXTURE0);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glDisable(GL_CULL_FACE);

	UnBindFBO();


	//render dOF
	if(!mbFallBackMode)
	if(mbDOF)
	{
		BindFBO(mMainFBO,0);
		glEnable(GL_DEPTH_TEST);
		glDepthMask(GL_TRUE);
		glColorMask(GL_FALSE,GL_FALSE,GL_FALSE,GL_FALSE);
		glBegin(GL_QUADS);
		glVertex3fv((eye-camFwd*20-camRight*50-camUp*50).v);
		glVertex3fv((eye-camFwd*20+camRight*50-camUp*50).v);
		glVertex3fv((eye-camFwd*20+camRight*50+camUp*50).v);
		glVertex3fv((eye-camFwd*20-camRight*50+camUp*50).v);
		glEnd();
		glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);
		UnBindFBO();
		float mul = 1;
		switch(iSuperSamples)
		{
		case 1: mul = 1.25f; break;
		case 2: mul = 1.5f; break;
		case 3: mul = 1.75f; break;
		case 4: mul = 2; break;
		}

		BindFBO(mMainFBO,1);
		float focalD = 27;// + (sin(mTimer.GetTime())*100);
		mShdrMgr.BindProgram(mShdrDOFH);
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSamplerRect("depth",1 ,mMainFBO.depthtexID);
		mShdrMgr.PassUniform1f("focalD",focalD);
		mShdrMgr.PassUniform1f("depthRange",30);
		mShdrMgr.PassUniform1f("blurFactor",0.05f*mul);
		glClear(GL_COLOR_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDepthMask(GL_FALSE);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		mShdrMgr.BindProgram(0);
		UnBindFBO();
		BindFBO(mMainFBO,0);
		mShdrMgr.BindProgram(mShdrDOFV);
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[1]);
		mShdrMgr.PassSamplerRect("depth",1 ,mMainFBO.depthtexID);
		mShdrMgr.PassUniform1f("focalD",focalD);
		mShdrMgr.PassUniform1f("depthRange",30);
		mShdrMgr.PassUniform1f("blurFactor",0.05f*mul);
		glClear(GL_COLOR_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDepthMask(GL_FALSE);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		mShdrMgr.BindProgram(0);
		UnBindFBO();
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		glDepthMask(GL_TRUE);

	}//*/


	BindFBO(mMainFBO,0);

	UTIL_GL::GL2D::SetOrtho(640,480);
	glClear(GL_DEPTH_BUFFER_BIT);
	glDisable(GL_DEPTH_TEST);

	glColor3f(0.1f*0.5f,0.1f*0.5f,0.5f);
	UTIL_GL::SetBlend(GL_ONE, GL_ONE);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, mGfxImg[GFX_STAR_GLOW]);
	Vec2 SP(320,72), UP, RIGHT;
	UTIL_Misc::MakeVectors(Rotation*5,UP,RIGHT);
	glBegin(GL_QUADS);
	glTexCoord2f(0,1); glVertex2fv((SP-UP*128-RIGHT*128).v);
	glTexCoord2f(1,1); glVertex2fv((SP+UP*128-RIGHT*128).v);
	glTexCoord2f(1,0); glVertex2fv((SP+UP*128+RIGHT*128).v);
	glTexCoord2f(0,0); glVertex2fv((SP-UP*128+RIGHT*128).v);
	glEnd();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);

	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	Vec2 sprUV, sprUVS;
	sprUVS = mSprites[SPR_UI].mUVsize;
	float scr = UTIL_Misc::Interpolate(fCreditsScroll, fOCreditScroll, interp);
	mFont1.EnableShadow();
	mFont1.SetAlignment(ALIGN_CENTER);
	mFont1.SetColor(1,1,1,1);
	mFont1.SetScale(1,1);
	mFont1.Print("CONGRATULATIONS!",320,scr);
	mFont1.SetScale(0.75f,0.75f);
	mFont1.Print("YOU HAVE COMPLETED SCREWBALL",320,50+scr);
	char szData[128];
	int iHrs,iMins,iSecs;
	UTIL_Misc::ConvertSecondsToHrsMinsSecs(iTimePlayed/60,iHrs,iMins,iSecs);
	sprintf(szData,"TOTAL TIME: %i:%.2i:%.2i",iHrs,iMins,iSecs);
	mFont1.Print(szData,320,90+scr);
	sprintf(szData,"FINAL SCORE: %i",miScore);
	mFont1.Print(szData,320,110+scr);

	mFont1.Print("CREDITS",320,500+scr);
	mFont1.SetScale(0.75f,0.5f);
	mFont1.Print("DRPETTER",320,550+scr);
	mFont1.Print("AMINE",320,570+scr);
	mFont1.Print("PHILHASSEY",320,590+scr);
	mFont1.Print("ENASKIL",320,610+scr);
	mFont1.Print("MJAU",320,630+scr);
	mFont1.Print("BENHEM",320,650+scr);
	mFont1.Print("THE2BEARS",320,670+scr);
	mFont1.Print("MADWORK",320,690+scr);
	mFont1.Print("GACHUK",320,710+scr);
	mFont1.Print("MANTIS",320,730+scr);
	mFont1.Print("ACE4016",320,750+scr);
	mFont1.Print("SARGON",320,770+scr);
	mFont1.Print("PLACIDBOX",320,790+scr);
	mFont1.Print("INTELLECT",320,810+scr);

	mFont1.Print("THANKYOU FOR SUPPORTING",320,1120+scr);
	mFont1.Print("DARK CASTLE SOFTWARE",320,1150+scr);
	mFont1.Print("WE HOPE YOU HAVE ENJOYED",320,1180+scr);
	mFont1.Print("THE GAME!",320,1210+scr);
	float sinCol2 = (sin(Rotation*0.5f) +1)/2;

	glColor4f(1,1,1,1);

	glColor3f(0.1f,0.1f,1);

	float slide1 = UTIL_Misc::Interpolate(fBushSlide,fOBushSlide,interp)*0.5f;
	float slide2 = UTIL_Misc::Interpolate(fBushSlide,fOBushSlide,interp)*7;
	if(slide1>50)slide1=50;
	if(slide2>400)slide2=400;
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, mGfxImg[GFX_BUSH1]);
	glBegin(GL_QUADS);
	glTexCoord2f(0,1); glVertex2f(0,324+slide1);
	glTexCoord2f(1,1); glVertex2f(320,324+slide1);
	glTexCoord2f(1,0); glVertex2f(320,580+slide1);
	glTexCoord2f(0,0); glVertex2f(0,580+slide1);
	glTexCoord2f(1,1); glVertex2f(320,324+slide1);
	glTexCoord2f(0,1); glVertex2f(640,324+slide1);
	glTexCoord2f(0,0); glVertex2f(640,580+slide1);
	glTexCoord2f(1,0); glVertex2f(320,580+slide1);
	glEnd();
	UTIL_GL::BindTexture(GL_TEXTURE_2D, mGfxImg[GFX_BUSH2]);
	glBegin(GL_QUADS);
	glTexCoord2f(0,1); glVertex2f(-slide2,0);
	glTexCoord2f(1,1); glVertex2f(512-slide2,0);
	glTexCoord2f(1,0); glVertex2f(512-slide2,512);
	glTexCoord2f(0,0); glVertex2f(-slide2,512);
	glEnd();
	UTIL_GL::BindTexture(GL_TEXTURE_2D, mGfxImg[GFX_BUSH3]);
	glBegin(GL_QUADS);
	glTexCoord2f(0,1); glVertex2f(128+slide2,0);
	glTexCoord2f(1,1); glVertex2f(640+slide2,0);
	glTexCoord2f(1,0); glVertex2f(640+slide2,512);
	glTexCoord2f(0,0); glVertex2f(128+slide2,512);
	glEnd();


	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);

	glColor4f(1,1,1,1);


	RenderMenus(interp);

	UnBindFBO();


	//fade systems
	if(!mFadeEng.mSystems.empty())
	{
		BindFBO(mFadeFBO,0);
		UTIL_GL::GL2D::SetOrtho(640,480);
		glClearColor(0,0,0,0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDisable(GL_CULL_FACE);
		mFadeEng.Render(interp);
		UTIL_GL::SetBlend(GL_ONE, GL_ONE);
		mPartEng.Render2D(interp);
		glDisable(GL_BLEND);
		UnBindFBO();

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);

		//fade from the last frame
		glColor3f(1,1,1);
		UTIL_GL::GL2D::SetOrtho(gpEng->winWidth,gpEng->winHeight);
		if(!mbFallBackMode)
		{
		UTIL_GL::BindTexture(GL_TEXTURE_RECTANGLE_ARB, gpEng->mFadeFBO.colortexID[1]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,mFadeFBO.h);					glVertex2f(0,0);
		glTexCoord2f( mFadeFBO.w,mFadeFBO.h);	glVertex2f(gpEng->winWidth,0);
		glTexCoord2f( mFadeFBO.w,0);					glVertex2f(gpEng->winWidth,gpEng->winHeight);
		glTexCoord2f( 0,0);									glVertex2f(0,gpEng->winHeight);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		}
		else
		{
		UTIL_GL::BindTexture(GL_TEXTURE_2D, gpEng->mFadeFBO.colortexID[1]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,1);	glVertex2f(0,0);
		glTexCoord2f( 1,1);	glVertex2f(gpEng->winWidth,0);
		glTexCoord2f( 1,0);	glVertex2f(gpEng->winWidth,gpEng->winHeight);
		glTexCoord2f( 0,0);	glVertex2f(0,gpEng->winHeight);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		}
		glDisable(GL_TEXTURE_2D);

		//the new frame
		mShdrMgr.BindProgram(mShdrFadeFx1);
		UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glColor3f(1,1,1);
		if(!mbFallBackMode)
		{
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSamplerRect("fade",1 ,mFadeFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		glActiveTexture(GL_TEXTURE1);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		}
		else
		{
		mShdrMgr.PassSampler2D("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSampler2D("fade",1 ,mFadeFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,1); glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, 1,1); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, 1,0); glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0); glVertex2f(0,winHeight);
		glEnd();
		glActiveTexture(GL_TEXTURE1);
		glDisable(GL_TEXTURE_2D);
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_2D);
		}
		glDisable(GL_BLEND);
		mShdrMgr.BindProgram(0);

	}
	else //render the scene as normal
	{
		//render the scene
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glColor3f(1,1,1);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		if(!mbFallBackMode)
		{
		UTIL_GL::BindTexture(GL_TEXTURE_RECTANGLE_ARB, mMainFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,mMainFBO.h);		glVertex2f(0,0);
		glTexCoord2f( mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glTexCoord2f( mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glTexCoord2f( 0,0);				glVertex2f(0,winHeight);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		}
		else
		{
		UTIL_GL::BindTexture(GL_TEXTURE_2D, mMainFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,1);	glVertex2f(0,0);
		glTexCoord2f( 1,1); glVertex2f(winWidth,0);
		glTexCoord2f( 1,0);	glVertex2f(winWidth,winHeight);
		glTexCoord2f( 0,0);	glVertex2f(0,winHeight);
		glEnd();
		}
		glDisable(GL_TEXTURE_2D);
	}
}