#pragma once
#include "Vector.h"
#include "FileIO.h"



//entity types
enum ENT_TYPE
{
	ENT_PLR=0,
	ENT_GEM,
	ENT_SPIKES,
	ENT_STAR,
	ENT_CLOCK,
	ENT_SLINKY,
	ENT_ARROW,
	ENT_ROTORBLADE,
	ENT_1UP,
	ENT_BUTTON,
	ENT_LASER,
	ENT_TELEPORT
};

struct Cube
{
	Vec3 Pos;
	unsigned int Faces[6];//image for each face.

	bool Load(CFileIO& fIO);
};

struct CubeEnt
{
	Vec3 mMins, mMaxs;
	Vec3 mMoveOffset;

	bool bStartOn;
	bool bVisible;
	bool bTriggerTouch;
	bool bPlayOnce;//needs triggering after one play.
	bool bReturn;//return to initial position
	bool bTriggerMessage;//once triggered, will popup a message

	float fWaitDelay;//delay at target position for this length of time
	float fMoveTime;//how long to reach destination

	char name[16];
	char Target[16];

	char TriggerMessage[512];//once triggered a message will popup on the screen

	Vec3 mPushVector;//push the player when hes on this
	bool mbJump;//make the player jump
	bool mbDamage;//make the player take damage

	bool Load(CFileIO& fIO);
};

struct Ent
{
	Vec2 mRotation;
	int iType;
	Vec3 Pos;
	Vec3 Color;
	Vec3 Right,Forward,Up;
	char name[16];
	char Target[16];

	float fStartDelay;
	float fHoldDelay;
	bool Load(CFileIO& fIO);
};