#pragma once
#include "Vector.h"
#include "EDFormats.h"

class Platform;
class Entity
{
public:
	unsigned int iBaseType;

	virtual void Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u)=0;
	void SetDefaultAttribs(Vec3 p, Vec3 f, Vec3 r, Vec3 u);
	virtual void Update()=0;
	virtual void Render(const float interp, int pass)=0;
	virtual void RenderShadow(const float interp)=0;
	virtual void RenderDepth(const float interp)=0;
	virtual void RenderFur(const float interp);
	virtual void RenderGlow(const float interp);
	virtual Entity* Clone() const =0;
	virtual void TakeDamage();
	virtual void Trigger();

	Vec3 mPos, mOPos;
	Vec3 mForward, mOForward;
	Vec3 mRight, mORight;
	Vec3 mUp, mOUp;

	float fDistToCamera;
	bool bRemove;
	bool bVisible;

	Vec3 mMins, mMaxs;
	bool BoxOverlap(Vec3 mins, Vec3 maxs);

	Platform* mpPlatform;
	Vec3 mColor;
	virtual void Freeze();
};


Entity* EntFactory(int type);

bool SortEntsByDistance(Entity* e1, Entity* e2);
bool PruneEnts(Entity* e);
bool CleanEnts(Entity* e);
bool FreezeEnts(Entity* e);

extern char gEntName[16];
bool TriggerEntityByGName(Entity* p);
bool TriggerPlatformByGName(Platform* p);