#pragma once
#include "Vector.h"
#include <list>

class FadeSystem
{
public:
	virtual void Spawn(float life, Vec3 col)=0;
	virtual void Update()=0;
	virtual void Render(const float interp)=0;
	virtual void RenderSecondary(const float interp){};
	float fLife, fMaxLife;
	Vec3 Color;
	bool bRemove;

	int iType;//should this fade from an old scene to the new, or just fade the current?
};

bool PruneFadeSystems(FadeSystem* f);

class FadeEngine
{
public:
	void Update();
	void Render(const float interp);
	void RenderSecondary(const float interp);
	void Cleanup();
	void InsertSystem(FadeSystem* FS);

	std::list<FadeSystem*> mSystems;
};

class FADE_Fade1 : public FadeSystem
{
public:
	void Spawn(float life, Vec3 col);
	void Update();
	void Render(const float interp);
	float fVerticalBar,fOVerticalBar;
};
struct Motion
{
	float Rot;
	float fAlpha;
	float scale;
};
bool PruneMotion(Motion& m);
class FADE_Star : public FadeSystem
{
public:
	void Spawn(float life, Vec3 col);
	void Update();
	void Render(const float interp);
//	void RenderSecondary(const float interp);
	float fSize,fOSize;
	float fRotation, fORotation;

};

class FADE_Box : public FadeSystem
{
public:
	void Spawn(float life, Vec3 col);
	void Update();
	void Render(const float interp);
	float fSize[10*10];
	int tileIDX;
};

class FADE_StarOut : public FadeSystem
{
public:
	void Spawn(float life, Vec3 col);
	void Update();
	void Render(const float interp);
//	void RenderSecondary(const float interp);
	float fSize,fOSize;
	float fRotation, fORotation;
};