#include "Engine.h"
extern float fWorldRotation,fOWorldRotation;

void Engine::StartGameSelect()
{
//	miWorld = miOWorld;
	this->miSaveGameSlot = 0;
	SlotMenu* menu = new SlotMenu;
	menu->Spawn(Vec2(320,240));
	mMenus.push_back(menu);
	mfOCloudScroll = mfCloudScroll = 0;

	if(!MusicIsPlaying())
	PlayMusicFadeIn(mAltMainMusic,true,300,false);

}
void Engine::UpdateGameSelect()
{
	//_ASSERTE( _CrtCheckMemory( ) );
/*	if(KEY_ACTION2.state == JUST_PRESSED && !mbPaused && mFadeEng.mSystems.empty())
	{
		if(!mMenus.empty() && mMenus.back()->bFadingIn ||
			!mMenus.empty() && mMenus.back()->bFadingOut ||
			 !mMenus.empty() && !mMenus.back()->bFadingIn && !mMenus.empty() && !mMenus.back()->bFadingOut ||
			mMenus.empty())
		mbQuit =true;
	}*/

	if(!mMenus.empty())
	{
		mMenus.back()->Update();
		mMenus.remove_if(PruneMenus);

		if(this->iEngineState == STATE_STAGESELECT)
		{
			gpEng->RenderSceneToFadeBuffer();
			gpEng->LoadStageSelectData();
			gpEng->StartStageSelect();
		}
	}

	fOWorldRotation = fWorldRotation;
	fWorldRotation += TIME_STEP * 1.5f*5;
	mfOCloudScroll = mfCloudScroll;
	mfCloudScroll += 0.002f;

	mPartEng.Update();
	mFadeEng.Update();
}
void Engine::RenderGameSelect(const float interp)
{
	miBoundFBO = 0;
	BindFBO(mMainFBO,0);
	glClearColor(0.7f,0.1,0.1,0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	UTIL_GL::GL3D::SetPerspective(70,1.3f,2,2048);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);

	//Vec3 eye = p - f * 2.7f - u * 2.7f;
	Vec3 eye(32,16,32);
	eye.x = UTIL_Misc::Clamp(eye.x, 0, MAP_DIMENSIONS);
	eye.y = UTIL_Misc::Clamp(eye.y, 0, MAP_DIMENSIONS);
	eye.z = UTIL_Misc::Clamp(eye.z, 0, MAP_DIMENSIONS);
//	gluLookAt(p.x,p.y,p.z, p.x+f.x,p.y+f.y,p.z+f.z, -u.x,-u.y,-u.z);
	Vec3 f(0,0,1);
	Vec3 u(0,-1,0);
	gluLookAt(eye.x,eye.y,eye.z, f.x,f.y,f.z, -u.x,-u.y,-u.z);
	float Rotation = UTIL_Misc::Interpolate(fWorldRotation,fOWorldRotation,interp);
//	glRotatef(Rotation*0.01, 1,0,0);
	glRotatef(Rotation, 0,1,0);

//	gluLookAt(0,0,0, f.x,f.y,f.z, -u.x,-u.y,-u.z);
	glScalef(1,0.5,1);
	glTranslatef(0,64,0);
	//skybox
	RenderWorld(miWorld,interp);

	GLfloat tempMatrix[16];
	glGetFloatv(GL_MODELVIEW_MATRIX,tempMatrix);
	Vec3 camRight = Vec3(tempMatrix[0],tempMatrix[4],tempMatrix[8]);
	Vec3 camUp = Vec3(tempMatrix[1],tempMatrix[5],tempMatrix[9]);
	Vec3 camFwd = Vec3(tempMatrix[2],tempMatrix[6],tempMatrix[10]);

	UnBindFBO();

	//render dOF
	if(!mbFallBackMode)
	if(mbDOF)
	{
		BindFBO(mMainFBO,0);
		glEnable(GL_DEPTH_TEST);
		glDepthMask(GL_TRUE);
		glColorMask(GL_FALSE,GL_FALSE,GL_FALSE,GL_FALSE);
		glBegin(GL_QUADS);
		glVertex3fv((eye-camFwd*20-camRight*50-camUp*50).v);
		glVertex3fv((eye-camFwd*20+camRight*50-camUp*50).v);
		glVertex3fv((eye-camFwd*20+camRight*50+camUp*50).v);
		glVertex3fv((eye-camFwd*20-camRight*50+camUp*50).v);
		glEnd();
		glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);
		UnBindFBO();

		float mul = 1;
		switch(iSuperSamples)
		{
		case 1: mul = 1.25f; break;
		case 2: mul = 1.5f; break;
		case 3: mul = 1.75f; break;
		case 4: mul = 2; break;
		}
		BindFBO(mMainFBO,1);
		float focalD = 7;// + (sin(mTimer.GetTime())*100);
		mShdrMgr.BindProgram(mShdrDOFH);
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSamplerRect("depth",1 ,mMainFBO.depthtexID);
		mShdrMgr.PassUniform1f("focalD",focalD);
		mShdrMgr.PassUniform1f("depthRange",20);
		mShdrMgr.PassUniform1f("blurFactor",0.05f*mul);
		glClear(GL_COLOR_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDepthMask(GL_FALSE);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		mShdrMgr.BindProgram(0);
		UnBindFBO();
		BindFBO(mMainFBO,0);
		mShdrMgr.BindProgram(mShdrDOFV);
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[1]);
		mShdrMgr.PassSamplerRect("depth",1 ,mMainFBO.depthtexID);
		mShdrMgr.PassUniform1f("focalD",focalD);
		mShdrMgr.PassUniform1f("depthRange",20);
		mShdrMgr.PassUniform1f("blurFactor",0.05f*mul);
		glClear(GL_COLOR_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDepthMask(GL_FALSE);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		mShdrMgr.BindProgram(0);
		UnBindFBO();
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		glDepthMask(GL_TRUE);

	}//*/


	BindFBO(mMainFBO,0);

	UTIL_GL::GL2D::SetOrtho(640,480);
	Vec2 sprUV, sprUVS;
	sprUVS = mSprites[SPR_UI].mUVsize;

	mFont1.EnableShadow();
	mFont1.SetAlignment(ALIGN_CENTER);
	mFont1.SetColor(1,1,1,1);
	mFont1.SetScale(0.75f,0.75f);
	mFont1.SetAlignment(ALIGN_LEFT);
	mFont1.SetScale(0.35f,0.5f);
	mFont1.Print("SELECT",582,417);
	mFont1.Print("BACK",582,449);

	glColor3f(1,1,1);
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, mSprites[SPR_UI].mImg);
	if(bJoystick)
	{
	glBegin(GL_QUADS);
	sprUV = mSprites[SPR_UI].GetTileUV(4);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 412);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(552, 412);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(552, 444);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 444);

	sprUV = mSprites[SPR_UI].GetTileUV(5);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 444);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(552, 444);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(552, 476);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 476);
	glEnd();
	}
	else
	{
	glBegin(GL_QUADS);
	sprUV = mSprites[SPR_UI].GetTileUV(29);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 404);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(584, 404);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(584, 452);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 452);

	//sprUV = mSprites[SPR_UI].GetTileUV(28);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 436);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(584, 436);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(584, 484);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 484);
	glEnd();
		mFont1.SetScale(0.35f,0.5f);
		mFont1.SetAlignment(ALIGN_LEFT);
		mFont1.Print("SPACE",530,417);
		mFont1.Print("ESC",535,449);
	}
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);

	RenderMenus(interp);
	UnBindFBO();

	//fade systems
	if(!mFadeEng.mSystems.empty())
	{
		BindFBO(mFadeFBO,0);
		UTIL_GL::GL2D::SetOrtho(640,480);
		glClearColor(0,0,0,0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDisable(GL_CULL_FACE);
		mFadeEng.Render(interp);
		UTIL_GL::SetBlend(GL_ONE, GL_ONE);
		mPartEng.Render2D(interp);
		glDisable(GL_BLEND);
		UnBindFBO();

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);

		//fade from the last frame
		glColor3f(1,1,1);
		UTIL_GL::GL2D::SetOrtho(gpEng->winWidth,gpEng->winHeight);
		if(!mbFallBackMode)
		{
		UTIL_GL::BindTexture(GL_TEXTURE_RECTANGLE_ARB, gpEng->mFadeFBO.colortexID[1]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,mFadeFBO.h);					glVertex2f(0,0);
		glTexCoord2f( mFadeFBO.w,mFadeFBO.h);	glVertex2f(gpEng->winWidth,0);
		glTexCoord2f( mFadeFBO.w,0);					glVertex2f(gpEng->winWidth,gpEng->winHeight);
		glTexCoord2f( 0,0);									glVertex2f(0,gpEng->winHeight);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		}
		else
		{
		UTIL_GL::BindTexture(GL_TEXTURE_2D, gpEng->mFadeFBO.colortexID[1]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,1);					glVertex2f(0,0);
		glTexCoord2f( 1,1);					glVertex2f(gpEng->winWidth,0);
		glTexCoord2f( 1,0);					glVertex2f(gpEng->winWidth,gpEng->winHeight);
		glTexCoord2f( 0,0);					glVertex2f(0,gpEng->winHeight);
		glEnd();
		}
		glDisable(GL_TEXTURE_2D);

		//the new frame
		mShdrMgr.BindProgram(mShdrFadeFx1);
		UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glColor3f(1,1,1);
		if(!mbFallBackMode)
		{
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSamplerRect("fade",1 ,mFadeFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		glActiveTexture(GL_TEXTURE1);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		glDisable(GL_BLEND);
		}
		else
		{
		mShdrMgr.PassSampler2D("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSampler2D("fade",1 ,mFadeFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,1);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, 1,1);		glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, 1,0);		glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);		glVertex2f(0,winHeight);
		glEnd();
		glActiveTexture(GL_TEXTURE1);
		glDisable(GL_TEXTURE_2D);
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_2D);
		glDisable(GL_BLEND);
		}
		mShdrMgr.BindProgram(0);

		UTIL_GL::GL2D::SetOrtho(640,480);
		glClearColor(0,0,0,0);
		glColor4f(1,1,1,1);
		glDisable(GL_LIGHTING);
		glDisable(GL_DEPTH_TEST);
		glDisable(GL_CULL_FACE);
		UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		mFadeEng.RenderSecondary(interp);
		glDisable(GL_BLEND);//*/

	}
	else //render the scene as normal
	{
		//render the scene
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glColor3f(1,1,1);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		if(!mbFallBackMode)
		{
//			mShdrMgr.BindProgram(mShdrSuperSample2xRect);
//			mShdrMgr.PassSamplerRect("rect",0,mMainFBO.colortexID[0]);
		UTIL_GL::BindTexture(GL_TEXTURE_RECTANGLE_ARB, mMainFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,mMainFBO.h);		glVertex2f(0,0);
		glTexCoord2f( mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glTexCoord2f( mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glTexCoord2f( 0,0);				glVertex2f(0,winHeight);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
//		mShdrMgr.BindProgram(0);
		}
		else
		{
		UTIL_GL::BindTexture(GL_TEXTURE_2D, gpEng->mMainFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,1);					glVertex2f(0,0);
		glTexCoord2f( 1,1);					glVertex2f(gpEng->winWidth,0);
		glTexCoord2f( 1,0);					glVertex2f(gpEng->winWidth,gpEng->winHeight);
		glTexCoord2f( 0,0);					glVertex2f(0,gpEng->winHeight);
		glEnd();
		}
		glDisable(GL_TEXTURE_2D);
	}


}
