#include "Hoop.h"
#include "Engine.h"


void Hoop::Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u)
{
//	gLog.OutPut("Spawning gemstone\n");
	SetDefaultAttribs(p, f,r,u);
	mPos = mOPos = mPos - f*0.5f + u * 0.1f;

	mMins = mPos - Vec3(0.25, 0.25, 0.25);
	mMaxs = mPos + Vec3(0.25, 0.25, 0.25);
	fHoopRotation = 0;

	colMins = Vec3(99999,99999,99999);
	colMaxs = Vec3(-99999,-99999,-99999);
	Vec3 pt[5];
	pt[0] = -r * 0.15f - f *0.1;
	pt[1] = r * 0.15f - f *0.1;
	pt[2] = -r * 0.15f + f *0.1;
	pt[3] = r * 0.15f + f *0.1;
	pt[4] = u * 0.5f;

	for(int n=0; n<5; n++)
	{
		if(pt[n].x < colMins.x)
			colMins.x = pt[n].x;
		if(pt[n].y < colMins.y)
			colMins.y = pt[n].y;
		if(pt[n].z < colMins.z)
			colMins.z = pt[n].z;

		if(pt[n].x > colMaxs.x)
			colMaxs.x = pt[n].x;
		if(pt[n].y > colMaxs.y)
			colMaxs.y = pt[n].y;
		if(pt[n].z > colMaxs.z)
			colMaxs.z = pt[n].z;
	}
}
void Hoop::Update()
{
	mOPos = mPos;
	mOForward = mForward;
	mORight = mRight;
	mOUp = mUp;

	if(gpEng->mPlayer.mbTimeOut)// || gpEng->mPlayer.mbStageWon)
		return;

/*	mForward = ArbitraryRotate(mForward,DEG2RAD(0),mUp);
	mForward = ArbitraryRotate(mForward,DEG2RAD(5),mRight);
	mRight = ArbitraryRotate(mRight,DEG2RAD(0),mUp);
	mRight = ArbitraryRotate(mRight,DEG2RAD(5),mRight);
	mUp = ArbitraryRotate(mUp,DEG2RAD(0),mUp);
	mUp = ArbitraryRotate(mUp,DEG2RAD(5),mRight);
*/
	fHoopRotation+= 1.5f;
	if(!mpPlatform || mpPlatform->bVisible)
	if(gpEng->mPlayer.mPos.x >= mPos.x + colMins.x)
	if(gpEng->mPlayer.mPos.x <= mPos.x + colMaxs.x)
	if(gpEng->mPlayer.mPos.y >= mPos.y + colMins.y)
	if(gpEng->mPlayer.mPos.y <= mPos.y + colMaxs.y)
	if(gpEng->mPlayer.mPos.z >= mPos.z + colMins.z)
	if(gpEng->mPlayer.mPos.z <= mPos.z + colMaxs.z)
//	if(gpEng->mPlayer.bJump && Distance(mPos, gpEng->mPlayer.mPos)<0.45 || !gpEng->mPlayer.bJump && Distance(mPos, gpEng->mPlayer.mPos)<0.35)//this could be slow, should do a bounds check first
	{
		bRemove = true;
	}

}
void Hoop::Render(const float interp, int pass)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
/*	glBegin(GL_LINES);
	glColor3f(1,0,0);
	glVertex3fv((p).v);
	glVertex3fv((p+u*0.5f).v);
//	glColor3f(0,1,0);
//	glVertex3fv((p-r*0.5f).v);
//	glVertex3fv((p+r*0.5f).v);
//	glColor3f(0,0,1);
//	glVertex3fv((p).v);
//	glVertex3fv((p+f*0.5f).v);
	glEnd();
//*/
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	float alpha = 1;
	if(mpPlatform)
		alpha = mpPlatform->iFadeTime>=0?UTIL_Misc::TimeRamp(0,1,0,100,mpPlatform->iFadeTime):0;
	glMultMatrixf(mat);
	glRotatef(90,1,0,0);
	glRotatef(90,0,1,0);
	glRotatef(fHoopRotation,0,0,1);
	glScalef(0.15,0.15,0.15);

	glColor4f(mColor.x,mColor.y,mColor.z,alpha);
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDepthMask(GL_FALSE);


	glEnable(GL_CULL_FACE);
	gpEng->mObjects[MDL_HOOP].RenderBuffer(true);
	glDisable(GL_CULL_FACE);
	glColor4f(1,1,1,1);

	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);

	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);
	glPopMatrix();
}
void Hoop::RenderShadow(const float interp)
{
	return;
	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);

	Vec3 pos = p;
	for(int n=0; n<80; n++)
	{
		pos = p + u *((float)n/10.0f);
		if(gpEng->GetMapTile(pos))
		{
			Block* b= gpEng->GetMapTile(pos);
/*			float	X = u.x!=0?
				(u.x<0?(int)pos.x+0.75f:(int)pos.x+0.25f):pos.x;
			float	Y = u.y!=0?
				(u.y<0?(int)pos.y+0.75f:(int)pos.y+0.25f):pos.y;
			float	Z = u.z!=0?
				(u.z<0?(int)pos.z+0.75f:(int)pos.z+0.25f):pos.z;
*/
			float X = u.x!=0?
				(u.x<0?b->pos.x+0.25f:b->pos.x-0.25f):pos.x;
			float Y = u.y!=0?
				(u.y<0?b->pos.y+0.25f:b->pos.y-0.25f):pos.y;
			float Z = u.z!=0?
				(u.z<0?b->pos.z+0.25f:b->pos.z-0.25f):pos.z;

			pos = Vec3(X,Y,Z);//&/
			pos -= u * 0.27f;
			if(b->mbPlatform)
			{
				Vec3 shadOff = UTIL_Misc::Interpolate(b->pPlat->mPos, b->pPlat->mOPos, interp)-b->pPlat->mPos;
				shadOff = Reflect(shadOff,mRight,0);
				shadOff = Reflect(shadOff,mForward,0);
				pos += shadOff;
			}
			break;
		}
	}//*/
	glPushMatrix();
	glTranslatef(pos.x,pos.y,pos.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glScalef(0.15,0.15,0);
	glRotatef(90,1,0,0);
	glRotatef(90,0,1,0);

	gpEng->mObjects[MDL_HOOP].RenderBuffer(false);
	glPopMatrix();
}
void Hoop::RenderDepth(const float interp)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glRotatef(90,1,0,0);
	glRotatef(90,0,1,0);
	glRotatef(fHoopRotation,0,0,1);
	glScalef(0.15,0.15,0.15);
	gpEng->mObjects[MDL_HOOP].RenderBuffer(false);
//*/
	glPopMatrix();

}
Entity* Hoop::Clone() const
{
	return new Hoop(*this);
}
