#include "Laser.h"
#include "Engine.h"

void Laser::Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u)
{
//	gLog.OutPut("Spawning switch\n");
	SetDefaultAttribs(p, f,r,u);
	mPos = mOPos = mPos + u*0.15f;
	mUp = Normalize(mUp);

	mMins = mPos - Vec3(0.25, 0.25, 0.25);
	mMaxs = mPos + Vec3(0.25, 0.25, 0.25);
//	IsToggled = false;

//	if(IsToggled)
//		gLog.OutPut("Laser is activated!\n");
	iPulseTime = 0;

}
void Laser::Update()
{
	mOPos = mPos;
	mOForward = mForward;
	mORight = mRight;
	mOUp = mUp;


	if(IsToggled)
	{
		Vec3 P = mPos;
		bool bLaserHit = false;
		for(int n=0; n<64; n++)
		{
			if(gpEng->GetMapTile(P-(mUp*(float)n) - mUp*0.5f) || 
				gpEng->GetMapTile(P-(mUp*(float)n) - mUp*0.5f + mRight *0.25f) ||
				gpEng->GetMapTile(P-(mUp*(float)n) - mUp*0.5f - mRight *0.25f) ||
				gpEng->GetMapTile(P-(mUp*(float)n) - mUp*0.5f + mForward *0.25f) ||
				gpEng->GetMapTile(P-(mUp*(float)n) - mUp*0.5f - mForward *0.25f) )
			{
				bLaserHit = true;
				Vec3 POINTS[8];
				Beam B;
				B.C = mColor;
				B.P = mPos + mRight * 0.25f - mUp * 0.1f + mForward *0.1f;
				B.P2 = mPos - (mUp*(float)n) + mRight * 0.25f + mForward *0.1f;
				gpEng->mBeams.push_back(B);
				Vec3 PS1 = B.P;
				Vec3 PE1 = B.P2;

				B.P = mPos - mRight * 0.25f - mUp * 0.1f - mForward *0.1f;
				B.P2 = mPos - (mUp*(float)n) - mRight * 0.25f - mForward *0.1f;
				gpEng->mBeams.push_back(B);
				Vec3 PS2 = B.P;
				Vec3 PE2 = B.P2;

				//rebuild mins maxs
				POINTS[0] = mPos - mRight * 0.25f - mForward * 0.25f;
				POINTS[1] = mPos + mRight * 0.25f - mForward * 0.25f;
				POINTS[2] = mPos + mRight * 0.25f + mForward * 0.25f;
				POINTS[3] = mPos - mRight * 0.25f + mForward * 0.25f;

				POINTS[4] = B.P2 - mRight * 0.25f - mForward * 0.25f;
				POINTS[5] = B.P2 + mRight * 0.25f - mForward * 0.25f;
				POINTS[6] = B.P2 + mRight * 0.25f + mForward * 0.25f;
				POINTS[7] = B.P2 - mRight * 0.25f + mForward * 0.25f;
				for(int i=0; i<8; i++)
				{
					if(mMins.x > POINTS[i].x)
						mMins.x = POINTS[i].x;
					if(mMins.y > POINTS[i].y)
						mMins.y = POINTS[i].y;
					if(mMins.z > POINTS[i].z)
						mMins.z = POINTS[i].z;

					if(mMaxs.x < POINTS[i].x)
						mMaxs.x = POINTS[i].x;
					if(mMaxs.y < POINTS[i].y)
						mMaxs.y = POINTS[i].y;
					if(mMaxs.z < POINTS[i].z)
						mMaxs.z = POINTS[i].z;
				}

			}
		}
		if(!bLaserHit)
			gLog.OutPut("Laser didnt hit anything!\n");
	}
	else
	{
	}
	if(gpEng->mPlayer.mbTimeOut || gpEng->mPlayer.mbStageWon)
		return;
	iPulseTime++;

	mForward = ArbitraryRotate(mForward,DEG2RAD(5),mUp);
	mForward = ArbitraryRotate(mForward,DEG2RAD(0),mRight);
	mRight = ArbitraryRotate(mRight,DEG2RAD(5),mUp);
	mRight = ArbitraryRotate(mRight,DEG2RAD(0),mRight);
	mUp = ArbitraryRotate(mUp,DEG2RAD(5),mUp);
	mUp = ArbitraryRotate(mUp,DEG2RAD(0),mRight);

	if(!gpEng->mPlayer.bTeleport)
	if(!gpEng->mPlayer.mbLostBall) 
	if(IsToggled)
	if(!mpPlatform || mpPlatform->bVisible)
	if(gpEng->mPlayer.iDmgTime==0)
	if(gpEng->mPlayer.mPos.x >= mMins.x)
	if(gpEng->mPlayer.mPos.x <= mMaxs.x)
	if(gpEng->mPlayer.mPos.y >= mMins.y)
	if(gpEng->mPlayer.mPos.y <= mMaxs.y)
	if(gpEng->mPlayer.mPos.z >= mMins.z)
	if(gpEng->mPlayer.mPos.z <= mMaxs.z)
//	if(Distance(mPos, gpEng->mPlayer.mPos)<0.35)//this could be slow, should do a bounds check first
	{
		Vec3 dir = (mPos-gpEng->mPlayer.mPos);
		dir = Reflect(dir,mUp,0);
		gpEng->mPlayer.mJumpDir = Vec3((int)-gpEng->mPlayer.mMoveUp.x,(int)-gpEng->mPlayer.mMoveUp.y,(int)-gpEng->mPlayer.mMoveUp.z);
		if(Dot(gpEng->mPlayer.mMoveForward,dir)>0)
		{
			gpEng->mPlayer.mMove = -gpEng->mPlayer.mMoveForward * 0.05f;
		}
		else
		{
			gpEng->mPlayer.mMove = gpEng->mPlayer.mMoveForward * 0.05f;
		}

		if(gpEng->mPlayer.mpPlatform)
			gpEng->mPlayer.mpPlatform->mbPlayerIsRiding = false;

		if(gpEng->mPlayer.bJump)
			gpEng->mPlayer.bTurning = false;
		gpEng->mPlayer.mpPlatform = NULL;
		gpEng->mPlayer.bJump = true;
		gpEng->mPlayer.iJumpCounter = 0;
		gpEng->mPlayer.mGravity = gpEng->mPlayer.mMoveUp*0.15f;
		gpEng->mPlayer.mJumpVel = -gpEng->mPlayer.mMoveUp*0.15f;
		gpEng->mPlayer.mPos += gpEng->mPlayer.mJumpVel;
		gpEng->mPlayer.bMoving = true;
		gpEng->mPlayer.mMove = -dir * 0.15f;
		gpEng->mPlayer.iTurnCounter = 1;
		if(gpEng->mPlayer.iDmgTime==0)
			gpEng->mPlayer.TakeDamage();
		gpEng->mPlayer.bTurnCorner = false;
	}

	mMins = mPos - Vec3(0.25, 0.25, 0.25);
	mMaxs = mPos + Vec3(0.25, 0.25, 0.25);


	if(!gpEng->mPlayer.mbLostBall) 
	if(!mpPlatform || mpPlatform->bVisible)
	if(gpEng->mPlayer.mPos.x >= mMins.x)
	if(gpEng->mPlayer.mPos.x <= mMaxs.x)
	if(gpEng->mPlayer.mPos.y >= mMins.y)
	if(gpEng->mPlayer.mPos.y <= mMaxs.y)
	if(gpEng->mPlayer.mPos.z >= mMins.z)
	if(gpEng->mPlayer.mPos.z <= mMaxs.z)
	if(Distance(mPos, gpEng->mPlayer.mPos)<0.5)//this could be slow, should do a bounds check first
	{
		Vec3 dir = (mPos-gpEng->mPlayer.mPos);
		dir = Reflect(dir,mUp,0);
		gpEng->mPlayer.mJumpDir = Vec3((int)-gpEng->mPlayer.mMoveUp.x,(int)-gpEng->mPlayer.mMoveUp.y,(int)-gpEng->mPlayer.mMoveUp.z);
		if(Dot(gpEng->mPlayer.mMoveForward,dir)>0)
		{
			gpEng->mPlayer.mMove = -gpEng->mPlayer.mMoveForward * 0.05f;
		}
		else
		{
			gpEng->mPlayer.mMove = gpEng->mPlayer.mMoveForward * 0.05f;
		}

		if(gpEng->mPlayer.mpPlatform)
			gpEng->mPlayer.mpPlatform->mbPlayerIsRiding = false;

		if(gpEng->mPlayer.bJump)
			gpEng->mPlayer.bTurning = false;
		gpEng->mPlayer.mpPlatform = NULL;
		gpEng->mPlayer.bJump = true;
		gpEng->mPlayer.iJumpCounter = 0;
		gpEng->mPlayer.mGravity = gpEng->mPlayer.mMoveUp*0.15f;
		gpEng->mPlayer.mJumpVel = -gpEng->mPlayer.mMoveUp*0.15f;
		gpEng->mPlayer.mPos += gpEng->mPlayer.mJumpVel;
		gpEng->mPlayer.bMoving = true;
		gpEng->mPlayer.mMove = -dir * 0.15f;
		gpEng->mPlayer.iTurnCounter = 1;
		if(gpEng->mPlayer.iDmgTime==0)
			gpEng->mPlayer.TakeDamage();
		gpEng->mPlayer.bTurnCorner = false;
	}

}
void Laser::Trigger()
{
	IsToggled = !IsToggled;
}
void Laser::Render(const float interp, int pass)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
/*	glBegin(GL_LINES);
	glColor3f(1,0,0);
	glVertex3fv((p).v);
	glVertex3fv((p+u*0.5f).v);
//	glColor3f(0,1,0);
//	glVertex3fv((p-r*0.5f).v);
//	glVertex3fv((p+r*0.5f).v);
//	glColor3f(0,0,1);
//	glVertex3fv((p).v);
//	glVertex3fv((p+f*0.5f).v);
	glEnd();
//*/
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	float alpha = 1;
	if(mpPlatform)
		alpha = mpPlatform->iFadeTime>=0?UTIL_Misc::TimeRamp(0,1,0,100,mpPlatform->iFadeTime):0;
	glMultMatrixf(mat);
//	glRotatef(90,1,0,0);
	glScalef(0.15,0.15,0.15);

	glColor4f(1,1,1,alpha);
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
//	glDepthMask(GL_FALSE);
	


	gpEng->mObjects[MDL_LASER].RenderBuffer(true);
//*/

	glDisable(GL_LIGHTING);
//	gpEng->mShdrMgr.BindProgram(0);
	float C = (sin((float)iPulseTime*0.075f)+1)/2;
	glColor4f(mColor.x*alpha*C,mColor.y*alpha*C,mColor.z*alpha*C,alpha);
	UTIL_GL::SetBlend(GL_ONE, GL_ONE);
	gpEng->mObjects[MDL_LASER_GLOW].RenderBuffer(true);
	glColor4f(1,1,1,1);

	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);

	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);
	glEnable(GL_LIGHTING);
	glPopMatrix();
}
void Laser::RenderShadow(const float interp)
{
	return;
	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);

	Vec3 pos = p;
	for(int n=0; n<80; n++)
	{
		pos = p + u *((float)n/10.0f);
		if(gpEng->GetMapTile(pos))
		{
			Block* b= gpEng->GetMapTile(pos);
/*			float	X = u.x!=0?
				(u.x<0?(int)pos.x+0.75f:(int)pos.x+0.25f):pos.x;
			float	Y = u.y!=0?
				(u.y<0?(int)pos.y+0.75f:(int)pos.y+0.25f):pos.y;
			float	Z = u.z!=0?
				(u.z<0?(int)pos.z+0.75f:(int)pos.z+0.25f):pos.z;
*/
			float X = u.x!=0?
				(u.x<0?b->pos.x+0.25f:b->pos.x-0.25f):pos.x;
			float Y = u.y!=0?
				(u.y<0?b->pos.y+0.25f:b->pos.y-0.25f):pos.y;
			float Z = u.z!=0?
				(u.z<0?b->pos.z+0.25f:b->pos.z-0.25f):pos.z;

			pos = Vec3(X,Y,Z);//&/
			pos -= u * 0.27f;
			if(b->mbPlatform)
			{
				Vec3 shadOff = UTIL_Misc::Interpolate(b->pPlat->mPos, b->pPlat->mOPos, interp)-b->pPlat->mPos;
				shadOff = Reflect(shadOff,mRight,0);
				shadOff = Reflect(shadOff,mForward,0);
				pos += shadOff;
			}
			break;
		}
	}//*/
	glPushMatrix();
	glTranslatef(pos.x,pos.y,pos.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glScalef(0.15,0.15,0);
	glRotatef(90,1,0,0);

	gpEng->mObjects[MDL_BUTTON].RenderBuffer(false);
	glPopMatrix();
}
void Laser::RenderDepth(const float interp)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
//	glRotatef(90,1,0,0);
	glScalef(0.15,0.15,0.15);
	gpEng->mObjects[MDL_LASER].RenderBuffer(false);
//*/
	glPopMatrix();

}
Entity* Laser::Clone() const
{
	return new Laser(*this);
}
