#pragma once
#include "Vector.h"

struct ModelHeader_t
{
	int ident;
	int version;
	int skinWidth;
	int skinHeight;
	int framesize;
	int numSkins;
	int numVerts;
	int numST;
	int numTri;
	int numGLcmds;
	int numFrames;
	int offsetSkins;
	int offsetST;
	int offsetTris;
	int offsetFrames;
	int offsetGLcmds;
	int offsetEnd;
};

struct FramePoint_t
{
	unsigned char v[3];
	unsigned char normalIdx;
};

struct Frame_t
{
	float scale[3];
	float translate[3];
	char name[16];
	FramePoint_t fp[1];
};

struct stIndex_t
{
	short s;
	short t;
};

struct Mesh_t
{
	unsigned short meshIndex[3];
	unsigned short stIndex[3];
};



class MD2Model
{
private:
	int numFrames;
	int numVerts;
	int numTri;
	int numTex;
	int frameSize;
	int currentFrame;
	int nextFrame;
	float interpol;
	Mesh_t* triIndex;
	Vec3* surfNormals;
	Vec2* texCoords;
	Vec3* verts;
	Vec3* normals;
public:
	unsigned int imgID;

	MD2Model();
	~MD2Model();
	bool Load(char* modelFile, int W, int H, unsigned int ID);
	void Cleanup();
	void Animate(int startFrame, int endFrame, float percent);
	void RenderFrame(int keyFrame);

	void MakeDisplayList();
	void RenderStatic();//uses display list
	unsigned int iDisplayList;

};
