//#include "pfence.h"
#include "Main.h"
#include "Serializer.h"
//#include "vld.h"

extern bool bRecordDemo;
extern bool bPlayDemo;
extern bool bVideoDemo;
extern char szDemoName[32];
extern int samples;
extern bool bForceFallback;

extern int iWindowRes;
extern int DOF;
extern int FUR;
extern int SHADOW;
extern int SUPER_SAMPLING;
extern int SHOW_FPS;
extern int BLUR;
int LOGGING = 0;
bool bFirstPlay = true;


bool DEMO_BUILD = false;
int _tmain(int argc, _TCHAR* argv[])
{

	int width = 800;
	int height = 600;
	bool fScreen = true;

	CFileIO fIO;
	int FIRSTPLAY = bFirstPlay?1:0;
	if(fIO.GetFile("GameState.dat","rt"))
	{
		gSerializer.ReadVariable("GameState.dat","FIRSTPLAY",FIRSTPLAY);
		bFirstPlay = FIRSTPLAY?true:false;
	}
	else
	{
		gSerializer.PutComment("GameState.dat","Game State");
		FIRSTPLAY = bFirstPlay?1:0;
		gSerializer.ReadVariable("GameState.dat","FIRSTPLAY",FIRSTPLAY);
	}

	if(fIO.GetFile("Video.dat","rt"))
	{
		gSerializer.ReadVariable("Video.dat","RES",iWindowRes);
		gSerializer.ReadVariable("Video.dat","DOF",DOF);
		gSerializer.ReadVariable("Video.dat","FUR",FUR);
		gSerializer.ReadVariable("Video.dat","SHADOW",SHADOW);
		gSerializer.ReadVariable("Video.dat","SAMPLING",SUPER_SAMPLING);
		gSerializer.ReadVariable("Video.dat","FPS",SHOW_FPS);
		gSerializer.ReadVariable("Video.dat","BLUR",BLUR);
		samples = SUPER_SAMPLING;
		switch(iWindowRes)
		{
		case 0: width = 640; height = 480; fScreen = false; break;
		case 1: width = 800; height = 600; fScreen = false; break;
		case 2: width = 1024; height = 768; fScreen = false; break;
		case 3: width = 640; height = 480; fScreen = true; break;
		case 4: width = 800; height = 600; fScreen = true; break;
		case 5: width = 1024; height = 768; fScreen = true; break;
		}
	}

	for(int numArgs= 0; numArgs<argc; numArgs++)
	{
		if(!stricmp("-log",argv[numArgs]))
		{
			LOGGING = 1;
		}
		if(!stricmp("record",argv[numArgs]))
		{
			strcpy(szDemoName,argv[numArgs+1]);
			bRecordDemo = true;
			break;
		}
		if(!stricmp("demo",argv[numArgs]))
		{
			strcpy(szDemoName,argv[numArgs+1]);
			bPlayDemo = true;
			break;
		}
		if(!stricmp("video",argv[numArgs]))
		{
			strcpy(szDemoName,argv[numArgs+1]);
			bVideoDemo = true;
			bPlayDemo = true;
			break;
		}
		if(!stricmp("-window",argv[numArgs]))
		{
			fScreen = false;
		//	break;
		}
		if(!stricmp("-fscreen",argv[numArgs]))
		{
			fScreen = true;
		//	break;
		}
		if(!stricmp("-res",argv[numArgs]))
		{
			width = atoi(argv[numArgs+1]);
			height = atoi(argv[numArgs+2]);
			//break;
		}
		if(!stricmp("-aa",argv[numArgs]))
		{
			samples = atoi(argv[numArgs+1]);
			SUPER_SAMPLING = samples;
			//break;
		}
		if(!stricmp("-low",argv[numArgs]))
		{
			bForceFallback = true;
			//break;
		}

	}

//	Engine* gEng = new Engine(640,480,false);
	try{

	Engine* gEng = new Engine(width,height,fScreen);
	delete gEng;
	}
	catch(...)
	{
	}

//	pfence_checkmemtree();
	return 0;
}

