#pragma once
#include <map>
#include <list>
#include <string>
#include "Vector.h"

#define DEPTH_PASS -1
#define BASE_PASS 0
#define GLOW_PASS 1
#define BUMP_PASS 2

struct Material
{
	unsigned int ID;
	std::string name;
	int Shininess;
	float specular[4];
	float ambient[4];
	float diffuse[4];
	Vec2 scroll;
	float rotation;
	Vec3 pulseTarget;
	float fPulseTime;
	int iPulseType;
	std::map<unsigned int, std::list<unsigned int > > mPass;//key is pass, value is a list of texture ID's for multitexturing
	bool bSpheremap;
};

class MaterialManager
{
public:
	MaterialManager();
	void CleanUp();
	void FreeMaterial(Material* m);
	Material* LoadMaterial(char* dir, char* name);
	bool ParseMaterial(char* dir, char* name, Material* m);

	unsigned int iMatCounter;
	std::map<unsigned int, Material*> mIDMaterials;//find by ID
	void SetMaterialAttributes(Material* m, int pass, const float interp);
	void SetMaterialLightOnly(Material* m);
	std::map<std::string, Material*> mMaterials;
private:
};