#include "Engine.h"
#include "Menu.h"


void RenderPanel(int type, Vec2 p, float w, float h, Vec3 TopGrad, Vec3 LowGrad, float alpha, bool outline, Vec3 outcol)
{
	glPushMatrix();
	glTranslatef(p.x,p.y,0);
	Vec2 UV, UVS;
	UTIL_GL::BindTexture(GL_TEXTURE_2D, gpEng->mSprites[SPR_MENU].mImg);
	Vec3 color;
	UVS = gpEng->mSprites[SPR_MENU].mUVsize;
	float ramp = h*2;
	glBegin(GL_QUADS);
	//topleft corner
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(0);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 0);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-w,			-h);
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(-(w-32),		-h);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 32.0/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(-(w-32),		-(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f(-w,			-(h-32));
	//topright corner
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(2);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 0);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f((w-32),		-h);
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(w,			-h);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 32.0/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(w,			-(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f((w-32),		-(h-32));
	//bottomleft corner
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, (ramp-32.0)/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(32);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-w,			(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(-(w-32),		(h-32));
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 1);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(-(w-32),		h);
	glTexCoord2f(UV.x,		UV.y);							glVertex2f(-w,			h);
	//bottomright corner
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(34);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, (ramp-32.0)/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f((w-32),		(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(w,			(h-32));
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 1);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(w,			h);
	glTexCoord2f(UV.x,		UV.y);							glVertex2f((w-32),		h);
	//top Center
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(1);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 0);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-(w-32),		-h);
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f((w-32),		-h);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 32.0/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f((w-32),		-(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f(-(w-32),		-(h-32));
	//bottom center
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(33);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, (ramp-32.0)/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-(w-32),		(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f((w-32),		(h-32));
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 1);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f((w-32),		h);
	glTexCoord2f(UV.x,		UV.y);							glVertex2f(-(w-32),		h);
	//left Center
	if(type==0)
	{
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(8);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 32.0/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-w,			-(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(-(w-32),		-(h-32));
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, (ramp-32.0)/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(-(w-32),		(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f(-w,			(h-32));
	//Right Center
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(10);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 32.0/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f((w-32),		-(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(w,			-(h-32));
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, (ramp-32.0)/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(w,			(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f((w-32),		(h-32));
	//Center
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(9);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 32.0/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-(w-32),		-(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f((w-32),		-(h-32));
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, (ramp-32.0)/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f((w-32),		(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f(-(w-32),		(h-32));
	}
	if(type>=1)
	{
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(8);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 64.0/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-w,			-(h-64));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(-(w-32),		-(h-64));
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, (ramp-32.0)/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(-(w-32),		(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f(-w,			(h-32));
	//Right Center
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(10);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 64.0/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f((w-32),		-(h-64));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(w,			-(h-64));
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, (ramp-32.0)/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(w,			(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f((w-32),		(h-32));
	//Center
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(9);
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 64.0/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-(w-32),		-(h-64));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f((w-32),		-(h-64));
	color = UTIL_Misc::Interpolate(LowGrad, TopGrad, (ramp-32.0)/ramp);
	glColor4f(color.x, color.y, color.z, alpha);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f((w-32),		(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f(-(w-32),		(h-32));

		UV = gpEng->mSprites[SPR_MENU].GetTileUV(11);
		color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 32.0/ramp);
		glColor4f(color.x, color.y, color.z, alpha);
		glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-w,			-(h-32));
		glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(-(w-32),		-(h-32));
		color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 64.0/ramp);
		glColor4f(color.x, color.y, color.z, alpha);
		glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(-(w-32),		-(h-64));
		glTexCoord2f(UV.x,		UV.y);							glVertex2f(-w,			-(h-64));
		//Right Center
		UV = gpEng->mSprites[SPR_MENU].GetTileUV(13);
		color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 32.0/ramp);
		glColor4f(color.x, color.y, color.z, alpha);
		glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f((w-32),		-(h-32));
		glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(w,			-(h-32));
		color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 64.0/ramp);
		glColor4f(color.x, color.y, color.z, alpha);
		glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(w,			-(h-64));
		glTexCoord2f(UV.x,		UV.y);							glVertex2f((w-32),		-(h-64));

		UV = gpEng->mSprites[SPR_MENU].GetTileUV(12);
		color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 32.0/ramp);
		glColor4f(color.x, color.y, color.z, alpha);
		glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-(w-32),		-(h-32));
		glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f((w-32),		-(h-32));
		color = UTIL_Misc::Interpolate(LowGrad, TopGrad, 64.0/ramp);
		glColor4f(color.x, color.y, color.z, alpha);
		glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f((w-32),		-(h-64));
		glTexCoord2f(UV.x,		UV.y);							glVertex2f(-(w-32),		-(h-64));
	}
	//outline***********************************************************
	//topleft corner
	if(outline)
	{
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(40);
	glColor4f(outcol.x, outcol.y, outcol.z, alpha);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-w,			-h);
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(-(w-32),		-h);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(-(w-32),		-(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f(-w,			-(h-32));
	//topright corner
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(42);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f((w-32),		-h);
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(w,			-h);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(w,			-(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f((w-32),		-(h-32));
	//bottomleft corner
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(56);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-w,			(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(-(w-32),		(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(-(w-32),		h);
	glTexCoord2f(UV.x,		UV.y);							glVertex2f(-w,			h);
	//bottomright corner
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(58);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f((w-32),		(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(w,			(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(w,			h);
	glTexCoord2f(UV.x,		UV.y);							glVertex2f((w-32),		h);
	//top Center
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(41);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-(w-32),		-h);
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f((w-32),		-h);
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f((w-32),		-(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f(-(w-32),		-(h-32));
	//bottom center
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(57);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-(w-32),		(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f((w-32),		(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f((w-32),		h);
	glTexCoord2f(UV.x,		UV.y);							glVertex2f(-(w-32),		h);
	//left Center
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(48);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f(-w,			-(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(-(w-32),		-(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(-(w-32),		(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f(-w,			(h-32));
	//Right Center
	UV = gpEng->mSprites[SPR_MENU].GetTileUV(50);
	glTexCoord2f(UV.x,		UV.y+UVS.y);					glVertex2f((w-32),		-(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);					glVertex2f(w,			-(h-32));
	glTexCoord2f(UV.x+UVS.x,UV.y);							glVertex2f(w,			(h-32));
	glTexCoord2f(UV.x,		UV.y);							glVertex2f((w-32),		(h-32));
	}
	glEnd();
	glPopMatrix();
	glDisable(GL_TEXTURE_2D);
}

bool PruneMenus(Menu* m)
{
//_ASSERTE( _CrtCheckMemory( ) );
	if(m->bFadingOut && m->iFadeTime <=0)
	{
		delete m;
		m = NULL;
//_ASSERTE( _CrtCheckMemory( ) );
		return true;
	}
//_ASSERTE( _CrtCheckMemory( ) );
	return false;
}
bool CleanupMenus(Menu* m)
{
//_ASSERTE( _CrtCheckMemory( ) );
	delete m;
	m = NULL;
//_ASSERTE( _CrtCheckMemory( ) );
	return true;
}

/****************************/
/*	generic menu implementation	*/
/****************************/
void Menu::GenericAttributes(Vec2 p, int fadein)
{
	mPos = p;
	bFadingIn = true;
	iFadeDuration = iFadeTime = fadein;
	bFadingOut = false;
	iOption = 0;
	iFlashTime = 0;
	mParent = NULL;
}
void Menu::DoFade()
{
//_ASSERTE( _CrtCheckMemory( ) );
	iFadeTime--;
	if(iFadeTime<=0)
	{
//_ASSERTE( _CrtCheckMemory( ) );
		if(bFadingOut)
			DoOnClose();
		if(bFadingIn)
			bFadingIn = false;
//_ASSERTE( _CrtCheckMemory( ) );
	}
	//flashing
	iFlashTime++;
	if(iFlashTime>=40)
		iFlashTime = 0;
//_ASSERTE( _CrtCheckMemory( ) );
}
void Menu::Close(int time)
{
	bFadingOut = true;
	iFadeDuration = iFadeTime = time;
}
void Menu::DoOnClose()//stub
{
}
void Menu::CallBack(int code)//stub
{
};
/****************************/
/*	Load slot menu			*/
/****************************/
void SlotMenu::Spawn(Vec2 p) 
{
	GenericAttributes(p,50);
	miSlot = 0;
	iSelection = 0;
	for(int n=0; n<3; n++)
	{
		LoadSaveSlot(n);
		SlotBall[n].vBallRotation = SlotBall[n].vOBallRotation = Vec2(0,0);
	}
}
void SlotMenu::Update()
{
	for(int n=0; n<3; n++)
	if(bSlot[n])
	{
		SlotBall[n].vOBallRotation = SlotBall[n].vBallRotation;
		SlotBall[n].vBallRotation += Vec2(TIME_STEP, TIME_STEP * 1.5f)*50;
	}

	DoFade();
	if(bFadingOut || bFadingIn)
		return;



	if(iOption == 0)
	{
		if(gpEng->KEY_TURN_RIGHT.state == JUST_PRESSED)
		{
			if(miSlot<2)
				PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);
			miSlot++;
			if(miSlot>2)
				miSlot = 2;
		}
		if(gpEng->KEY_TURN_LEFT.state == JUST_PRESSED)
		{
			if(miSlot>0)
				PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);
			miSlot--;
			if(miSlot<0)
				miSlot = 0;
		}
	}
	if(gpEng->KEY_JUMP.state == JUST_PRESSED)
	{
		switch(iOption)
		{
		case 0: iOption = 1; iSelection = 0; PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false); break;
		case 1:
			if(!bSlot[miSlot])
			{
				PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
				iClosingCode = SLOT_NEWGAME;
				SureMenu* menu = new SureMenu;
				menu->Spawn(Vec2(320,240));
				strcpy(menu->szMessage,"ARE YOU SURE YOU WANT TO START A NEW GAME?");
				menu->mParent = this;
				gpEng->mMenus.push_back(menu);
				for(int n=0; n<3; n++)
				if(bSlot[n])
					SlotBall[n].vOBallRotation = SlotBall[n].vBallRotation;

			}
			else
			{
				if(iSelection==0)//load
				{
					PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
					iClosingCode = SLOT_CONTINUEGAME;
					SureMenu* menu = new SureMenu;
					menu->Spawn(Vec2(320,240));
					strcpy(menu->szMessage,"ARE YOU SURE YOU WANT TO CONTINUE THIS GAME?");
					menu->mParent = this;
					gpEng->mMenus.push_back(menu);
					for(int n=0; n<3; n++)
					if(bSlot[n])
						SlotBall[n].vOBallRotation = SlotBall[n].vBallRotation;
				}
				else if(iSelection ==1)//delete save file
				{
					PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
					iClosingCode = SLOT_DELETEGAME;
					SureMenu* menu = new SureMenu;
					menu->Spawn(Vec2(320,240));
					strcpy(menu->szMessage,"ARE YOU SURE YOU WANT TO DELETE THIS GAME?");
					menu->mParent = this;
					gpEng->mMenus.push_back(menu);
					for(int n=0; n<3; n++)
					if(bSlot[n])
						SlotBall[n].vOBallRotation = SlotBall[n].vBallRotation;
				}
			}
			return;
		}

	}
	if(iOption == 1)
	{
		if(bSlot[miSlot])
		{
			if(gpEng->KEY_FORWARD.state == JUST_PRESSED)
			{
				if(iSelection>0)
					PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);
				iSelection--;
				if(iSelection<=0)
					iSelection = 0;
			}
			if(gpEng->KEY_BACK.state == JUST_PRESSED)
			{
				if(iSelection<1)
				PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);
				//gLog.OutPut("moved down\n");
				iSelection++;
				if(iSelection>=1)
					iSelection = 1;
			}
		}
	}
	if(gpEng->KEY_ACTION2.state == JUST_PRESSED)
	{
		if(iOption>0)
			PlaySample(CHNL_UI_BACKUP,gpEng->mSnd[SND_UI_BACKUP],false);
		iOption--;
		if(iOption < 0)
		{
			iOption = 0;
			Close(124);
			iClosingCode = -10;

			BindFBO(gpEng->mFadeFBO,1);
			glClearColor(0,0,0,0);
			glClear(GL_COLOR_BUFFER_BIT);
			UnBindFBO();
			FADE_StarOut* FS = new FADE_StarOut;
			FS->Spawn(1,Vec3(1,1,1));
			gpEng->mFadeEng.InsertSystem(FS);//*/
			gpEng->ChangeState(STATE_SPLASH,125,&CALLBACK_StartSplash);
			MasterMusicFadeout(300);
		}
	}


}

void SlotMenu::DoOnClose()
{
	switch(iClosingCode)
	{
	case SLOT_NEWGAME:
		{
/*			NameMenu* menu = new NameMenu;
			menu->Spawn(Vec2(320,240));
			gpEng->mMenus.push_back(menu);
			strcpy(gpEng->szPlayerName,"_______");*/
			gpEng->miSaveGameSlot = miSlot;
			gpEng->miLives = 5;
			gpEng->iTimePlayed = 0;
			gpEng->miStarCount = 0;
			gpEng->miGemCount = 0;
			gpEng->miOWorld = 0;//TODO: this is here just to test the new worlds was miWorld = 0
			gpEng->iBonusStage = 0;//TODO anything above 0 to test bonus stage
			gpEng->iPreservedBonusStage = 0;
			gpEng->miScore = 0;
			gpEng->miPreservedScore = 0;
			LoadingMenu* lodmenu = new LoadingMenu;
			lodmenu->Spawn(Vec2(320,240));
			lodmenu->iLoadType = 1;
			gpEng->mMenus.push_back(lodmenu);

			//**END**/
			for(int n=0; n<15; n++)
			{
				gpEng->miStagePersistance[n].clear();
				gpEng->mbStageSelect[n] = false;
			}
			gpEng->miCurrentPersistance.clear();

		}
		break;
	case SLOT_CONTINUEGAME:
		{
			for(int n=0; n<15; n++)
			{
				gpEng->miStagePersistance[n].clear();
				gpEng->mbStageSelect[n] = false;
			}
			strcpy(gpEng->szPlayerName, szSlot[miSlot]);
			gpEng->miSaveGameSlot = miSlot;
			gpEng->mPlayerType = SlotBall[miSlot];
			gpEng->iPlayerStickerType = iStickerType[miSlot];
			gpEng->miLives = iSlotLives[miSlot];
			gpEng->iTimePlayed = iSlotTime[miSlot];
			gpEng->miStarCount = iSlotStars[miSlot];
			gpEng->miGemCount = iSlotGems[miSlot];
			gpEng->miOWorld = iSlotWorld[miSlot];
			gpEng->miPlayerBallIdx = iSlotBallType[miSlot];
			gpEng->iBonusStage = iSlotBonus[miSlot];
			gpEng->iPreservedBonusStage = iPreservedSlotBonus[miSlot];
			gpEng->miScore = iSlotScore[miSlot];
			gpEng->miPreservedScore = iPreservedSlotScore[miSlot];
			gpEng->miSelectedStageBall = 0;
			
			LoadingMenu* menu = new LoadingMenu;
			menu->Spawn(Vec2(320,240));
			menu->iLoadType = 0;
			gpEng->mMenus.push_back(menu);
		}
		break;
	}
}
void SlotMenu::Render(const float interp)
{
	float flash = 1;
	flash = iFlashTime>19?
		UTIL_Misc::Interpolate(1,0,(float)(iFlashTime-20)/20.0f):
		UTIL_Misc::Interpolate(0,1,(float)iFlashTime/20.0f);

	fAlpha = 1;
	if(bFadingOut)
		fAlpha = UTIL_Misc::Interpolate(0,1,  ((float)iFadeDuration-(float)iFadeTime) / (float)iFadeDuration);
	else if(bFadingIn)
		fAlpha = UTIL_Misc::Interpolate(1,0,  ((float)iFadeDuration-(float)iFadeTime) / (float)iFadeDuration);
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);


	glDisable(GL_TEXTURE_2D);
	RenderPanel(1,Vec2(120,230) , 100,125, miSlot==0?Vec3(0,0.5f,1):Vec3(0,0.2f,0.7f), miSlot==0?Vec3(0, 0, 0.5f):Vec3(0, 0, 0.2f), fAlpha,miSlot==0?true:false, Vec3(1,1,0));
	RenderPanel(1,Vec2(320,230) , 100,125, miSlot==1?Vec3(0,0.5f,1):Vec3(0,0.2f,0.7f), miSlot==1?Vec3(0, 0, 0.5f):Vec3(0, 0, 0.2f), fAlpha,miSlot==1?true:false, Vec3(1,1,0));
	RenderPanel(1,Vec2(520,230) , 100,125, miSlot==2?Vec3(0,0.5f,1):Vec3(0,0.2f,0.7f), miSlot==2?Vec3(0, 0, 0.5f):Vec3(0, 0, 0.2f), fAlpha,miSlot==2?true:false, Vec3(1,1,0));

	RenderPanel(0,Vec2(320,420) , 210,60,Vec3(0,0.5f,1), Vec3(0, 0, 0.5f), fAlpha, true, Vec3(1,1,0));
	RenderPanel(0,Vec2(320,60) , 210,40,Vec3(0,0.5f,1), Vec3(0, 0, 0.5f), fAlpha, true, Vec3(1,1,0));

	for(int n=0; n<3; n++)
	{
		Vec2 p(120+(n*200),220);
		if(bSlot[n])
		{
			miSlot == n?
				glColor4f(1,1,1,fAlpha):
				glColor4f(1,1,1,fAlpha*0.75f);
			UTIL_GL::BindTexture(GL_TEXTURE_2D, gpEng->MenuImgs[GFXMENU_WORLD1+iSlotWorld[n]]);
			glBegin(GL_QUADS);
			glTexCoord2f(0,1);	glVertex2f(p.x-84,p.y-75);
			glTexCoord2f(1,1);	glVertex2f(p.x+84,p.y-75);
			glTexCoord2f(1,0);	glVertex2f(p.x+84,p.y+75);
			glTexCoord2f(0,0);	glVertex2f(p.x-84,p.y+75);
			glEnd();
		}
	}
	glDisable(GL_BLEND);

	gpEng->mFont1.EnableShadow();
	gpEng->mFont1.SetColor(1,1,1,fAlpha);
	gpEng->mFont1.SetScale(0.75f,0.75f);
	gpEng->mFont1.SetAlignment(ALIGN_CENTER);
	gpEng->mFont1.Print("SAVE DATA SELECTION",320,45);
	gpEng->mFont1.SetScale(0.5f,0.5f);

	for(int n=0; n<3; n++)
	{
		float px;
		switch(n)
		{		case 0: px = 120; break; case 1: px = 320; break; case 2: px = 520; break;		}

		gpEng->mFont1.SetAlignment(ALIGN_CENTER);
		gpEng->mFont1.SetColor(1,1,1,fAlpha);
		if(!bSlot[n])
		{
			gpEng->mFont1.SetScale(0.5f,0.5f);
			gpEng->mFont1.Print("EMPTY",px,125);
			gpEng->mFont1.SetAlignment(ALIGN_LEFT);
			gpEng->mFont1.SetColor(1,1,1,fAlpha);
			if(miSlot == n && iOption == 1 && iSelection ==0)
				gpEng->mFont1.SetColor(1,flash,0,fAlpha);
			gpEng->mFont1.Print("NEW GAME",px-75,310);
		}
		else
		{
			gpEng->mFont1.SetScale(0.5f,0.5f);
			gpEng->mFont1.Print(szSlot[n],px,125);
			gpEng->mFont1.SetScale(0.375f,0.375f);
			gpEng->mFont1.SetAlignment(ALIGN_LEFT);
			char szData[64];
			sprintf(szData,"WORLD %i",iSlotWorld[n]+1);
			gpEng->mFont1.Print(szData,px-75,230);
			sprintf(szData,"LIVES %i",iSlotLives[n]);
			gpEng->mFont1.Print(szData,px-75,240);
			sprintf(szData,"STARS %i",iSlotStars[n]);
			gpEng->mFont1.Print(szData,px-75,250);
			sprintf(szData,"GEMS %i",iSlotGems[n]);
			gpEng->mFont1.Print(szData,px-75,260);
			int iHrs,iMins,iSecs;
			UTIL_Misc::ConvertSecondsToHrsMinsSecs(iSlotTime[n]/60,iHrs,iMins,iSecs);
			sprintf(szData,"TIME %i:%.2i:%.2i",iHrs,iMins,iSecs);
			gpEng->mFont1.Print(szData,px-75,270);
			sprintf(szData,"SCORE %i",iSlotScore[n]);
			gpEng->mFont1.Print(szData,px-75,280);

			gpEng->mFont1.SetScale(0.5f,0.5f);
			gpEng->mFont1.SetColor(1,1,1,fAlpha);
			if(miSlot == n && iOption == 1 && iSelection ==0)
				gpEng->mFont1.SetColor(1,flash,0,fAlpha);
			gpEng->mFont1.Print("LOAD GAME",px-75,300);
			gpEng->mFont1.SetColor(1,1,1,fAlpha);
			if(miSlot == n && iOption == 1 && iSelection ==1)
				gpEng->mFont1.SetColor(1,flash,0,fAlpha);
			gpEng->mFont1.Print("DELETE GAME",px-75,315);
		}
	}

	gpEng->mFont1.SetAlignment(ALIGN_CENTER);
	gpEng->mFont1.SetColor(1,1,1,fAlpha);
	gpEng->mFont1.SetScale(0.5f,0.5f);
	if(iOption == 0)
		gpEng->mFont1.Print("SELECT A SAVE SLOT",320,410);
	if(iOption == 1 && !bSlot[miSlot] && iSelection == 0)
		gpEng->mFont1.Print("START NEW GAME FROM BEGINNING",320,410);
	if(iOption == 1 && bSlot[miSlot] && iSelection == 0)
		gpEng->mFont1.PrintClipped("CONTINUE PLAYING FROM A PREVIOUS GAME",320,410,300);
	if(iOption == 1 && bSlot[miSlot] && iSelection == 1)
		gpEng->mFont1.Print("DELETE A SAVE GAME",320,410);


	//render ball model
	for(int n=0; n<3; n++)
	{
		if(!bSlot[n])
			continue;

		glClear(GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
		UTIL_GL::GL3D::SetPerspective(45,1.3f,0.1f,20);
		glEnable(GL_DEPTH_TEST);
		glDepthMask(GL_FALSE);
		glDepthFunc(GL_LEQUAL);
		gluLookAt(0,-1.5f,0, 0,0,5, 0,-1,0);

		GLfloat tempMatrix[16];
		glGetFloatv(GL_MODELVIEW_MATRIX,tempMatrix);
		Vec3 camRight = Vec3(tempMatrix[0],tempMatrix[4],tempMatrix[8]);
		Vec3 camUp = Vec3(tempMatrix[1],tempMatrix[5],tempMatrix[9]);
		Vec3 camFwd = Vec3(tempMatrix[2],tempMatrix[6],tempMatrix[10]);
		glDisable(GL_CULL_FACE);

		glEnable(GL_LIGHTING);
		glEnable(GL_LIGHT0);
		Vec3 lp = Vec3(0,0,0) + camUp * 1 + camRight*5;
	//	float LightPos[4]={-500,-1000.1f,500,1};
		float LightPos[4]={lp.x,lp.y,lp.z,0};
		float LightDir[4]={-camUp.x,-camUp.y,-camUp.z,0};
		float amb[4]={0.15f,0.15f,0.15f,1};
		float dif[4]={0.4f,0.4f,0.4f,1};
		float gldif[4]={0.7f,0.7f,0.7f,1};
		float glamb[4]={0.95f,0.95f,0.95f,1};
		float spec[4]={1,1,1,0};
		float blk[4]={0,0,0,1};
		glShadeModel(GL_SMOOTH);
	//	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
		glLightModelfv(GL_LIGHT_MODEL_AMBIENT, amb);
		glEnable(GL_LIGHTING);
		glEnable(GL_LIGHT0);
		glLightfv(GL_LIGHT0,  GL_POSITION, LightPos);
		glLightfv(GL_LIGHT0,  GL_SPOT_DIRECTION, LightDir);
		glLightfv(GL_LIGHT0,  GL_AMBIENT, dif);
		glLightfv(GL_LIGHT0,  GL_DIFFUSE, gldif);
		glLightfv(GL_LIGHT0,  GL_SPECULAR, glamb);
		glEnable(GL_COLOR_MATERIAL);
		//glColorMaterial(GL_FRONT, GL_AMBIENT);
		//glColorMaterial(GL_FRONT, GL_DIFFUSE);
		glMaterialfv(GL_FRONT, GL_AMBIENT, dif);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, glamb);
		glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
		glMateriali(GL_FRONT, GL_SHININESS, 100);


		Vec2 mins(0,0), maxs(1,1);
	//	gpEng->mShdrMgr.BindProgram(gpEng->mShdrPPDirLight);
		gpEng->mShdrMgr.BindProgram(gpEng->mShdrPBallLight);
		GLint AtLocmins = gpEng->mShdrMgr.GetAttribLocation("inmins");
		GLint AtLocmaxs = gpEng->mShdrMgr.GetAttribLocation("inmaxs");
	//	gpEng->mShdrMgr.PassUniform3fv("up",1,camUp.v);
		gpEng->mShdrMgr.PassAttrib2fv(AtLocmins, mins.v);
		gpEng->mShdrMgr.PassAttrib2fv(AtLocmaxs, maxs.v);

		glEnable(GL_CULL_FACE);
		glCullFace(GL_BACK);
		for(int k=0; k<2; k++)
		{
			if(k==0)
				glMaterialfv(GL_FRONT, GL_SPECULAR, blk);
			else
				glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
		glPushMatrix();
		glTranslatef(0,2,16);
	
		switch(n)
		{
		case 0: glTranslatef(-5.5f,0,0); break;
		case 2: glTranslatef(5.5f,0,0); break;
		}
		Vec2 ballRot = UTIL_Misc::Interpolate(SlotBall[n].vBallRotation,SlotBall[n].vOBallRotation,interp);
		glRotatef(ballRot.x, 1,0,0);
		glRotatef(ballRot.y, 0,1,0);

		gpEng->mMatMgr.SetMaterialAttributes(gpEng->mObjects[MDL_SPHERE].mMaterials[gpEng->mObjects[MDL_SPHERE].mFaces.front().mattID].pMat,BASE_PASS,0);
		for(int j=0;j<(int)SlotBall[n].iLayers.size();j++)
		{
			if(j>0)
			{
				UTIL_GL::SetBlend(GL_ONE, GL_ONE);
				miSlot == n?
					glColor3fv((BallColors[SlotBall[n].iColLayers[j]]).v):
				glColor3fv((BallColors[SlotBall[n].iColLayers[j]]*0.5f).v);
			}
			else
			{
				float col[4];
				glDisable(GL_BLEND);
				miSlot == n?
					glColor3fv((BallColors[SlotBall[n].iColLayers[j]]).v):
				glColor3fv((BallColors[SlotBall[n].iColLayers[j]]*0.5f).v);
			}
			if(k==0)
			{
				glColor3f(0,0,0);
				glPushMatrix();
				glScalef(1.075f,1.075f,1.075f);
			//	glDepthMask(GL_FALSE);
			}
			//gpEng->mShdrMgr.PassSampler2D("bumpMap",1,gpEng->mMaterials[MAT_FLAT]->mPass[BUMP_PASS].front());
			gpEng->mShdrMgr.PassSampler2D("tex",0,SlotBall[n].iLayers[j]);
			gpEng->mObjects[SlotBall[n].iMdlType].RenderBuffer(false);
			if(k==0)
			{
				glPopMatrix();
			//	glDepthMask(GL_TRUE);
			}
		}
		if(iStickerType[n]>=0)
		{
			UTIL_GL::SetBlend(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
			glColor4f(1,1,1,1);
			gpEng->mShdrMgr.PassSampler2D("tex",0,gpEng->mStickers[iStickerType[n]]);
			gpEng->mObjects[MDL_STICKER].RenderBuffer(false);
			glDisable(GL_BLEND);
		}

		glPopMatrix();
		}
		glDisable(GL_CULL_FACE);

		gpEng->mShdrMgr.BindProgram(0);
	}
		glDisable(GL_COLOR_MATERIAL);
		glDisable(GL_LIGHTING);
		glDisable(GL_LIGHT0);
		glActiveTexture(GL_TEXTURE1);
		glDisable(GL_TEXTURE_2D);
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_2D);
		glDisable(GL_BLEND);
		glDisable(GL_CULL_FACE);
		glDepthMask(GL_TRUE);
	UTIL_GL::GL2D::SetOrtho(640,480);
}

bool SlotMenu::LoadSaveSlot(int slot)
{
//_ASSERTE( _CrtCheckMemory( ) );
	CFileIO fIO;
	char szFile[256];
	sprintf(szFile,"Loading Game Slot: %i\n",slot);
	gLog.OutPut(szFile);

	sprintf(szFile,"Data/Slots/Slot%i.slt",slot);

	if(!fIO.GetFile(szFile,"rb"))
	{
		bSlot[slot] = false;
		return false;//doesnt exit - no slot created
	}	
	bSlot[slot] = true;

	if(!fIO.ReadBinary(&szSlot[slot]))
		return false;
	if(!fIO.ReadBinary(&iSlotWorld[slot]))
		return false;
	if(!fIO.ReadBinary(&iSlotStars[slot]))
		return false;
	if(!fIO.ReadBinary(&iSlotGems[slot]))
		return false;
	if(!fIO.ReadBinary(&iSlotLives[slot]))
		return false;
	if(!fIO.ReadBinary(&iSlotTime[slot]))
		return false;
	if(!fIO.ReadBinary(&iSlotBallType[slot]))
		return false;

	SlotBall[slot] = gpEng->mBallTypes[iSlotBallType[slot]];
	SlotBall[slot].iColLayers.clear();
	int numLayers = 0;
	if(!fIO.ReadBinary(&numLayers))
		return false;
	for(int n=0; n<numLayers; n++)
	{
		int color;
		if(!fIO.ReadBinary(&color))
			return false;
		SlotBall[slot].iColLayers.push_back(color);
	}
	if(!fIO.ReadBinary(&iSlotBonus[slot]))
		return false;
	if(!fIO.ReadBinary(&iPreservedSlotBonus[slot]))
		return false;
	if(!fIO.ReadBinary(&iStickerType[slot]))
		return false;
	if(!fIO.ReadBinary(&iSlotScore[slot]))
		return false;
	if(!fIO.ReadBinary(&iPreservedSlotScore[slot]))
		return false;

//_ASSERTE( _CrtCheckMemory( ) );
	return true;
}
void SlotMenu::CallBack(int code)
{
	if(code == MENU_ACCEPT)
	{
		if(iClosingCode == SLOT_NEWGAME)
		{
			PlaySample(CHNL_UI_SELECT,gpEng->mSnd[SND_UI_SELECT],false);
			Close(50);
		}
		 if(iClosingCode == SLOT_DELETEGAME)
		{
			PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
			char szFile[256];
			sprintf(szFile,"Data/Slots/Slot%i.slt",miSlot);
			DeleteFile(szFile);
			for(int n=0; n<5;n++)//delete all persistance data for every world
			{
				sprintf(szFile,"Data/Slots/World%iSlot%i.slt",n,miSlot);
				DeleteFile(szFile);
			}
			bSlot[miSlot] = false;
			iOption = 0;
		}
		if(iClosingCode == SLOT_CONTINUEGAME)
		{
			PlaySample(CHNL_UI_SELECT,gpEng->mSnd[SND_UI_SELECT],false);
			for(int n=0; n<15; n++)
			{
				gpEng->miStagePersistance[n].clear();
				gpEng->mbStageSelect[n] = false;
			}
			strcpy(gpEng->szPlayerName, szSlot[miSlot]);
			gpEng->miSaveGameSlot = miSlot;
			gpEng->mPlayerType = SlotBall[miSlot];
			gpEng->iPlayerStickerType = iStickerType[miSlot];
			gpEng->miLives = iSlotLives[miSlot];
			gpEng->iTimePlayed = iSlotTime[miSlot];
			gpEng->miStarCount = iSlotStars[miSlot];
			gpEng->miGemCount = iSlotGems[miSlot];
			gpEng->miOWorld = iSlotWorld[miSlot];
			gpEng->miPlayerBallIdx = iSlotBallType[miSlot];
			gpEng->iBonusStage = iSlotBonus[miSlot];
			gpEng->iPreservedBonusStage = iPreservedSlotBonus[miSlot];
			gpEng->miScore = iSlotScore[miSlot];
			gpEng->miPreservedScore = iPreservedSlotScore[miSlot];
			gpEng->miSelectedStageBall = 0;

			LoadingMenu* menu = new LoadingMenu;
			menu->Spawn(Vec2(320,240));
			gpEng->mMenus.push_back(menu);
			Close(1);
		}
	}
}

/****************************/
/*	name entry menu			*/
/****************************/
int giLastNameIdx;
void NameMenu::Spawn(Vec2 p) 
{
	GenericAttributes(p,50);
	strcpy(Table, "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ!<>?*()-+=[]@#~:;,./");
	iXIdx = iYIdx = iNameIdx = 0;
}
void NameMenu::Update()
{
	DoFade();
	if(bFadingOut || bFadingIn)
		return;


	if(gpEng->KEY_ACTION2.state == JUST_PRESSED && gpEng->mFadeEng.mSystems.empty())
	{
		iClosingCode = NAME_CANCEL;
		SureMenu* menu = new SureMenu;
		menu->Spawn(Vec2(320,240));
		strcpy(menu->szMessage,"ARE YOU SURE YOU WANT TO GO BACK?");
		menu->mParent = this;
		gpEng->mMenus.push_back(menu);
	}
	if(gpEng->KEY_JUMP.state == JUST_PRESSED)
	{
		int idx;
		if(iYIdx<4)
			idx = iYIdx*10;
		else idx = (iYIdx*10)-4;
		idx += iXIdx;

		if(iXIdx<0)
		{
			switch(iYIdx)
			{
			case 0:
				if(iNameIdx>=7)iNameIdx = 7;
				if(iNameIdx==0)iNameIdx = 1;
				gpEng->szPlayerName[--iNameIdx] = '_'; if(iNameIdx<0)iNameIdx = 0; 
				break;//backspace
			case 1:
				if(iNameIdx<7)
				{
					gpEng->szPlayerName[iNameIdx] = ' ';
					iNameIdx++;
				}  break;//space
			case 2:
				{
					for(int k=iNameIdx;k<7;k++)
						gpEng->szPlayerName[k] = '\0';
					iClosingCode = NAME_DONE;
					SureMenu* menu = new SureMenu;
					menu->Spawn(Vec2(320,240));
					menu->mParent = this;
					strcpy(menu->szMessage,"ARE YOU SURE YOU WANT TO USE THIS NAME?");
					gpEng->mMenus.push_back(menu);
				}
				break;
			}
			return;
		}
		if(iNameIdx<7)
		{
			gpEng->szPlayerName[iNameIdx] = Table[idx];
			iNameIdx++;
		}
	}
	if(gpEng->KEY_TURN_RIGHT.state == JUST_PRESSED)
	{
		iXIdx++;
		if(iXIdx>9)
			iXIdx=9;
		if(iYIdx==3)
			if(iXIdx>5)
				iXIdx = 5;
	}
	if(gpEng->KEY_TURN_LEFT.state == JUST_PRESSED)
	{
		if(iXIdx==0)
			iYIdx = 0;
		iXIdx--;
		if(iXIdx<-1)
			iXIdx = -1;

	}
	if(gpEng->KEY_FORWARD.state == JUST_PRESSED)
	{
		iYIdx--;
		if(iYIdx<0)
			iYIdx =0;
		if(iYIdx==3)
			if(iXIdx>5)
				iXIdx = 5;
	}
	if(gpEng->KEY_BACK.state == JUST_PRESSED)
	{
		iYIdx++;
		if(iYIdx>5)
			iYIdx = 5;
		if(iYIdx==3)
			if(iXIdx>5)
				iXIdx = 5;
		if(iXIdx<0)
			if(iYIdx>2)
				iYIdx = 2;
	}
}

void NameMenu::DoOnClose()
{
	switch(iClosingCode)
	{
	case NAME_CANCEL:
		{
			SlotMenu* menu = new SlotMenu;
			menu->Spawn(Vec2(320,240));
			gpEng->mMenus.push_back(menu);
		}
		break;
	case NAME_DONE:
		{

		}
		break;
	}
}
void NameMenu::CallBack(int code)
{
	if(code == MENU_ACCEPT)
	{
		if(iClosingCode == NAME_DONE)
		{
			Close(1);
			giLastNameIdx = iNameIdx;

			gpEng->RenderSceneToFadeBuffer();

			gpEng->ChangeState(STATE_DESIGN,0);
			gpEng->StartDesigner();
		}
		else if(iClosingCode == NAME_CANCEL)
		{
			Close(50);
		}
	}
}
void NameMenu::Render(const float interp)
{
	float flash = 1;
	flash = iFlashTime>19?
		UTIL_Misc::Interpolate(1,0,(float)(iFlashTime-20)/20.0f):
		UTIL_Misc::Interpolate(0,1,(float)iFlashTime/20.0f);

	fAlpha = 1;
	if(bFadingOut)
		fAlpha = UTIL_Misc::Interpolate(0,1,  ((float)iFadeDuration-(float)iFadeTime) / (float)iFadeDuration);
	else if(bFadingIn)
		fAlpha = UTIL_Misc::Interpolate(1,0,  ((float)iFadeDuration-(float)iFadeTime) / (float)iFadeDuration);

	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	RenderPanel(0,Vec2(320,260) , 300,110, Vec3(0,0.2f,0.7f),Vec3(0, 0, 0.2f), fAlpha,true, Vec3(1,1,0));

	RenderPanel(0,Vec2(320,60) , 210,40,Vec3(0,0.5f,1), Vec3(0, 0, 0.5f), fAlpha, true, Vec3(1,1,0));
	RenderPanel(0,Vec2(320,420) , 210,60,Vec3(0,0.5f,1), Vec3(0, 0, 0.5f), fAlpha, true, Vec3(1,1,0));
	RenderPanel(0,Vec2(320,125) , 180,40,Vec3(1,0.5f,0.5f), Vec3(0.5f, 0, 0), fAlpha, true, Vec3(1,1,0));


	//draw cursor
		UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		UTIL_GL::BindTexture(GL_TEXTURE_2D, gpEng->mSprites[SPR_UI].mImg);
		Vec2 UV, UVS;
		UV = gpEng->mSprites[SPR_UI].GetTileUV(8);
		UVS = gpEng->mSprites[SPR_UI].mUVsize;
		glColor4f(1, flash, flash, fAlpha);
		glBegin(GL_QUADS);
	if(iXIdx>=0)
	{
		glTexCoord2f(UV.x,		UV.y+UVS.y);glVertex2f((320-200)+(iXIdx*48)-16,	(300-130)+(iYIdx*30));
		glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);glVertex2f((320-200)+(iXIdx*48)+16,	(300-130)+(iYIdx*30));
		glTexCoord2f(UV.x+UVS.x,UV.y);		glVertex2f((320-200)+(iXIdx*48)+16,	(300-130)+(iYIdx*30)+32);
		glTexCoord2f(UV.x,		UV.y);		glVertex2f((320-200)+(iXIdx*48)-16,	(300-130)+(iYIdx*30)+32);
	}
	else
	{
		UV = gpEng->mSprites[SPR_UI].GetTileUV(9);
		glTexCoord2f(UV.x,		UV.y+UVS.y);glVertex2f((320-280),	(300-130)+(iYIdx*30));
		glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);glVertex2f((320-280)+32,(300-130)+(iYIdx*30));
		glTexCoord2f(UV.x+UVS.x,UV.y);		glVertex2f((320-280)+32,(300-130)+(iYIdx*30)+32);
		glTexCoord2f(UV.x,		UV.y);		glVertex2f((320-280),	(300-130)+(iYIdx*30)+32);
		UV = gpEng->mSprites[SPR_UI].GetTileUV(10);
		glTexCoord2f(UV.x,		UV.y+UVS.y);glVertex2f((320-280)+40,	(300-130)+(iYIdx*30));
		glTexCoord2f(UV.x+UVS.x,UV.y+UVS.y);glVertex2f((320-280)+72,(300-130)+(iYIdx*30));
		glTexCoord2f(UV.x+UVS.x,UV.y);		glVertex2f((320-280)+72,(300-130)+(iYIdx*30)+32);
		glTexCoord2f(UV.x,		UV.y);		glVertex2f((320-280)+40,	(300-130)+(iYIdx*30)+32);
	}
		glEnd();
		glDisable(GL_TEXTURE_2D);
		glDisable(GL_BLEND);


	gpEng->mFont1.EnableShadow();
	gpEng->mFont1.SetColor(1,1,1,fAlpha);
	gpEng->mFont1.SetScale(0.75f,0.75f);
	gpEng->mFont1.SetAlignment(ALIGN_CENTER);
	gpEng->mFont1.Print("ENTER YOUR NAME",320,45);
	gpEng->mFont1.SetScale(0.75f,0.75f);
	for(int n=0; n<10; n++)
	{
		char sz[6]; 
		sprintf(sz,"%c",Table[n]);
		gpEng->mFont1.Print(sz,(320-200)+n*48,300-130);
		sprintf(sz,"%c",Table[n+10]);
		gpEng->mFont1.Print(sz,(320-200)+n*48,300-100);
		sprintf(sz,"%c",Table[n+20]);
		gpEng->mFont1.Print(sz,(320-200)+n*48,300-70);
		if(n<6)
		{
			sprintf(sz,"%c",Table[n+30]);
			gpEng->mFont1.Print(sz,(320-200)+n*48,300-40);
		}
		sprintf(sz,"%c",Table[n+36]);
		gpEng->mFont1.Print(sz,(320-200)+n*48,300-10);
		sprintf(sz,"%c",Table[n+46]);
		gpEng->mFont1.Print(sz,(320-200)+n*48,300+20);

	}
	gpEng->mFont1.SetAlignment(ALIGN_LEFT);
	gpEng->mFont1.SetScale(0.4f,0.75f);
	gpEng->mFont1.Print("DEL",320-270,300-130);
	gpEng->mFont1.Print("SPACE",320-270,300-100);
	gpEng->mFont1.Print("END",320-270,300-70);

	gpEng->mFont1.SetAlignment(ALIGN_CENTER);
	gpEng->mFont1.SetScale(1,0.75f);
	gpEng->mFont1.Print(gpEng->szPlayerName,320,115);

	gpEng->mFont1.SetColor(1,1,1,fAlpha);
	gpEng->mFont1.SetScale(0.5f,0.5f);
	gpEng->mFont1.Print("ENTER THE NAME YOU WISH TO USE",320,410);
}

/***********************************/
/* Sure menu					   */
/***********************************/
void SureMenu::Spawn(Vec2 p)
{
	GenericAttributes(p, 50);
}
void SureMenu::Update()
{
//_ASSERTE( _CrtCheckMemory( ) );
	DoFade();
	if(bFadingOut || bFadingIn)
		return;


	if(gpEng->KEY_JUMP.state == JUST_PRESSED)
	{
		PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
		iClosingCode = MENU_ACCEPT;
		Close(50);
	}
	if(gpEng->KEY_ACTION2.state == JUST_PRESSED)
	{
		PlaySample(CHNL_UI_BACKUP,gpEng->mSnd[SND_UI_BACKUP],false);
		iClosingCode = MENU_CANCEL;
		Close(50);
	}
//_ASSERTE( _CrtCheckMemory( ) );
}
void SureMenu::Render(const float interp)
{
	float flash = 1;
	flash = iFlashTime>19?
		UTIL_Misc::Interpolate(1,0,(float)(iFlashTime-20)/20.0f):
		UTIL_Misc::Interpolate(0,1,(float)iFlashTime/20.0f);

	fAlpha = 1;
	if(bFadingOut)
		fAlpha = UTIL_Misc::Interpolate(0,1,  ((float)iFadeDuration-(float)iFadeTime) / (float)iFadeDuration);
	else if(bFadingIn)
		fAlpha = UTIL_Misc::Interpolate(1,0,  ((float)iFadeDuration-(float)iFadeTime) / (float)iFadeDuration);

	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	RenderPanel(0,Vec2(320,240) , 250,105, Vec3(0,0.5f,1), Vec3(0, 0, 0.5f), fAlpha,true, Vec3(1,1,0));

	gpEng->mFont1.EnableShadow();
	gpEng->mFont1.SetColor(1,1,1,fAlpha);
	gpEng->mFont1.SetScale(0.75f,0.75f);
	gpEng->mFont1.SetAlignment(ALIGN_CENTER);
	gpEng->mFont1.PrintClipped(szMessage,320,225,450);
	gpEng->mFont1.SetScale(0.35f,0.5f);
	gpEng->mFont1.SetAlignment(ALIGN_LEFT);
	gpEng->mFont1.Print("ACCEPT",315,268);
	gpEng->mFont1.Print("CANCEL",315,297);

	glColor4f(1,1,1,fAlpha);
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, gpEng->mSprites[SPR_UI].mImg);
	if(gpEng->bJoystick)
	{
	glBegin(GL_QUADS);
	Vec2 sprUVS = gpEng->mSprites[SPR_UI].mUVsize;
	Vec2 sprUV = gpEng->mSprites[SPR_UI].GetTileUV(4);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(268, 263);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(300, 263);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(300, 295);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(268, 295);

	sprUV = gpEng->mSprites[SPR_UI].GetTileUV(5);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(268, 292);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(300, 292);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(300, 324);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(268, 324);
	glEnd();
	}
	else
	{
		glBegin(GL_QUADS);
		Vec2 sprUVS = gpEng->mSprites[SPR_UI].mUVsize;
		Vec2 sprUV = gpEng->mSprites[SPR_UI].GetTileUV(29);
		glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(248, 255);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(312, 255);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(312, 303);
		glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(248, 303);

		//sprUV = gpEng->mSprites[SPR_UI].GetTileUV(28);
		glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(248, 286);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(312, 286);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(312, 332);
		glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(248, 332);
		glEnd();
		gpEng->mFont1.SetScale(0.35f,0.5f);
		gpEng->mFont1.SetAlignment(ALIGN_LEFT);
		gpEng->mFont1.Print("SPACE",258,268);
		gpEng->mFont1.Print("ESC",263,297);
	}
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
}
void SureMenu::DoOnClose()
{
//_ASSERTE( _CrtCheckMemory( ) );
	gpEng->KEY_JUMP.state = JUST_RELEASED;
	gpEng->KEY_ACTION2.state = JUST_RELEASED;
	if(mParent)
	{
		mParent->CallBack(iClosingCode);
	}
	else
	{
		if(iClosingCode == MENU_ACCEPT)
		{
			switch(iExternalCode)
			{
			case SURE_DESIGNER_CANCEL:
				{
					gpEng->ChangeState(STATE_GAMESELECT,0);
					NameMenu* menu = new NameMenu;
					menu->Spawn(Vec2(320,240));
					menu->iNameIdx = giLastNameIdx;
					menu->iXIdx = -1;
					menu->iYIdx = 2;
					gpEng->mMenus.push_back(menu);
					FADE_Box* FS = new FADE_Box;
					FS->Spawn(1,Vec3(1,1,1));
					gpEng->mFadeEng.InsertSystem(FS);//*/

					gpEng->RenderSceneToFadeBuffer();
				}
				break;

			case SURE_DESIGNER_ACCEPT:
				{
					gpEng->miGemCount = 0;
					//gpEng->miWorld = 0;
					gpEng->RenderSceneToFadeBuffer();
					gpEng->SaveGameSlot();
					gpEng->miSelectedStageBall = 0;
					//gpEng->mbQuit = true;

					LoadingMenu* menu = new LoadingMenu;
					menu->Spawn(Vec2(320,240));
					gpEng->mMenus.push_back(menu);

//					gpEng->ChangeState(STATE_STAGESELECT,0);
//					gpEng->miSelectedStageBall = 0;
//					gpEng->LoadStageSelectData();
//					gpEng->StartStageSelect();
				}
				break;

			case SURE_STAGESELECT_ACCEPT:
				{
					gpEng->LoadSelectedStage();
				}
				break;
			
			case SURE_QUIT_STAGE:
				{
					PlaySample(CHNL_UI_WHOOSH2,gpEng->mSnd[SND_UI_WHOOSH2],false);

					SureMenu* menu = new SureMenu;
					menu->Spawn(Vec2(320,240));
					menu->iExternalCode = SURE_QUIT_STAGE2;
					gpEng->bBonusStage?
						strcpy(menu->szMessage,"YOU ONLY GET ONE CHANCE AT BONUS STAGES"):
					strcpy(menu->szMessage,"ALL STARS AND GEMS WILL BE LOST");
					gpEng->mMenus.push_back(menu);
				}
				break;

			case SURE_QUIT_STAGE2:
				{
					//gpEng->RenderSceneToFadeBuffer();
					FADE_StarOut* FS = new FADE_StarOut;
					FS->Spawn(1,Vec3(1,1,1));
					gpEng->mFadeEng.InsertSystem(FS);//*/
					gpEng->ChangeState(STATE_STAGESELECT,125,&CALLBACK_StartStageSelect);
					gpEng->CleanupMap();
					gpEng->SaveGameSlot();
					UnPauseAudio();
					StopMusic();
					StopMasterChannel();

					//THIS SHOULD ONLY HAPPEN WHEN THE STAGE IS COMPLETE
					//copy persistance over for the played stage into storage ** this should only be done when the stage is completed**
					/*std::list<unsigned int>::iterator it;
					for(it = gpEng->miCurrentPersistance.begin(); it!=gpEng->miCurrentPersistance.end(); it++)
					{
						gpEng->miStagePersistance[gpEng->miSelectedStageBall].push_back((*it));
					}
					gpEng->miGemCount += gpEng->miLocalGemCount;
					gpEng->miStarCount += gpEng->miLocalStarCount;
					gpEng->miCurrentPersistance.clear();
					gpEng->SavePerstistanceData();
					gpEng->SaveGameSlot();//*/
				}
				break;
			case SURE_EXIT_TUTORIAL:
				{
					FADE_StarOut* FS = new FADE_StarOut;
					FS->Spawn(1,Vec3(1,1,1));
					gpEng->mFadeEng.InsertSystem(FS);//*/
					gpEng->ChangeState(STATE_SPLASH,125,&CALLBACK_StartSplash);
					gpEng->CleanupMap();
					UnPauseAudio();
					StopMusic();
					StopMasterChannel();
				}
				break;
			case SURE_RETRY_STAGE:
				{
					//gpEng->CleanupMap();
					gpEng->LoadSelectedStage();
				}
				break;
			case SURE_RETRY_WORLD:
				{
					FADE_StarOut* FS = new FADE_StarOut;
					FS->Spawn(1,Vec3(1,1,1));
					gpEng->mFadeEng.InsertSystem(FS);//*/
					gpEng->ChangeState(STATE_STAGESELECT,125,&CALLBACK_StartStageSelect);
					gpEng->CleanupMap();
					//reset game vars
					//gpEng->miStarCount = 0;
					//gpEng->miGemCount = 0;
					gpEng->miLives = 5;
					gpEng->miScore = gpEng->miPreservedScore;
					gpEng->SaveGameSlot();
					//gpEng->iBonusStage = gpEng->iPreservedBonusStage;
					//reset persistance data
					/*char szFile[64];
					sprintf(szFile,"Data/Slots/World%iSlot%i.slt",gpEng->miWorld,gpEng->miSaveGameSlot);
					DeleteFile(szFile);
					for(int n=0; n<15;n++)//delete all persistance data for every stage
					{
						gpEng->mbStageSelect[n] = false;
						gpEng->miStagePersistance[n].clear();
					}*/
					gpEng->SaveGameSlot();
					gpEng->LoadPerstistanceData();
					gpEng->miSelectedStageBall = 0;
				}
				break;
			}
		}
		else if(iClosingCode == MENU_CANCEL)
		{
			if(iExternalCode == SURE_STAGESELECT_ACCEPT)
			{
				gpEng->iOption = 0;
			}
			if(iExternalCode == SURE_RETRY_STAGE)
			{
				//gpEng->RenderSceneToFadeBuffer();
				FADE_StarOut* FS = new FADE_StarOut;
				FS->Spawn(1,Vec3(1,1,1));
				gpEng->mFadeEng.InsertSystem(FS);//*/
				gpEng->ChangeState(STATE_STAGESELECT,125,&CALLBACK_StartStageSelect);
				gpEng->CleanupMap();
				gpEng->SaveGameSlot();
			}
			if(iExternalCode == SURE_RETRY_WORLD)
			{
				FADE_Box* FS = new FADE_Box;
				FS->Spawn(1,Vec3(1,1,1));
				gpEng->mFadeEng.InsertSystem(FS);//*/
				gpEng->RenderGame(gpEng->mInterp);
				gpEng->RenderSceneToFadeBuffer();
				//reset game vars
				//gpEng->miStarCount = 0;
				//gpEng->miGemCount = 0;
				gpEng->miLives = 5;
				gpEng->miScore = gpEng->miPreservedScore;
				gpEng->SaveGameSlot();
				//reset persistance data
				/*char szFile[64];
				sprintf(szFile,"Data/Slots/World%iSlot%i.slt",gpEng->miWorld,gpEng->miSaveGameSlot);
				DeleteFile(szFile);
				for(int n=0; n<15;n++)//delete all persistance data for every stage
				{
					gpEng->mbStageSelect[n] = false;
					gpEng->miStagePersistance[n].clear();
				}*/
				gpEng->ChangeState(STATE_GAMESELECT,0);
				gpEng->StartGameSelect();
			}
			if(iExternalCode == SURE_QUIT_STAGE || iExternalCode == SURE_QUIT_STAGE2 || SURE_EXIT_TUTORIAL)
			{
				UnPauseAudio();
			}
		}
	}
//_ASSERTE( _CrtCheckMemory( ) );
}


/********************************/
/* WorldSelect menu				*/
/********************************/
void WorldMenu::Spawn(Vec2 p)
{
	GenericAttributes(p,50);
	iOption = 0;
//	gpEng->iOption = 0;
}
void WorldMenu::Update()
{
//_ASSERTE( _CrtCheckMemory( ) );
	DoFade();
	if(bFadingOut || bFadingIn)
		return;

//_ASSERTE( _CrtCheckMemory( ) );

	if(iOption == 0 && gpEng->iOption == 0)
	{
		if(gpEng->KEY_ACTION2.state == JUST_PRESSED)
		{
			SureMenu* menu = new SureMenu;
			menu->Spawn(Vec2(320,240));
			iClosingCode = WORLD_QUIT;
			menu->mParent = this;
			strcpy(menu->szMessage,"ARE YOU SURE YOU WANT TO QUIT THIS GAME?");
			gpEng->mMenus.push_back(menu);
			return;
		}
	}
//_ASSERTE( _CrtCheckMemory( ) );
}
void WorldMenu::Render(const float interp)
{
//_ASSERTE( _CrtCheckMemory( ) );
	float flash = 1;
	flash = iFlashTime>19?
		UTIL_Misc::Interpolate(1,0,(float)(iFlashTime-20)/20.0f):
		UTIL_Misc::Interpolate(0,1,(float)iFlashTime/20.0f);

	fAlpha = 1;
//	if(bFadingOut)
//		fAlpha = UTIL_Misc::Interpolate(0,1,  ((float)iFadeDuration-(float)iFadeTime) / (float)iFadeDuration);
//	else if(bFadingIn)
//		fAlpha = UTIL_Misc::Interpolate(1,0,  ((float)iFadeDuration-(float)iFadeTime) / (float)iFadeDuration);

	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	RenderPanel(0,Vec2(320,60) , 210,40,Vec3(0,0.5f,1), Vec3(0, 0, 0.5f), fAlpha, true, Vec3(1,1,0));
	RenderPanel(0,Vec2(320,420) , 210,60,Vec3(0,0.5f,1), Vec3(0, 0, 0.5f), fAlpha, true, Vec3(1,1,0));

	char szData[64];
	sprintf(szData,"WORLD %i",gpEng->miWorld+1);

	gpEng->mFont1.EnableShadow();
	gpEng->mFont1.SetColor(1,1,1,fAlpha);
	gpEng->mFont1.SetScale(0.75f,0.75f);
	gpEng->mFont1.SetAlignment(ALIGN_CENTER);
	gpEng->mFont1.Print(szData,320,45);


	gpEng->mFont1.SetColor(1,1,1,fAlpha);
	gpEng->mFont1.SetScale(0.5f,0.5f);
	gpEng->mFont1.Print("SELECT YOUR DESTINATION",320,410);
//	gLog.OutPut("rendered world menu\n");
//_ASSERTE( _CrtCheckMemory( ) );

}
void WorldMenu::DoOnClose()
{
//_ASSERTE( _CrtCheckMemory( ) );
	switch(iClosingCode)
	{
	case WORLD_QUIT:
		{
			FADE_Box* FS = new FADE_Box;
			FS->Spawn(1,Vec3(1,1,1));
			gpEng->mFadeEng.InsertSystem(FS);//*/
			gpEng->RenderSceneToFadeBuffer();
			gpEng->ChangeState(STATE_GAMESELECT,1,CALLBACK_StartGameSelect2);
			//gpEng->StartGameSelect();
		}
		break;
	}
//_ASSERTE( _CrtCheckMemory( ) );
}
void WorldMenu::CallBack(int code)
{
//_ASSERTE( _CrtCheckMemory( ) );
	if(code == MENU_ACCEPT)
	{
		if(iClosingCode == WORLD_QUIT)
		{
			Close(1);
		}
	}
	else if(code == MENU_CANCEL)
	{
		if(iClosingCode == WORLD_QUIT)
		{
			gLog.OutPut("Changed option\n");
			gpEng->iOption = 0;
		}
	}
//_ASSERTE( _CrtCheckMemory( ) );
}
/********************************/
/* loading  menu				*/
/********************************/
void LoadingMenu::Spawn(Vec2 p)
{
	GenericAttributes(p,50);
	iLoadType = 0;
}
void LoadingMenu::Update()
{
	DoFade();
	if(bFadingOut || bFadingIn)
		return;

	if(iFadeTime<=0)
	{
			gpEng->RenderSceneToFadeBuffer();
			if(gpEng->miOWorld != gpEng->miWorld)
			{
				gpEng->miWorld = gpEng->miOWorld;
				gpEng->CleanupWorldData();
				gpEng->LoadWorldData();
			}

			if(iLoadType==1)
			{
				NameMenu* menu = new NameMenu;
				menu->Spawn(Vec2(320,240));
				gpEng->mMenus.push_back(menu);
				strcpy(gpEng->szPlayerName,"_______");
				Close(0);
				//gpEng->mMenus.remove_if(CleanupMenus);
				FADE_Star* FS2 = new FADE_Star;
				FS2->Spawn(1,Vec3(0,1,1));
				gpEng->mFadeEng.InsertSystem(FS2);//*/
			}
			if(iLoadType==0)
			{
				gpEng->LoadPerstistanceData();
				gpEng->ChangeState(STATE_STAGESELECT,0);
				
				//gpEng->StartStageSelect();
				Close(0);
			}

	}

}
void LoadingMenu::Render(const float interp)
{
	float flash = 1;
	flash = iFlashTime>19?
		UTIL_Misc::Interpolate(1,0,(float)(iFlashTime-20)/20.0f):
		UTIL_Misc::Interpolate(0,1,(float)iFlashTime/20.0f);

	fAlpha = 1;
	if(bFadingOut)
		fAlpha = UTIL_Misc::Interpolate(0,1,  ((float)iFadeDuration-(float)iFadeTime) / (float)iFadeDuration);
	else if(bFadingIn)
		fAlpha = UTIL_Misc::Interpolate(1,0,  ((float)iFadeDuration-(float)iFadeTime) / (float)iFadeDuration);

	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	RenderPanel(0,Vec2(320,240) , 250,100, Vec3(0,0.5f,1), Vec3(0, 0, 0.5f), fAlpha,true, Vec3(1,1,0));

	gpEng->mFont1.EnableShadow();
	gpEng->mFont1.SetColor(1,1,1,fAlpha);
	gpEng->mFont1.SetScale(0.75f,0.75f);
	gpEng->mFont1.SetAlignment(ALIGN_CENTER);
	gpEng->mFont1.PrintClipped("LOADING...                        PLEASE WAIT",320,225,450);
	glColor4f(1,1,1,1);

}
/***********************************/
/* Sure menu					   */
/***********************************/
void PopMenu::Spawn(Vec2 p)
{
	GenericAttributes(p, 50);
/*	if(gpEng->iEngineState == STATE_GAME)
	{
		PauseAudio();
		PlaySample(CHNL_UI_WHOOSH2,gpEng->mSnd[SND_UI_WHOOSH2],false);
	}*/
}
void PopMenu::Update()
{
	DoFade();
	if(bFadingOut || bFadingIn)
		return;


	if(gpEng->KEY_JUMP.state == JUST_PRESSED || gpEng->KEY_ACTION2.state == JUST_PRESSED)
	{
	//	PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
		iClosingCode = MENU_ACCEPT;
		Close(50);
	}
}
void PopMenu::Render(const float interp)
{
	float flash = 1;
	flash = iFlashTime>19?
		UTIL_Misc::Interpolate(1,0,(float)(iFlashTime-20)/20.0f):
		UTIL_Misc::Interpolate(0,1,(float)iFlashTime/20.0f);

	fAlpha = 1;
	if(bFadingOut)
		fAlpha = UTIL_Misc::Interpolate(0,1,  ((float)iFadeDuration-(float)iFadeTime) / (float)iFadeDuration);
	else if(bFadingIn)
		fAlpha = UTIL_Misc::Interpolate(1,0,  ((float)iFadeDuration-(float)iFadeTime) / (float)iFadeDuration);

	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	RenderPanel(0,Vec2(320,240) , 250,100, Vec3(0,0.5f,1), Vec3(0, 0, 0.5f), fAlpha,true, Vec3(1,1,0));

	gpEng->mFont1.EnableShadow();
	gpEng->mFont1.SetColor(1,1,1,fAlpha);
	gpEng->mFont1.SetScale(0.75f,0.75f);
	gpEng->mFont1.SetAlignment(ALIGN_CENTER);
	gpEng->mFont1.PrintClipped(szMessage,320,225,450);

	gpEng->mFont1.EnableShadow();
	gpEng->mFont1.SetColor(1,1,1,fAlpha);
	gpEng->mFont1.SetScale(0.75f,0.75f);
	gpEng->mFont1.SetAlignment(ALIGN_CENTER);
	gpEng->mFont1.PrintClipped(szMessage,320,225,450);
	gpEng->mFont1.SetScale(0.35f,0.5f);
	gpEng->mFont1.SetAlignment(ALIGN_LEFT);
	gpEng->mFont1.Print("ACCEPT",315,268);

	glColor4f(1,1,1,fAlpha);
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, gpEng->mSprites[SPR_UI].mImg);
	if(gpEng->bJoystick)
	{
	glBegin(GL_QUADS);
	Vec2 sprUVS = gpEng->mSprites[SPR_UI].mUVsize;
	Vec2 sprUV = gpEng->mSprites[SPR_UI].GetTileUV(4);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(268, 263);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(300, 263);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(300, 295);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(268, 295);
	glEnd();
	}
	else
	{
		glBegin(GL_QUADS);
		Vec2 sprUVS = gpEng->mSprites[SPR_UI].mUVsize;
		Vec2 sprUV = gpEng->mSprites[SPR_UI].GetTileUV(29);
		glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(248, 255);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(312, 255);
		glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(312, 303);
		glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(248, 303);
		glEnd();
		gpEng->mFont1.SetScale(0.35f,0.5f);
		gpEng->mFont1.SetAlignment(ALIGN_LEFT);
		gpEng->mFont1.Print("SPACE",258,268);
	}
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
}
void PopMenu::DoOnClose()
{
//	if(gpEng->iEngineState == STATE_GAME)
//		UnPauseAudio();
	gpEng->KEY_JUMP.state = JUST_RELEASED;
	gpEng->KEY_ACTION2.state = JUST_RELEASED;
	switch(iExternalCode)
	{
	case POP_VIDEO:break;
	}
}
