#pragma once
#include "Vector.h"
#include "BallType.h"

void RenderPanel(int type, Vec2 p, float w, float h, Vec3 TopGrad, Vec3 LowGrad, float alpha, bool outline, Vec3 outcol);
class Menu
{
public:
	void GenericAttributes(Vec2 p, int fadein);
	virtual void Spawn(Vec2 p)=0;
	virtual void Update()=0;
	virtual void Render(const float interp)=0;

	virtual void DoFade();
	void Close(int time);

	Vec2 mPos;

	float fAlpha;
	int iFadeTime, iFadeDuration;
	bool bFadingIn, bFadingOut;

	int iOption;
	int iFlashTime;

	int iClosingCode;//value at time of closing
	virtual void DoOnClose();
	virtual void CallBack(int code);
	Menu* mParent;
};

bool PruneMenus(Menu* m);
bool CleanupMenus(Menu* m);
enum
{
	MENU_CANCEL = 0,
	MENU_ACCEPT
};
/****************************/
/*	Load slot menu			*/
/****************************/
class SlotMenu : public Menu
{
public:
	void Spawn(Vec2 p);
	void Update();
	void Render(const float interp);
	void DoOnClose();
	void CallBack(int code);

	bool bSlot[3];//does the slot exist
	char szSlot[3][8];//the persons name
	int iSlotWorld[3];//the current world they are on
	int iSlotGems[3];//how many gems the currently have
	int iSlotLives[3];//how many lives the currently have
	int iSlotStars[3];//how many lives the currently have
	int iSlotBonus[3];//which bonus stages have they played
	int iPreservedSlotBonus[3];//which bonus stages have they played
	unsigned int iSlotScore[3];//score
	unsigned int iPreservedSlotScore[3];//preserved score
	unsigned int iSlotTime[3];//how long the player has taken

	int iSlotBallType[3];//ball index
	BallType SlotBall[3];//the ball type they are using
	int iStickerType[3];

	bool LoadSaveSlot(int slot);
	int miSlot;
	int iSelection;

	enum {
		SLOT_NEWGAME = 0,
		SLOT_CONTINUEGAME,
		SLOT_DELETEGAME
	};
};

/********************************/
/* Name entry menu				*/
/********************************/
class NameMenu : public Menu
{
public:
	void Spawn(Vec2 p);
	void Update();
	void Render(const float interp);
	void DoOnClose();
	void CallBack(int code);

	int iXIdx,iYIdx, iNameIdx;

	enum
	{
		NAME_CANCEL = 0,
		NAME_DONE
	};
	 char Table[128];
};

/********************************/
/* Are You Sure					*/
/********************************/
class SureMenu : public Menu
{
public:
	void Spawn(Vec2 p);
	void Update();
	void Render(const float interp);
	void DoOnClose();

	char szMessage[256];

	int iExternalCode;
	enum
	{
		SURE_DESIGNER_CANCEL=50,
		SURE_DESIGNER_ACCEPT,
		SURE_STAGESELECT_CANCEL1=100,
		SURE_STAGESELECT_ACCEPT,
		SURE_QUIT_STAGE,
		SURE_QUIT_STAGE2,
		SURE_RETRY_STAGE,
		SURE_RETRY_WORLD,
		SURE_EXIT_TUTORIAL
	};
};
class PopMenu : public Menu
{
public:
	void Spawn(Vec2 p);
	void Update();
	void Render(const float interp);
	void DoOnClose();

	char szMessage[512];
	int iExternalCode;
	enum
	{
		POP_VIDEO=500,
		POP_TUTORIAL
	};
};
/********************************/
/* WorldSelect menu				*/
/********************************/
class WorldMenu : public Menu
{
public:
	void Spawn(Vec2 p);
	void Update();
	void Render(const float interp);
	void DoOnClose();
	void CallBack(int code);

	enum
	{
		WORLD_QUIT = 150,
		WORLD_DONE
	};
};
/********************************/
/* loading menu					*/
/********************************/
class LoadingMenu : public Menu
{
public:
	void Spawn(Vec2 p);
	void Update();
	void Render(const float interp);

	int iLoadType;
};

