#pragma once
#include "Vector.h"
#include <list>
#include <vector>


struct Particle
{
	Particle()
	{
	 R= oR= vR = 0;//rotation
	 ID = 0;//tile idx
	 fLife= fMaxLife= 0;

	}
	Vec3 P, oP;//position
	Vec3 Vel;//velocity
	Vec2 S, oS;//scale
	Vec3 Col,MaxColor;//color
	float R, oR, vR;//rotation
	unsigned int ID;//tile idx
	float fLife, fMaxLife;
};


class ParticleSystem
{
public:
	ParticleSystem(){}
	virtual void Spawn(Vec3 p, Vec3 v, Vec2 s, Vec3 c, float r, unsigned int id, float life)=0;
	virtual void Update()=0;
	virtual void Emit(float count)=0;
	void RemoveDeadParticle(std::vector<Particle>::iterator i);
	std::vector<Particle> mParticles;
	bool bRemove;
};
bool PruneParticleSystems(ParticleSystem* ps);

class ParticleEngine
{
public:
	void Update();
	void Render3D(const float interp);
	void Render2D(const float interp);
	void CleanUp();
	void InsertSystem(ParticleSystem* PS, bool Is2D);
	void InsertAlphaSystem(ParticleSystem* PS);

	std::list<ParticleSystem*> mSystems3D,mSystems3DAlpha;
	std::list<ParticleSystem*> mSystems2D;
};