#pragma once
#include "Particle.h"


class PS_Fade1 : public ParticleSystem
{
public:
	void Spawn(Vec3 p, Vec3 v, Vec2 s, Vec3 c, float r, unsigned int id, float life);
	void Update();
	void Emit(float count);

	float fVerticalBar;//scrolls down the screen
};

class PS_Stars : public ParticleSystem
{
public:
	void Spawn(Vec3 p, Vec3 v, Vec2 s, Vec3 c, float r, unsigned int id, float life);
	void Update();
	void Emit(float count);

	bool bAlive;
	Vec3 mPos;
	Vec3 up;
	Vec3 fStarColor;

	int iEmitTime;
};

class PS_BallExplode : public ParticleSystem
{
public:
	void Spawn(Vec3 p, Vec3 v, Vec2 s, Vec3 c, float r, unsigned int id, float life);
	void Update();
	void Emit(float count);
	Vec3 mPos, Up;
	Vec3 Color;
	int IDtype;
	int iChildEmit;
};

class PS_BallJumpDust : public ParticleSystem
{
public:
	void Spawn(Vec3 p, Vec3 v, Vec2 s, Vec3 c, float r, unsigned int id, float life);
	void Update();
	void Emit(float count);

	Vec3 mPos;
	Vec3 up;
	Vec3 DustCol;
};

class PS_CollectedStar : public ParticleSystem
{
public:
	void Spawn(Vec3 p, Vec3 v, Vec2 s, Vec3 c, float r, unsigned int id, float life);
	void Update();
	void Emit(float count);

	Vec3 mPos;
	Vec3 mTarget;
	Vec3 Color;
	int iStarCounter;
	int iEmitTime;
	int iChildEmit;
	int iLifeTime;
	bool bCircle;//start circling the star
};

class PS_CollectedGem : public ParticleSystem
{
public:
	void Spawn(Vec3 p, Vec3 v, Vec2 s, Vec3 c, float r, unsigned int id, float life);
	void Update();
	void Emit(float count);

	Vec3 mPos;
	Vec3 Color;
	int iPartCounter;
	int iEmitTime;
	int iChildEmit;
};

class PS_ProjectileDust : public ParticleSystem
{
public:
	void Spawn(Vec3 p, Vec3 v, Vec2 s, Vec3 c, float r, unsigned int id, float life);
	void Update();
	void Emit(float count);

	Vec3 mPos;
	Vec3 up,mRight,mForward;
	Vec3 DustCol;
};

class PS_Snow : public ParticleSystem
{
public:
	void Spawn(Vec3 p, Vec3 v, Vec2 s, Vec3 c, float r, unsigned int id, float life);
	void Update();
	void Emit(float count);

	bool bAlive;

	int iEmitTime;
};

class PS_AreaClear : public ParticleSystem
{
public:
	void Spawn(Vec3 p, Vec3 v, Vec2 s, Vec3 c, float r, unsigned int id, float life);
	void Update();
	void Emit(float count);

	Vec3 mPos;
	int iStarCounter;
	int iEmitTime;
	int iChildEmit;
	int iLifeTime;
	Vec3 mTarget;
};

class PS_Firework : public ParticleSystem
{
public:
	void Spawn(Vec3 p, Vec3 v, Vec2 s, Vec3 c, float r, unsigned int id, float life);
	void Update();
	void Emit(float count);
	Vec3 mEffectCol;
	Vec3 mPos;
};

class PS_BonusRing : public ParticleSystem
{
public:
	void Spawn(Vec3 p, Vec3 v, Vec2 s, Vec3 c, float r, unsigned int id, float life);
	void Update();
	void Emit(float count);

	Vec3 mPos;
	int iStarCounter;
	int iEmitTime;
	int iChildEmit;
	int iLifeTime;
	Vec3 mTarget;
};