#pragma once
#include "Entity.h"
#include <list>
#include "Block.h"
class Platform
{
public:
	Platform();
	Platform(const Platform& p);

	void Generate(Vec3 mins, Vec3 maxs);
	void Cleanup();
	

	void Update();
	void Render(const float interp);


	std::list<Entity*> mChilds;//entity children

	Block** mpBlocks;
	std::list<Block> mBlocks;

	Vec3 mMins, mMaxs, mPos, mOPos, mSize;

	bool mbMoveDir;//which way its moving
	Vec3 mMoveDest;//destination
	Vec3 mMoveStart;//start position
	int iMoveTime, iMaxMoveTime;
	int iWaitTime, iMaxWaitTime;
	bool bWaiting;

	bool PointInPlat(Vec3 p);
	Block* GetTileInPlat(Vec3 p);

	bool mbPlayerIsRiding;

	Vec3 mMoveSpeed;

	bool bPlayOnce;
	bool bReturnStart, bHasReturned;
	bool bActivated;

	bool bVisible;
	int iFadeTime;

	bool bTriggerTouch;

	char TargetName[16];//trigger this ent
	char Name[16];//so I can be triggered
	void Trigger();
	bool bTriggered;
	char TriggerMessage[512];

	int iLogicDebugStep;
	void Freeze();
};
bool FreezePlatforms(Platform* e);
