#include "Player.h"
#include "Engine.h"

void Player::Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u)
{
	mPos = mOPos = p;//+Vec3(0,-2,0);
//	mfRotation = rotation;// = Vec2(0,0);

	mForward = Vec3(0,0,-1);
	mRight = Vec3(1,0,0);
	mUp = Vec3(0,1,0);
	mForward = f;
	mRight = r;
	mUp = u;
/*	mForward = ArbitraryRotate(mForward,DEG2RAD(rotation.y),mRight);
	mForward = ArbitraryRotate(mForward,DEG2RAD(rotation.x),mUp);
	mRight = ArbitraryRotate(mRight,DEG2RAD(rotation.y),mRight);
	mRight = ArbitraryRotate(mRight,DEG2RAD(rotation.x),mUp);
	mUp = ArbitraryRotate(mUp,DEG2RAD(rotation.y),mRight);
	mUp = ArbitraryRotate(mUp,DEG2RAD(rotation.x),mUp);
*/
	mMoveForward = mForward;
	mMoveRight = mRight;
	mMoveUp = mUp;
	mBallForward = mBallOForward = mForward;
	mBallRight = mBallORight = mRight;
	mBallUp = mBallOUp = mUp;

	mfRotation = Vec2(0,0);
	bTurning = false;
	iTurnCounter = 0;
	vTurn = Vec2(0,0);
	bMoving = false;
	mGravity = -mUp;
	bJump = false;
	fBounceScale = 0;
	iJumpCounter = 0;
	iSpawnTime = 200;
	bTurnCorner = false;
	bLanded = false;
	mpPlatform = NULL;
	mfSpeedupTime = 0;
	iDmgTime = 0;
	mbFallOut = false;
	miActionTimer = 0;
	mbTimeOut = false;
	mbStageWon = false;
	mbLostBall = false;
	iHealth = 5;//start out with 5 hearts
	iKeyTurnRTime = 0;
	iKeyTurnLTime = 0;
	iDeathTime = 0;
	mbGameOver = false;
	iMaxJumpCounter = 40;
	mbWorldWon = false;
	bSliding = false;
	bSlideJump = false;
	mSlideMove = Vec3(0,0,0);
	gpEng->pLastBlock = NULL;
	iTeleportTimer = 0;


}
void Player::Update()
{
	//_ASSERTE( _CrtCheckMemory( ) );
	gpEng->iTimePlayed++;
	mOForward = mForward;
	mORight = mRight;
	mOUp = mUp;
	mBallOForward = mBallForward;
	mBallORight = mBallRight;
	mBallOUp = mBallUp;
	mOPos = mPos;

	if(iTeleportTimer>0)
	{
		iTeleportTimer--;
		return;
	}

	mfOSpeedupTime = mfSpeedupTime;
	if(iDeathTime>0)
	{
		iDeathTime--;
		float d = (250-iDeathTime)/20.0f;
		mBallForward = ArbitraryRotate(mBallForward,DEG2RAD(d),mBallUp);
		mBallForward = ArbitraryRotate(mBallForward,DEG2RAD(d),mBallRight);
		mBallRight = ArbitraryRotate(mBallRight,DEG2RAD(d),mBallUp);
		mBallRight = ArbitraryRotate(mBallRight,DEG2RAD(d),mBallRight);
		mBallUp = ArbitraryRotate(mBallUp,DEG2RAD(d),mBallUp);
		mBallUp = ArbitraryRotate(mBallUp,DEG2RAD(d),mBallRight);
		float shakeD = (float)(350-iDeathTime)/2000.0f;
		mShakeBall = Vec3((UTIL_Misc::RandFloat(1)-0.5f)*shakeD,(UTIL_Misc::RandFloat(1)-0.5f)*shakeD,(UTIL_Misc::RandFloat(1)-0.5f)*shakeD);
		iDmgTime = 2;
		if(iDeathTime == 50)
			PlaySample(CHNL_VOICE, gpEng->mSnd[SND_VOICE_LOSTBALL],false);

		if(iDeathTime==1)
		{
			PS_BallExplode* PS = new PS_BallExplode;
			PS->Spawn(mPos,Vec3(0,0,0),Vec2(16,16),Vec3(1,1,0),0,0,1);
			PS->Up = mMoveUp;
			gpEng->mPartEng.InsertSystem(PS,false);
			PS_BallExplode* PS2 = new PS_BallExplode;
			PS2->Spawn(mPos,Vec3(0,0,0),Vec2(16,16),Vec3(1,0,0),0,0,1);
			PS2->Up = mMoveUp;
			gpEng->mPartEng.InsertSystem(PS2,false);
			PlaySample(-1,gpEng->mSnd[SND_BALL_EXPLODE],false);
//			PS_BallExplode* PS3 = new PS_BallExplode;
//			PS3->Spawn(mPos,Vec3(0,0,0),Vec2(16,16),Vec3(1,0.8,0.2f),0,2,1);
//			gpEng->mPartEng.InsertAlphaSystem(PS3);//*/
		}
	}
	//_ASSERTE( _CrtCheckMemory( ) );

	iKeyTurnRTime--;
	iKeyTurnLTime--;
	if(iDmgTime>0 && !mbLostBall && !mbStageWon && !mbFallOut)
	{
		//if(!bJump)
		iDmgTime--;
		if(iDmgTime==0)
		{
			iHealth--;
			if(iHealth == 0)
			{
				iDeathTime = 250;
				if(!mbFallOut)
				{
					mbLostBall = true;
					LoseLife();
					miActionTimer = 0;
				}
			}
		}
	}


	if(bTurning)
	{
		mfSpeedupTime += TIME_STEP * 7;
		if(mfSpeedupTime>4)
			mfSpeedupTime=4;
	}
	else
	{
//		mfSpeedupTime -= TIME_STEP *21;
//		if(mfSpeedupTime<0)
			mfSpeedupTime = 0;
	}
	if(!bJump)// && !mpPlatform)
	{
/*		float	X = mMoveUp.x!=0?
			(mMoveUp.x>0?(int)mPos.x+0.75f:(int)mPos.x+0.25f):mPos.x;
		float	Y = mMoveUp.y!=0?
			(mMoveUp.y>0?(int)mPos.y+0.75f:(int)mPos.y+0.25f):mPos.y;
		float	Z = mMoveUp.z!=0?
			(mMoveUp.z>0?(int)mPos.z+0.75f:(int)mPos.z+0.25f):mPos.z;
			mPos = Vec3(X,Y,Z);//&/
*/
		Block* b = gpEng->GetMapTile(mPos+mMoveUp);//*025f wasnt here
		if(b)
		{

			Vec3 u = mMoveUp;
			float X = u.x!=0?
				(u.x<0?b->pos.x+0.75f:b->pos.x-0.75f):mPos.x;
			float Y = u.y!=0? 
				(u.y<0?b->pos.y+0.75f:b->pos.y-0.75f):mPos.y;
			float Z = u.z!=0?
				(u.z<0?b->pos.z+0.75f:b->pos.z-0.75f):mPos.z;

			mPos = Vec3(X,Y,Z);//&/
		}
/*		else
		{
		float	X = mMoveUp.x!=0?
			(mMoveUp.x>0?(int)mPos.x+0.75f:(int)mPos.x+0.25f):mPos.x;
		float	Y = mMoveUp.y!=0?
			(mMoveUp.y>0?(int)mPos.y+0.75f:(int)mPos.y+0.25f):mPos.y;
		float	Z = mMoveUp.z!=0?
			(mMoveUp.z>0?(int)mPos.z+0.75f:(int)mPos.z+0.25f):mPos.z;
			mPos = Vec3(X,Y,Z);//&/

		}*/
	}
	//_ASSERTE( _CrtCheckMemory( ) );
	if(iSpawnTime>-100)
	{
		iSpawnTime--;
		if(iSpawnTime == 0)
		{
			if(gpEng->bBonusStage)
				PlaySample(CHNL_VOICE, gpEng->mSnd[SND_VOICE_BONUS_STAGE],false);
			else
				PlaySample(CHNL_VOICE, gpEng->mSnd[SND_VOICE_GETREADY],false);
		}
		if(iSpawnTime==-100)
		{
			//tutorial stage rquires triggering of platform
			Block* bl = gpEng->GetMapTile(mPos+mMoveUp);
			if(bl == NULL)//see if we are on the edge
				bl = gpEng->GetMapTile(mPos+mMoveUp-mMoveRight*0.2f);
			if(bl == NULL)//see if we are on the edge
				bl = gpEng->GetMapTile(mPos+mMoveUp+mMoveRight*0.2f);
			if(bl && !bJump)// && !mpPlatform)
			{
				//rolled onto a platform
				if(!mpPlatform && bl->mbPlatform)
				{
					if(!gpEng->mPlatforms.empty())
					{
						std::list<Platform*>::iterator pl;
						for(pl=gpEng->mPlatforms.begin(); pl!=gpEng->mPlatforms.end(); pl++)
						{
							if((*pl)->PointInPlat(mPos+mMoveUp) && (*pl)->GetTileInPlat(mPos+mMoveUp) ||
								(*pl) == bl->pPlat || 
							(*pl)->PointInPlat(mPos-mMoveUp+mMoveRight*0.2f) && (*pl)->GetTileInPlat(mPos-mMoveUp+mMoveRight*0.2f) ||
							(*pl)->PointInPlat(mPos-mMoveUp-mMoveRight*0.2f) && (*pl)->GetTileInPlat(mPos-mMoveUp-mMoveRight*0.2f) )
							{
								(*pl)->mbPlayerIsRiding = true;
								mpPlatform = (*pl);
								//if((*pl)->PointInPlat(mPos+mMoveUp))
									if((*pl)->bTriggerTouch)
									{
										(*pl)->Trigger();
										(*pl)->mbPlayerIsRiding = false;
										mpPlatform = NULL;
									}
								break;
							}
						}
					}
				}
			}

		}
		return;
	}
	//_ASSERTE( _CrtCheckMemory( ) );

	if(!mbTimeOut && !mbStageWon && !mbLostBall)
	if(!bTurning && !bTurnCorner && !bJump)
	{
		if(!bTurning && !bMoving || !bTurning && bSliding)
		{
			if(gpEng->KEY_FORWARD.state == PRESSED || bSliding)
			{
				if(//gpEng->GetMapTile(mPos+mMoveUp)>0 &&
					//gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.52f)>0 &&		//infront
					!bSliding &&
					gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.52f)>0 ||		//infront
					//gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.22f)>0 ||		//infront

					!bSliding &&
					gpEng->GetMapTile(mPos+mMoveUp)>0 &&						//below
					gpEng->GetMapTile(mPos+mMoveUp + mMoveRight*0.75f)==0 &&	//below to right is empty
					gpEng->GetMapTile(mPos+mMoveUp - mMoveRight*0.75f)==0 &&	//below to left is empty
					gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.52f - mMoveRight*0.75f)==0 &&			//left is empty
					gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.52f + mMoveRight*0.75f)==0 &&			//right is empty
					gpEng->GetMapTile(mPos+mMoveForward*0.52f - mMoveRight*0.75f)==0 &&			//left is empty
					gpEng->GetMapTile(mPos+mMoveForward*0.52f + mMoveRight*0.75f)==0 &&			//right is empty
					gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.52f)==0 ||	//infront is empty

					!bSliding &&
					gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.52f)==0 &&
					gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.52f)==0 &&
					gpEng->GetMapTile(mPos+mMoveUp-mMoveForward*0.52f)==0 &&
					gpEng->GetMapTile(mPos+mMoveUp)>0 &&
					gpEng->GetMapTile(mPos - mMoveRight*0.75f)==0 &&
					gpEng->GetMapTile(mPos + mMoveRight*0.75f)==0 &&
					gpEng->GetMapTile(mPos+mMoveUp + mMoveRight*1)==0 &&
					gpEng->GetMapTile(mPos+mMoveUp - mMoveRight*1)==0 || // )//*/

					bSliding &&
					gpEng->GetMapTile(mPos+mSlideUp+mSlideForward*0.22f)>0 ||		//infront

					bSliding &&
					gpEng->GetMapTile(mPos+mSlideUp)>0 &&						//below
					gpEng->GetMapTile(mPos+mSlideUp + mSlideRight*0.75f)==0 &&	//below to right is empty
					gpEng->GetMapTile(mPos+mSlideUp - mSlideRight*0.75f)==0 &&	//below to left is empty
					gpEng->GetMapTile(mPos+mSlideUp+mSlideForward*0.52f - mSlideRight*0.75f)==0 &&			//left is empty
					gpEng->GetMapTile(mPos+mSlideUp+mSlideForward*0.52f + mSlideRight*0.75f)==0 &&			//right is empty
					gpEng->GetMapTile(mPos+mSlideForward*0.52f - mSlideRight*0.75f)==0 &&			//left is empty
					gpEng->GetMapTile(mPos+mSlideForward*0.52f + mSlideRight*0.75f)==0 &&			//right is empty
					gpEng->GetMapTile(mPos+mSlideUp+mSlideForward*0.52f)==0 ||	//infront is empty

					bSliding &&
					gpEng->GetMapTile(mPos+mSlideUp+mSlideForward*0.52f)==0 &&
					gpEng->GetMapTile(mPos+mSlideUp+mSlideForward*0.52f)==0 &&
					gpEng->GetMapTile(mPos+mSlideUp-mSlideForward*0.52f)==0 &&
					gpEng->GetMapTile(mPos+mSlideUp)>0 &&
					gpEng->GetMapTile(mPos - mSlideRight*0.75f)==0 &&
					gpEng->GetMapTile(mPos + mSlideRight*0.75f)==0 &&
					gpEng->GetMapTile(mPos+mSlideUp + mSlideRight*1)==0 &&
					gpEng->GetMapTile(mPos+mSlideUp - mSlideRight*1)==0 )//*/

				{
					bMoving = true;
					iTurnCounter = 1;
					if(!bSliding)
						mMove = mMoveForward * 0.05f;
				}
				else if(gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.95f)==0 && gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.72f+mMoveRight*0.5f)>0 && gpEng->GetMapTile(mPos+mMoveRight*0.5f)==0 && gpEng->GetMapTile(mPos+mMoveUp+mMoveRight*0.5f)>0 )
				{
					bMoving = true;
					iTurnCounter = 1;
					//TODO: dont allow to lerp around corner if too far from it
					if(!bSliding)
					{
					float dir;
					if(mMoveForward.x !=0)
						dir = mMoveForward.x>0?mMoveForward.x:-mMoveForward.x;
					else if(mMoveForward.y !=0)
						dir = mMoveForward.y>0?mMoveForward.y:-mMoveForward.y;
					else if(mMoveForward.z !=0)
						dir = mMoveForward.z>0?mMoveForward.z:-mMoveForward.z;
					//if(dir<=0.5)
					//	mMove = mMoveForward * 0.05f + mMoveRight * 0.06f;
					//else
						mMove = mMoveForward * 0 + mMoveRight * 0.04f;//was 0.5
					}
				}
				else if(gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.95f)==0 && gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.72f-mMoveRight*0.5f)>0 && gpEng->GetMapTile(mPos-mMoveRight*0.5f)==0 && gpEng->GetMapTile(mPos+mMoveUp-mMoveRight*0.5f)>0)
				{
					bMoving = true;
					iTurnCounter = 1;
					//if(!bSliding)
					//{
					float dir;
					if(mMoveForward.x !=0)
						dir = mMoveForward.x>0?mMoveForward.x:-mMoveForward.x;
					else if(mMoveForward.y !=0)
						dir = mMoveForward.y>0?mMoveForward.y:-mMoveForward.y;
					else if(mMoveForward.z !=0)
						dir = mMoveForward.z>0?mMoveForward.z:-mMoveForward.z;
					//if(dir<=0.5)
					//	mMove = mMoveForward * 0.05f - mMoveRight * 0.06f;
					//else
						mMove = mMoveForward * 0 -mMoveRight * 0.04f;//was 0.5
					//}
				}
				//extra lerping
				else if(gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.95f)==0 && gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.72f+mMoveRight*1.0f)>0 && gpEng->GetMapTile(mPos+mMoveRight*0.5f)==0 && gpEng->GetMapTile(mPos+mMoveUp+mMoveRight*0.5f)>0)
				{
					bMoving = true;
					iTurnCounter = 1;
					//TODO: dont allow to lerp around corner if too far from it
					if(!bSliding)
					{
					float dir;
					if(mMoveForward.x !=0)
						dir = mMoveForward.x>0?mMoveForward.x:-mMoveForward.x;
					else if(mMoveForward.y !=0)
						dir = mMoveForward.y>0?mMoveForward.y:-mMoveForward.y;
					else if(mMoveForward.z !=0)
						dir = mMoveForward.z>0?mMoveForward.z:-mMoveForward.z;
				//	if(dir<=0.5)
				//		mMove = mMoveForward * 0.05f + mMoveRight * 0.06f;
				//	else
						mMove = mMoveForward * 0 + mMoveRight * 0.04f;//was 0.5
					}
				}
				else if(gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.95f)==0 && gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.72f-mMoveRight*1.0f)>0 && gpEng->GetMapTile(mPos-mMoveRight*0.5f)==0 && gpEng->GetMapTile(mPos+mMoveUp-mMoveRight*0.5f)>0)
				{
					bMoving = true;
					iTurnCounter = 1;
					//if(!bSliding)
					//{
					float dir;
					if(mMoveForward.x !=0)
						dir = mMoveForward.x>0?mMoveForward.x:-mMoveForward.x;
					else if(mMoveForward.y !=0)
						dir = mMoveForward.y>0?mMoveForward.y:-mMoveForward.y;
					else if(mMoveForward.z !=0)
						dir = mMoveForward.z>0?mMoveForward.z:-mMoveForward.z;
				//	if(dir<=0.5)
				//		mMove = mMoveForward * 0.05f - mMoveRight * 0.06f;
				//	else
						mMove = mMoveForward * 0 -mMoveRight * 0.04f;//was 0.5
					//}
				}


				else if(gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.75f)==0 && gpEng->GetMapTile(mPos+mMoveUp)>0 && gpEng->GetMapTile(mPos+mMoveUp-mMoveRight*0.95f)==0 && gpEng->GetMapTile(mPos+mMoveUp+mMoveRight*0.95f)==0)
				{
					//if(!bSliding)
					//{
					Block* center = gpEng->GetMapTile(mPos+mMoveUp);
					if(center)
					{
//						float D = 0;
//						if((D=Distance(Reflect(mPos,mMoveUp,0),Reflect(center->pos,mMoveUp,0)))>0.3f)
						{
							bMoving = true;
							iTurnCounter = 1;
							mMove = (center->pos - mPos)*0.075f;
							mMove = Reflect(mMove, mMoveUp, 0);//cancel out upwards movement
					//gLog.OutPut("Drifting!\n");
						}
					}
						//char dist[64];
						//sprintf(dist,"%.2f\n",D);
						//gLog.OutPut(dist);
					//}
				}
/*				else
				{
					mMove *= 0;
				}//*/

			}

		}
		if(iKeyTurnLTime<=0)
		if(gpEng->KEY_TURN_LEFT.state == PRESSED)
		{
			bMoving = false;
			bTurning = true;
			iTurnCounter = 1;
			vTurn.x = -90;
			mMove *= 0;
			iKeyTurnLTime = 25;
			UTIL_Misc::Rand()%2?
				PlaySample(CHNL_UI_WHOOSH,gpEng->mSnd[SND_UI_WHOOSH],false):
			PlaySample(CHNL_UI_WHOOSH,gpEng->mSnd[SND_UI_WHOOSH3],false);
		}
		if(iKeyTurnRTime<=0)
		if(gpEng->KEY_TURN_RIGHT.state == PRESSED)
		{
			bMoving = false;
			bTurning = true;
			iTurnCounter = 1;
			vTurn.x = 90;
			mMove *= 0;
			iKeyTurnRTime = 25;
			UTIL_Misc::Rand()%2?
				PlaySample(CHNL_UI_WHOOSH,gpEng->mSnd[SND_UI_WHOOSH],false):
			PlaySample(CHNL_UI_WHOOSH,gpEng->mSnd[SND_UI_WHOOSH3],false);
		}

	}
	//_ASSERTE( _CrtCheckMemory( ) );

//	if(bJump)
//		gpEng->pLastBlock = NULL;
	//if there is nothing beneath us, better fall.
	if(!bJump && !bTurnCorner)
	{
		if(gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.2f)==0 &&//WAS 0.2f
			gpEng->GetMapTile(mPos+mMoveUp-mMoveForward*0.2f)==0 &&
			gpEng->GetMapTile(mPos+mMoveUp+mMoveRight*0.2f)==0 &&
			gpEng->GetMapTile(mPos+mMoveUp-mMoveRight*0.2f)==0 &&
			gpEng->GetMapTile(mPos+mMoveUp)==0 )
		{
//			gpEng->pLastBlock = NULL;
			if(mpPlatform)
				mpPlatform->mbPlayerIsRiding = false;
			mpPlatform = NULL;
			bJump = true;
			iJumpCounter = 0;
			mMoveUp = Normalize(mMoveUp);
			mGravity = mMoveUp*0.15f;
			mJumpVel = mMoveUp*0.15f;
			mJumpDir = Vec3((int)-mMoveUp.x,(int)-mMoveUp.y,(int)-mMoveUp.z);
			mPos += mJumpVel;
			PlaySample(CHNL_JUMP, gpEng->mSnd[SND_BALL_JUMP],false);
			//gLog.OutPut("Player Fell!\n");
		}
	}

	if(bTurning)
	{
		Vec2 angle;
		if(vTurn.x >0)
			angle.x = 5;
		if(vTurn.x <0)
			angle.x = -5;
		if(vTurn.y >0)
			angle.y = 5;
		if(vTurn.y <0)
			angle.y = -5;


		if(angle.y>0)
		{
			mBallForward = ArbitraryRotate(mBallForward,DEG2RAD(angle.x),mUp);
			mBallForward = ArbitraryRotate(mBallForward,DEG2RAD(10),mRight);
			mBallRight = ArbitraryRotate(mBallRight,DEG2RAD(angle.x),mUp);
			mBallRight = ArbitraryRotate(mBallRight,DEG2RAD(10),mRight);
			mBallUp = ArbitraryRotate(mBallUp,DEG2RAD(angle.x),mUp);
			mBallUp = ArbitraryRotate(mBallUp,DEG2RAD(10),mRight);
		}
		iTurnCounter++;
		mfRotation += angle;
		if(bSliding && vTurn.y<0)
		{
		mForward = ArbitraryRotate(mForward,DEG2RAD(angle.x),mSlideUp);
		mForward = ArbitraryRotate(mForward,DEG2RAD(angle.y),mSlideRight);
		mRight = ArbitraryRotate(mRight,DEG2RAD(angle.x),mSlideUp);
		mRight = ArbitraryRotate(mRight,DEG2RAD(angle.y),mSlideRight);
		mUp = ArbitraryRotate(mUp,DEG2RAD(angle.x),mSlideUp);
		mUp = ArbitraryRotate(mUp,DEG2RAD(angle.y),mSlideRight);
		}
		else
		{
		mForward = ArbitraryRotate(mForward,DEG2RAD(angle.x),mUp);
		mForward = ArbitraryRotate(mForward,DEG2RAD(angle.y),mRight);
		mRight = ArbitraryRotate(mRight,DEG2RAD(angle.x),mUp);
		mRight = ArbitraryRotate(mRight,DEG2RAD(angle.y),mRight);
		mUp = ArbitraryRotate(mUp,DEG2RAD(angle.x),mUp);
		mUp = ArbitraryRotate(mUp,DEG2RAD(angle.y),mRight);
		}

		if(iTurnCounter >= 19)
		{
			bTurning = false;
//			if(!bSliding)
			if(bSliding && vTurn.y <0)
			{
			mMoveForward = ArbitraryRotate(mMoveForward,DEG2RAD(vTurn.x),mSlideUp);
			mMoveForward = ArbitraryRotate(mMoveForward,DEG2RAD(vTurn.y),mSlideRight);
			mMoveRight = ArbitraryRotate(mMoveRight,DEG2RAD(vTurn.x),mSlideUp);
			mMoveRight = ArbitraryRotate(mMoveRight,DEG2RAD(vTurn.y),mSlideRight);
			mMoveUp = ArbitraryRotate(mMoveUp,DEG2RAD(vTurn.x),mSlideUp);
			mMoveUp = ArbitraryRotate(mMoveUp,DEG2RAD(vTurn.y),mSlideRight);

			mSlideForward = ArbitraryRotate(mSlideForward,DEG2RAD(vTurn.x),mSlideUp);
			mSlideForward = ArbitraryRotate(mSlideForward,DEG2RAD(vTurn.y),mSlideRight);
			mSlideRight = ArbitraryRotate(mSlideRight,DEG2RAD(vTurn.x),mSlideUp);
			mSlideRight = ArbitraryRotate(mSlideRight,DEG2RAD(vTurn.y),mSlideRight);
			mSlideUp = ArbitraryRotate(mSlideUp,DEG2RAD(vTurn.x),mSlideUp);
			mSlideUp = ArbitraryRotate(mSlideUp,DEG2RAD(vTurn.y),mSlideRight);
			mSlideForward = Vec3((int)mSlideForward.x, (int)mSlideForward.y, (int)mSlideForward.z);
			mSlideRight = Vec3((int)mSlideRight.x, (int)mSlideRight.y, (int)mSlideRight.z);
			mSlideUp = Vec3((int)mSlideUp.x, (int)mSlideUp.y, (int)mSlideUp.z);
			}
			else
			{
			mMoveForward = ArbitraryRotate(mMoveForward,DEG2RAD(vTurn.x),mMoveUp);
			mMoveForward = ArbitraryRotate(mMoveForward,DEG2RAD(vTurn.y),mMoveRight);
			mMoveRight = ArbitraryRotate(mMoveRight,DEG2RAD(vTurn.x),mMoveUp);
			mMoveRight = ArbitraryRotate(mMoveRight,DEG2RAD(vTurn.y),mMoveRight);
			mMoveUp = ArbitraryRotate(mMoveUp,DEG2RAD(vTurn.x),mMoveUp);
			mMoveUp = ArbitraryRotate(mMoveUp,DEG2RAD(vTurn.y),mMoveRight);
			}
			mMoveForward = Vec3((int)mMoveForward.x, (int)mMoveForward.y, (int)mMoveForward.z);
			mMoveRight = Vec3((int)mMoveRight.x, (int)mMoveRight.y, (int)mMoveRight.z);
			mMoveUp = Vec3((int)mMoveUp.x, (int)mMoveUp.y, (int)mMoveUp.z);
			mForward = mMoveForward;
			mRight = mMoveRight;
			mUp = mMoveUp;
			if(vTurn.y>0)
			{
//				gLog.OutPut("Started Turning corner!\n");
				bTurnCorner = true;
				bMoving = true;
				iTurnCounter = -4;
				mMove = mMoveForward * 0.1f;
			//	fBounceScale=0.025f;
				bLanded = true;
			}
			if(vTurn.y<0)
			{
				bMoving = true;
				iTurnCounter = 1;
				if(!bSliding)
					mMove = mMoveForward * 0.1f;
				else
					mMove = mSlideForward * 0.1f;

			}
			if(bTurnCorner && bSliding)
			{
				mIceSlide = mSlideForward * 0.05f;
				mSlideMove = mIceSlide;
			}
			//bSliding = false;
			if(vTurn.y<0)
				bTurnCorner = false;
			vTurn = Vec2(0,0);



		}
	}
	else if(bMoving)// || mMove.Length()>0.01)
	{
		Vec2 angle(0,10);
		if(!bSliding)
		{
		mBallForward = ArbitraryRotate(mBallForward,DEG2RAD(angle.x),mUp);
		mBallForward = ArbitraryRotate(mBallForward,DEG2RAD(angle.y),mRight);
		mBallRight = ArbitraryRotate(mBallRight,DEG2RAD(angle.x),mUp);
		mBallRight = ArbitraryRotate(mBallRight,DEG2RAD(angle.y),mRight);
		mBallUp = ArbitraryRotate(mBallUp,DEG2RAD(angle.x),mUp);
		mBallUp = ArbitraryRotate(mBallUp,DEG2RAD(angle.y),mRight);
		}
		else
		{
		mBallForward = ArbitraryRotate(mBallForward,DEG2RAD(angle.x),mSlideUp);
		mBallForward = ArbitraryRotate(mBallForward,DEG2RAD(angle.y),mSlideRight);
		mBallRight = ArbitraryRotate(mBallRight,DEG2RAD(angle.x),mSlideUp);
		mBallRight = ArbitraryRotate(mBallRight,DEG2RAD(angle.y),mSlideRight);
		mBallUp = ArbitraryRotate(mBallUp,DEG2RAD(angle.x),mSlideUp);
		mBallUp = ArbitraryRotate(mBallUp,DEG2RAD(angle.y),mSlideRight);
		}
		int X = mMoveForward.x != 0? 1:0;
		int Y = mMoveForward.y != 0? 1:0;
		int Z = mMoveForward.z != 0? 1:0;
		if(bSliding)
		{
			X = mSlideForward.x != 0? 1:0;
			Y = mSlideForward.y != 0? 1:0;
			Z = mSlideForward.z != 0? 1:0;
		}
	//	if(iTurnCounter == 1)
		{
			if(!bSliding && bJump && gpEng->GetMapTile(mPos+Normalize(mMove)*0.5f) || !bSliding && !bJump && gpEng->GetMapTile(mPos+mForward*0.5f) ||
			bSliding && bJump && gpEng->GetMapTile(mPos+Normalize(mSlideForward)*0.5f) || bSliding && !bJump && gpEng->GetMapTile(mPos+mSlideForward*0.5f))
			{
				bTurnCorner = false;
				bMoving = false;
				if(!bJump)
				{
					bTurning = true;
					iTurnCounter = 1;
					bTurnCorner = true;
					vTurn.y = -90;
				//	gLog.OutPut("Corner\n");
					return;
				}
			}
		}
		Block* B1= NULL, *B2= NULL, *B3 = NULL;
		if(bJump && (B1=gpEng->GetMapTile(mPos+Normalize(mMove)*0.5f)) )// || 
//			bJump && (B2=gpEng->GetMapTile(mPos+mMoveForward*0.5f+mMoveRight*0.15f)) || 
//			bJump && (B3=gpEng->GetMapTile(mPos+mMoveForward*0.5f-mMoveRight*0.15f)) ) 
		{
/*			if(B1 && B1->mbPlatform)
				mPos += B1->pPlat->mMoveSpeed;
			if(B2 && B2->mbPlatform)
				mPos += B2->pPlat->mMoveSpeed;
			if(B3 && B3->mbPlatform)
				mPos += B3->pPlat->mMoveSpeed;*/
			//gLog.OutPut("Hit a wall!\n");
			bMoving = false;
			mMove = -mMoveForward * 0.05f;
			PlaySample(CHNL_BALL_CLIP,gpEng->mSnd[SND_BALL_CLIP],false);
			return;
		}
		//smooth motion so that we stay on track with the current block
		Block* bl = gpEng->GetMapTile(mPos+mMoveUp);
		if(bl == NULL)//see if we are on the edge
			bl = gpEng->GetMapTile(mPos+mMoveUp-mMoveRight*0.2f);
		if(bl == NULL)//see if we are on the edge
			bl = gpEng->GetMapTile(mPos+mMoveUp+mMoveRight*0.2f);
		if(!bSliding)
		mPos += mMove;
		if(bl && !bJump)// && !mpPlatform)
		{
/*		if(X==0)
			mPos.x += ((0.5f-(mPos.x-(int)mPos.x))*0.05f);
		if(Y==0)
			mPos.y += ((0.5f-(mPos.y-(int)mPos.y))*0.05f);
		if(Z==0)
			mPos.z += ((0.5f-(mPos.z-(int)mPos.z))*0.05f);
*/
			if(X==0)
				mPos.x += (((bl->pos.x-mPos.x))*0.05f);
			if(Y==0)
				mPos.y += (((bl->pos.y-mPos.y))*0.05f);
			if(Z==0)
				mPos.z += (((bl->pos.z-mPos.z))*0.05f);
			//rolled onto a platform
			if(!mpPlatform && bl->mbPlatform)
			{
				if(!gpEng->mPlatforms.empty())
				{
					std::list<Platform*>::iterator pl;
					for(pl=gpEng->mPlatforms.begin(); pl!=gpEng->mPlatforms.end(); pl++)
					{
						if((*pl)->PointInPlat(mPos+mMoveUp) && (*pl)->GetTileInPlat(mPos+mMoveUp) ||
							(*pl) == bl->pPlat || 
						(*pl)->PointInPlat(mPos-mMoveUp+mMoveRight*0.2f) && (*pl)->GetTileInPlat(mPos-mMoveUp+mMoveRight*0.2f) ||
						(*pl)->PointInPlat(mPos-mMoveUp-mMoveRight*0.2f) && (*pl)->GetTileInPlat(mPos-mMoveUp-mMoveRight*0.2f) )
						{
							(*pl)->mbPlayerIsRiding = true;
							mpPlatform = (*pl);
							//if((*pl)->PointInPlat(mPos+mMoveUp))
								if((*pl)->bTriggerTouch)
								{
									(*pl)->Trigger();
							(*pl)->mbPlayerIsRiding = false;
							mpPlatform = NULL;
								}
							break;
						}
					}
				}
			}
		}


		iTurnCounter++;
		if(!bJump)
		if(gpEng->GetMapTile(mPos+mMoveUp)==0 && gpEng->GetMapTile(mPos+mMoveUp-mMoveRight*0.2f)==0 && gpEng->GetMapTile(mPos+mMoveUp+mMoveRight*0.2f)==0 && gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.5f)==0)
		{
			if(!bSliding)
			bTurnCorner = true;
			//gLog.OutPut("Cornering!\n");
		}



		if(iTurnCounter >= 4)//was == 11 before inertia was added
		{
			bMoving = false;
			bTurnCorner = false;
			if(!bJump)
			if(gpEng->GetMapTile(mPos+mMoveUp)==0 && gpEng->GetMapTile(mPos+mMoveUp-mMoveRight*0.2f)==0 && gpEng->GetMapTile(mPos+mMoveUp+mMoveRight*0.2f)==0)
			if(gpEng->GetMapTile(mPos+mMoveUp-mMoveRight*0.75f-mMoveForward*0.5f)==0 && gpEng->GetMapTile(mPos+mMoveUp+mMoveRight*0.75f-mMoveForward*0.5f)==0)
			{
				if(	gpEng->GetMapTile(mPos+mMoveUp-mMoveForward*1.5f)>0 || gpEng->GetMapTile(mPos+mMoveUp-mMoveForward*0.5f)>0 )
			//	if(	gpEng->GetMapTile(mPos+mMoveUp-mMoveForward*0.1f)>0)
				if(gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.22f)==0 || gpEng->GetMapTile(mPos+mMoveForward*0.5f)>0)
				{
					if(!bSliding)
					{
					bTurning = true;
					iTurnCounter = 1;
					vTurn.y = 90;
					bTurnCorner = true;
					//gLog.OutPut("Turned corner..\n");
					}
				}
			}
			if(bJump)
			//if(gpEng->KEY_FORWARD.state == PRESSED && iJumpCounter>16 || iJumpCounter<=16)
			{
				iTurnCounter = 1;
				bMoving = true;
			}
		}
//		if(gpEng->KEY_FORWARD.state == RELEASED)
//			mMove *= 0.927f;
	}
	//_ASSERTE( _CrtCheckMemory( ) );

	if(bJump)
	{
		bSliding = false;
		iJumpCounter++;
		if(iJumpCounter>=iMaxJumpCounter)
			mMove *= 0;
		Block* b = NULL;
		if((b=gpEng->GetMapTile(mPos-mJumpDir*0.25f))>0)// ||
		//	(b=gpEng->GetMapTile(mPos-mJumpDir*0.35f+mMoveForward*0.2f))>0 ||
		//	(b=gpEng->GetMapTile(mPos-mJumpDir*0.35f-mMoveForward*0.2f))>0 ||
		//	(b=gpEng->GetMapTile(mPos-mJumpDir*0.35f-mMoveRight*0.2f))>0 ||
		//	(b=gpEng->GetMapTile(mPos-mJumpDir*0.35f+mMoveRight*0.2f))>0)

		{
			//Block* b = gpEng->GetMapTile(mPos-mJumpDir*0.25f);
			if(b)
			{
				//gLog.OutPut("Hit a block\n");
			//iTurnCounter = 1;
			//bTurning = false;
//			mPos = mOPos;
/*			float X = mJumpDir.x!=0?
				(mJumpDir.x<0?(int)mPos.x+0.75f:(int)mPos.x+0.25f):mPos.x;
			float Y = mJumpDir.y!=0?
				(mJumpDir.y<0?(int)mPos.y+0.75f:(int)mPos.y+0.25f):mPos.y;
			float Z = mJumpDir.z!=0?
				(mJumpDir.z<0?(int)mPos.z+0.75f:(int)mPos.z+0.25f):mPos.z;
*/

			//check see if we landed on a platform
			bool FallThrough = false;
			if(b->mbPlatform)
			if(!gpEng->mPlatforms.empty())
			{
				FallThrough = true;
				std::list<Platform*>::iterator pl;
				for(pl=gpEng->mPlatforms.begin(); pl!=gpEng->mPlatforms.end(); pl++)
				{
					if((*pl)->PointInPlat(mPos-mJumpDir*0.25f) && (*pl)->GetTileInPlat(mPos-mJumpDir*0.25f))// ||
	//					(*pl)->PointInPlat(mPos-mJumpDir*0.35f+mMoveRight*0.2f) && (*pl)->GetTileInPlat(mPos-mJumpDir*0.35f+mMoveRight*0.2f) ||
	//					(*pl)->PointInPlat(mPos-mJumpDir*0.35f-mMoveRight*0.2f) && (*pl)->GetTileInPlat(mPos-mJumpDir*0.35f-mMoveRight*0.2f) )

					{
						Vec3 Perp = Reflect(mJumpDir,(*pl)->mPos-(*pl)->mOPos,0);
						if(Perp.Length()>0)
						{
						//if((*pl)->PointInPlat(mPos))
							if((*pl)->bTriggerTouch)
								(*pl)->Trigger();
						FallThrough = false;
						b = (*pl)->GetTileInPlat(mPos-mJumpDir*0.25f);
						if(b==NULL)
							b = (*pl)->GetTileInPlat(mPos-mJumpDir*0.35f+mMoveRight*0.2f);
						if(b==NULL)
							b = (*pl)->GetTileInPlat(mPos-mJumpDir*0.35f-mMoveRight*0.2f);
						char szBlock[64];
						//gLog.OutPut("Landed on a platform...\n");
						//sprintf(szBlock,"Pos X%.2f, Y%.2f, Z%.2f\n",b->pos.x, b->pos.y, b->pos.z);
						//gLog.OutPut(szBlock);
						//sprintf(szBlock,"Platform: Pos X%.2f, Y%.2f, Z%.2f\n",(*pl)->mPos.x, (*pl)->mPos.y, (*pl)->mPos.z);
						//gLog.OutPut(szBlock);

						(*pl)->mbPlayerIsRiding = true;
						mpPlatform = (*pl);
						}

					}
				}
			}
			if(!FallThrough)
			{
				//gLog.OutPut("clamped\n");
			//clamp to the surface
			float X = mJumpDir.x!=0?
				(mJumpDir.x<0?b->pos.x-0.75f:b->pos.x+0.75f):mPos.x;
			float Y = mJumpDir.y!=0?
				(mJumpDir.y<0?b->pos.y-0.75f:b->pos.y+0.75f):mPos.y;
			float Z = mJumpDir.z!=0?
				(mJumpDir.z<0?b->pos.z-0.75f:b->pos.z+0.75f):mPos.z;

			mPos = Vec3(X,Y,Z);//&/
			bJump = false;
			mMove *= 0;
			bTurnCorner = false;

			PS_BallJumpDust* PS = new PS_BallJumpDust;
			PS->Spawn(mPos+mUp*0.2f,mUp,Vec2(16,16),Vec3(1,0.8f,0.2f),0,1,1);
			gpEng->mPartEng.InsertAlphaSystem(PS);

	//		fBounceScale=0.025f;
			bLanded = true;
			//check to see if the ball is stuck inside a block and nudge it out
			}
			while(gpEng->GetMapTile(mPos-mMoveRight*0.25f) || gpEng->GetMapTile(mPos+mMoveRight*0.25f) ||
				gpEng->GetMapTile(mPos-mMoveForward*0.25f) || gpEng->GetMapTile(mPos+mMoveForward*0.25f) )
			{
				//gLog.OutPut("Nudge*\n");
				if(gpEng->GetMapTile(mPos-mMoveRight*0.25f))
					mPos += mMoveRight*0.25f;
				if(gpEng->GetMapTile(mPos+mMoveRight*0.25f))
					mPos -= mMoveRight*0.25f;
				if(gpEng->GetMapTile(mPos-mMoveForward*0.25f))
					mPos += mMoveForward*0.25f;
				if(gpEng->GetMapTile(mPos+mMoveForward*0.25f))
					mPos -= mMoveForward*0.25f;
			}
			PlaySample(CHNL_BALL_CLIP,gpEng->mSnd[SND_BALL_CLIP],false);
			}


		}
		else if(gpEng->GetMapTile(mPos))
		{
			//gLog.OutPut("Collided during a jump...\n");
			//char szBlock[64];
			Block* bl = gpEng->GetMapTile(mPos);
			//sprintf(szBlock,"Pos X%.2f, Y%.2f, Z%.2f\n",bl->pos.x, bl->pos.y, bl->pos.z);
			//gLog.OutPut(szBlock);
			//bJump = false;
			mJumpVel = -mJumpVel;
			PlaySample(CHNL_BALL_CLIP,gpEng->mSnd[SND_BALL_CLIP],false);
			mPos += mJumpVel;
		}
		else
		{
			mGravity *= 1.025f;
			mJumpVel += mGravity *0.045f;
			mJumpVel.x = UTIL_Misc::Clamp(mJumpVel.x,-0.25f,0.25f);
			mJumpVel.y = UTIL_Misc::Clamp(mJumpVel.y,-0.25f,0.25f);
			mJumpVel.z = UTIL_Misc::Clamp(mJumpVel.z,-0.25f,0.25f);
			mPos += mJumpVel;
		}
		if(!bMoving)
		{
			Vec2 angle(0,10);
			mBallForward = ArbitraryRotate(mBallForward,DEG2RAD(angle.x),mUp);
			mBallForward = ArbitraryRotate(mBallForward,DEG2RAD(angle.y),mRight);
			mBallRight = ArbitraryRotate(mBallRight,DEG2RAD(angle.x),mUp);
			mBallRight = ArbitraryRotate(mBallRight,DEG2RAD(angle.y),mRight);
			mBallUp = ArbitraryRotate(mBallUp,DEG2RAD(angle.x),mUp);
			mBallUp = ArbitraryRotate(mBallUp,DEG2RAD(angle.y),mRight);

		}
	}
	//_ASSERTE( _CrtCheckMemory( ) );
	if(!mbTimeOut && !mbStageWon && !mbLostBall)
	if(!bTurning && !bTurnCorner)
	{
		if(!bJump)
		{
			if(gpEng->KEY_JUMP.state == JUST_PRESSED)
			{
				PlaySample(CHNL_JUMP, gpEng->mSnd[SND_BALL_JUMP],false);
				bJump = true;
				iJumpCounter = 0;
				mGravity = mMoveUp*0.15f;
				mJumpVel = -mMoveUp*0.15f;
				mMoveUp = Normalize(mMoveUp);
				mJumpDir = Vec3((int)-mMoveUp.x,(int)-mMoveUp.y,(int)-mMoveUp.z);
				mPos += mJumpVel;
				if(gpEng->KEY_FORWARD.state == PRESSED)
				{
					iMaxJumpCounter = 40;
					bMoving = true;
					mMove = mMoveForward * 0.05f;
					if(gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.75f)==0 && gpEng->GetMapTile(mPos+mMoveForward*2.0f))
						mMove = mMoveForward * 0.075f;

					iTurnCounter = 1;
					mIceSlide = mMoveForward * 0.05f;
					mSlideForward = mMoveForward;
					mSlideRight = mMoveRight;
					mSlideUp = mMoveUp;
				}
				else if(bSliding)
				{
					mSlideMove = mIceSlide;
					mMove = mSlideMove;
					iMaxJumpCounter = 40;
					bMoving = true;
					iTurnCounter = 1;
					bSlideJump = true;
				}
				if(mpPlatform)
				{
					float DOT = Dot(mMoveUp,Normalize(mpPlatform->mPos - mpPlatform->mOPos));
					if(/*DOT == 1 ||*/ DOT == -1)
						mMove += mpPlatform->mPos - mpPlatform->mOPos;
					mpPlatform->mbPlayerIsRiding = false;
				}
				mpPlatform = NULL;
			}


		}
	}



//*/
	if(bLanded)
	{
		fBounceScale += 0.005f;
		if(fBounceScale>=0.025f)
			bLanded = false;
	}
	else
	fBounceScale*=0.87f;

	//check to see if the player has fallen out of the map
	if(!mbFallOut && !mbTimeOut && !mbLostBall)// && !mbStageWon
	if(mPos.x <-20 || mPos.y <-20 || mPos.z <-20 || mPos.x > MAP_DIMENSIONS+20 || mPos.y > MAP_DIMENSIONS+20 || mPos.z > MAP_DIMENSIONS+20)
	{
		MasterMusicFadeout(500);
		PlaySample(CHNL_VOICE, gpEng->mSnd[SND_VOICE_DROPOUT],false);
		mbFallOut = true;
		mFallPos = mPos;
		mbStageWon = false;
		miActionTimer = 0;
		LoseLife();
	}

	if(gpEng->mFadeEng.mSystems.empty())
	{
		if(mbFallOut || mbTimeOut || mbLostBall || mbGameOver)
		{
			miActionTimer++;
			if(miActionTimer == 1)
				MasterMusicFadeout(500);
			if(!mbGameOver)
			{
				if(!mbLostBall && miActionTimer == 200 || mbLostBall && miActionTimer == 500)
				{
					if(!gpEng->bBonusStage)
					{
						if(gpEng->bTutorialGame)
						{
							gpEng->StartTutorial();
						}
						else
						{
							SureMenu* menu = new SureMenu;
							menu->Spawn(Vec2(320,240));
							menu->iExternalCode = SureMenu::SURE_RETRY_STAGE;
							strcpy(menu->szMessage,"TRY AGAIN?");
							gpEng->mMenus.push_back(menu);
						}
					}
					else
					{
						FADE_StarOut* FS = new FADE_StarOut;
						FS->Spawn(1,Vec3(1,1,1));
						gpEng->mFadeEng.InsertSystem(FS);//*/
						gpEng->ChangeState(STATE_STAGESELECT,125,&CALLBACK_StartStageSelect);
						gpEng->CleanupMap();
					}

				}
			}
			else
			{
				if(!mbLostBall && miActionTimer == 500 || mbLostBall && miActionTimer == 800)
				{
					if(!gpEng->bBonusStage)
					{
						SureMenu* menu = new SureMenu;
						menu->Spawn(Vec2(320,240));
						menu->iExternalCode = SureMenu::SURE_RETRY_WORLD;
						strcpy(menu->szMessage,"CONTINUE GAME?");
						gpEng->mMenus.push_back(menu);
					}
					else
					{
						FADE_StarOut* FS = new FADE_StarOut;
						FS->Spawn(1,Vec3(1,1,1));
						gpEng->mFadeEng.InsertSystem(FS);//*/
						gpEng->ChangeState(STATE_STAGESELECT,125,&CALLBACK_StartStageSelect);
						gpEng->CleanupMap();
					}
				}
			}
		}

		if(mbStageWon && gpEng->GetMapTile(mPos+mMoveUp) && !bJump && miActionTimer<300 && !bSliding ||
		 mbStageWon && miActionTimer>=300)
		{
			Block* BLOCK = gpEng->GetMapTile(mPos+mMoveUp);
			if(BLOCK && BLOCK->iSpecial != SURF_BREAK || BLOCK == NULL)
			{
			miActionTimer++;
			gpEng->mi1UpGiveTimer--;
			if(gpEng->mi1UpGiveTimer<=0)
			{
				gpEng->mi1UpGiveTimer = 50;
				if(gpEng->miLocal1UpCount>0)
				{
					gpEng->miLocal1UpCount--;
					//gpEng->mi1UpSlotTime[gpEng->miLocal1UpCount]=50;
					gpEng->miLives++;
				}
			}

			//rotate the camera
			float turnAngle = 3;
			if(miActionTimer<150)
				turnAngle = ((float)miActionTimer/150.0f)*3;
			if(miActionTimer>350)
				turnAngle = 3-(((float)(miActionTimer-350)/150.0f)*3);
			mForward = ArbitraryRotate(mForward,DEG2RAD(turnAngle),mUp);
			mForward = ArbitraryRotate(mForward,DEG2RAD(0),mRight);
			mRight = ArbitraryRotate(mRight,DEG2RAD(turnAngle),mUp);
			mRight = ArbitraryRotate(mRight,DEG2RAD(0),mRight);
			mUp = ArbitraryRotate(mUp,DEG2RAD(turnAngle),mUp);
			mUp = ArbitraryRotate(mUp,DEG2RAD(0),mRight);

			if(miActionTimer == 1)
			{
				MasterMusicFadeout(250);
				if(gpEng->bBonusStage || gpEng->mbPerfect)
					gpEng->miScore += 1000;
			}
			//spawn area effect
			if(miActionTimer==50)
			{
				PlayMusic(gpEng->mClearedMusic,false,false);
				PS_AreaClear* PS = new PS_AreaClear;
				PS->mTarget = Vec3(320,180,0)+Vec3(sin((float)300*0.075f)*240,cos((float)300*0.075f)*100,0);
				PS->Spawn(PS->mTarget,Vec3(0,0,0),Vec2(16,16),Vec3(1,1,0),0,1,2);
				gpEng->mPartEng.InsertSystem(PS,true);
				PlaySample(CHNL_CHEER,gpEng->mSnd[SND_CHEER],false);

			}
			if(miActionTimer==250)
			{
			//TODO: Start win music
			}
			//make the ball jump up and down
			if(miActionTimer>=300)
			if(miActionTimer%50 == 0)
			{
				if(mpPlatform)
					mpPlatform->mbPlayerIsRiding = false;
				mpPlatform = NULL;
				bJump = true;
				iJumpCounter = 0;
				mGravity = mMoveUp*0.15f;
				mJumpVel = -mMoveUp*0.15f;
				mMoveUp = Normalize(mMoveUp);
				mJumpDir = Vec3((int)-mMoveUp.x,(int)-mMoveUp.y,(int)-mMoveUp.z);
				mPos += mJumpVel;
				iTurnCounter = 1;
			}

			if(miActionTimer==500)
			{
				MasterMusicFadeout(125);
					//beat the final level
					if(gpEng->miSelectedStageBall==12)
						mbWorldWon = true;
					mOPos = mPos;
					gpEng->mGameEnts.remove_if(FreezeEnts);
					gpEng->mPlatforms.remove_if(FreezePlatforms);
					//gpEng->RenderSceneToFadeBuffer();
					FADE_StarOut* FS = new FADE_StarOut;
					FS->Spawn(1,Vec3(1,1,1));
					gpEng->mFadeEng.InsertSystem(FS);//*/
					if(gpEng->bTutorialGame)
						gpEng->ChangeState(STATE_SPLASH,125,&CALLBACK_StartSplash);
					else
						gpEng->ChangeState(STATE_STAGESELECT,125,&CALLBACK_StartStageSelect);
					//gpEng->CleanupMap();

					if(!gpEng->bTutorialGame)
					{
						//THIS SHOULD ONLY HAPPEN WHEN THE STAGE IS COMPLETE
						//copy persistance over for the played stage into storage ** this should only be done when the stage is completed**
						if(!gpEng->bBonusStage)
						{
						gpEng->mbStageSelect[gpEng->miSelectedStageBall] = true;
						std::list<unsigned int>::iterator it;
						for(it = gpEng->miCurrentPersistance.begin(); it!=gpEng->miCurrentPersistance.end(); it++)
						{
							gpEng->miStagePersistance[gpEng->miSelectedStageBall].push_back((*it));
						}
						gpEng->miGemCount += gpEng->miLocalGemCount;
						gpEng->miStarCount += gpEng->miLocalStarCount;
						gpEng->miCurrentPersistance.clear();
						gpEng->SavePerstistanceData();
						//gpEng->miGemCount+=50;//TODO this must be removed
						}
						if(gpEng->bBonusStage)
						{
							gpEng->iBonusStage++;
							gpEng->bBonusStage = false;
						}
						gpEng->SaveGameSlot();
					}
				return;
			}
			}
		}
	}
	if(mPos.x <-50 || mPos.y <-50 || mPos.z <-50 || mPos.x > MAP_DIMENSIONS+50 || mPos.y > MAP_DIMENSIONS+50 || mPos.z > MAP_DIMENSIONS+50)
	{
		mPos = mOPos;
	}

	//_ASSERTE( _CrtCheckMemory( ) );

	gpEng->mCameraShake = Vec3(0,0,0);
	//see if player is on a special tile
	Block* BLOCK = NULL;
	if((BLOCK=gpEng->GetMapTile(mPos+mMoveUp)) ||
		!bSliding && (BLOCK=gpEng->GetMapTile(mPos+mMoveUp+mMoveForward*0.25f)) ||
		!bSliding && (BLOCK=gpEng->GetMapTile(mPos+mMoveUp-mMoveForward*0.25f)) ||
		!bSliding && (BLOCK=gpEng->GetMapTile(mPos+mMoveUp+mMoveRight*0.25f)) ||
		!bSliding && (BLOCK=gpEng->GetMapTile(mPos+mMoveUp-mMoveRight*0.25f)) ||
		bSliding && (BLOCK=gpEng->GetMapTile(mPos+mMoveUp+mSlideForward*0.25f)) ||
		bSliding && (BLOCK=gpEng->GetMapTile(mPos+mMoveUp-mSlideForward*0.25f)) ||
		bSliding && (BLOCK=gpEng->GetMapTile(mPos+mMoveUp+mSlideRight*0.25f)) ||
		bSliding && (BLOCK=gpEng->GetMapTile(mPos+mMoveUp-mSlideRight*0.25f)) )

	{
		int FACE = GetBlockFace(*BLOCK,mMoveUp);
		if(BLOCK->Faces[FACE]==SURF_BREAK)
		{
			//	gLog.OutPut("Touched a breakable tile!\n");
			BLOCK->iSpecial = SURF_BREAK;
			float MUL = 1;
			if(BLOCK->iScaleDelay>=20)
				MUL = UTIL_Misc::TimeRamp(0,1,0,15,35-BLOCK->iScaleDelay);
			if(BLOCK->iScaleDelay<=10)
				MUL = UTIL_Misc::TimeRamp(1,0,0,10,10-BLOCK->iScaleDelay);
			if(!gpEng->mbCamPreviewMode)
				gpEng->mCameraShake = Vec3(UTIL_Misc::RandFloat(0.1f)-0.05f,UTIL_Misc::RandFloat(0.1f)-0.05f,UTIL_Misc::RandFloat(0.1f)-0.05f) * MUL;
			if(BLOCK->iScaleDelay == 35)
			{
				float DIST = Distance(BLOCK->pos,gpEng->mCameraPos);
				if(DIST<10)
					SetSoundPosition(PlaySample(gpEng->mSnd[SND_CRUMBLE],false), 0, (DIST+1)*50);
			}
		}
		if(BLOCK->Faces[FACE]!=SURF_ICE)
		{
		//	if(!bTurnCorner)
			{
			mIceSlide = mMoveForward * 0.05f;
			mSlideForward = mMoveForward;
			mSlideRight = mMoveRight;
			mSlideUp = mMoveUp;
			}
		//	gLog.OutPut("changed ice direction.\n");
			if(!bJump)
			if(gpEng->bBonusStage)
			{
				if(!BLOCK->bColored && gpEng->pLastBlock != BLOCK)
				{
					gpEng->pLastBlock = BLOCK;
					if(BLOCK->Faces[FACE]!=SURF_BREAK)
					{
						for(int n=0; n<6; n++)
							if(BLOCK->Faces[n] == SURF_JUMP)
								BLOCK->Faces[n] += 2;
							else	BLOCK->Faces[n]++;
						BLOCK->bColored = true;
						BLOCK->iColortime = 50;
						gpEng->iColoredBlocks--;
						if(gpEng->iColoredBlocks<=0 && BLOCK->Faces[FACE] != SURF_JUMP && BLOCK->Faces[FACE] != SURF_JUMP+2)
						{
							if(!mbStageWon)
							{
								mbStageWon = true;
								miActionTimer = 0;
								iDmgTime = 2;
								gpEng->mi1UpGiveTimer = 100;
							}
						}
					}
				}
				else if(gpEng->pLastBlock != BLOCK)
				{
					gpEng->pLastBlock = BLOCK;
					if(BLOCK->Faces[FACE]!=SURF_BREAK)
					{
						if(BLOCK->bColored)
						{
						for(int n=0; n<6; n++)
							if(BLOCK->Faces[n] > SURF_JUMP)
								BLOCK->Faces[n] -= 2;
							else
							BLOCK->Faces[n]--;
						BLOCK->bColored = false;
						BLOCK->iColortime = 50;
						gpEng->iColoredBlocks++;
						}
					}
				}
			}
		}
		if(!bJump)
		{
			if(BLOCK->Faces[FACE]==SURF_JUMP || BLOCK->Faces[FACE]==SURF_JUMP+2 )
			{
				if(mpPlatform)
					mpPlatform->mbPlayerIsRiding = false;
				mpPlatform = NULL;
				PlaySample(CHNL_JUMP_PAD, gpEng->mSnd[SND_BALL_JUMP_PAD],false);
				bJump = true;
				iJumpCounter = 0;
				mGravity = mMoveUp*0.15f;
				mJumpVel = -mMoveUp*0.15f;
				mMoveUp = Normalize(mMoveUp);
				mJumpDir = Vec3((int)-mMoveUp.x,(int)-mMoveUp.y,(int)-mMoveUp.z);
				mPos += mJumpVel;
	//			if(gpEng->KEY_FORWARD.state == PRESSED)
				{
					iMaxJumpCounter = 32;
					bMoving = true;
	/*				if(Distance(mPos,BLOCK->pos)>1.15f)
					{
						mMove = mMoveForward * 0.1f;
						gLog.OutPut("Extend\n");
					}
					else*/
						mMove = mMoveForward * 0.095f;
					//if coming around a corner onto the jump, its too short
					if(bTurnCorner)
						mMove = mMoveForward * 0.12f;
					bTurnCorner = false;

					iTurnCounter = 1;
				}
			}
			if(BLOCK->Faces[FACE]==SURF_ICE)
			{
				if(!bSliding)
				{
					//need to test if this is landing from a jump
					if(!bSlideJump)
					{
					mIceSlide = mMoveForward * 0.05f;
					mSlideForward = mMoveForward;
					mSlideRight = mMoveRight;
					mSlideUp = mMoveUp;
					}
					bSlideJump = false;
					mSlideMove = mIceSlide;
					bSliding = true;
				}
			//	if(bTurnCorner)
			//		bSliding = false;
			}
			else if(!bTurnCorner)
				bSliding = false;

		}
	}
	if(bTurnCorner)
		mSlideMove = Vec3(0,0,0);
	if(!bSliding)
	{
		mSlideMove *= 0.85f;
	}
	if(!mbTimeOut && !mbLostBall)
	mPos += mSlideMove;
	//_ASSERTE( _CrtCheckMemory( ) );
}
void Player::Render(const float interp, int pass)
{
	if(mbLostBall && iDeathTime <=0)
		return;
	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mBallForward, mBallOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mBallRight, mBallORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mBallUp, mBallOUp, interp);

	if(iDeathTime>0)
	{
		p += mShakeBall;
	}
/*	glBegin(GL_LINES);
	glColor3f(1,0,0);
//	glVertex3fv((p).v);
//	glVertex3fv((p+u*0.5f).v);
//	glColor3f(0,1,0);
//	glVertex3fv((p-r*0.5f).v);
//	glVertex3fv((p+r*0.5f).v);
//	glColor3f(0,0,1);
	glVertex3fv((p).v);
	glVertex3fv((p+f*0.5f).v);
	glEnd();
//*/
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	double mat[16];
	float scale = fBounceScale * 22.5f;
	glScalef(0.25f,0.25f,0.25f);
	glScalef(mMoveUp.x>0? 1-mMoveUp.x*scale:1+mMoveUp.x*scale,
		mMoveUp.y>0?1-mMoveUp.y*scale:1+mMoveUp.y*scale,
		mMoveUp.z>0?1-mMoveUp.z*scale:1+mMoveUp.z*scale);

	scale = fBounceScale * 12.5f;
	glScalef(mMoveRight.x>0? 1+mMoveRight.x*scale:1-mMoveRight.x*scale,
		mMoveRight.y>0?1+mMoveRight.y*scale:1-mMoveRight.y*scale,
		mMoveRight.z>0?1+mMoveRight.z*scale:1-mMoveRight.z*scale);

	glScalef(mMoveForward.x>0? 1+mMoveForward.x*scale:1-mMoveForward.x*scale,
		mMoveForward.y>0?1+mMoveForward.y*scale:1-mMoveForward.y*scale,
		mMoveForward.z>0?1+mMoveForward.z*scale:1-mMoveForward.z*scale);

	scale = 0.15f;
	glScalef(mUp.x>0? 1-mUp.x*scale:1+mUp.x*scale,
		mUp.y>0?1-mUp.y*scale:1+mUp.y*scale,
		mUp.z>0?1-mUp.z*scale:1+mUp.z*scale);

	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixd(mat);//*/



	glColor3f(1,1,1);
	float TeleAlpha = 1;
	if(iTeleportTimer>0)
		bTeleport?
			TeleAlpha = UTIL_Misc::TimeRamp(0,1,0,100,100-iTeleportTimer):
		TeleAlpha = UTIL_Misc::TimeRamp(1,0,0,100,100-iTeleportTimer);

//	gpEng->mObjects[MDL_SPHERE].RenderBuffer(true);
	gpEng->mMatMgr.SetMaterialLightOnly(gpEng->mObjects[MDL_SPHERE].mMaterials[gpEng->mObjects[MDL_SPHERE].mFaces.front().mattID].pMat);
	for(int n=0;n<(int)gpEng->mPlayerType.iLayers.size();n++)
	{
		if(n>0)
		{
			UTIL_GL::SetBlend(GL_ONE,GL_ONE);
			glColor3fv((BallColors[gpEng->mPlayerType.iColLayers[n]]*TeleAlpha).v);
		}
		else
		{
			UTIL_GL::SetBlend(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
			glColor4f(BallColors[gpEng->mPlayerType.iColLayers[n]].x,BallColors[gpEng->mPlayerType.iColLayers[n]].y,BallColors[gpEng->mPlayerType.iColLayers[n]].z,TeleAlpha);
		//	glDisable(GL_BLEND);
		}
		//gpEng->mShdrMgr.PassSampler2D("bumpMap",1,gpEng->mPlayerType.idBump);
		gpEng->mShdrMgr.PassSampler2D("tex",0,gpEng->mPlayerType.iLayers[n]);
		//glColor3fv(BallColors[gpEng->mPlayerType.iColLayers[n]].v);
		gpEng->mObjects[gpEng->mPlayerType.iMdlType].RenderBuffer(false);
	}
	if(gpEng->iPlayerStickerType>=0)
	{
		UTIL_GL::SetBlend(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(1,1,1,TeleAlpha);
		gpEng->mShdrMgr.PassSampler2D("tex",0,gpEng->mStickers[gpEng->iPlayerStickerType]);
		gpEng->mObjects[MDL_STICKER].RenderBuffer(false);
		glDisable(GL_BLEND);
	}
	if(iTeleportTimer>0)
	{
		float C = 1;
		UTIL_GL::SetBlend(GL_ONE,GL_ONE);
		
		bTeleport?
			C = UTIL_Misc::TimeRamp(1,0,0,100,100-iTeleportTimer):
		C = UTIL_Misc::TimeRamp(0,1,0,100,100-iTeleportTimer);
		glColor4f(C,C,0,1);
		gpEng->mShdrMgr.PassSampler2D("tex",0,gpEng->mMaterials[MAT_FLAT]->mPass[BASE_PASS].front());
		gpEng->mObjects[gpEng->mPlayerType.iMdlType].RenderBuffer(false);

		bTeleport?
			C = UTIL_Misc::TimeRamp(1,0,50,50,100-iTeleportTimer):
		C = UTIL_Misc::TimeRamp(0,1,0,50,100-iTeleportTimer);
		glColor4f(C,C,0,1);
		glPushMatrix();
		glRotatef((float)iTeleportTimer*5,1,1,1);
		gpEng->mShdrMgr.PassSampler2D("tex",0,gpEng->mGfxImg[GFX_GRID]);
		gpEng->mObjects[gpEng->mPlayerType.iMdlType].RenderBuffer(false);
		glPopMatrix();
	}
	glDisable(GL_BLEND);
	//gpEng->mSurfaces.push_back(CreateSurfaceEntity((Entity*)this,gpEng->mGfxImg[GFX_BUBBLE],DRAW_FUR,Distance(p,gpEng->mCameraPos)));

	glDisable(GL_TEXTURE_2D);
	glPopMatrix();
}
void Player::RenderShadow(const float interp)
{
	if(mbLostBall && iDeathTime <=0)
		return;
	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = mMoveUp;//UTIL_Misc::Interpolate(mMoveUp, mMoveOUp, interp);

	Vec3 pos;
	if(bTurnCorner)
	{
		pos = p + mUp * 0.3f;
	}
	else
	for(int n=0; n<80; n++)
	{
		pos = p + u *((float)n/10.0f);
		if(gpEng->GetMapTile(pos))
		{
			Block* b = gpEng->GetMapTile(pos);
			if(b)
			{
/*			float	X = u.x!=0?
				(u.x<0?(int)pos.x+0.75f:(int)pos.x+0.25f):pos.x;
			float	Y = u.y!=0?
				(u.y<0?(int)pos.y+0.75f:(int)pos.y+0.25f):pos.y;
			float	Z = u.z!=0?
				(u.z<0?(int)pos.z+0.75f:(int)pos.z+0.25f):pos.z;
*/
			float X = u.x!=0?
				(u.x<0?b->pos.x+0.25f:b->pos.x-0.25f):pos.x;
			float Y = u.y!=0? 
				(u.y<0?b->pos.y+0.25f:b->pos.y-0.25f):pos.y;
			float Z = u.z!=0?
				(u.z<0?b->pos.z+0.25f:b->pos.z-0.25f):pos.z;


			pos = Vec3(X,Y,Z);//&/
			pos -= u * 0.26f;
			if(b->mbPlatform)
			{
				Vec3 shadOff = UTIL_Misc::Interpolate(b->pPlat->mPos, b->pPlat->mOPos, interp)-b->pPlat->mPos;
				shadOff = Reflect(shadOff,mMoveRight,0);
				shadOff = Reflect(shadOff,mMoveForward,0);
				pos += shadOff;
			}
			break;
			}
		}
	}//*/
	glPushMatrix();
	glTranslatef(pos.x,pos.y,pos.z);
	double mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixd(mat);
	glScalef(0.25f+fBounceScale,0.25f+fBounceScale,0.1);




//	glColor3f(0,0,0);
	gpEng->mObjects[MDL_SPHERE].RenderBuffer(false);
	glPopMatrix();
}

void Player::RenderFur(const float interp)
{

}

void Player::RenderDepth(const float interp)
{
	if(mbLostBall && iDeathTime <=0)
		return;
	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mBallForward, mBallOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mBallRight, mBallORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mBallUp, mBallOUp, interp);

	if(iDeathTime>0)
	{
		p += mShakeBall;
	}

	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	double mat[16];
	float scale = fBounceScale * 22.5f;
	glScalef(0.25f,0.25f,0.25f);
	glScalef(mMoveUp.x>0? 1-mMoveUp.x*scale:1+mMoveUp.x*scale,
		mMoveUp.y>0?1-mMoveUp.y*scale:1+mMoveUp.y*scale,
		mMoveUp.z>0?1-mMoveUp.z*scale:1+mMoveUp.z*scale);

	scale = fBounceScale * 12.5f;
	glScalef(mMoveRight.x>0? 1+mMoveRight.x*scale:1-mMoveRight.x*scale,
		mMoveRight.y>0?1+mMoveRight.y*scale:1-mMoveRight.y*scale,
		mMoveRight.z>0?1+mMoveRight.z*scale:1-mMoveRight.z*scale);

	glScalef(mMoveForward.x>0? 1+mMoveForward.x*scale:1-mMoveForward.x*scale,
		mMoveForward.y>0?1+mMoveForward.y*scale:1-mMoveForward.y*scale,
		mMoveForward.z>0?1+mMoveForward.z*scale:1-mMoveForward.z*scale);

	scale = 0.15f;
	glScalef(mUp.x>0? 1-mUp.x*scale:1+mUp.x*scale,
		mUp.y>0?1-mUp.y*scale:1+mUp.y*scale,
		mUp.z>0?1-mUp.z*scale:1+mUp.z*scale);

	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixd(mat);//*/



	for(int n=0;n<(int)gpEng->mPlayerType.iLayers.size();n++)
	{
		gpEng->mObjects[gpEng->mPlayerType.iMdlType].RenderBuffer(false);
	}
	glPopMatrix();
}
Entity* Player::Clone() const
{
	return new Player(*this);
}

void Player::TakeDamage()
{
	iDmgTime = 25;
	PlaySample(-1,gpEng->mSnd[SND_BALL_POP],false);
}
void Player::LoseLife()
{
	if(gpEng->bBonusStage || gpEng->bTutorialGame)
		return;
	gpEng->miLives--;
	if(gpEng->miLives < 0)
	{
		mbGameOver = true;
		gpEng->fStageWonY = gpEng->fOStageWonY = 0;
	}
}