#pragma once
#include "Vector.h"
#include "Entity.h"
#include "Platform.h"

class Player : public Entity
{
public:
	void Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u);
	void Update();
	void Render(const float interp, int pass);
	void RenderShadow(const float interp);
	void RenderDepth(const float interp);
	void RenderFur(const float interp);
	Entity* Clone() const;
	void TakeDamage();


//	Vec3 mPos, mOPos;
//	Vec3 mForward, mRight, mUp;
//	Vec3 mOForward, mORight, mOUp;
	Vec3 mMoveForward, mMoveRight, mMoveUp;

	int iKeyTurnRTime,iKeyTurnLTime;//cant hold the key down to keep turning
	bool bTurning;
	bool bTurnCorner;
	int iTurnCounter;
	Vec2 vTurn;
	bool bMoving;
	Vec3 mMove;
	Vec2 mfRotation;
	Vec3 mSlideMove, mSlideRight,mSlideForward, mSlideUp, mIceSlide;
	bool bSliding,bSlideJump;

	Vec3 mGravity;
	Vec3 mJumpVel;
	Vec3 mJumpDir;
	bool bJump;
	bool bLanded;
	int iJumpCounter,iMaxJumpCounter;

	Vec3 mBallForward, mBallRight, mBallUp;
	Vec3 mBallOForward, mBallORight, mBallOUp;
	float fBounceScale;

	int iSpawnTime;


	Platform* mpPlatform;
	float mfSpeedupTime,mfOSpeedupTime;

	int iDmgTime;
	int iHealth;
	int iDeathTime;
	Vec3 mShakeBall;

	bool mbFallOut, mbTimeOut, mbStageWon, mbLostBall, mbGameOver, mbWorldWon;
	Vec3 mFallPos;
	int miActionTimer;//timer for some action that is happening, like falling out etc.

	int iTeleportTimer;
	bool bTeleport;//in or out

	void LoseLife();
};