#include "Rotor.h"
#include "Engine.h"


void Rotor::Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u)
{
//	gLog.OutPut("Spawning Rotor\n");
	SetDefaultAttribs(p, f,r,u);
	mPos = mOPos = p + u*0.5f;

	mMins = mPos - Vec3(0.5, 0.5, 0.5);
	mMaxs = mPos + Vec3(0.5, 0.5, 0.5);
}
void Rotor::Update()
{
	mOPos = mPos;
	mOForward = mForward;
	mORight = mRight;
	mOUp = mUp;
	mMins = mPos - Vec3(0.5, 0.5, 0.5);
	mMaxs = mPos + Vec3(0.5, 0.5, 0.5);
	if(gpEng->mPlayer.mbTimeOut || gpEng->mPlayer.mbStageWon)
		return;

	mForward = ArbitraryRotate(mForward,DEG2RAD(2),mUp);
	mForward = ArbitraryRotate(mForward,DEG2RAD(0),mRight);
	mRight = ArbitraryRotate(mRight,DEG2RAD(2),mUp);
	mRight = ArbitraryRotate(mRight,DEG2RAD(0),mRight);
	mUp = ArbitraryRotate(mUp,DEG2RAD(2),mUp);
	mUp = ArbitraryRotate(mUp,DEG2RAD(0),mRight);

	//Generate spheres
	mSpheres.clear();
	mSpheres.push_back(Sphere(mPos,0.05));
	for(int n=1; n<5; n++)
	{
		mSpheres.push_back(Sphere(mPos+ mRight *(0.2f*(float)n) -mUp*0.25f, 0.1f));
		mSpheres.push_back(Sphere(mPos- mRight *(0.2f*(float)n) -mUp*0.25f, 0.1f));
	}
	std::list<Sphere>::iterator s;
	if(!gpEng->mPlayer.mbLostBall)
	if(gpEng->mPlayer.iDmgTime==0)
	if(!mpPlatform || mpPlatform->bVisible)
	if(gpEng->mPlayer.mPos.x >= mPos.x-2)
	if(gpEng->mPlayer.mPos.x <= mPos.x+2)
	if(gpEng->mPlayer.mPos.y >= mPos.y-2)
	if(gpEng->mPlayer.mPos.y <= mPos.y+2)
	if(gpEng->mPlayer.mPos.z >= mPos.z-2)
	if(gpEng->mPlayer.mPos.z <= mPos.z+2)
	//if(Distance(mPos, gpEng->mPlayer.mPos)<0.35)//this could be slow, should do a bounds check first
	for(s=mSpheres.begin(); s!=mSpheres.end(); s++)
	{
		if(Distance((*s).p, gpEng->mPlayer.mPos)< 0.35f+(*s).r)
		{
		Vec3 dir = Normalize(mPos-gpEng->mPlayer.mPos)*0.5f;
		//dir = Reflect(dir,mRight,0);
		dir = Reflect(dir,mUp,0);
		gpEng->mPlayer.mJumpDir = Vec3((int)-gpEng->mPlayer.mMoveUp.x,(int)-gpEng->mPlayer.mMoveUp.y,(int)-gpEng->mPlayer.mMoveUp.z);
		if(Dot(gpEng->mPlayer.mMoveForward,dir)>0)
		{
		//	gpEng->mPlayer.mJumpDir -= Vec3((int)-gpEng->mPlayer.mMoveForward.x,(int)-gpEng->mPlayer.mMoveForward.y,(int)-gpEng->mPlayer.mMoveForward.z);
			gpEng->mPlayer.mMove = -gpEng->mPlayer.mMoveForward * 0.05f;
		}
		else
		{
		//	gpEng->mPlayer.mJumpDir += Vec3((int)-gpEng->mPlayer.mMoveForward.x,(int)-gpEng->mPlayer.mMoveForward.y,(int)-gpEng->mPlayer.mMoveForward.z);
			gpEng->mPlayer.mMove = gpEng->mPlayer.mMoveForward * 0.05f;
		}

		if(gpEng->mPlayer.mpPlatform)
			gpEng->mPlayer.mpPlatform->mbPlayerIsRiding = false;

		if(gpEng->mPlayer.bJump)
			gpEng->mPlayer.bTurning = false;
		gpEng->mPlayer.mpPlatform = NULL;
		gpEng->mPlayer.bJump = true;
		gpEng->mPlayer.iJumpCounter = 0;
		gpEng->mPlayer.mGravity = gpEng->mPlayer.mMoveUp*0.15f;
		gpEng->mPlayer.mJumpVel = -gpEng->mPlayer.mMoveUp*0.15f;
	//	gpEng->mPlayer.mJumpDir = -dir;
		gpEng->mPlayer.mPos += gpEng->mPlayer.mJumpVel;
		gpEng->mPlayer.bMoving = true;
		gpEng->mPlayer.mMove = -dir * 0.15f;
		gpEng->mPlayer.iTurnCounter = 1;
		if(gpEng->mPlayer.iDmgTime==0)
			gpEng->mPlayer.TakeDamage();
		gpEng->mPlayer.bTurnCorner = false;
		//gpEng->mPlayer.bLanded = false;
		break;
		}
	}
}
void Rotor::Render(const float interp, int pass)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
/*	glBegin(GL_LINES);
	glColor3f(1,0,0);
	glVertex3fv((p).v);
	glVertex3fv((p+u*0.5f).v);
//	glColor3f(0,1,0);
//	glVertex3fv((p-r*0.5f).v);
//	glVertex3fv((p+r*0.5f).v);
//	glColor3f(0,0,1);
//	glVertex3fv((p).v);
//	glVertex3fv((p+f*0.5f).v);
	glEnd();
//*/
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	float alpha = 1;
	if(mpPlatform)
		alpha = mpPlatform->iFadeTime>=0?UTIL_Misc::TimeRamp(0,0.45,0,100,mpPlatform->iFadeTime):0;
	glMultMatrixf(mat);
	glRotatef(180,0,1,0);
	glScalef(0.15,0.15,0.15);
	glColor4f(mColor.x,mColor.y,mColor.z,alpha);
	gpEng->mObjects[MDL_ROTORBLADE].RenderBuffer(true);
//*/
	glColor4f(1,1,1,1);
	glDisable(GL_BLEND);
	glPopMatrix();
}
void Rotor::RenderShadow(const float interp)
{
	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);

	Vec3 pos = p;
	for(int n=0; n<80; n++)
	{
		pos = p + u *((float)n/10.0f);
		if(gpEng->GetMapTile(pos))
		{
			Block* b= gpEng->GetMapTile(pos);
/*			float	X = u.x!=0?
				(u.x<0?(int)pos.x+0.75f:(int)pos.x+0.25f):pos.x;
			float	Y = u.y!=0?
				(u.y<0?(int)pos.y+0.75f:(int)pos.y+0.25f):pos.y;
			float	Z = u.z!=0?
				(u.z<0?(int)pos.z+0.75f:(int)pos.z+0.25f):pos.z;
*/
			float X = u.x!=0?
				(u.x<0?b->pos.x+0.25f:b->pos.x-0.25f):pos.x;
			float Y = u.y!=0?
				(u.y<0?b->pos.y+0.25f:b->pos.y-0.25f):pos.y;
			float Z = u.z!=0?
				(u.z<0?b->pos.z+0.25f:b->pos.z-0.25f):pos.z;

			pos = Vec3(X,Y,Z);//&/
			pos -= u * 0.27f;
			if(b->mbPlatform)
			{
				Vec3 shadOff = UTIL_Misc::Interpolate(b->pPlat->mPos, b->pPlat->mOPos, interp)-b->pPlat->mPos;
				shadOff = Reflect(shadOff,mRight,0);
				shadOff = Reflect(shadOff,mForward,0);
				pos += shadOff;
			}
			break;
		}
	}//*/
	glPushMatrix();
	glTranslatef(pos.x,pos.y,pos.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glRotatef(180,0,1,0);
	glScalef(0.15,0.15,0);

	gpEng->mObjects[MDL_ROTORBLADE].RenderBuffer(false);
	glPopMatrix();
	return;

}
void Rotor::RenderDepth(const float interp)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glRotatef(180,0,1,0);
	glScalef(0.15,0.15,0.15);
	gpEng->mObjects[MDL_ROTORBLADE].RenderBuffer(false);
	glPopMatrix();

}
Entity* Rotor::Clone() const
{
	return new Rotor(*this);
}
