#pragma once 
/****************
 * Pass through *
 ****************/
static char* vp_pass =
"void main()\n"
"{\n"
//"	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;\n"
"	gl_Position = ftransform();\n"
"	gl_FrontColor = gl_Color;\n"
"	gl_TexCoord[0] = gl_MultiTexCoord0;\n"
"	gl_TexCoord[1] = gl_MultiTexCoord1;\n"
"}\n\0";
static char* fp_pass =
"uniform sampler2D tex;\n"
"void main()\n"
"{\n"
"	gl_FragColor = texture2D(tex,gl_TexCoord[0].st) * gl_Color;\n"
"}\n\0";
static char* fp_passrect =
"#extension GL_ARB_texture_rectangle : enable\n"
"uniform sampler2DRect rect;\n"
"void main()\n"
"{\n"
"	vec4 color = texture2DRect(rect,gl_TexCoord[0].st);\n"
"	gl_FragColor = color*gl_Color;\n"
"}\n\0";
static char* fp_passrectscale =
"#extension GL_ARB_texture_rectangle : enable\n"
"uniform sampler2DRect rect;\n"
"uniform vec2 screensize;\n"
"void main()\n"
"{\n"
"	vec4 color = texture2DRect(rect,gl_TexCoord[0].st * screensize);\n"
"	gl_FragColor = color*gl_Color;\n"
//"	float sep = (color.r + color.g + color.b) / 3.0;\n"
//"	gl_FragColor = vec4(sep, sep, sep, color.a);\n"
"}\n\0";

static char* fp_passGrey =
"uniform sampler2D tex;\n"
"uniform float factor;\n"
"void main()\n"
"{\n"
"	vec4 color = texture2D(tex,gl_TexCoord[0].st) * gl_Color;\n"
"	float sep = (color.r + color.g + color.b) / 3.0;\n"
"	color = mix(color, vec4(sep, sep, sep, 1.0), factor);\n"
"	gl_FragColor = vec4(color.r, color.g, color.b, 1.0) * gl_Color;\n"
"}\n\0";
static char* fp_passrectscaleGrey =
"#extension GL_ARB_texture_rectangle : enable\n"
"uniform sampler2DRect rect;\n"
"uniform vec2 screensize;\n"
"uniform float factor;\n"
"void main()\n"
"{\n"
"	vec4 color = texture2DRect(rect,gl_TexCoord[0].st * screensize);\n"
"	float sep = (color.r + color.g + color.b) / 3.0;\n"
"	color = mix(color, vec4(sep, sep, sep, 1.0), factor);\n"
"	gl_FragColor = vec4(color.r, color.g, color.b, 1.0) * gl_Color;\n"
"}\n\0";

static char* vp_passLerp =
"	uniform float interp;\n"
"void main()\n"
"{\n"
"	vec3 tempnormal = mix(gl_Normal, gl_MultiTexCoord2.xyz, interp);\n"
"	vec3 normal = normalize(gl_NormalMatrix * tempnormal);\n"
"	vec4 vertex = mix(gl_Vertex, gl_MultiTexCoord1, interp);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * vertex;\n"
"	gl_FrontColor = gl_Color;\n"
"	gl_TexCoord[0] = gl_MultiTexCoord0;\n"
"}\n\0";

static char* fp_colorpass =
"void main()\n"
"{\n"
"	gl_FragColor = gl_Color;\n"
"}\n\0";


static char* fp_Distort =
"uniform sampler2D tex;\n"
"uniform sampler2D tex2;\n"
"uniform sampler2D depth;\n"
"void main()\n"
"{\n"
"	float dist = 0.125;\n"//1.0 - texture2D(depth,gl_TexCoord[0].st).r;\n"
"	gl_FragColor = texture2D(tex,gl_TexCoord[0].st + ((texture2D(tex2,gl_TexCoord[0].st).xy)*(dist)))  * gl_Color;\n"
"}\n\0";
static char* fp_Distortrect =
"#extension GL_ARB_texture_rectangle : enable\n"
"uniform sampler2DRect rect;\n"
"uniform sampler2DRect rect2;\n"
"uniform sampler2DRect depth;\n"
"uniform vec2 screensize;\n"
"void main()\n"
"{\n"
"	float dist = 0.125;\n"//1.0 - texture2DRect(depth,gl_TexCoord[0].st).r;\n"
"	vec4 color = texture2DRect(rect,gl_TexCoord[0].st + (((texture2DRect(rect2,gl_TexCoord[0].st).xy *(dist))* screensize)));\n"
"	gl_FragColor = color*gl_Color;\n"
"}\n\0";


//per pixel lighting - directional from the eye - not realistic, but works good for this game
static char* vp_ppdirlight = 
"	uniform vec3 up;\n"
"	varying vec4 diffuse,ambientGlobal,ambient;\n"
//"	varying vec3 lightDir;\n"
//"	varying float dist;\n"
"	varying vec3 eyeVec;\n"
//"	varying vec3 gLight;\n"
//"	varying vec3 halfVector;\n"
"	varying vec3 biVec;\n"
"	attribute vec2 inmins;\n"
"	attribute vec2 inmaxs;\n"
"	varying vec2 mins;\n"
"	varying vec2 maxs;\n"
	
"	void main()\n"
"	{	\n"
"		vec4 ecPos;\n"
"		vec3 aux;\n"
"		vec3 normal = normalize(gl_NormalMatrix * gl_Normal);\n"
		
		/* these are the new lines of code to compute the light's direction */
"		ecPos = gl_ModelViewMatrix * gl_Vertex;\n"
"		aux = vec3(gl_LightSource[0].position-ecPos);\n"
//"		gLight = normalize(aux);\n"
//"		dist = length(aux);\n"
	
//"		diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;\n"
//"		ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;\n"
//"		ambientGlobal = gl_LightModel.ambient * gl_FrontMaterial.ambient;\n"
//"		diffuse = gl_Color * gl_FrontMaterial.diffuse;\n"
//"		ambient = gl_Color * gl_FrontMaterial.ambient;\n"
//"		ambientGlobal = gl_Color * gl_LightModel.ambient;\n"
"		diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse * gl_Color;\n"
"		ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient * gl_Color;\n"
"		ambientGlobal = gl_LightModel.ambient * gl_FrontMaterial.ambient * gl_Color;\n"
		
			
"		gl_Position = ftransform();\n"
"		gl_TexCoord[0] = gl_MultiTexCoord0;\n"


//create tangents for bumpmaps
"	vec3 tangent; \n"
"	vec3 binormal; \n"
"	vec3 c1 = cross(gl_Normal, vec3(0.0, 0.0, 1.0)); \n"
"	vec3 c2 = cross(gl_Normal, vec3(0.0, 1.0, 0.0)); \n"
"	if(length(c1)>length(c2))\n"
"	{\n"
"		tangent = c1;	\n"
"	}\n"
"	else\n"
"	{\n"
"		tangent = c2;	\n"
"	}\n"
"	tangent = normalize(gl_NormalMatrix * tangent);\n"
"	binormal = cross(normal, tangent); \n"

//output new light and eye vecs
"	biVec.x = dot(aux, tangent);\n"
"	biVec.y = dot(aux, binormal);\n"
"	biVec.z = dot(aux, normal);\n"
"	vec3 etemp = -ecPos.xyz;\n"
//"	vec3 etemp = -ecPos.xyz+up;\n"
"	eyeVec.x = dot(etemp, tangent);\n"
"	eyeVec.y = dot(etemp, binormal);\n"
"	eyeVec.z = dot(etemp, normal);\n"//*/
//"	halfVector.x = dot(gl_LightSource[0].halfVector.xyz, tangent);\n"
//"	halfVector.y = dot(gl_LightSource[0].halfVector.xyz, binormal);\n"
//"	halfVector.z = dot(gl_LightSource[0].halfVector.xyz, normal);\n"

"	mins = inmins;\n"
"	maxs = inmaxs;\n"


"}\n\0";

/*********************************************************************************************
//per pixel lighting - directional from the eye - not realistic, but works good for this game
/* This version using texcoord1 as an extra vertex, so we can lerp for animation
/*********************************************************************************************/
static char* vp_ppdirlightLerp = 
"	uniform vec3 up;\n"
"	varying vec4 diffuse,ambientGlobal,ambient;\n"
//"	varying vec3 lightDir;\n"
//"	varying float dist;\n"
"	varying vec3 eyeVec;\n"
//"	varying vec3 gLight;\n"
//"	varying vec3 halfVector;\n"
"	varying vec3 biVec;\n"
"	attribute vec2 inmins;\n"
"	attribute vec2 inmaxs;\n"
"	varying vec2 mins;\n"
"	varying vec2 maxs;\n"
"	uniform float interp;\n"
"	void main()\n"
"	{	\n"
"		vec4 ecPos;\n"
"		vec4 vertex;\n"
"		vec3 aux;\n"
"		vec3 tempnormal = mix(gl_Normal, gl_MultiTexCoord2.xyz, interp);\n"
"		vec3 normal = normalize(gl_NormalMatrix * tempnormal);\n"
		
		/* these are the new lines of code to compute the light's direction */
"		vertex = mix(gl_Vertex, gl_MultiTexCoord1, interp);\n"
"		ecPos = gl_ModelViewMatrix * vertex;\n"
"		aux = vec3(gl_LightSource[0].position-ecPos);\n"
//"		gLight = normalize(aux);\n"
//"		dist = length(aux);\n"
	
//"		diffuse = gl_Color * gl_FrontMaterial.diffuse;\n"
//"		ambient = gl_Color * gl_FrontMaterial.ambient;\n"
//"		ambientGlobal = gl_Color * gl_LightModel.ambient;\n"
"		diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse * gl_Color;\n"
"		ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient * gl_Color;\n"
"		ambientGlobal = gl_LightModel.ambient * gl_FrontMaterial.ambient * gl_Color;\n"
		
			
"		gl_Position = gl_ModelViewProjectionMatrix * vertex;\n"
"		gl_TexCoord[0] = gl_MultiTexCoord0;\n"


//create tangents for bumpmaps
"	vec3 tangent; \n"
"	vec3 binormal; \n"
"	vec3 c1 = cross(tempnormal, vec3(0.0, 0.0, 1.0)); \n"
"	vec3 c2 = cross(tempnormal, vec3(0.0, 1.0, 0.0)); \n"
"	if(length(c1)>length(c2))\n"
"	{\n"
"		tangent = c1;	\n"
"	}\n"
"	else\n"
"	{\n"
"		tangent = c2;	\n"
"	}\n"
"	tangent = normalize(gl_NormalMatrix * tangent);\n"
"	binormal = cross(normal, tangent); \n"

//output new light and eye vecs
"	biVec.x = dot(aux, tangent);\n"
"	biVec.y = dot(aux, binormal);\n"
"	biVec.z = dot(aux, normal);\n"
"	vec3 etemp = -ecPos.xyz;\n"
//"	vec3 etemp = -ecPos.xyz+up;\n"
"	eyeVec.x = dot(etemp, tangent);\n"
"	eyeVec.y = dot(etemp, binormal);\n"
"	eyeVec.z = dot(etemp, normal);\n"//*/
//"	halfVector.x = dot(gl_LightSource[0].halfVector.xyz, tangent);\n"
//"	halfVector.y = dot(gl_LightSource[0].halfVector.xyz, binormal);\n"
//"	halfVector.z = dot(gl_LightSource[0].halfVector.xyz, normal);\n"

"	mins = inmins;\n"
"	maxs = inmaxs;\n"


"}\n\0";

static char* fp_ppdirlight = 
"uniform sampler2D tex;\n"
"uniform sampler2D bumpMap;\n"
"	varying vec4 diffuse,ambientGlobal, ambient;\n"
//"	varying vec3 lightDir;\n"
"	varying float dist;\n"
"	varying vec3 eyeVec;\n"
//"	varying vec3 gLight;\n"
//"	varying vec3 halfVector;\n"
"	varying vec3 biVec;\n"
"	varying vec2 mins;\n"
"	varying vec2 maxs;\n"
	
"	void main()\n"
"	{\n"
"		float NdotL;\n"
"		vec4 color = ambientGlobal;\n"
//"		float distSqr = dot(lightDir, lightDir);\n"
//"		vec3 lVec = lightDir * inversesqrt(distSqr);\n"
"		vec3 vVec = normalize(eyeVec);"

//parallax mapping
"	float height = 	texture2D(bumpMap,gl_TexCoord[0].st).a;\n"
"	height = 0.03 * height - 0.015;\n"
"	vec2 offsetSample = clamp(gl_TexCoord[0].st + (vVec.xy * height), mins, maxs);\n"

//TODO seems to work, but must clamp to tile coords
// end//*/

"		vec3 bump = (texture2D(bumpMap,offsetSample).xyz * 2.0 - 1.0);\n"
"		NdotL = max(dot(normalize(biVec), bump),0.0);\n"
//"		if (NdotL > 0.0) {\n"	
"			color += (diffuse * NdotL + ambient);\n"
"			float specular = pow(clamp(dot(bump, vVec), 0.0, 1.0), gl_FrontMaterial.shininess );\n"
"			color += gl_FrontMaterial.specular * gl_LightSource[0].specular * specular;\n"
//"		}\n"
//"		float z = 1.0 - clamp(((gl_FragCoord.z / gl_FragCoord.w) / 5.0) - 0.25, 0.0, 0.5);\n"
"		gl_FragColor = texture2D(tex, gl_TexCoord[0].st) * color;\n"// * vec4(z,z,z,z);\n"//
"}\n\0";



static char* fp_DofH =
//"#version 110\n"
"#extension GL_ARB_texture_rectangle : enable\n"
"uniform sampler2DRect rect;\n"
"uniform sampler2DRect depth;\n"
"uniform float focalD;\n"
"uniform float depthRange;\n"
"uniform float blurFactor;\n"
"void main()\n"
"{\n"
"	float dist = texture2DRect(depth,gl_TexCoord[0].st).r;\n"
"	vec2 vd = vec2(dist,dist);\n"
"	float d = 2.0 * depthRange / (depthRange - dist * (depthRange - 2.0));\n"
"	float focus = (d - focalD)*blurFactor;\n"
"	vec4 color = texture2DRect(rect, vec2(gl_TexCoord[0].x,				  gl_TexCoord[0].y));\n"
"	vec4 color2 = color * 0.2;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x - 4.0 * focus, gl_TexCoord[0].y)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x - 4.0 * focus, gl_TexCoord[0].y)) * 0.08;\n"
"	else color2 += color * 0.08;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x - 3.0 * focus, gl_TexCoord[0].y)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x - 3.0 * focus, gl_TexCoord[0].y)) * 0.04;\n"
"	else color2 += color * 0.04;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x - 2.0 * focus, gl_TexCoord[0].y)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x - 2.0 * focus, gl_TexCoord[0].y)) * 0.12;\n"
"	else color2 += color * 0.12;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x - 1.0 * focus, gl_TexCoord[0].y)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x - 1.0 * focus, gl_TexCoord[0].y)) * 0.16;\n"
"	else color2 += color * 0.16;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x + 1.0 * focus, gl_TexCoord[0].y)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x + 1.0 * focus, gl_TexCoord[0].y)) * 0.16;\n"
"	else color2 += color * 0.16;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x + 2.0 * focus, gl_TexCoord[0].y)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x + 2.0 * focus, gl_TexCoord[0].y)) * 0.12;\n"
"	else color2 += color * 0.12;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x + 3.0 * focus, gl_TexCoord[0].y)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x + 3.0 * focus, gl_TexCoord[0].y)) * 0.04;\n"
"	else color2 += color * 0.04;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x + 4.0 * focus, gl_TexCoord[0].y)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x + 4.0 * focus, gl_TexCoord[0].y)) * 0.08;\n"
"	else color2 += color * 0.08;\n"
"	gl_FragColor = color2;\n"
"}\n\0";

static char* fp_DofV =
//"#version 110\n"
"#extension GL_ARB_texture_rectangle : enable\n"
"uniform sampler2DRect rect;\n"
"uniform sampler2DRect depth;\n"
"uniform float focalD;\n"
"uniform float depthRange;\n"
"uniform float blurFactor;\n"
"void main()\n"
"{\n"
"	float dist = texture2DRect(depth,gl_TexCoord[0].st).r;\n"
"	vec2 vd = vec2(dist,dist);\n"
"	float d = 2.0 * depthRange / (depthRange - dist * (depthRange - 2.0));\n"
"	float focus = (d - focalD)*blurFactor;\n"
"	vec4 color = texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y		      ));\n"
"	vec4 color2 = color * 0.2;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 3.0 * focus)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 3.0 * focus)) * 0.04;\n"
"	else color2 += color * 0.04;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 2.0 * focus)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 2.0 * focus)) * 0.12;\n"
"	else color2 += color * 0.12;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 1.0 * focus)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 1.0 * focus)) * 0.16;\n"
"	else color2 += color * 0.16;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 4.0 * focus)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 4.0 * focus)) * 0.08;\n"
"	else color2 += color * 0.08;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 1.0 * focus)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 1.0 * focus)) * 0.16;\n"
"	else color2 += color * 0.16;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 2.0 * focus)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 2.0 * focus)) * 0.12;\n"
"	else color2 += color * 0.12;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 3.0 * focus)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 3.0 * focus)) * 0.04;\n"
"	else color2 += color * 0.04;\n"
"   if(length(vd-vec2(texture2DRect(depth, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 4.0 * focus)).xy)) < 0.0005)\n"
"	color2 +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 4.0 * focus)) * 0.08;\n"
"	else color2 += color * 0.08;\n"
"	gl_FragColor = color2;\n"
"}\n\0";


static char* fp_Radial =
//"#version 120\n"
"#extension GL_ARB_texture_rectangle : enable\n"
"uniform sampler2DRect rect;\n"
"uniform float sampleDist;\n"
"uniform float sampleStrength; \n"
"uniform vec2 screensize;\n"
"void main()\n"
"{\n"
"   float samples[10] =  float[10](-0.08,-0.05,-0.03,-0.02,-0.01,0.01,0.02,0.03,0.05,0.08);\n"
"	vec2 uv = (gl_TexCoord[0].xy / screensize);\n"
"   vec2 dir = vec2(0.5,0.35) - uv;\n"
"	float dist = sqrt(dir.x*dir.x + dir.y*dir.y); \n"
//"	dir = dir/dist;\n"
"	vec4 color = texture2DRect(rect,gl_TexCoord[0].xy); \n"
"	vec4 sum = color;\n"
"	for (int i = 0; i < 9; i++)\n"
"   {\n"
"		sum += texture2DRect( rect, (uv + dir * samples[i] * sampleDist) * screensize);\n"
"   }\n"
"	sum /= 10.0;\n"
"	sum.a = 1.0;\n"
"	gl_FragColor = mix( color, sum, clamp(1.0 - (uv.y*2.0), 0.0, 1.0) );\n"
"}\n\0";

//fur shader
static char* vp_furpass =
"attribute float vecoffset;\n"
"varying float offset;\n"
"void main()\n"
"{\n"
//"	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;\n"
"	gl_Position = ftransform();\n"
"	gl_FrontColor = gl_Color;\n"
"	gl_TexCoord[0] = gl_MultiTexCoord0;\n"
"	gl_TexCoord[1] = gl_MultiTexCoord1;\n"
"	offset = vecoffset;\n"
"}\n\0";

static char* fp_Fur =
"uniform sampler2D fur;\n"
"uniform sampler2D dis;\n"//displacement
"uniform float time;\n"
"varying float offset;\n"
"void main()\n"
"{\n"
"	vec4 displacement = texture2D(dis,gl_TexCoord[0].st);\n"
"	displacement.x -= 0.5;\n"
"	displacement.z -= 0.5;\n"
"	vec2 displace = vec2(displacement.x+(sin(time*5.0)*0.05), displacement.z+(cos(time*5.0)*0.05)) * displacement.a;\n"
"	vec4 col = texture2D(fur,gl_TexCoord[0].st + displace * vec2(0.125*offset, 0.5*offset));\n"
"	col.a -= (1.0 - gl_Color.a);\n"
"	gl_FragColor = col * gl_Color;\n"
"}\n\0";

//fade effect1: multiplay framebuffer with another
static char* fp_FadeFx1 =
"#extension GL_ARB_texture_rectangle : enable\n"
"uniform sampler2DRect rect;\n"
"uniform sampler2DRect fade;\n"
"void main()\n"
"{\n"
"	vec4 color = texture2DRect(rect,gl_TexCoord[0].st);\n"
"	float f = texture2DRect(fade,gl_TexCoord[0].st).r;\n"
"	gl_FragColor = vec4(color.r, color.g, color.b, 1.0) * vec4(1.0,1.0,1.0,f) * gl_Color;\n"
"}\n\0";
static char* fp_FadeFx1Fallback = 
"uniform sampler2D rect;\n"
"uniform sampler2D fade;\n"
"void main()\n"
"{\n"
"	vec4 color = texture2D(rect,gl_TexCoord[0].st);\n"
"	float f = texture2D(fade,gl_TexCoord[0].st).r;\n"
"	gl_FragColor = vec4(color.r, color.g, color.b, 1.0) * vec4(1.0,1.0,1.0,f) * gl_Color;\n"
"}\n\0";

//inverted = mulitply where black, not white
static char* fp_FadeFx2 =
"#extension GL_ARB_texture_rectangle : enable\n"
//"uniform sampler2DRect rect;\n"
"uniform sampler2DRect fade;\n"
"void main()\n"
"{\n"
//"	vec4 color = texture2DRect(rect,gl_TexCoord[0].st);\n"
"	float f = 1.0 - texture2DRect(fade,gl_TexCoord[0].st).r;\n"
"	gl_FragColor = vec4(gl_Color.r, gl_Color.g, gl_Color.b, f);\n"
"}\n\0";
static char* fp_FadeFx2FallBack =
//"uniform sampler2DRect rect;\n"
"uniform sampler2D fade;\n"
"void main()\n"
"{\n"
//"	vec4 color = texture2DRect(rect,gl_TexCoord[0].st);\n"
"	float f = 1.0 - texture2D(fade,gl_TexCoord[0].st).r;\n"
"	gl_FragColor = vec4(gl_Color.r, gl_Color.g, gl_Color.b, f);\n"
"}\n\0";



//per pixel lighting - directional from the eye - not realistic, but works good for this game
static char* vp_pBallLight = 
"	varying vec4 diffuse,ambientGlobal,ambient;\n"
"	varying vec3 eyeVec;\n"
"	varying vec3 biVec;\n"
"	varying vec3 normal;\n"
	
"	void main()\n"
"	{	\n"
"		vec4 ecPos;\n"
"		vec3 aux;\n"
"		normal = vec3(normalize(gl_NormalMatrix * gl_Normal));\n"
"		ecPos = gl_ModelViewMatrix * gl_Vertex;\n"
"		eyeVec = -ecPos.xyz;\n"
"		biVec = vec3(gl_LightSource[0].position-ecPos);\n"
//"		diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;\n"
//"		ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;\n"
//"		ambientGlobal = gl_LightModel.ambient * gl_FrontMaterial.ambient;\n"
"		diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse * gl_Color;\n"
"		ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient * gl_Color;\n"
"		ambientGlobal = gl_LightModel.ambient * gl_FrontMaterial.ambient * gl_Color;\n"
"		gl_Position = ftransform();\n"
"		gl_TexCoord[0] = gl_MultiTexCoord0;\n"

"}\n\0";

static char* fp_pBallLight = 
"uniform sampler2D tex;\n"
"	varying vec4 diffuse,ambientGlobal, ambient;\n"
"	varying vec3 eyeVec;\n"
"	varying vec3 biVec;\n"
"	varying vec3 normal;\n"
	
"	void main()\n"
"	{\n"
"		float NdotL;\n"
"		vec4 color = ambientGlobal;\n"
"		vec3 vVec = normalize(eyeVec);"
"		NdotL = max(dot(normalize(biVec), normal),0.0);\n"
//"		if (NdotL > 0.0) {\n"	
"			color += (diffuse * NdotL + ambient);\n"
"			float specular = pow(clamp(dot(normal, vVec), 0.0, 1.0), gl_FrontMaterial.shininess );\n"
"			color += gl_FrontMaterial.specular * gl_LightSource[0].specular * specular;\n"
//"		}\n"

//"		float z = 1.0 - clamp(((gl_FragCoord.z / gl_FragCoord.w) / 5.0) - 0.25, 0.0, 0.5);\n"
"		gl_FragColor = texture2D(tex, gl_TexCoord[0].st) * color;\n"// * vec4(z,z,z,z);\n"
"}\n\0";

/**********************************/
/*	 super sampling				  */
/**********************************/

static char* fp_SuperSample2x =
"uniform sampler2D tex;\n"
"uniform vec2 screensize;\n"
"void main()\n"
"{\n"
"	gl_FragColor = texture2D(tex,gl_TexCoord[0].st) * gl_Color;\n"
"}\n\0";
static char* fp_SuperSampleRect2x =
"#extension GL_ARB_texture_rectangle : enable\n"
"uniform sampler2DRect rect;\n"
"void main()\n"
"{\n"
"	vec4 color = texture2DRect(rect,gl_TexCoord[0].st) * 0.25;\n"
"	color += texture2DRect(rect,gl_TexCoord[0].st+vec2(-1.0,-1.0)) * 0.125;\n"
"	color += texture2DRect(rect,gl_TexCoord[0].st+vec2(1.0,-1.0)) * 0.125;\n"
"	color += texture2DRect(rect,gl_TexCoord[0].st+vec2(1.0,1.0)) * 0.125;\n"
"	color += texture2DRect(rect,gl_TexCoord[0].st+vec2(-1.0,1.0)) * 0.125;\n"

"	color += texture2DRect(rect,gl_TexCoord[0].st+vec2(-1.0,-1.0)) * 0.0625;\n"
"	color += texture2DRect(rect,gl_TexCoord[0].st+vec2(1.0,-1.0)) * 0.0625;\n"
"	color += texture2DRect(rect,gl_TexCoord[0].st+vec2(1.0,1.0)) * 0.0625;\n"
"	color += texture2DRect(rect,gl_TexCoord[0].st+vec2(-1.0,1.0)) * 0.0625;\n"
"	gl_FragColor = color*gl_Color;\n"
"}\n\0";