#include "Slinky.h"
#include "Engine.h"


void Slinky::Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u)
{
//	gLog.OutPut("Spawning Slinky\n");
	SetDefaultAttribs(p, f,r,u);
	mPos = mOPos = mPos + u*0.2f;

	mMins = mPos - Vec3(0.5, 0.5, 0.5);
	mMaxs = mPos + Vec3(0.5, 0.5, 0.5);
	fAnimation = 0;
	iMoveCounter = 0;
	iTurnCounter = 0;
}
void Slinky::Update()
{
	mOPos = mPos;
	mOForward = mForward;
	mORight = mRight;
	mOUp = mUp;
	mMins = mPos - Vec3(0.5, 0.5, 0.5);
	mMaxs = mPos + Vec3(0.5, 0.5, 0.5);
	if(gpEng->mPlayer.mbTimeOut || gpEng->mPlayer.mbStageWon)
		return;

	fAnimation += TIME_STEP*25;
	if(fAnimation>=15)
		fAnimation -= 15;
	if(iTurnCounter == 0)
	{
		if(gpEng->GetMapTile(mPos+mUp + mForward * 0.5f)>0 && gpEng->GetMapTile(mPos + mForward * 0.5f)==0)
		{
			mPos += mForward * 0.01f;
		}
		else
		{
		//	gLog.OutPut("needed to turn.\n");
			iTurnCounter = 1;
			bDoubleTurn = false;
			if(gpEng->GetMapTile(mPos+mUp + mRight * 0.75f)>0 && gpEng->GetMapTile(mPos+mRight * 0.75f)==0)
				iTurnDirection = -1;
			else if(gpEng->GetMapTile(mPos+mUp - mRight * 0.75f)>0 && gpEng->GetMapTile(mPos-mRight * 0.75f)==0)
				iTurnDirection = 1;
			else
			{
				iTurnDirection = 1;
				bDoubleTurn = true;
			}
		}
	}
	if(iTurnCounter>=1)
	{
		iTurnCounter++;
		mForward = ArbitraryRotate(mForward,DEG2RAD(9*iTurnDirection),mUp);
		mForward = ArbitraryRotate(mForward,DEG2RAD(0),mRight);
		mRight = ArbitraryRotate(mRight,DEG2RAD(9*iTurnDirection),mUp);
		mRight = ArbitraryRotate(mRight,DEG2RAD(0),mRight);
		mUp = ArbitraryRotate(mUp,DEG2RAD(9*iTurnDirection),mUp);
		mUp = ArbitraryRotate(mUp,DEG2RAD(0),mRight);
		if(bDoubleTurn && iTurnCounter>20 || !bDoubleTurn && iTurnCounter>10)
		{
			iTurnCounter = 0;
		}
	}

	if(!gpEng->mPlayer.mbLostBall)
	if(gpEng->mPlayer.iDmgTime==0)
	if(!mpPlatform || mpPlatform->bVisible)
	if(gpEng->mPlayer.mPos.x >= mPos.x-1)
	if(gpEng->mPlayer.mPos.x <= mPos.x+1)
	if(gpEng->mPlayer.mPos.y >= mPos.y-1)
	if(gpEng->mPlayer.mPos.y <= mPos.y+1)
	if(gpEng->mPlayer.mPos.z >= mPos.z-1)
	if(gpEng->mPlayer.mPos.z <= mPos.z+1)
	if(Distance(mPos, gpEng->mPlayer.mPos)<0.35)//this could be slow, should do a bounds check first
	{
		Vec3 dir = (mPos-gpEng->mPlayer.mPos);
		//dir = Reflect(dir,mRight,0);
		dir = Reflect(dir,mUp,0);
		gpEng->mPlayer.mJumpDir = Vec3((int)-gpEng->mPlayer.mMoveUp.x,(int)-gpEng->mPlayer.mMoveUp.y,(int)-gpEng->mPlayer.mMoveUp.z);
		if(Dot(gpEng->mPlayer.mMoveForward,dir)>0)
		{
			//gpEng->mPlayer.mJumpDir -= Vec3((int)-gpEng->mPlayer.mMoveForward.x,(int)-gpEng->mPlayer.mMoveForward.y,(int)-gpEng->mPlayer.mMoveForward.z);
			gpEng->mPlayer.mMove = -gpEng->mPlayer.mMoveForward * 0.05f;
		}
		else
		{
		//	gpEng->mPlayer.mJumpDir += Vec3((int)-gpEng->mPlayer.mMoveForward.x,(int)-gpEng->mPlayer.mMoveForward.y,(int)-gpEng->mPlayer.mMoveForward.z);
			gpEng->mPlayer.mMove = gpEng->mPlayer.mMoveForward * 0.05f;
		}

		if(gpEng->mPlayer.mpPlatform)
			gpEng->mPlayer.mpPlatform->mbPlayerIsRiding = false;
		

		gpEng->mPlayer.mpPlatform = NULL;
		gpEng->mPlayer.bJump = true;
		gpEng->mPlayer.iJumpCounter = 0;
		gpEng->mPlayer.mGravity = gpEng->mPlayer.mMoveUp*0.15f;
		gpEng->mPlayer.mJumpVel = -gpEng->mPlayer.mMoveUp*0.15f;
	//	gpEng->mPlayer.mJumpDir = -dir;
		gpEng->mPlayer.mPos += gpEng->mPlayer.mJumpVel;
		gpEng->mPlayer.bMoving = true;
		gpEng->mPlayer.mMove = -dir * 0.15f;
		gpEng->mPlayer.iTurnCounter = 1;
		gpEng->mPlayer.TakeDamage();
	//	gpEng->mPlayer.bTurning = false;
		gpEng->mPlayer.bTurnCorner = false;
		//gpEng->mPlayer.bLanded = false;
		//make the slinky change direction
		iTurnDirection = 1;
		bDoubleTurn = true;
		iTurnCounter = 1;
	}
}
void Slinky::Render(const float interp, int pass)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
/*	glBegin(GL_LINES);
	glColor3f(1,0,0);
	glVertex3fv((p).v);
	glVertex3fv((p+u*0.5f).v);
//	glColor3f(0,1,0);
//	glVertex3fv((p-r*0.5f).v);
//	glVertex3fv((p+r*0.5f).v);
//	glColor3f(0,0,1);
//	glVertex3fv((p).v);
//	glVertex3fv((p+f*0.5f).v);
	glEnd();
//*/
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	float alpha = 0.45;
	if(mpPlatform)
		alpha = mpPlatform->iFadeTime>=0?UTIL_Misc::TimeRamp(0,0.45,0,100,mpPlatform->iFadeTime):0;
	glMultMatrixf(mat);
	glRotatef(180,1,0,0);
	glRotatef(-90,0,0,1);
	glScalef(0.15,0.15,0.15);

	glColor4f(mColor.x,mColor.y,mColor.z,alpha);

	gpEng->mShdrMgr.PassUniform1f("interp",fAnimation-(int)fAnimation);
	gpEng->mObjects[MDL_SLINKY01+(int)fAnimation].RenderLerpBuffer(true,gpEng->mObjects[MDL_SLINKY01+(int)fAnimation+1].miVBOID);
	
//*/
	glColor4f(1,1,1,1);


	glPopMatrix();
}
void Slinky::RenderShadow(const float interp)
{
//	return;
	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);

	Vec3 pos = p;
	for(int n=0; n<80; n++)
	{
		pos = p + u *((float)n/10.0f);
		if(gpEng->GetMapTile(pos))
		{
			Block* b= gpEng->GetMapTile(pos);
/*			float	X = u.x!=0?
				(u.x<0?(int)pos.x+0.75f:(int)pos.x+0.25f):pos.x;
			float	Y = u.y!=0?
				(u.y<0?(int)pos.y+0.75f:(int)pos.y+0.25f):pos.y;
			float	Z = u.z!=0?
				(u.z<0?(int)pos.z+0.75f:(int)pos.z+0.25f):pos.z;
*/
			float X = u.x!=0?
				(u.x<0?b->pos.x+0.25f:b->pos.x-0.25f):pos.x;
			float Y = u.y!=0?
				(u.y<0?b->pos.y+0.25f:b->pos.y-0.25f):pos.y;
			float Z = u.z!=0?
				(u.z<0?b->pos.z+0.25f:b->pos.z-0.25f):pos.z;

			pos = Vec3(X,Y,Z);//&/
			pos -= u * 0.27f;
			if(b->mbPlatform)
			{
				Vec3 shadOff = UTIL_Misc::Interpolate(b->pPlat->mPos, b->pPlat->mOPos, interp)-b->pPlat->mPos;
				shadOff = Reflect(shadOff,mRight,0);
				shadOff = Reflect(shadOff,mForward,0);
				pos += shadOff;
			}
			break;
		}
	}//*/
	glPushMatrix();
	glTranslatef(pos.x,pos.y,pos.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glScalef(0.15,0.15,0);
	glRotatef(180,1,0,0);
	glRotatef(-90,0,0,1);

	gpEng->mShdrMgr.BindProgram(gpEng->mShdrPassLerp);
	gpEng->mShdrMgr.PassUniform1f("interp",fAnimation-(int)fAnimation);
	gpEng->mObjects[MDL_SLINKY01+(int)fAnimation].RenderLerpBuffer(false,gpEng->mObjects[MDL_SLINKY01+(int)fAnimation+1].miVBOID);
	gpEng->mShdrMgr.BindProgram(0);
	glPopMatrix();
}
void Slinky::RenderDepth(const float interp)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glRotatef(180,1,0,0);
	glRotatef(-90,0,0,1);
	glScalef(0.15,0.15,0.15);
	gpEng->mShdrMgr.BindProgram(gpEng->mShdrPassLerp);
	gpEng->mShdrMgr.PassUniform1f("interp",fAnimation-(int)fAnimation);
	gpEng->mObjects[MDL_SLINKY01+(int)fAnimation].RenderLerpBuffer(false,gpEng->mObjects[MDL_SLINKY01+(int)fAnimation+1].miVBOID);
	gpEng->mShdrMgr.BindProgram(0);

	glPopMatrix();

}
Entity* Slinky::Clone() const
{
	return new Slinky(*this);
}
