#include "Spikes.h"
#include "Engine.h"


void Spikes::Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u)
{
//	gLog.OutPut("Spawning Spikes\n");
	SetDefaultAttribs(p, f,r,u);
	mPos = mOPos = mPos - u * 0.9f;
	mMins = mPos - Vec3(0.25, 0.25, 0.25);
	mMaxs = mPos + Vec3(0.25, 0.25, 0.25);


	colMins = Vec3(99999,99999,99999);
	colMaxs = Vec3(-99999,-99999,-99999);
	Vec3 pt[5];
	pt[0] = -r * 0.4f - f *0.4;
	pt[1] = r * 0.4f - f *0.4;
	pt[2] = -r * 0.4f + f *0.4;
	pt[3] = r * 0.4f + f *0.4;
	pt[4] = u * 0.5f;

	for(int n=0; n<5; n++)
	{
		if(pt[n].x < colMins.x)
			colMins.x = pt[n].x;
		if(pt[n].y < colMins.y)
			colMins.y = pt[n].y;
		if(pt[n].z < colMins.z)
			colMins.z = pt[n].z;

		if(pt[n].x > colMaxs.x)
			colMaxs.x = pt[n].x;
		if(pt[n].y > colMaxs.y)
			colMaxs.y = pt[n].y;
		if(pt[n].z > colMaxs.z)
			colMaxs.z = pt[n].z;
	}

	fTime = 0;
	bActive = false;
	bStarted = false;
	mStartPos = mPos;
	fShiftPosition = 0;
	if(fHoldDelay == 0)
	{
		bStarted = true;
		bActive = true;
	}

}
void Spikes::Update()
{
	mOPos = mPos;

	if(gpEng->mPlayer.mbTimeOut || gpEng->mPlayer.mbStageWon)
		return;

	fTime += TIME_STEP;
	if(!bStarted)
	{
		if(fTime>=fStartDelay)
		{
			bActive = true;
			bStarted = true;
			fTime = 0;
		}
	}
	else
	{
		if(fTime>=fHoldDelay)
		{
			if(fHoldDelay != 0)
			{
				bActive = !bActive;
				fTime = 0;
				if(bActive)
				{
					float DIST = Distance(mPos,gpEng->mCameraPos);
					if(DIST<10)
						SetSoundPosition(PlaySample(gpEng->mSnd[SND_SPIKES],false), 0, (DIST+1)*50);
				}

			}
		}
		if(bActive)
		{
			fShiftPosition += TIME_STEP;
			if(fShiftPosition >= 0.1f)
				fShiftPosition = 0.1f;

		}
		else
		{
			fShiftPosition -= TIME_STEP;
			if(fShiftPosition <= 0)
				fShiftPosition = 0;
		}
		mPos = mStartPos + mUp * (fShiftPosition*3);
	}

	if(!gpEng->mPlayer.mbLostBall)
	if(!mpPlatform || mpPlatform->bVisible)
	if(fShiftPosition>0.02f)
	if(gpEng->mPlayer.mPos.x >= mPos.x + colMins.x)
	if(gpEng->mPlayer.mPos.x <= mPos.x + colMaxs.x)
	if(gpEng->mPlayer.mPos.y >= mPos.y + colMins.y)
	if(gpEng->mPlayer.mPos.y <= mPos.y + colMaxs.y)
	if(gpEng->mPlayer.mPos.z >= mPos.z + colMins.z)
	if(gpEng->mPlayer.mPos.z <= mPos.z + colMaxs.z)
//	if(Distance(mPos, gpEng->mPlayer.mPos)<0.35)//this could be slow, should do a bounds check first
	{
		Vec3 dir = (mPos-gpEng->mPlayer.mPos);
		//dir = Reflect(dir,mRight,0);
		dir = Normalize(Reflect(dir,mUp,0));
		dir = Vec3((int)dir.x,(int)dir.y,(int)dir.z);
		gpEng->mPlayer.mJumpDir = Vec3((int)-gpEng->mPlayer.mMoveUp.x,(int)-gpEng->mPlayer.mMoveUp.y,(int)-gpEng->mPlayer.mMoveUp.z);
		if(Dot(gpEng->mPlayer.mMoveForward,dir)>0)
		{
		//	gpEng->mPlayer.mJumpDir -= Vec3((int)-gpEng->mPlayer.mMoveForward.x,(int)-gpEng->mPlayer.mMoveForward.y,(int)-gpEng->mPlayer.mMoveForward.z);
			gpEng->mPlayer.mMove = -gpEng->mPlayer.mMoveForward * 0.05f;
		}
		else
		{
		//	gpEng->mPlayer.mJumpDir += Vec3((int)-gpEng->mPlayer.mMoveForward.x,(int)-gpEng->mPlayer.mMoveForward.y,(int)-gpEng->mPlayer.mMoveForward.z);
			gpEng->mPlayer.mMove = gpEng->mPlayer.mMoveForward * 0.05f;
		}
		bool bCaught = false;
		if(dir == gpEng->mPlayer.mMoveUp || Dot(dir,gpEng->mPlayer.mMoveUp)<0.4 && Dot(dir,gpEng->mPlayer.mMoveUp)>-0.4)
		{
			gLog.OutPut("Caught on spikes\n");
			UTIL_Misc::Rand()%2?
				dir = -gpEng->mPlayer.mMoveForward:
			dir = gpEng->mPlayer.mMoveForward;
			bCaught = true;
		//	gpEng->mPlayer.mJumpDir += dir;
		}
		if(gpEng->mPlayer.mpPlatform)
			gpEng->mPlayer.mpPlatform->mbPlayerIsRiding = false;

		if(gpEng->mPlayer.bJump)
			gpEng->mPlayer.bTurning = false;
		gpEng->mPlayer.mpPlatform = NULL;
		gpEng->mPlayer.bJump = true;
		gpEng->mPlayer.iJumpCounter = 0;
		gpEng->mPlayer.mGravity = gpEng->mPlayer.mMoveUp*0.15f;
		gpEng->mPlayer.mJumpVel = -gpEng->mPlayer.mMoveUp*0.15f;
	//	gpEng->mPlayer.mJumpDir = -dir;
		gpEng->mPlayer.mPos += gpEng->mPlayer.mJumpVel;
		gpEng->mPlayer.bMoving = true;
		gpEng->mPlayer.mMove = -dir * 0.025f;
		gpEng->mPlayer.iTurnCounter = 1;
		if(gpEng->mPlayer.iDmgTime==0)
			gpEng->mPlayer.TakeDamage();
		gpEng->mPlayer.bTurnCorner = false;
		//gpEng->mPlayer.bLanded = false;
		
	}

}
void Spikes::Render(const float interp, int pass)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
/*	glBegin(GL_LINES);
	glColor3f(1,0,0);
	glVertex3fv((p).v);
	glVertex3fv((p+u*0.5f).v);
//	glColor3f(0,1,0);
//	glVertex3fv((p-r*0.5f).v);
//	glVertex3fv((p+r*0.5f).v);
//	glColor3f(0,0,1);
//	glVertex3fv((p).v);
//	glVertex3fv((p+f*0.5f).v);
	glEnd();
//*/
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	float alpha = 1;
	if(mpPlatform)
		alpha = mpPlatform->iFadeTime>=0?UTIL_Misc::TimeRamp(0,0.45,0,100,mpPlatform->iFadeTime):0;
	glMultMatrixf(mat);
	glScalef(0.15,0.15,0.15);
	glColor4f(mColor.x,mColor.y,mColor.z,alpha);
	gpEng->mObjects[MDL_SPIKES].RenderBuffer(true);
//*/
	glColor4f(1,1,1,1);


	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);
	glPopMatrix();
}
void Spikes::RenderShadow(const float interp)
{
	return;
	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);

	Vec3 pos = p;
	for(int n=0; n<80; n++)
	{
		pos = p + u *((float)n/10.0f);
		if(gpEng->GetMapTile(pos))
		{
			Block* b= gpEng->GetMapTile(pos);
/*			float	X = u.x!=0?
				(u.x<0?(int)pos.x+0.75f:(int)pos.x+0.25f):pos.x;
			float	Y = u.y!=0?
				(u.y<0?(int)pos.y+0.75f:(int)pos.y+0.25f):pos.y;
			float	Z = u.z!=0?
				(u.z<0?(int)pos.z+0.75f:(int)pos.z+0.25f):pos.z;
*/
			float X = u.x!=0?
				(u.x<0?b->pos.x+0.25f:b->pos.x-0.25f):pos.x;
			float Y = u.y!=0?
				(u.y<0?b->pos.y+0.25f:b->pos.y-0.25f):pos.y;
			float Z = u.z!=0?
				(u.z<0?b->pos.z+0.25f:b->pos.z-0.25f):pos.z;

			pos = Vec3(X,Y,Z);//&/
			pos -= u * 0.27f;
			break;
		}
	}//*/
	glPushMatrix();
	glTranslatef(pos.x,pos.y,pos.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glScalef(0.15,0.15,0);

	gpEng->mObjects[MDL_SPIKES].Render(false);
	glPopMatrix();
}
void Spikes::RenderDepth(const float interp)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glScalef(0.15,0.15,0.15);
	gpEng->mObjects[MDL_SPIKES].RenderBuffer(false);
//*/
	glPopMatrix();

}
Entity* Spikes::Clone() const
{
	return new Spikes(*this);
}
