#include "Engine.h"
#include "Serializer.h"

extern float fWorldRotation,fOWorldRotation;
int iSplashPage = 0;
int iSplashFade = 0;
bool bSplashFade;
int iWindowRes = 1;
int DOF = 1;
int FUR = 1;
int SHADOW = 1;
int SUPER_SAMPLING = 0;
int SHOW_FPS = 0;
int BLUR = 1;

float fBushSlide, fOBushSlide;
bool bPlayedTutorial = false;
extern bool bFirstPlay;


void Engine::StartSplash()
{

	if(miWorld!=0)
	{
		miWorld = 0;
		LoadWorldData();
	}
//	FADE_Star* FS2 = new FADE_Star;
//	FS2->Spawn(1,Vec3(0,1,1));
//	mFadeEng.InsertSystem(FS2);//*/
	BindFBO(gpEng->mMainFBO,0);
	miBoundFBO = 0;
	glClearColor(0,0,0,0);
	glClear(GL_COLOR_BUFFER_BIT);
	SDL_GL_SwapBuffers();
	UnBindFBO();
		FADE_Fade1* FS = new FADE_Fade1;
		FS->Spawn(1,Vec3(1,1,1));
		mFadeEng.InsertSystem(FS);//*/
//		(this->*pRenderFunc)(mInterp);
		RenderSceneToFadeBuffer();
	PS_Fade1* PS = new PS_Fade1;
	PS->Spawn(Vec3(0,0,0),Vec3(0,0,0),Vec2(32,32),Vec3(1,1,1),0,1,1);
	mPartEng.InsertSystem(PS,true);//*/

	mSplashBalls.clear();

	for(int n=0; n<15; n++)
	{
		SplashBall sb;
		sb.miSticker = UTIL_Misc::Rand() % ((int)mStickers.size());
		sb.mOPos = sb.mPos = Vec3((UTIL_Misc::Rand()% 25)-12.5f,((UTIL_Misc::Rand()% 5)+25), 0);
		sb.mORot = sb.mRot = Vec3(0,0,0);
		sb.mType = mBallTypes[UTIL_Misc::Rand()%10];
		sb.mVel = Vec3(((UTIL_Misc::Rand()% 50)-25)/80.0f, (UTIL_Misc::Rand()% 10)/ 10.0f,0);
		sb.mRVel = Vec3(((UTIL_Misc::Rand()% 20)-10), ((UTIL_Misc::Rand()% 20)-10),((UTIL_Misc::Rand()% 20)-10));
		std::vector<int>::iterator ui;
		for(ui=sb.mType.iColLayers.begin(); ui<sb.mType.iColLayers.end();ui++)
		{
			(*ui) = UTIL_Misc::Rand()%50;
		}
		mSplashBalls.push_back(sb);
	}
	//if(!MusicIsPlaying())
	PlayMusic(mSplashMusic,true,false);

	fWorldRotation=fOWorldRotation=-150;
	iOption = 0;
	iSplashPage = 0;
	iSplashFade = 0;

	fBushSlide= fOBushSlide=0;
	bTutorialGame = false;
}
void Engine::StartTutorial()
{
	iDebugFrame = 0;
	CleanupMap();
	bTutorialGame = true;
	MasterMusicFadeout(500);
	PlayMusic(mMainMusic,true,false);
	FADE_Fade1* FS = new FADE_Fade1;
	FS->Spawn(1,Vec3(1,1,1));
	mFadeEng.InsertSystem(FS);//*/
	(this->*pRenderFunc)(mInterp);
	RenderSceneToFadeBuffer();

	//mMenus.remove_if(CleanupMenus);
	mSurfaces.clear();
	CleanupMap();
	gpEng->miCurrentPersistance.clear();

//	char sz[64];
	if(!LoadMap("Data/Maps/Tutorial1.map",true))
		mbQuit = true;

	PS_Fade1* PS = new PS_Fade1;
	PS->Spawn(Vec3(0,0,0),Vec3(0,0,0),Vec2(32,32),Vec3(1,1,1),0,1,1);
	mPartEng.InsertSystem(PS,true);//*/

	mi1UpSlotTwistTime = 0;
	mi1UpGiveTimer = 0;
	miGemCount = 0;
	miStarCount = 0;
	miLocal1UpCount = 0;
	miLocalGemCount = 0;//reset the counter each time the level starts
	miLocalStarCount = 0;
	miLives = 5;
	mfHudColRamp = 0;
	mfStageTime = 61;//starting time
	mfStageTimeEnd = 0;
	fStageWonGrav = 0;
	fStageWonY = fOStageWonY = 0;
	iHUDGemFlashTime = 0;
	iHUDStarFlashTime = 0;
	ChangeState(STATE_GAME, 0);
	(this->*pUpdateFunc)();

	miBonusClock = 0;
	mbPauseClock = false;
	fPauseClockTime = 0;
	fMusicTimer = 0;
	fGreyScaleClockStart = fGreyScaleClock = 0;
	mPlayerType = mBallTypes[0];
	iPlayerStickerType = -1;
}
void Engine::UpdateSplash()
{
//	_ASSERTE( _CrtCheckMemory( ) );
	if(KEY_ACTION2.state == JUST_PRESSED && !mbPaused && mFadeEng.mSystems.empty() && iSplashPage==0)
	{
		if(!mMenus.empty() && mMenus.back()->bFadingIn ||
			!mMenus.empty() && mMenus.back()->bFadingOut ||
			 !mMenus.empty() && !mMenus.back()->bFadingIn && !mMenus.empty() && !mMenus.back()->bFadingOut ||
			mMenus.empty())
		{
			FADE_StarOut* FS = new FADE_StarOut;
			FS->Spawn(1,Vec3(1,1,1));
			gpEng->mFadeEng.InsertSystem(FS);//*/
			ChangeState(STATE_GAMESELECT, 125, &CALLBACK_Quit);
			MasterMusicFadeout(300);
		}
	}

	fOWorldRotation = fWorldRotation;
	fWorldRotation += TIME_STEP * 1.5f*5;
	fOBushSlide = fBushSlide;
	fBushSlide+=TIME_STEP * 10;

	std::list<SplashBall>::iterator it;
	for(it = mSplashBalls.begin(); it!=mSplashBalls.end(); it++)
	{
		(*it).mVel.y += 0.01f;
		//(*it).mVel.y *= 0.97f;
		//if((*it).mVel.y > 0.5f)
		//	(*it).mVel.y = 0.5f;
		(*it).mOPos = (*it).mPos;
		(*it).mORot = (*it).mRot;
		(*it).mRot += (*it).mRVel;
		(*it).mPos += (*it).mVel;
		if((*it).mPos.y > 24)
		{
			(*it).mPos.y = 24;
			(*it).mVel.y = -(*it).mVel.y * 0.75f;
			if((*it).mVel.y<0 && (*it).mVel.y> -0.05f)
				(*it).mVel.y -= 0.5f;
		}
		if((*it).mPos.x > 19)
		{
			(*it).mPos.x = 19;
			(*it).mVel.x = -(*it).mVel.x;
		}
		if((*it).mPos.x < -19)
		{
			(*it).mPos.x = -19;
			(*it).mVel.x = -(*it).mVel.x;
		}

		std::list<SplashBall>::iterator it2;
		for(it2 = mSplashBalls.begin(); it2!=mSplashBalls.end(); it2++)
		{
			if(it==it2)
				continue;

			if(Distance((*it).mPos, (*it2).mPos)<2.5f)
			{
				(*it).mVel = ((*it).mPos - (*it2).mPos)*0.1f;
				(*it2).mVel = ((*it2).mPos - (*it).mPos)*0.1f;
			}
		}
	}
	mPartEng.Update();
	mFadeEng.Update();

	if(mFadeEng.mSystems.empty() && iSplashFade==0 && mMenus.empty())
	{
		if(iSplashPage == 0)//main splash
		{
			if(KEY_FORWARD.state == JUST_PRESSED)
			{
				if(iOption >0)
				{
					iOption--;
					PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);
				}
			}
			if(KEY_BACK.state == JUST_PRESSED)
			{
				if(iOption <3)
				{
					iOption++;
					PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);
				}
			}
			if(KEY_JUMP.state == JUST_PRESSED)
			{
				switch(iOption)
				{
				case 0:
					{
						if(bFirstPlay && !bPlayedTutorial)
						{
							PopMenu* menu = new PopMenu;
							menu->iExternalCode = PopMenu::POP_VIDEO;
							menu->Spawn(Vec2(320,240));
							strcpy(menu->szMessage,"YOU MUST PLAY THE TUTORIAL FIRST");
							gpEng->mMenus.push_back(menu);
						}
						else
						{
							PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
							FADE_StarOut* FS = new FADE_StarOut;
							FS->Spawn(1,Vec3(1,1,1));
							gpEng->mFadeEng.InsertSystem(FS);//*/
							ChangeState(STATE_GAMESELECT, 125, &CALLBACK_StartGameSelect);
							MasterMusicFadeout(300);
						}
					}
					break;
				case 1://tutorial
					{
						bPlayedTutorial = true;
						DeleteFile("GameState.dat");
						gSerializer.PutComment("GameState.dat","Game State");
						int FIRSTPLAY = 0;
						gSerializer.ReadVariable("GameState.dat","FIRSTPLAY",FIRSTPLAY);
						PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
						StartTutorial();
					}
					break;
				case 2:
					{
						PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
						iSplashFade = 150;
						bSplashFade = true; //increment page
					}
					break;
				case 3:
					{
						PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
						FADE_StarOut* FS = new FADE_StarOut;
						FS->Spawn(1,Vec3(1,1,1));
						gpEng->mFadeEng.InsertSystem(FS);//*/
						ChangeState(STATE_GAMESELECT, 125, &CALLBACK_Quit);
						MasterMusicFadeout(300);
					}
					break;
				}
			}
		}
		if(iSplashPage == 1)
		{
			if(KEY_ACTION2.state == JUST_PRESSED)
			{
						PopMenu* menu = new PopMenu;
						menu->iExternalCode = PopMenu::POP_VIDEO;
						menu->Spawn(Vec2(320,240));
						strcpy(menu->szMessage,"VIDEO CHANGES WILL TAKE PLACE ON RESTART");
						gpEng->mMenus.push_back(menu);

						DeleteFile("Video.dat");
						gSerializer.PutComment("Video.dat","Video Configuration");
						gSerializer.ReadVariable("Video.dat","RES",iWindowRes);
						DOF = mbDOF?1:0;
						FUR = mbFUR?1:0;
						SHADOW = mbShadows?1:0;
						SHOW_FPS = mbShowFPS?1:0;
						BLUR = mbBlur?1:0;
						gSerializer.ReadVariable("Video.dat","DOF",DOF);
						gSerializer.ReadVariable("Video.dat","FUR",FUR);
						gSerializer.ReadVariable("Video.dat","SHADOW",SHADOW);
						gSerializer.ReadVariable("Video.dat","SAMPLING",SUPER_SAMPLING);
						gSerializer.ReadVariable("Video.dat","FPS",SHOW_FPS);
						gSerializer.ReadVariable("Video.dat","BLUR",BLUR);
						PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
						iSplashFade = 150;
						bSplashFade = false; //decrement page

			}
			if(KEY_FORWARD.state == JUST_PRESSED)
			{
				if(iOption >0)
				{
					iOption--;
					PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);
				}
			}
			if(KEY_BACK.state == JUST_PRESSED)
			{
				if(iOption <7)
				{
					iOption++;
					PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);
				}
			}
			if(KEY_JUMP.state == JUST_PRESSED)
			{
				switch(iOption)
				{
				case 0: iWindowRes++; if(iWindowRes==6)iWindowRes=0; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false); break;
				case 1: if(!mbFallBackMode){mbDOF = !mbDOF; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);}else PlaySample(CHNL_UI_BACKUP,gpEng->mSnd[SND_UI_BACKUP],false); break;
				case 2: mbFUR = !mbFUR; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false); break;
				case 3: mbShadows = !mbShadows; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false); break;
				case 4: if(!mbFallBackMode){mbBlur = !mbBlur; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);} else PlaySample(CHNL_UI_BACKUP,gpEng->mSnd[SND_UI_BACKUP],false); PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false); break;
				case 5: if(!mbFallBackMode){SUPER_SAMPLING++; if(SUPER_SAMPLING>4)SUPER_SAMPLING=0; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);} else PlaySample(CHNL_UI_BACKUP,gpEng->mSnd[SND_UI_BACKUP],false); break;
				case 6: mbShowFPS = !mbShowFPS;PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false); break;
				
				case 7:
					{
						PopMenu* menu = new PopMenu;
						menu->iExternalCode = PopMenu::POP_VIDEO;
						menu->Spawn(Vec2(320,240));
						strcpy(menu->szMessage,"VIDEO CHANGES WILL TAKE PLACE ON RESTART");
						gpEng->mMenus.push_back(menu);

						DeleteFile("Video.dat");
						gSerializer.PutComment("Video.dat","Video Configuration");
						gSerializer.ReadVariable("Video.dat","RES",iWindowRes);
						DOF = mbDOF?1:0;
						FUR = mbFUR?1:0;
						SHADOW = mbShadows?1:0;
						SHOW_FPS = mbShowFPS?1:0;
						BLUR = mbBlur?1:0;
						gSerializer.ReadVariable("Video.dat","DOF",DOF);
						gSerializer.ReadVariable("Video.dat","FUR",FUR);
						gSerializer.ReadVariable("Video.dat","SHADOW",SHADOW);
						gSerializer.ReadVariable("Video.dat","SAMPLING",SUPER_SAMPLING);
						gSerializer.ReadVariable("Video.dat","FPS",SHOW_FPS);
						gSerializer.ReadVariable("Video.dat","BLUR",BLUR);
						PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
						iSplashFade = 150;
						bSplashFade = false; //decrement page
					}
					break;
				}
			}
		}
	}
	if(!mMenus.empty())
	{
		mMenus.back()->Update();
		mMenus.remove_if(PruneMenus);
		return;
	}

	if(iSplashFade>0)
	{
		iSplashFade--;
		if(iSplashFade == 75)
		{
			bSplashFade?
				iSplashPage++:
				iSplashPage--;
			iOption = 0;
		}
	}
}

void Engine::RenderSplash(const float interp)
{
	miBoundFBO = 0;
	BindFBO(mMainFBO,0);
	glClearColor(0,0,0.3f,0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	UTIL_GL::GL3D::SetPerspective(70,1.3f,2,2048);


	static float PrevViewMat[16];
	static float PrevViewMatInverse[16];
	static float Proj[16];
	float Rotation = UTIL_Misc::Interpolate(fWorldRotation,fOWorldRotation,interp);

	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);

	//Vec3 eye = p - f * 2.7f - u * 2.7f;
	Vec3 eye(32,16,32);
	eye.x = UTIL_Misc::Clamp(eye.x, 0, MAP_DIMENSIONS);
	eye.y = UTIL_Misc::Clamp(eye.y, 0, MAP_DIMENSIONS);
	eye.z = UTIL_Misc::Clamp(eye.z, 0, MAP_DIMENSIONS);
//	gluLookAt(p.x,p.y,p.z, p.x+f.x,p.y+f.y,p.z+f.z, -u.x,-u.y,-u.z);
	Vec3 f(0,0,1);
	Vec3 u(0,-1,0);
	gluLookAt(eye.x,eye.y,eye.z, f.x,f.y,f.z, -u.x,-u.y,-u.z);

	glRotatef(Rotation, 0,1,0);

//	gluLookAt(0,0,0, f.x,f.y,f.z, -u.x,-u.y,-u.z);
	glScalef(1,0.5,1);
	glTranslatef(0,54,0);
	//skybox
	float sinCol = (sin(Rotation*0.01f) +1)/2;
	if(sinCol>1)sinCol=1;
	if(sinCol<0.1f)sinCol=0.1f;
	glColor3f(sinCol,sinCol,1);
	RenderWorld(miWorld,interp);


//	if(!mbFallBackMode)
//		glClearDepth(0.995f);
	glClear(GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);



	UTIL_GL::GL3D::SetPerspective(45,1.3f,0.1f,60);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	gluLookAt(0,-1.5f,0, 0,0,5, 0,-1,0);

	GLfloat tempMatrix[16];
	glGetFloatv(GL_MODELVIEW_MATRIX,tempMatrix);
	Vec3 camRight = Vec3(tempMatrix[0],tempMatrix[4],tempMatrix[8]);
	Vec3 camUp = Vec3(tempMatrix[1],tempMatrix[5],tempMatrix[9]);
	Vec3 camFwd = Vec3(tempMatrix[2],tempMatrix[6],tempMatrix[10]);
	glEnable(GL_CULL_FACE);



	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	Vec3 lp = Vec3(0,0,0) + camUp * 1 + camRight*5;
//	float LightPos[4]={-500,-1000.1f,500,1};
	float LightPos[4]={lp.x,lp.y,lp.z,0};
	float LightDir[4]={-camUp.x,-camUp.y,-camUp.z,0};
	float amb[4]={0.15f,0.15f,0.15f,1};
	float dif[4]={0.4f*sinCol,0.4f*sinCol,0.4f,1};
	float gldif[4]={0.7f*sinCol,0.7f*sinCol,0.7f,1};
	float glamb[4]={0.95f,0.95f,0.95f,1};
	float spec[4]={1,1,1,0};
	float blk[4]={0,0,0,1};
	glShadeModel(GL_SMOOTH);
//	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, amb);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0,  GL_POSITION, LightPos);
	glLightfv(GL_LIGHT0,  GL_SPOT_DIRECTION, LightDir);
	glLightfv(GL_LIGHT0,  GL_AMBIENT, dif);
	glLightfv(GL_LIGHT0,  GL_DIFFUSE, gldif);
	glLightfv(GL_LIGHT0,  GL_SPECULAR, glamb);
	glMaterialfv(GL_FRONT, GL_AMBIENT, dif);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, gldif);
	glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
	glMateriali(GL_FRONT, GL_SHININESS, 100);
	glEnable(GL_COLOR_MATERIAL);

	gpEng->mShdrMgr.BindProgram(gpEng->mShdrPBallLight);
	Vec2 mins(0,0), maxs(1,1);
//	mShdrMgr.BindProgram(mShdrPPDirLight);
	GLint AtLocmins = mShdrMgr.GetAttribLocation("inmins");
	GLint AtLocmaxs = mShdrMgr.GetAttribLocation("inmaxs");
//	mShdrMgr.PassUniform3fv("up",1,camUp.v);
	mShdrMgr.PassAttrib2fv(AtLocmins, mins.v);
	mShdrMgr.PassAttrib2fv(AtLocmaxs, maxs.v);

	mMatMgr.SetMaterialAttributes(mObjects[MDL_SPHERE].mMaterials[mObjects[MDL_SPHERE].mFaces.front().mattID].pMat,BASE_PASS,0);
	int n;
	float fx = -3;
	std::list<SplashBall>::iterator it;
	for(it = mSplashBalls.begin(); it!=mSplashBalls.end(); it++)
	{

		glPushMatrix();
		Vec3 pos = UTIL_Misc::Interpolate((*it).mPos, (*it).mOPos, interp);
		glTranslatef(pos.x,pos.y,pos.z);
		glTranslatef(0,0,32);
		Vec3 ballRot = UTIL_Misc::Interpolate((*it).mRot,(*it).mORot,interp);
		glRotatef(ballRot.x, 1,0,0);
		glRotatef(ballRot.y, 0,1,0);
		glRotatef(ballRot.z, 0,0,1);
		glScalef(1.5f,1.5f,1.5f);
		for(n=0;n<(int)(*it).mType.iLayers.size();n++)
		{
			if(n>0)
				UTIL_GL::SetBlend(GL_ONE,GL_ONE);
			else glDisable(GL_BLEND);

//			mShdrMgr.PassSampler2D("bumpMap",1,mBallTypes[i].idBump);
			mShdrMgr.PassSampler2D("tex",0,(*it).mType.iLayers[n]);
			glColor3fv(BallColors[(*it).mType.iColLayers[n]].v);
			mObjects[(*it).mType.iMdlType].RenderBuffer(false);
		}
			//if(gpEng->iSelectedSticker>=0)
		{
			UTIL_GL::SetBlend(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
			glColor4f(1,1,1,1);
			mShdrMgr.PassSampler2D("tex",0,mStickers[(*it).miSticker]);
			mObjects[MDL_STICKER].RenderBuffer(false);
			glDisable(GL_BLEND);
		}
		glPopMatrix();
		fx+=3;
	}

	mShdrMgr.BindProgram(0);



	Vec3 newlp = Vec3(0,-5,-10);
	float LightPos2[4]={newlp.x,newlp.y,newlp.z,0};
	glLightfv(GL_LIGHT0,  GL_POSITION, LightPos2);
	//render stars
	glDisable(GL_BLEND);
	glPushMatrix();
	glTranslatef(0,-1.5f,15);
	glRotatef(-180,1,0,0);
	glRotatef(Rotation*15, 0,-1,0);
	glScalef(0.5f,0.5f,0.5f);

	glPushMatrix();
	mShdrMgr.BindProgram(0);
	glScalef(1.23,1.23,1.23);
	glDisable(GL_LIGHTING);
	glColor3f(0,0,0);
	glDepthMask(GL_FALSE);
	mObjects[MDL_STAR].RenderBuffer(false);
	glDepthMask(GL_TRUE);
	glDisable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	//glClear(GL_DEPTH_BUFFER_BIT);
	mShdrMgr.BindProgram(mShdrPPDirLight);
	glPopMatrix();

	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	glCullFace(GL_FRONT);

	glColor4f(1,1,0,0.5f);
	mObjects[MDL_STAR].RenderBuffer(true);
	glCullFace(GL_BACK);
	mObjects[MDL_STAR].RenderBuffer(true);
	glDisable(GL_CULL_FACE);
	glColor4f(1,1,1,1);
	UTIL_GL::SetBlend(GL_ONE,GL_ONE);
	glScalef(1.1,1.1,1.1);
	mObjects[MDL_STAR].RenderBuffer(true);

	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);
	glDepthMask(GL_TRUE);
	glEnable(GL_DEPTH_TEST);
	glPopMatrix();

	glDisable(GL_BLEND);
	mShdrMgr.BindProgram(0);


	glDisable(GL_COLOR_MATERIAL);
	glDisable(GL_LIGHTING);
	glDisable(GL_LIGHT0);
	glActiveTexture(GL_TEXTURE1);
	glDisable(GL_TEXTURE_2D);
	glActiveTexture(GL_TEXTURE0);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glDisable(GL_CULL_FACE);

	UnBindFBO();


	//render dOF
	if(!mbFallBackMode)
	if(mbDOF)
	{
		BindFBO(mMainFBO,0);
		glEnable(GL_DEPTH_TEST);
		glDepthMask(GL_TRUE);
		glColorMask(GL_FALSE,GL_FALSE,GL_FALSE,GL_FALSE);
		glBegin(GL_QUADS);
		glVertex3fv((eye-camFwd*20-camRight*50-camUp*50).v);
		glVertex3fv((eye-camFwd*20+camRight*50-camUp*50).v);
		glVertex3fv((eye-camFwd*20+camRight*50+camUp*50).v);
		glVertex3fv((eye-camFwd*20-camRight*50+camUp*50).v);
		glEnd();
		glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);
		UnBindFBO();
		float mul = 1;
		switch(iSuperSamples)
		{
		case 1: mul = 1.25f; break;
		case 2: mul = 1.5f; break;
		case 3: mul = 1.75f; break;
		case 4: mul = 2; break;
		}

		BindFBO(mMainFBO,1);
		float focalD = 27;// + (sin(mTimer.GetTime())*100);
		mShdrMgr.BindProgram(mShdrDOFH);
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSamplerRect("depth",1 ,mMainFBO.depthtexID);
		mShdrMgr.PassUniform1f("focalD",focalD);
		mShdrMgr.PassUniform1f("depthRange",30);
		mShdrMgr.PassUniform1f("blurFactor",0.05f*mul);
		glClear(GL_COLOR_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDepthMask(GL_FALSE);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		mShdrMgr.BindProgram(0);
		UnBindFBO();
		BindFBO(mMainFBO,0);
		mShdrMgr.BindProgram(mShdrDOFV);
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[1]);
		mShdrMgr.PassSamplerRect("depth",1 ,mMainFBO.depthtexID);
		mShdrMgr.PassUniform1f("focalD",focalD);
		mShdrMgr.PassUniform1f("depthRange",30);
		mShdrMgr.PassUniform1f("blurFactor",0.05f*mul);
		glClear(GL_COLOR_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDepthMask(GL_FALSE);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		mShdrMgr.BindProgram(0);
		UnBindFBO();
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		glDepthMask(GL_TRUE);

	}//*/


	BindFBO(mMainFBO,0);

	UTIL_GL::GL2D::SetOrtho(640,480);
	glClear(GL_DEPTH_BUFFER_BIT);
	glDisable(GL_DEPTH_TEST);

	//star glow
//	glActiveTexture(GL_TEXTURE0);
//	glDisable(GL_COLOR_MATERIAL);
//	glDisable(GL_DEPTH_TEST);
//	glDisable(GL_LIGHTING);
//	glDisable(GL_LIGHT0);
//	UTIL_GL::GL2D::SetOrtho(640,480);
	glColor3f(sinCol*0.5f,sinCol*0.5f,0.5f);
	UTIL_GL::SetBlend(GL_ONE, GL_ONE);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, mGfxImg[GFX_STAR_GLOW]);
	Vec2 SP(320,72), UP, RIGHT;
	UTIL_Misc::MakeVectors(Rotation*5,UP,RIGHT);
	glBegin(GL_QUADS);
	glTexCoord2f(0,1); glVertex2fv((SP-UP*128-RIGHT*128).v);
	glTexCoord2f(1,1); glVertex2fv((SP+UP*128-RIGHT*128).v);
	glTexCoord2f(1,0); glVertex2fv((SP+UP*128+RIGHT*128).v);
	glTexCoord2f(0,0); glVertex2fv((SP-UP*128+RIGHT*128).v);
/*	UTIL_Misc::MakeVectors(Rotation*9,UP,RIGHT);
	glTexCoord2f(0,1); glVertex2fv((SP-UP*128-RIGHT*128).v);
	glTexCoord2f(1,1); glVertex2fv((SP+UP*128-RIGHT*128).v);
	glTexCoord2f(1,0); glVertex2fv((SP+UP*128+RIGHT*128).v);
	glTexCoord2f(0,0); glVertex2fv((SP-UP*128+RIGHT*128).v);
*/	glEnd();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
//	glEnable(GL_LIGHTING);
//	UTIL_GL::GL3D::SetPerspective(45,1.3f,0.1f,60);
//	gluLookAt(0,-1.5f,0, 0,0,5, 0,-1,0);
//	glEnable(GL_COLOR_MATERIAL);

	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, MenuImgs[GFXMENU_SPLASH]);
	glColor4f(1,1,1,1);

	float fr1 = sin(Rotation) *0.1f;
	float fr2 = cos(Rotation) *0.5f;
	glBegin(GL_QUADS);
	glTexCoord2f(0,1); glVertex2f(fr1+(320-256),fr2+80);
	glTexCoord2f(1,1); glVertex2f(fr1+(320+256),fr2+80);
	glTexCoord2f(1,0); glVertex2f(fr1+(320+256),fr2+208);
	glTexCoord2f(0,0); glVertex2f(fr1+(320-256),fr2+208);
	glEnd();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);

	Vec2 sprUV, sprUVS;
	sprUVS = mSprites[SPR_UI].mUVsize;

	mFont1.EnableShadow();
	mFont1.SetAlignment(ALIGN_CENTER);
	mFont1.SetColor(1,1,1,1);
	mFont1.SetScale(0.75f,0.75f);
	float sinCol2 = (sin(Rotation*0.5f) +1)/2;

	float splashAlpha = 1;
	if(iSplashFade > 75)
		splashAlpha = UTIL_Misc::TimeRamp(1,0,0,75, 150-iSplashFade);
	else
		splashAlpha = UTIL_Misc::TimeRamp(0,1,0,75, 75-iSplashFade);

	if(iSplashPage == 0)
	{
		iOption == 0? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
		mFont1.Print("START GAME",320,300);
		iOption == 1? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
		mFont1.Print("TUTORIAL",320,330);
		iOption == 2? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
		mFont1.Print("OPTIONS",320,360);
		iOption == 3? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
		mFont1.Print("QUIT",320,390);
	}
	if(iSplashPage == 1)
	{
		mFont1.SetAlignment(ALIGN_LEFT);

		iOption == 0? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
		mFont1.Print("RESOLUTION",120,180);
		iOption == 1? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
		mFont1.Print("DEPTH OF FIELD",120,210);
		iOption == 2? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
		mFont1.Print("FUR SHADING",120,240);
		iOption == 3? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
		mFont1.Print("SHADOWS",120,270);
		iOption == 4? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
		mFont1.Print("BLUR",120,300);
		iOption == 5? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
		mFont1.Print("SUPER SAMPLING",120,330);
		iOption == 6? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
		mFont1.Print("SHOW FPS",120,360);
		iOption == 7? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
		mFont1.SetAlignment(ALIGN_CENTER);
		mFont1.Print("BACK",320,390);

		if(mbFallBackMode)
		{
			mFont1.SetColor(1,0,0,splashAlpha);
			mFont1.SetAlignment(ALIGN_RIGHT);
			mFont1.Print("N/A",520,210);
			iOption == 2? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
			mFont1.Print(mbFUR?"ON":"OFF",520,240);
			iOption == 3? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
			mFont1.Print(mbShadows?"ON":"OFF",520,270);
			mFont1.SetColor(1,0,0,splashAlpha);
			mFont1.Print("N/A",520,300);
			mFont1.Print("N/A",520,330);
			mFont1.SetAlignment(ALIGN_RIGHT);
			iOption == 0? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
			mFont1.SetScale(0.5f,0.75f);
			switch(iWindowRes)
			{
			case 0: mFont1.Print("640x480 Window",520,180); break;
			case 1: mFont1.Print("800x600 Window",520,180); break;
			case 2: mFont1.Print("1024x768 Window",520,180); break;
			case 3: mFont1.Print("640x480 Full",520,180); break;
			case 4: mFont1.Print("800x600 Full",520,180); break;
			case 5: mFont1.Print("1024x768 Full",520,180); break;
			}
			mFont1.SetScale(0.75f,0.75f);
			iOption == 6? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
			mFont1.Print(mbShowFPS?"ON":"OFF",520,360);
		}
		else
		{
			
			mFont1.SetAlignment(ALIGN_RIGHT);
			iOption == 0? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
			mFont1.SetScale(0.5f,0.75f);
			switch(iWindowRes)
			{
			case 0: mFont1.Print("640x480 Window",520,180); break;
			case 1: mFont1.Print("800x600 Window",520,180); break;
			case 2: mFont1.Print("1024x768 Window",520,180); break;
			case 3: mFont1.Print("640x480 Full",520,180); break;
			case 4: mFont1.Print("800x600 Full",520,180); break;
			case 5: mFont1.Print("1024x768 Full",520,180); break;
			}
			mFont1.SetScale(0.75f,0.75f);
			iOption == 1? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
			mFont1.Print(mbDOF?"ON":"OFF",520,210);
			iOption == 2? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
			mFont1.Print(mbFUR?"ON":"OFF",520,240);
			iOption == 3? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
			mFont1.Print(mbShadows?"ON":"OFF",520,270);
			iOption == 4? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
			mFont1.Print(mbBlur?"ON":"OFF",520,300);
			iOption == 5? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
			switch(SUPER_SAMPLING)
			{
			case 0: mFont1.Print("OFF",520,330); break;
			case 1: mFont1.Print("1x",520,330); break;
			case 2: mFont1.Print("2x",520,330); break;
			case 3: mFont1.Print("3x",520,330); break;
			case 4: mFont1.Print("4x",520,330); break;
			}
			iOption == 6? mFont1.SetColor(1,sinCol2,0,splashAlpha):mFont1.SetColor(1,1,1,splashAlpha);
			mFont1.Print(mbShowFPS?"ON":"OFF",520,360);
		}
	}


	glColor4f(1,1,1,1);

	glColor3f(sinCol,sinCol,1);

	float slide1 = UTIL_Misc::Interpolate(fBushSlide,fOBushSlide,interp)*0.5f;
	float slide2 = UTIL_Misc::Interpolate(fBushSlide,fOBushSlide,interp)*7;
	if(slide1>50)slide1=50;
	if(slide2>400)slide2=400;
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, mGfxImg[GFX_BUSH1]);
	glBegin(GL_QUADS);
	glTexCoord2f(0,1); glVertex2f(0,324+slide1);
	glTexCoord2f(1,1); glVertex2f(320,324+slide1);
	glTexCoord2f(1,0); glVertex2f(320,580+slide1);
	glTexCoord2f(0,0); glVertex2f(0,580+slide1);
	glTexCoord2f(1,1); glVertex2f(320,324+slide1);
	glTexCoord2f(0,1); glVertex2f(640,324+slide1);
	glTexCoord2f(0,0); glVertex2f(640,580+slide1);
	glTexCoord2f(1,0); glVertex2f(320,580+slide1);
	glEnd();
	UTIL_GL::BindTexture(GL_TEXTURE_2D, mGfxImg[GFX_BUSH2]);
	glBegin(GL_QUADS);
	glTexCoord2f(0,1); glVertex2f(-slide2,0);
	glTexCoord2f(1,1); glVertex2f(512-slide2,0);
	glTexCoord2f(1,0); glVertex2f(512-slide2,512);
	glTexCoord2f(0,0); glVertex2f(-slide2,512);
	glEnd();
	UTIL_GL::BindTexture(GL_TEXTURE_2D, mGfxImg[GFX_BUSH3]);
	glBegin(GL_QUADS);
	glTexCoord2f(0,1); glVertex2f(128+slide2,0);
	glTexCoord2f(1,1); glVertex2f(640+slide2,0);
	glTexCoord2f(1,0); glVertex2f(640+slide2,512);
	glTexCoord2f(0,0); glVertex2f(128+slide2,512);
	glEnd();


	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);

	glColor4f(1,1,1,1);

/*	mFont1.SetAlignment(ALIGN_LEFT);
	mFont1.SetScale(0.35f,0.5f);
	mFont1.Print("SELECT",582,417);
	mFont1.Print("BACK",582,449);

/*	glColor3f(1,1,1);
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, mSprites[SPR_UI].mImg);
	if(bJoystick)
	{
	glBegin(GL_QUADS);
	sprUV = mSprites[SPR_UI].GetTileUV(4);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 412);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(552, 412);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(552, 444);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 444);

	sprUV = mSprites[SPR_UI].GetTileUV(5);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 444);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(552, 444);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(552, 476);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 476);
	glEnd();
	}
	else
	{
	glBegin(GL_QUADS);
	sprUV = mSprites[SPR_UI].GetTileUV(29);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 404);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(584, 404);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(584, 452);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 452);

	//sprUV = mSprites[SPR_UI].GetTileUV(28);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 436);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(584, 436);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(584, 484);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 484);
	glEnd();
		mFont1.SetScale(0.35f,0.5f);
		mFont1.SetAlignment(ALIGN_LEFT);
		mFont1.Print("SPACE",530,417);
		mFont1.Print("ESC",535,449);
	}
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
*/
	RenderMenus(interp);

	UnBindFBO();


	//fade systems
	if(!mFadeEng.mSystems.empty())
	{
		BindFBO(mFadeFBO,0);
		UTIL_GL::GL2D::SetOrtho(640,480);
		glClearColor(0,0,0,0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDisable(GL_CULL_FACE);
		mFadeEng.Render(interp);
		UTIL_GL::SetBlend(GL_ONE, GL_ONE);
		mPartEng.Render2D(interp);
		glDisable(GL_BLEND);
		UnBindFBO();

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);

		//fade from the last frame
		glColor3f(1,1,1);
		UTIL_GL::GL2D::SetOrtho(gpEng->winWidth,gpEng->winHeight);
		if(!mbFallBackMode)
		{
		UTIL_GL::BindTexture(GL_TEXTURE_RECTANGLE_ARB, gpEng->mFadeFBO.colortexID[1]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,mFadeFBO.h);					glVertex2f(0,0);
		glTexCoord2f( mFadeFBO.w,mFadeFBO.h);	glVertex2f(gpEng->winWidth,0);
		glTexCoord2f( mFadeFBO.w,0);					glVertex2f(gpEng->winWidth,gpEng->winHeight);
		glTexCoord2f( 0,0);									glVertex2f(0,gpEng->winHeight);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		}
		else
		{
		UTIL_GL::BindTexture(GL_TEXTURE_2D, gpEng->mFadeFBO.colortexID[1]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,1);	glVertex2f(0,0);
		glTexCoord2f( 1,1);	glVertex2f(gpEng->winWidth,0);
		glTexCoord2f( 1,0);	glVertex2f(gpEng->winWidth,gpEng->winHeight);
		glTexCoord2f( 0,0);	glVertex2f(0,gpEng->winHeight);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		}
		glDisable(GL_TEXTURE_2D);

		//the new frame
		mShdrMgr.BindProgram(mShdrFadeFx1);
		UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glColor3f(1,1,1);
		if(!mbFallBackMode)
		{
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSamplerRect("fade",1 ,mFadeFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		glActiveTexture(GL_TEXTURE1);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		}
		else
		{
		mShdrMgr.PassSampler2D("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSampler2D("fade",1 ,mFadeFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,1); glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, 1,1); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, 1,0); glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0); glVertex2f(0,winHeight);
		glEnd();
		glActiveTexture(GL_TEXTURE1);
		glDisable(GL_TEXTURE_2D);
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_2D);
		}
		glDisable(GL_BLEND);
		mShdrMgr.BindProgram(0);
		UTIL_GL::GL2D::SetOrtho(640,480);
		mFont1.SetAlignment(ALIGN_LEFT);
		mFont1.SetColor(1,1,1,1);
		mFont1.SetScale(0.5f,0.5f);
		mFont1.Print("LOADING..",520,448);

	}
	else //render the scene as normal
	{
		//render the scene
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glColor3f(1,1,1);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		if(!mbFallBackMode)
		{
		UTIL_GL::BindTexture(GL_TEXTURE_RECTANGLE_ARB, mMainFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,mMainFBO.h);		glVertex2f(0,0);
		glTexCoord2f( mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glTexCoord2f( mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glTexCoord2f( 0,0);				glVertex2f(0,winHeight);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		}
		else
		{
		UTIL_GL::BindTexture(GL_TEXTURE_2D, mMainFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,1);	glVertex2f(0,0);
		glTexCoord2f( 1,1); glVertex2f(winWidth,0);
		glTexCoord2f( 1,0);	glVertex2f(winWidth,winHeight);
		glTexCoord2f( 0,0);	glVertex2f(0,winHeight);
		glEnd();
		}
		glDisable(GL_TEXTURE_2D);
	}
}

void Engine::RenderLoadingBar(float percent)
{
	UTIL_GL::GL2D::SetOrtho(640,480);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glColor4f(1,1,1,1);
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, gpEng->mSprites[SPR_UI].mImg);
	glBegin(GL_QUADS);
	Vec2 sprUVS = gpEng->mSprites[SPR_UI].mUVsize;
	Vec2 sprUV = gpEng->mSprites[SPR_UI].GetTileUV(24);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(100, 440);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(132, 440);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(132, 472);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(100, 472);

	sprUV = gpEng->mSprites[SPR_UI].GetTileUV(27);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(508, 440);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(540, 440);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(540, 472);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(508, 472);

	sprUV = gpEng->mSprites[SPR_UI].GetTileUV(26);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(132, 440);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(508, 440);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(508, 472);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(132, 472);

	sprUV = gpEng->mSprites[SPR_UI].GetTileUV(25);
	float LENGTH = (508-132) * (percent / 100.0f);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(132, 440);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(132+LENGTH, 440);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(132+LENGTH, 472);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(132, 472);

	glEnd();
	glDisable(GL_BLEND);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, mGfxImg[GFX_LOADING1]);
	glBegin(GL_QUADS);
	glTexCoord2f(0,1); glVertex2f(320-64,240-64);
	glTexCoord2f(1,1); glVertex2f(320+64,240-64);
	glTexCoord2f(1,0); glVertex2f(320+64,240+64);
	glTexCoord2f(0,0); glVertex2f(320-64,240+64);
	glEnd();
	glDisable(GL_TEXTURE_2D);

	mFont1.SetAlignment(ALIGN_LEFT);
	mFont1.SetColor(1,1,1,1);
	mFont1.SetScale(0.5f,0.5f);
	mFont1.Print("LOADING..",520,448);
	char sz[32];
	sprintf(sz,"%i%%",(int)percent);
	mFont1.SetAlignment(ALIGN_CENTER);
	mFont1.Print(sz,320,448);
	SDL_GL_SwapBuffers();

}