#include "SpriteSheet.h"
//================================================================================================//
						/*****************************
						** constructor			**	
						******************************/
//================================================================================================//
SpriteSheet::SpriteSheet()
{
	mImg = 0;
	width = 0;
	height = 0;
	NumFrames = 0;
}
//================================================================================================//
						/*****************************
						** split the sheet			**	
						******************************/
//================================================================================================//
void SpriteSheet::Split(unsigned int img, int w, int h, int imgWidth, int imgHeight)
{
	mUV.clear();
	mImg = img;
	width = w;
	height = h;
	ImgWidth = imgWidth;
	ImgHeight = imgHeight;
	mFrameSize.x = imgWidth/w;
	mFrameSize.y = imgHeight/h;

	float u,v;
	mUVsize.x = u = (1.0f / (float)w);
	mUVsize.y = v = (1.0f / (float)h);

	int numRows = w;
	int numCols = h;

	for(int y=0; y<numCols; y++)
	{
		for(int x=0; x<numRows; x++)
		{
			mUV.push_back( Vec2((u*x), 1-(v*(y+1))) );
		}
	}
	NumFrames = (int)mUV.size();
}
//================================================================================================//
						/**************************************
						** fetch tile UV coords for an frame index **	
						***************************************/
//================================================================================================//
Vec2 SpriteSheet::GetTileUV(int ID)
{
	return mUV[ID];
}
//================================================================================================//
						/**************************************
						** render a frame					 **	
						***************************************/
//================================================================================================//
#include "UTIL_OpenGL.h"
void SpriteSheet::RenderSprite(Vec2 p, Vec2 s, int frame)
{
	Vec2 sprUV = GetTileUV(frame);
	Vec2 sprUVS = mUVsize;
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(p.x-s.x, p.y-s.y);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(p.x+s.x, p.y-s.y);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(p.x+s.x, p.y+s.y);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(p.x-s.x, p.y+s.y);
}
#include "UTIL_Misc.h"
void SpriteSheet::RenderSprite(Vec2 p, float r, Vec2 s, int frame)
{
	Vec2 sprUV = GetTileUV(frame);
	Vec2 sprUVS = mUVsize;
	Vec2 f,u;
	UTIL_Misc::MakeVectors(r+90,u,f);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2fv((p-f*s.x - u*s.y).v);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2fv((p+f*s.x - u*s.y).v);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2fv((p+f*s.x + u*s.y).v);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2fv((p-f*s.x + u*s.y).v);
}
