#include "Engine.h"

extern float fWorldRotation,fOWorldRotation;
float fOpenBall, fOOpenBall;
float fBallVel = 0;
float fOpenPos, fOOpenPos;
float fBallGrav;
float fBallStagesAlpha = 0;
float fViewScale=1;
float fViewStageAlpha = 0;
std::list<Block> mMapView[15];
//bool mbStageComplete[15];

Vec3 mViewOffset;//find the center of the map for rotation
float fArrowBounce=0;
bool bFadeStage= true;
int miSelectedStageBallNew;
extern bool bFirstPlay;

void Engine::LoadStageSelectData()//so we only load these maps one time
{
//	_ASSERTE( _CrtCheckMemory( ) );
	CleanupMap();
	mPlayer.Spawn(Vec3(0,0,1),Vec3(0,0,0),Vec3(1,0,0),Vec3(0,1,0));
	for(int n=0; n<13; n++)
	{
		mMapView[n].clear();
		char sz[64];
		sprintf(sz,"Data/Maps/World%i_%i.map",miWorld+1,n+1);
		if(LoadMap(sz,false))
		{
			mMapView[n].clear();
			std::list<Block>::iterator it;
			for(it=mMapBlocks.begin(); it!=mMapBlocks.end(); it++)
			{
				mMapView[n].push_back((*it));
			}
			//need to copy the blocks from platforms back into the view display
			std::list<Platform*>::iterator pl;
			for(pl=mPlatforms.begin(); pl!=mPlatforms.end(); pl++)
			{
				if(!(*pl)->bVisible)
					continue;
				std::list<Block>::iterator bl;
				for(bl = (*pl)->mBlocks.begin(); bl!=(*pl)->mBlocks.end(); bl++)
				{
					(*bl).pPlat = NULL;
					(*bl).mbPlatform = false;
					mMapView[n].push_back((*bl));
				}
				
			}
			CleanupMap();
		}		
	}
//	_ASSERTE( _CrtCheckMemory( ) );
}
extern bool DEMO_BUILD;

void Engine::StartStageSelect()
{
	StopMasterChannel();

//	_ASSERTE( _CrtCheckMemory( ) );
	CleanupMap();
	if(gpEng->bBonusStage)
	{
		gpEng->iBonusStage++;
		gpEng->SaveGameSlot();
	}

	gpEng->bBonusStage = false;
	if(mPlayer.mbWorldWon)
	{
		gpEng->miOWorld++;
		gpEng->miWorld = gpEng->miOWorld;
		if(miWorld >= 5)
		{
			miWorld = miOWorld = 4;
			gpEng->SavePerstistanceData();
			gpEng->SaveGameSlot();
			miWorld = miOWorld = 5;
			gpEng->mMenus.remove_if(CleanupMenus);
			ChangeState(STATE_CREDITS, 0);
			StartCredits();
			return;
		}
		else if(DEMO_BUILD)
		{
			miWorld = miOWorld = 0;
			//gpEng->SavePerstistanceData();
			//gpEng->SaveGameSlot();
			gpEng->mMenus.remove_if(CleanupMenus);
			ChangeState(STATE_ENDDEMO, 0);
			StartEndDemo();
			return;
		}
		else
		{
			miPreservedScore = miScore;
			iPreservedBonusStage = iBonusStage;
			gpEng->CleanupWorldData();
			gpEng->LoadWorldData();
			miStarCount = 0;
			//miGemCount = 0;//dont clear gems between worlds
			for(int n=0; n<15; n++)
			{
				gpEng->miStagePersistance[n].clear();
				gpEng->mbStageSelect[n] = false;
			}
			gpEng->miSelectedStageBall = 0;
			gpEng->SavePerstistanceData();
			gpEng->SaveGameSlot();
			gpEng->LoadPerstistanceData();
			gpEng->LoadStageSelectData();
			//gpEng->StartStageSelect();
			mPlayer.mbWorldWon = false;
			gLog.OutPut("Player beat world\n");
		}
	}

	gpEng->miWorld = gpEng->miOWorld;
	gpEng->mMenus.remove_if(CleanupMenus);
	FADE_Star* FS2 = new FADE_Star;
	FS2->Spawn(1,Vec3(0,1,1));
	mFadeEng.InsertSystem(FS2);//*/

	WorldMenu* menu = new WorldMenu;
	menu->Spawn(Vec2(320,240));
	mMenus.push_back(menu);
	fOpenBall = fOOpenBall =0;
	fBallVel = 0;
	fBallStagesAlpha = 0;
	fOpenPos = fOOpenPos = -7;
	fBallGrav = 0;

	//find the center
	Vec2 mx(100,-100),my(100,-100),mz(100,-100);//mins/maxs
	std::list<Block>::iterator it;
	for(it=mMapView[miSelectedStageBall].begin();it!=mMapView[miSelectedStageBall].end();it++)
	{
	
		if((*it).pos.x<mx.x)
			mx.x = (*it).pos.x;
		if((*it).pos.x>mx.y)
			mx.y = (*it).pos.x;

		if((*it).pos.y<my.x)
			my.x = (*it).pos.y;
		if((*it).pos.y>my.y)
			my.y = (*it).pos.y;

		if((*it).pos.z<mz.x)
			mz.x = (*it).pos.z;
		if((*it).pos.z>mz.y)
			mz.y = (*it).pos.z;
	}
	mViewOffset = Vec3(0,0,0);//((Vec3((int)mx.y,(int)my.y,(int)mz.y)-Vec3(32,32,32))/2) + (Vec3(mx.x,my.x,mz.x)-Vec3(32,32,32));
//	char offset[128];
//	sprintf(offset,"%.2f %.2f %.2f\n", mViewOffset.x,mViewOffset.y,mViewOffset.z);
//	gLog.OutPut(offset);
	float dx =  mx.y-mx.x;
	float dy =  my.y-my.x;
	float dz =  mz.y-mz.x;
	fViewScale = dx>dy?(dx>dz?dx:dz):(dy>dz?dy:dz);
	fViewScale = 1.0 - (fViewScale / 64.0f);

	fArrowBounce = 0;
	fViewStageAlpha = 0;
	bFadeStage = false;
	miSelectedStageBallNew = miSelectedStageBall;
	iOption = 0;
	mPartEng.CleanUp();
	mTimer.Reset();

	if(gpEng->miGemCount>=100)//need to find a good value for this
	{
		mMenus.remove_if(CleanupMenus);
		miGemCount -= 100;
		bBonusStage = true;
		LoadSelectedStage();
	}
	iDebugFrame = 0;

	if(!MusicIsPlaying())
		PlayMusicFadeIn(mAltMainMusic,true,300,false);


//	_ASSERTE( _CrtCheckMemory( ) );

/*	int tmpFlag = _CrtSetDbgFlag( _CRTDBG_REPORT_FLAG );
	tmpFlag |= _CRTDBG_CHECK_ALWAYS_DF;
	_CrtSetDbgFlag(tmpFlag);*/
}
extern bool bFixFadeBug;

void Engine::LoadSelectedStage()
{
	mbCamPreviewMode = false;
	StopMasterChannel();
//	_ASSERTE( _CrtCheckMemory( ) );
	if(!bBonusStage)
	{
		MasterMusicFadeout(500);
		PlayMusic(mMainMusic,false,false);
		FADE_Fade1* FS = new FADE_Fade1;
		FS->Spawn(1,Vec3(1,1,1));
		mFadeEng.InsertSystem(FS);//*/
		(this->*pRenderFunc)(1);
		RenderSceneToFadeBuffer();
	}
	else
	{
		MasterMusicFadeout(500);
		PlayMusic(mBonusMusic,false,false);

	}
//	mMenus.remove_if(CleanupMenus);
	mSurfaces.clear();
	CleanupMap();
	gpEng->miCurrentPersistance.clear();

	miSelectedStageBall = miSelectedStageBallNew;
	char sz[64];
	sprintf(sz,"Data/Maps/World%i_%i.map",miWorld+1,miSelectedStageBallNew+1);
	if(bBonusStage)
	{
		sprintf(sz,"Data/Maps/Bonus%i.map",iBonusStage+1);
		gLog.OutPut("Entering bonus stage: ");
		gLog.OutPut(sz);
		gLog.OutPut("\n");
	}
	if(!LoadMap(sz,true))
		mbQuit = true;

	if(!bBonusStage)
	{
	PS_Fade1* PS = new PS_Fade1;
	PS->Spawn(Vec3(0,0,0),Vec3(0,0,0),Vec2(32,32),Vec3(1,1,1),0,1,1);
	mPartEng.InsertSystem(PS,true);//*/
	}

	for(int n=0; n<10; n++)
	{
		mi1UpSlotTime[n] = 0;
		mi1UpSlotRotateTime[n] = 0;
	}
	mi1UpSlotTwistTime = 0;
	mi1UpGiveTimer = 0;
	miLocal1UpCount = 0;
	miLocalGemCount = 0;//reset the counter each time the level starts
	miLocalStarCount = 0;
	mfHudColRamp = 0;
	mfStageTime = 61;//starting time
	mfStageTimeEnd = 0;
	fStageWonGrav = 0;
	fStageWonY = fOStageWonY = 0;
	iHUDGemFlashTime = 0;
	iHUDStarFlashTime = 0;
	ChangeState(STATE_GAME, 0);
	bFixFadeBug = true;
	(this->*pUpdateFunc)();
	bFixFadeBug = false;

	if(miWorld == 3 && !bBonusStage)//snow
	{
		PS_Snow* PS2 = new PS_Snow;
		PS2->Spawn(Vec3(0,0,0),Vec3(0,0,0),Vec2(32,32),Vec3(1,1,1),0,1,1);
		mPartEng.InsertSystem(PS2,false);//*/
	}
	miBonusClock = 0;
	mbPauseClock = false;
	fPauseClockTime = 0;
	fMusicTimer = 0;
	fGreyScaleClockStart = fGreyScaleClock = 0;
	gLog.OutPut("ended start selected stage.\n");
//	_ASSERTE( _CrtCheckMemory( ) );
	iDebugFrame = 0;

}
void Engine::UpdateStageSelect()
{
//	_ASSERTE( _CrtCheckMemory( ) );
/*	if(KEY_QUIT.state == JUST_PRESSED && !mbPaused && mFadeEng.mSystems.empty())
	{
		if(!mMenus.empty() && mMenus.back()->bFadingIn ||
			!mMenus.empty() && mMenus.back()->bFadingOut ||
			 !mMenus.empty() && !mMenus.back()->bFadingIn && !mMenus.empty() && !mMenus.back()->bFadingOut ||
			mMenus.empty())
		mbQuit =true;
	}//*/

	if(!mMenus.empty())
	{
		mMenus.back()->Update();
//_ASSERTE( _CrtCheckMemory( ) );
		mMenus.remove_if(PruneMenus);
		if(this->iEngineState == STATE_GAME || this->iEngineState == STATE_GAMESELECT)
		{
			gLog.OutPut("Removed menu's\n");
			mMenus.remove_if(CleanupMenus);
		}
	}
//_ASSERTE( _CrtCheckMemory( ) );
	fOWorldRotation = fWorldRotation;
	fWorldRotation += TIME_STEP * 1.5f*5;
	mfOCloudScroll = mfCloudScroll;
	mfCloudScroll += 0.002f;
	mPartEng.Update();
	mFadeEng.Update();

	if(mFadeEng.mSystems.empty())
	{
		fBallGrav += 0.03f;
		fOOpenPos = fOpenPos;
		fOpenPos += fBallGrav;
		if(fOpenPos>=-0.5f)
		{
			fOpenPos = -0.5f;
			fBallGrav = - fBallGrav * 0.65f;
			if(fBallGrav<0 && fBallGrav<-0.05f || fBallGrav>0 && fBallGrav>0.05f)
				PlaySample(mSnd[SND_UI_BOUNCE],false);
			if(fBallGrav<=0.03f)
			{
				fBallVel += 0.3f;//call this gravity
				fOOpenBall = fOpenBall;
				fOpenBall += fBallVel;
				if(fOpenBall>=165)
				{
					fOpenBall = 165;
					fBallVel = - fBallVel * 0.75f;
				if(fBallVel<0 && fBallVel<-1 || fBallVel>0 && fBallVel>1)
					PlaySample(CHNL_BALL_CLIP,mSnd[SND_BALL_CLIP],false);
				}
				if(fOpenBall>75)
				{
					fBallStagesAlpha += 0.01f;
					if(fBallStagesAlpha>1)
						fBallStagesAlpha = 1;
					if(!bFadeStage)
					{
						fViewStageAlpha+=TIME_STEP;
						if(fViewStageAlpha>1)
							fViewStageAlpha=1;
					}
				}
			}
		}
	}
	fArrowBounce += TIME_STEP*5;
//_ASSERTE( _CrtCheckMemory( ) );
	if(iOption == 0)
	{
		if(!bFadeStage)
		{
			if(KEY_BACK.state == JUST_PRESSED)
			{
				switch(miSelectedStageBall)
				{
				case 0: miSelectedStageBallNew = 2; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);break;
				case 1: case 2: case 3: miSelectedStageBallNew = miSelectedStageBall+4; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);break;
				case 5: case 6: case 7: miSelectedStageBallNew = miSelectedStageBall+4; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);break;
				case 10: miSelectedStageBallNew = 12; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);break;
				}
			}
			if(KEY_FORWARD.state == JUST_PRESSED)
			{
				switch(miSelectedStageBall)
				{
				case 12: miSelectedStageBallNew = 10; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);break;
				case 9: case 10: case 11: miSelectedStageBallNew = miSelectedStageBall-4; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);break;
				case 5: case 6: case 7: miSelectedStageBallNew = miSelectedStageBall-4; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);break;
				case 2: miSelectedStageBallNew = 0; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);break;
				}
			}
			if(KEY_TURN_RIGHT.state == JUST_PRESSED)
			{
				switch(miSelectedStageBall)
				{
				case 0: case 3: case 8: case 11: case 12: break;
				default: miSelectedStageBallNew++; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);break;
				}
			}
			if(KEY_TURN_LEFT.state == JUST_PRESSED)
			{
				switch(miSelectedStageBall)
				{
				case 0: case 1: case 4: case 9: case 12: break;
				default: miSelectedStageBallNew--; PlaySample(CHNL_UI_MOVE,gpEng->mSnd[SND_UI_MOVE],false);break;
				}
			}
			if(miSelectedStageBall != miSelectedStageBallNew)
				bFadeStage = true;
			if(KEY_ACTION2.state == JUST_PRESSED)
			{
				PlaySample(CHNL_UI_BACKUP,gpEng->mSnd[SND_UI_BACKUP],false);
				iOption = 1;
			}

			if(fOpenBall>=75)
			if(KEY_JUMP.state == JUST_PRESSED)
			{
				bool GotEnoughStars = false;
				switch(miWorld)
				{
				case 0: if(miStarCount>=15)GotEnoughStars=true;				break;
				case 1: if(miStarCount>=20)GotEnoughStars=true;				break;
				case 2: if(miStarCount>=25)GotEnoughStars=true;				break;
				case 3: if(miStarCount>=25)GotEnoughStars=true;				break;
				case 4: if(miStarCount>=25)GotEnoughStars=true;				break;//should be 27
				}
				if(miSelectedStageBall == 12 && !GotEnoughStars)
					PlaySample(CHNL_UI_BACKUP,gpEng->mSnd[SND_UI_BACKUP],false);

				if(miSelectedStageBall == 12 && GotEnoughStars || miSelectedStageBall != 12)
				{
					if(bFirstPlay)
					{
						bFirstPlay = false;
						PopMenu* menu = new PopMenu;
						menu->iExternalCode = PopMenu::POP_VIDEO;
						menu->Spawn(Vec2(320,240));
						strcpy(menu->szMessage,"PLAY STAGES IN ANY ORDER TOO TOUGH? TRY ANOTHER!");
						gpEng->mMenus.push_back(menu);
					}
					else
					{
						PlaySample(CHNL_UI_SELECT2,gpEng->mSnd[SND_UI_SELECT2],false);
						iOption = 1;
						SureMenu* menu = new SureMenu;
						menu->Spawn(Vec2(320,240));
						menu->iExternalCode = SureMenu::SURE_STAGESELECT_ACCEPT;
						mbStageSelect[miSelectedStageBall]?
							strcpy(menu->szMessage,"THIS STAGE IS ALREADY COMPLETED   PLAY AGAIN?"):
						strcpy(menu->szMessage,"PLAY THIS STAGE?");
						gpEng->mMenus.push_back(menu);
						KEY_JUMP.state = JUST_RELEASED;
					}
				}
			}

		}
	}
//_ASSERTE( _CrtCheckMemory( ) );
	if(bFadeStage)
	{
		fViewStageAlpha-=TIME_STEP*5;
		if(fViewStageAlpha<0)
		{
			fViewStageAlpha=0;
			miSelectedStageBall = miSelectedStageBallNew;
			bFadeStage = false;

			//find the center
			Vec2 mx(100,-100),my(100,-100),mz(100,-100);//mins/maxs
			std::list<Block>::iterator it;
			for(it=mMapView[miSelectedStageBall].begin();it!=mMapView[miSelectedStageBall].end();it++)
			{
			
				if((*it).pos.x<mx.x)
					mx.x = (*it).pos.x;
				if((*it).pos.x>mx.y)
					mx.y = (*it).pos.x;

				if((*it).pos.y<my.x)
					my.x = (*it).pos.y;
				if((*it).pos.y>my.y)
					my.y = (*it).pos.y;

				if((*it).pos.z<mz.x)
					mz.x = (*it).pos.z;
				if((*it).pos.z>mz.y)
					mz.y = (*it).pos.z;
			}
			mViewOffset = Vec3(0,0,0);//((Vec3((int)mx.y,(int)my.y,(int)mz.y)-Vec3(32,32,32))/2) + (Vec3(mx.x,my.x,mz.x)-Vec3(32,32,32));
			//char offset[128];
			//sprintf(offset,"%.2f %.2f %.2f\n", mViewOffset.x,mViewOffset.y,mViewOffset.z);
			//gLog.OutPut(offset);
			float dx =  mx.y-mx.x;
			float dy =  my.y-my.x;
			float dz =  mz.y-mz.x;
			fViewScale = dx>dy?(dx>dz?dx:dz):(dy>dz?dy:dz);
			fViewScale = 1.0 - (fViewScale / 64.0f);
		}
	}
//_ASSERTE( _CrtCheckMemory( ) );
	mPlayerType.vOBallRotation = mPlayerType.vBallRotation;
	mPlayerType.vBallRotation += Vec2(TIME_STEP*20, TIME_STEP*40);
	//hud gem colors
	mfHudColRamp += TIME_STEP*3;
	if(mfHudColRamp>=1)
	{
		mfHudColRamp-=1;
		mHudColors.push_back(mHudColors.front());
		mHudColors.pop_front();
	}
}
void Engine::RenderStageSelect(const float interp)
{
//_ASSERTE( _CrtCheckMemory( ) );
	miBoundFBO = 0;
	BindFBO(mMainFBO,0);
	glClearColor(0.7f,0.1,0.1,0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	UTIL_GL::GL3D::SetPerspective(70,1.3f,2,2048);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glEnable(GL_MULTISAMPLE_ARB);
	//Vec3 eye = p - f * 2.7f - u * 2.7f;
	Vec3 eye(32,32,32);
	eye.x = UTIL_Misc::Clamp(eye.x, 0, MAP_DIMENSIONS);
	eye.y = UTIL_Misc::Clamp(eye.y, 0, MAP_DIMENSIONS);
	eye.z = UTIL_Misc::Clamp(eye.z, 0, MAP_DIMENSIONS);
//	gluLookAt(p.x,p.y,p.z, p.x+f.x,p.y+f.y,p.z+f.z, -u.x,-u.y,-u.z);
	Vec3 f(0,0,1);
	Vec3 u(0,-1,0);
	gluLookAt(eye.x,eye.y,eye.z, f.x,f.y,f.z, -u.x,-u.y,-u.z);
	float Rotation = UTIL_Misc::Interpolate(fWorldRotation,fOWorldRotation,interp);
//	glRotatef(Rotation*0.01, 1,0,0);
	glRotatef(Rotation, 0,1,0);

//	gluLookAt(0,0,0, f.x,f.y,f.z, -u.x,-u.y,-u.z);
	glScalef(1,0.5,1);
	glTranslatef(0,64,0);
	//skybox
	RenderWorld(miWorld,interp);
//_ASSERTE( _CrtCheckMemory( ) );
	UTIL_GL::GL3D::SetPerspective(45,1.3f,0.1f,30);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	gluLookAt(0,-1.5f,0, 0,0,5, 0,-1,0);

	GLfloat tempMatrix[16];
	glGetFloatv(GL_MODELVIEW_MATRIX,tempMatrix);
	Vec3 camRight = Vec3(tempMatrix[0],tempMatrix[4],tempMatrix[8]);
	Vec3 camUp = Vec3(tempMatrix[1],tempMatrix[5],tempMatrix[9]);
	Vec3 camFwd = Vec3(tempMatrix[2],tempMatrix[6],tempMatrix[10]);

	UnBindFBO();

	//render dOF
	if(!mbFallBackMode)
	if(mbDOF)
	{
		BindFBO(mMainFBO,0);
		glEnable(GL_DEPTH_TEST);
		glDepthMask(GL_TRUE);
		glColorMask(GL_FALSE,GL_FALSE,GL_FALSE,GL_FALSE);
		glBegin(GL_QUADS);
		glVertex3fv((eye-camFwd*20-camRight*50-camUp*50).v);
		glVertex3fv((eye-camFwd*20+camRight*50-camUp*50).v);
		glVertex3fv((eye-camFwd*20+camRight*50+camUp*50).v);
		glVertex3fv((eye-camFwd*20-camRight*50+camUp*50).v);
		glEnd();
		glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);
		UnBindFBO();

		float mul = 1;
		switch(iSuperSamples)
		{
		case 1: mul = 1.25f; break;
		case 2: mul = 1.5f; break;
		case 3: mul = 1.75f; break;
		case 4: mul = 2; break;
		}
		BindFBO(mMainFBO,1);
		float focalD = 7;// + (sin(mTimer.GetTime())*100);
		mShdrMgr.BindProgram(mShdrDOFH);
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSamplerRect("depth",1 ,mMainFBO.depthtexID);
		mShdrMgr.PassUniform1f("focalD",focalD);
		mShdrMgr.PassUniform1f("depthRange",20);
		mShdrMgr.PassUniform1f("blurFactor",0.05f*mul);
		glClear(GL_COLOR_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDepthMask(GL_FALSE);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		mShdrMgr.BindProgram(0);
		UnBindFBO();
		BindFBO(mMainFBO,0);
		mShdrMgr.BindProgram(mShdrDOFV);
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[1]);
		mShdrMgr.PassSamplerRect("depth",1 ,mMainFBO.depthtexID);
		mShdrMgr.PassUniform1f("focalD",focalD);
		mShdrMgr.PassUniform1f("depthRange",20);
		mShdrMgr.PassUniform1f("blurFactor",0.05f*mul);
		glClear(GL_COLOR_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDepthMask(GL_FALSE);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		mShdrMgr.BindProgram(0);
		UnBindFBO();
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		glDepthMask(GL_TRUE);

	}//*/


	BindFBO(mMainFBO,0);


//_ASSERTE( _CrtCheckMemory( ) );

	glClear(GL_DEPTH_BUFFER_BIT);
	UTIL_GL::GL3D::SetPerspective(45,1.3f,0.1f,30);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	gluLookAt(0,0,0, 0,0,5, 0,-1,0);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	Vec3 lp = Vec3(0,0,0) + camUp * 1 + camRight*5;
//	float LightPos[4]={-500,-1000.1f,500,1};
	float LightPos[4]={lp.x,lp.y,lp.z,0};
	float LightDir[4]={-camUp.x,-camUp.y,-camUp.z,0};
	float amb[4]={0.15f,0.15f,0.15f,1};
	float dif[4]={0.4f,0.4f,0.4f,1};
	float gldif[4]={0.7f,0.7f,0.7f,1};
	float glamb[4]={0.95f,0.95f,0.95f,1};
	float spec[4]={1,1,1,0};
	float blk[4]={0,0,0,1};
	glShadeModel(GL_SMOOTH);
//	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, amb);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0,  GL_POSITION, LightPos);
	glLightfv(GL_LIGHT0,  GL_SPOT_DIRECTION, LightDir);
	glLightfv(GL_LIGHT0,  GL_AMBIENT, dif);
	glLightfv(GL_LIGHT0,  GL_DIFFUSE, gldif);
	glLightfv(GL_LIGHT0,  GL_SPECULAR, glamb);
	glEnable(GL_COLOR_MATERIAL);
	glMaterialfv(GL_FRONT, GL_AMBIENT, dif);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, glamb);
	glMaterialfv(GL_FRONT, GL_SPECULAR, blk);
	glMateriali(GL_FRONT, GL_SHININESS, 100);

	float fBallY = UTIL_Misc::Interpolate(fOpenPos,fOOpenPos,interp);
	glTranslatef(-1.8,fBallY,6);
	glDisable(GL_CULL_FACE);
	Vec2 mins(0,0), maxs(1,1);
	gpEng->mShdrMgr.BindProgram(gpEng->mShdrPBallLight);

	glPushMatrix();
	glRotatef(180,0,0,1);
	glRotatef(20,0,1,0);
	glRotatef(-45,1,0,0);
	glScalef(1.05,1.05,1.05);
	glColor3f(0,0,0);
	mObjects[MDL_HALFBALL].RenderBuffer(false);
	glPopMatrix();
	glPushMatrix();
	glRotatef(180,0,0,1);
	glRotatef(20,0,1,0);
	float fopen = UTIL_Misc::Interpolate(fOpenBall,fOOpenBall,interp);
	glRotatef(-45+fopen,1,0,0);
	glScalef(1,-1,1);
	glScalef(1.05,1.05,1.05);
	mObjects[MDL_HALFBALL].RenderBuffer(false);
	glClear(GL_DEPTH_BUFFER_BIT);
	glPopMatrix();

	glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
	mMatMgr.SetMaterialAttributes(mMaterials[MAT_FLAT],BASE_PASS,0);
	glPushMatrix();
	glRotatef(180,0,0,1);
	glRotatef(20,0,1,0);
	glRotatef(-45,1,0,0);
	glColor3f(1,0,0);
	mObjects[MDL_HALFBALL].RenderBuffer(false);
	glPopMatrix();
	glPushMatrix();
	glRotatef(180,0,0,1);
	glRotatef(20,0,1,0);
	glRotatef(-45+fopen,1,0,0);
	glScalef(1,-1,1);
	glColor3f(1,1,1);
	mObjects[MDL_HALFBALL].RenderBuffer(false);
	glPopMatrix();


	mShdrMgr.BindProgram(0);
	glDisable(GL_COLOR_MATERIAL);
	glDisable(GL_LIGHTING);
	glDisable(GL_LIGHT0);
	glActiveTexture(GL_TEXTURE1);
	glDisable(GL_TEXTURE_2D);
	glActiveTexture(GL_TEXTURE0);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);

	UTIL_GL::GL2D::SetOrtho(640,480);
	mFont1.EnableShadow();
	mFont1.SetAlignment(ALIGN_CENTER);
	mFont1.SetColor(1,1,1,1);
	mFont1.SetScale(0.75f,0.75f);
	mFont1.SetAlignment(ALIGN_LEFT);
	mFont1.SetScale(0.35f,0.5f);
	mFont1.Print("SELECT",582,417);
	mFont1.Print("BACK",582,449);

	Vec2 sprUV, sprUVS;
	sprUVS = mSprites[SPR_UI].mUVsize;
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	UTIL_GL::BindTexture(GL_TEXTURE_2D, mSprites[SPR_UI].mImg);

	//2d stage spheres
	glPushMatrix();
	glDepthMask(GL_FALSE);
	glColor4f(1,1,1,fBallStagesAlpha);
	glTranslatef(78,225,0);
	glBegin(GL_QUADS);
	miSelectedStageBallNew==0?
		(mbStageSelect[0]?		mSprites[SPR_UI].RenderSprite(Vec2(64,0),Vec2(16,16), 13) : mSprites[SPR_UI].RenderSprite(Vec2(64,0),Vec2(16,16), 15)):
		(mbStageSelect[0]?		mSprites[SPR_UI].RenderSprite(Vec2(64,0),Vec2(16,16), 12) : mSprites[SPR_UI].RenderSprite(Vec2(64,0),Vec2(16,16), 14));
	miSelectedStageBallNew==1?
		(mbStageSelect[1]?		mSprites[SPR_UI].RenderSprite(Vec2(32,24),Vec2(16,16), 13) : mSprites[SPR_UI].RenderSprite(Vec2(32,24),Vec2(16,16), 15)):
		(mbStageSelect[1]?		mSprites[SPR_UI].RenderSprite(Vec2(32,24),Vec2(16,16), 12) : mSprites[SPR_UI].RenderSprite(Vec2(32,24),Vec2(16,16), 14));
	miSelectedStageBallNew==2?
		(mbStageSelect[2]?		mSprites[SPR_UI].RenderSprite(Vec2(64,24),Vec2(16,16), 13) : mSprites[SPR_UI].RenderSprite(Vec2(64,24),Vec2(16,16), 15)):
		(mbStageSelect[2]?		mSprites[SPR_UI].RenderSprite(Vec2(64,24),Vec2(16,16), 12) : mSprites[SPR_UI].RenderSprite(Vec2(64,24),Vec2(16,16), 14));
	miSelectedStageBallNew==3?
		(mbStageSelect[3]?		mSprites[SPR_UI].RenderSprite(Vec2(96,24),Vec2(16,16), 13) : mSprites[SPR_UI].RenderSprite(Vec2(96,24),Vec2(16,16), 15)):
		(mbStageSelect[3]?		mSprites[SPR_UI].RenderSprite(Vec2(96,24),Vec2(16,16), 12) : mSprites[SPR_UI].RenderSprite(Vec2(96,24),Vec2(16,16), 14));
	miSelectedStageBallNew==4?
		(mbStageSelect[4]?		mSprites[SPR_UI].RenderSprite(Vec2(0,48),Vec2(16,16), 13) : mSprites[SPR_UI].RenderSprite(Vec2(0,48),Vec2(16,16), 15)):
		(mbStageSelect[4]?		mSprites[SPR_UI].RenderSprite(Vec2(0,48),Vec2(16,16), 12) : mSprites[SPR_UI].RenderSprite(Vec2(0,48),Vec2(16,16), 14));
	miSelectedStageBallNew==5?
		(mbStageSelect[5]?		mSprites[SPR_UI].RenderSprite(Vec2(32,48),Vec2(16,16), 13) : mSprites[SPR_UI].RenderSprite(Vec2(32,48),Vec2(16,16), 15)):
		(mbStageSelect[5]?		mSprites[SPR_UI].RenderSprite(Vec2(32,48),Vec2(16,16), 12) : mSprites[SPR_UI].RenderSprite(Vec2(32,48),Vec2(16,16), 14));
	miSelectedStageBallNew==6?
		(mbStageSelect[6]?		mSprites[SPR_UI].RenderSprite(Vec2(64,48),Vec2(16,16), 13) : mSprites[SPR_UI].RenderSprite(Vec2(64,48),Vec2(16,16), 15)):
		(mbStageSelect[6]?		mSprites[SPR_UI].RenderSprite(Vec2(64,48),Vec2(16,16), 12) : mSprites[SPR_UI].RenderSprite(Vec2(64,48),Vec2(16,16), 14));
	miSelectedStageBallNew==7?
		(mbStageSelect[7]?		mSprites[SPR_UI].RenderSprite(Vec2(96,48),Vec2(16,16), 13) : mSprites[SPR_UI].RenderSprite(Vec2(96,48),Vec2(16,16), 15)):
		(mbStageSelect[7]?		mSprites[SPR_UI].RenderSprite(Vec2(96,48),Vec2(16,16), 12) : mSprites[SPR_UI].RenderSprite(Vec2(96,48),Vec2(16,16), 14));
	miSelectedStageBallNew==8?
		(mbStageSelect[8]?		mSprites[SPR_UI].RenderSprite(Vec2(128,48),Vec2(16,16), 13) : mSprites[SPR_UI].RenderSprite(Vec2(128,48),Vec2(16,16), 15)):
		(mbStageSelect[8]?		mSprites[SPR_UI].RenderSprite(Vec2(128,48),Vec2(16,16), 12) : mSprites[SPR_UI].RenderSprite(Vec2(128,48),Vec2(16,16), 14));
	miSelectedStageBallNew==9?
		(mbStageSelect[9]?		mSprites[SPR_UI].RenderSprite(Vec2(32,72),Vec2(16,16), 13) : mSprites[SPR_UI].RenderSprite(Vec2(32,72),Vec2(16,16), 15)):
		(mbStageSelect[9]?		mSprites[SPR_UI].RenderSprite(Vec2(32,72),Vec2(16,16), 12) : mSprites[SPR_UI].RenderSprite(Vec2(32,72),Vec2(16,16), 14));
	miSelectedStageBallNew==10?
		(mbStageSelect[10]?		mSprites[SPR_UI].RenderSprite(Vec2(64,72),Vec2(16,16), 13) : mSprites[SPR_UI].RenderSprite(Vec2(64,72),Vec2(16,16), 15)):
		(mbStageSelect[10]?		mSprites[SPR_UI].RenderSprite(Vec2(64,72),Vec2(16,16), 12) : mSprites[SPR_UI].RenderSprite(Vec2(64,72),Vec2(16,16), 14));
	miSelectedStageBallNew==11?
		(mbStageSelect[11]?		mSprites[SPR_UI].RenderSprite(Vec2(96,72),Vec2(16,16), 13) : mSprites[SPR_UI].RenderSprite(Vec2(96,72),Vec2(16,16), 15)):
		(mbStageSelect[11]?		mSprites[SPR_UI].RenderSprite(Vec2(96,72),Vec2(16,16), 12) : mSprites[SPR_UI].RenderSprite(Vec2(96,72),Vec2(16,16), 14));
	miSelectedStageBallNew==12?
		(mbStageSelect[12]?		mSprites[SPR_UI].RenderSprite(Vec2(64,96),Vec2(16,16), 13) : mSprites[SPR_UI].RenderSprite(Vec2(64,96),Vec2(16,16), 15)):
		(mbStageSelect[12]?		mSprites[SPR_UI].RenderSprite(Vec2(64,96),Vec2(16,16), 12) : mSprites[SPR_UI].RenderSprite(Vec2(64,96),Vec2(16,16), 14));

	switch(miSelectedStageBallNew)
	{
	case 0:	mSprites[SPR_UI].RenderSprite(Vec2(64,-(32+sin(fArrowBounce)*2)),Vec2(16,16), 11); break;
	case 1:	mSprites[SPR_UI].RenderSprite(Vec2(32,24-(32+sin(fArrowBounce)*2)),Vec2(16,16), 11); break;
	case 2:	mSprites[SPR_UI].RenderSprite(Vec2(64,24-(32+sin(fArrowBounce)*2)),Vec2(16,16), 11); break;
	case 3:	mSprites[SPR_UI].RenderSprite(Vec2(96,24-(32+sin(fArrowBounce)*2)),Vec2(16,16), 11); break;
	case 4:	mSprites[SPR_UI].RenderSprite(Vec2(0,48-(32+sin(fArrowBounce)*2)),Vec2(16,16), 11); break;
	case 5:	mSprites[SPR_UI].RenderSprite(Vec2(32,48-(32+sin(fArrowBounce)*2)),Vec2(16,16), 11); break;
	case 6:	mSprites[SPR_UI].RenderSprite(Vec2(64,48-(32+sin(fArrowBounce)*2)),Vec2(16,16), 11); break;
	case 7:	mSprites[SPR_UI].RenderSprite(Vec2(96,48-(32+sin(fArrowBounce)*2)),Vec2(16,16), 11); break;
	case 8:	mSprites[SPR_UI].RenderSprite(Vec2(128,48-(32+sin(fArrowBounce)*2)),Vec2(16,16), 11); break;
	case 9:	mSprites[SPR_UI].RenderSprite(Vec2(32,72-(32+sin(fArrowBounce)*2)),Vec2(16,16), 11); break;
	case 10: mSprites[SPR_UI].RenderSprite(Vec2(64,72-(32+sin(fArrowBounce)*2)),Vec2(16,16), 11); break;
	case 11: mSprites[SPR_UI].RenderSprite(Vec2(96,72-(32+sin(fArrowBounce)*2)),Vec2(16,16), 11); break;
	case 12: mSprites[SPR_UI].RenderSprite(Vec2(64,96-(32+sin(fArrowBounce)*2)),Vec2(16,16), 11); break;
	}
	//bouncy arrow	
	glEnd();
	//let the player know final stage is open
	if(miWorld == 0 && miStarCount>=15 || miWorld == 1 && miStarCount>=20 || miWorld == 2 && miStarCount>=25 ||
		miWorld == 3 && miStarCount>=25 || miWorld == 4 && miStarCount>=27)
	{
		if(((miInternalClock/25) % 2) == 0)
		{
			UTIL_GL::BindTexture(GL_TEXTURE_2D, mSprites[SPR_PARTICLESALPHA].mImg);
			glBegin(GL_QUADS);
			glColor4f(1,1,0,fBallStagesAlpha);
			mSprites[SPR_PARTICLESALPHA].RenderSprite(Vec2(64,96),Vec2(16,16), 1);
			glColor4f(0,0,0,fBallStagesAlpha);
			mSprites[SPR_PARTICLESALPHA].RenderSprite(Vec2(64,96),Vec2(16,16), 3);
			glColor4f(1,1,1,fBallStagesAlpha);
			glEnd();
			UTIL_GL::BindTexture(GL_TEXTURE_2D, mSprites[SPR_UI].mImg);
		}
	}
//_ASSERTE( _CrtCheckMemory( ) );
	glDepthMask(GL_TRUE);
	glPopMatrix();

	//360 buttons
	glColor3f(1,1,1);
	if(bJoystick)
	{
	glBegin(GL_QUADS);
	sprUV = mSprites[SPR_UI].GetTileUV(4);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 412);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(552, 412);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(552, 444);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 444);

	sprUV = mSprites[SPR_UI].GetTileUV(5);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 444);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(552, 444);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(552, 476);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 476);
	glEnd();
	}
	else
	{
	glBegin(GL_QUADS);
	sprUV = mSprites[SPR_UI].GetTileUV(29);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 404);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(584, 404);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(584, 452);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 452);

	//sprUV = mSprites[SPR_UI].GetTileUV(28);
	glTexCoord2f(sprUV.x,sprUV.y+sprUVS.y);							glVertex2f(520, 436);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y+sprUVS.y);				glVertex2f(584, 436);
	glTexCoord2f(sprUV.x+sprUVS.x,sprUV.y);							glVertex2f(584, 484);
	glTexCoord2f(sprUV.x,sprUV.y);									glVertex2f(520, 484);
	glEnd();
		mFont1.SetScale(0.35f,0.5f);
		mFont1.SetAlignment(ALIGN_LEFT);
		mFont1.Print("SPACE",530,417);
		mFont1.Print("ESC",535,449);
		UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		UTIL_GL::BindTexture(GL_TEXTURE_2D, mSprites[SPR_UI].mImg);
	}	

	RenderPanel(0,Vec2(450,230),150,150,Vec3(0,0.5f,1), Vec3(0, 0, 0.5f), 1, true, Vec3(1,1,0));

	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_STENCIL_TEST);
	glStencilFunc(GL_ALWAYS, 1, 1);
	glStencilOp(GL_KEEP, GL_KEEP, GL_REPLACE);
	glColorMask(GL_FALSE,GL_FALSE,GL_FALSE,GL_FALSE);
	glBegin(GL_QUADS);
	glVertex2f(450-130,230-130);
	glVertex2f(450+130,230-130);
	glVertex2f(450+130,230+130);
	glVertex2f(450-130,230+130);
	glEnd();
	glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);

	//map display
	glStencilFunc(GL_EQUAL, 1, 1);						
	UTIL_GL::GL3D::SetPerspective(90,1.3f,0.1f,380);
	glClear(GL_DEPTH_BUFFER_BIT);
	glScalef(0.25,0.25,0.25);
	gluLookAt(0,0,-64, 0,0,0, -u.x,-u.y,-u.z);
//	Vec3 cp = Vec3(32,32,32) + Vec3(sin(DEG2RAD(Rotation))*32,-sin(DEG2RAD(Rotation)*0.25f)*32,cos(DEG2RAD(Rotation))*32);
//	gluLookAt(cp.x,cp.y,cp.z, 32,32,32, -u.x,-u.y,-u.z);
//	glTranslatef(-50,5,0);
	glDepthFunc(GL_LEQUAL);
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, amb);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0,  GL_POSITION, LightPos);
	glLightfv(GL_LIGHT0,  GL_SPOT_DIRECTION, LightDir);
	glLightfv(GL_LIGHT0,  GL_AMBIENT, dif);
	glLightfv(GL_LIGHT0,  GL_DIFFUSE, gldif);
	glLightfv(GL_LIGHT0,  GL_SPECULAR, glamb);
	glEnable(GL_COLOR_MATERIAL);
	glMaterialfv(GL_FRONT, GL_AMBIENT, dif);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, glamb);
	glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
	glMateriali(GL_FRONT, GL_SHININESS, 100);
//	mMatMgr.SetMaterialLightOnly(mMaterials[miWorld+1]);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_COLOR_MATERIAL);
	mShdrMgr.BindProgram(mShdrPPDirLight);
	mShdrMgr.BindProgram(mShdrPPDirLight);
	GLint AtLocmins = mShdrMgr.GetAttribLocation("inmins");
	GLint AtLocmaxs = mShdrMgr.GetAttribLocation("inmaxs");
//	mShdrMgr.PassUniform3fv("up",1,camUp.v);
//	mShdrMgr.PassAttrib2fv(AtLocmins, mins.v);
//	mShdrMgr.PassAttrib2fv(AtLocmaxs, maxs.v);
	mShdrMgr.PassUniform3fv("up",1,camUp.v);
	mSurfaces.clear();
//	glTranslatef(-mViewOffset.x,-mViewOffset.y,-mViewOffset.z);
	glTranslatef(-30,5,0);
	glRotatef(Rotation*7.5f, 1,0,1);
	glRotatef(Rotation*10, 0,1,0);
	glScalef(5*fViewScale,5*fViewScale,5*fViewScale);
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glColor4f(1,1,1,fViewStageAlpha);

//_ASSERTE( _CrtCheckMemory( ) );
	glEnable(GL_SCISSOR_TEST);
	float w = mMainFBO.w;
	float h = mMainFBO.h;

	if(!mbFallBackMode)
	{
		w = winWidth;
		h = winHeight;
		float mul = 1;
		switch(iSuperSamples)
		{
		case 1: mul = 1.25f; break;
		case 2: mul = 1.5f; break;
		case 3: mul = 1.75f; break;
		case 4: mul = 2; break;
		}
		w *= mul;
		h *= mul;
	}
	glScissor((float)(w/8)*4.1,(float)(h/8)*2.15f,(float)(w/8)*3.1,(float)(h/8)*3.9);
	if(!mMapView[miSelectedStageBall].empty())
	{
		mShdrMgr.PassSampler2D("tex",0,mGfxImg[GFX_TILES]);
		mShdrMgr.PassSampler2D("bumpMap",1,mGfxImg[GFX_TILES_NM]);
		
		std::list<Block>::iterator b;
		glBegin(GL_QUADS);
		for(b=mMapView[miSelectedStageBall].begin(); b!=mMapView[miSelectedStageBall].end(); b++)
		{
			RenderCube((*b), (*b).pos - Vec3(32,32,32) - Vec3(mViewOffset.x,mViewOffset.y,mViewOffset.z),Vec3(0,0,0), (*b).scale, AtLocmins, AtLocmaxs);
		}
		glEnd();
		glDisable(GL_TEXTURE_2D);
	}
	glDisable(GL_SCISSOR_TEST);
	glDisable(GL_STENCIL_TEST);	
	glDisable(GL_BLEND);

	//render lives
/*	UTIL_GL::GL3D::SetPerspective(45,1.3f,0.1f,380);
	gluLookAt(0,0,-1, 0,0,0, -u.x,-u.y,-u.z);
	mMatMgr.SetMaterialAttributes(mObjects[MDL_SPHERE].mMaterials[mObjects[MDL_SPHERE].mFaces.front().mattID].pMat,BASE_PASS,0);
	lp = Vec3(0,0,-1) + camUp * 5 + camRight*10;
	float LightPos2[4]={lp.x,lp.y,lp.z,0};
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, amb);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0,  GL_POSITION, LightPos2);
	glLightfv(GL_LIGHT0,  GL_SPOT_DIRECTION, LightDir);
	glLightfv(GL_LIGHT0,  GL_AMBIENT, dif);
	glLightfv(GL_LIGHT0,  GL_DIFFUSE, gldif);
	glLightfv(GL_LIGHT0,  GL_SPECULAR, glamb);

	glPushMatrix();
	glScalef(0.035f,0.035f,0.035f);
	glTranslatef(-1.5,6,1);
	Vec2 ballRot = UTIL_Misc::Interpolate(mPlayerType.vBallRotation,mPlayerType.vOBallRotation,interp);
	glRotatef(ballRot.x, 1,0,0);
	glRotatef(ballRot.y, 0,1,0);
	glColor4f(1,1,1,1);
	mShdrMgr.PassAttrib2fv(AtLocmins, mins.v);
	mShdrMgr.PassAttrib2fv(AtLocmaxs, maxs.v);
	for(int n=0;n<(int)mPlayerType.iLayers.size();n++)
	{
		if(n>0)
			UTIL_GL::SetBlend(GL_ONE,GL_ONE);
		else glDisable(GL_BLEND);

		mShdrMgr.PassSampler2D("bumpMap",1,mPlayerType.idBump);
		mShdrMgr.PassSampler2D("tex",0,mPlayerType.iLayers[n]);
		glColor3fv(BallColors[mPlayerType.iColLayers[n]].v);
		mObjects[mPlayerType.iMdlType].RenderBuffer(false);
	}
	glPopMatrix();
	glDisable(GL_BLEND);
	mShdrMgr.BindProgram(0);

	glActiveTexture(GL_TEXTURE1);
	glDisable(GL_TEXTURE_2D);
	glActiveTexture(GL_TEXTURE0);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_COLOR_MATERIAL);
	glDisable(GL_LIGHTING);
	glDisable(GL_LIGHT0);*/
	//********render Stars collected*******
	//render the players ball model on the hud
	glClear(GL_DEPTH_BUFFER_BIT);
	//2d particles
	UTIL_GL::GL2D::SetOrtho(640,480);
	UTIL_GL::GL3D::SetPerspective(45,1.3f,0.1f,380);
	gluLookAt(0,0,-1, 0,0,0, 0,-1,0);
	Vec3 newlp = Vec3(10,-5,-1);
	float LightPos2[4]={newlp.x,newlp.y,newlp.z,0};
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0,  GL_POSITION, LightPos2);
	glShadeModel(GL_SMOOTH);
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, amb);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0,  GL_SPOT_DIRECTION, LightDir);
	glLightfv(GL_LIGHT0,  GL_AMBIENT, dif);
	glLightfv(GL_LIGHT0,  GL_DIFFUSE, gldif);
	glLightfv(GL_LIGHT0,  GL_SPECULAR, glamb);
	glEnable(GL_COLOR_MATERIAL);
	glMaterialfv(GL_FRONT, GL_AMBIENT, dif);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, glamb);
	glMaterialfv(GL_FRONT, GL_SPECULAR, blk);
	glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
	glMateriali(GL_FRONT, GL_SHININESS, 100);

	glPushMatrix();
	glTranslatef(0.55f,0.19,0);

	glScalef(0.035f,0.035f,0.035f);
	glPushMatrix();
	glTranslatef(-14.5,-11,1);
	Vec2 ballRot = UTIL_Misc::Interpolate(mPlayerType.vBallRotation,mPlayerType.vOBallRotation,interp);
	glRotatef(ballRot.x, 1,0,0);
	glRotatef(ballRot.y, 0,1,0);
	glColor4f(1,1,1,1);
	Vec3 up(0,-1,0);
	glPushMatrix();
	glColor3f(0,0,0);
	glScalef(1.15,1.15,1.15);
	glMaterialfv(GL_FRONT, GL_SPECULAR, blk);
	glDisable(GL_LIGHTING);
	for(int n=0;n<(int)mPlayerType.iLayers.size();n++)
	{
		mObjects[mPlayerType.iMdlType].RenderBuffer(false);
	}
	glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
	glClear(GL_DEPTH_BUFFER_BIT);
	glEnable(GL_LIGHTING);
	glPopMatrix();
	mMatMgr.SetMaterialAttributes(mObjects[MDL_SPHERE].mMaterials[mObjects[MDL_SPHERE].mFaces.front().mattID].pMat,BASE_PASS,0);
	gpEng->mShdrMgr.BindProgram(gpEng->mShdrPBallLight);
	//mShdrMgr.BindProgram(mShdrPPDirLight);
	//AtLocmins = mShdrMgr.GetAttribLocation("inmins");
	//AtLocmaxs = mShdrMgr.GetAttribLocation("inmaxs");
	//mShdrMgr.PassUniform3fv("up",1,up.v);
	mins=Vec2(0,0);
	maxs=Vec2(1,1);
	//mShdrMgr.PassAttrib2fv(AtLocmins, mins.v);
	//mShdrMgr.PassAttrib2fv(AtLocmaxs, maxs.v);
	for(int n=0;n<(int)mPlayerType.iLayers.size();n++)
	{
		if(n>0)
			UTIL_GL::SetBlend(GL_ONE,GL_ONE);
		else glDisable(GL_BLEND);

//		mShdrMgr.PassSampler2D("bumpMap",1,mPlayerType.idBump);
		mShdrMgr.PassSampler2D("tex",0,mPlayerType.iLayers[n]);
		glColor3fv(BallColors[mPlayerType.iColLayers[n]].v);
		mObjects[mPlayerType.iMdlType].RenderBuffer(false);
	}
	if(iPlayerStickerType>=0)
	{
		UTIL_GL::SetBlend(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(1,1,1,1);
		gpEng->mShdrMgr.PassSampler2D("tex",0,gpEng->mStickers[iPlayerStickerType]);
		gpEng->mObjects[MDL_STICKER].RenderBuffer(false);
		glDisable(GL_BLEND);
	}
	glPopMatrix();
	//render gems
	 glDisable(GL_BLEND);
	float newLightPos[4]={-10,5,-1,0};
	glLightfv(GL_LIGHT0,  GL_POSITION, newLightPos);

	glPushMatrix();
	glTranslatef(-6.5,-11,1);
	glRotatef(20,1,0,0);
	glRotatef(ballRot.y*5, 0,1,0);
	glScalef(0.75f,0.75f,0.75f);

	glPushMatrix();
	mShdrMgr.BindProgram(0);
	glScalef(1.2,1.2,1.2);
	glDisable(GL_LIGHTING);
	glColor3f(0,0,0);
	mObjects[MDL_GEM].RenderBuffer(false);
	glEnable(GL_LIGHTING);
	glClear(GL_DEPTH_BUFFER_BIT);
	mShdrMgr.BindProgram(mShdrPPDirLight);
	glPopMatrix();

	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	glCullFace(GL_FRONT);

	Vec3 CurCol = (*mHudColors.begin()+1);
	Vec3 gemCol = UTIL_Misc::Interpolate(CurCol,mHudColors.front(),mfHudColRamp);
	glColor4f(gemCol.x,gemCol.y,gemCol.z,0.25f);
	mObjects[MDL_GEM].RenderBuffer(true);
	glCullFace(GL_BACK);
	mObjects[MDL_GEM].RenderBuffer(true);
	glDisable(GL_CULL_FACE);
	glColor4f(1,1,1,1);

	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);
	glDepthMask(GL_TRUE);
	glPopMatrix();
	//render stars
	glPushMatrix();
	glTranslatef(-10.5,-11,1);
	glRotatef(-160,1,0,0);
	glRotatef(ballRot.y*5, 0,-1,0);
	glScalef(0.5f,0.5f,0.5f);

	glPushMatrix();
	mShdrMgr.BindProgram(0);
	glScalef(1.23,1.23,1.23);
	glDisable(GL_LIGHTING);
	glColor3f(0,0,0);
	mObjects[MDL_STAR].RenderBuffer(false);
	glEnable(GL_LIGHTING);
	glClear(GL_DEPTH_BUFFER_BIT);
	mShdrMgr.BindProgram(mShdrPPDirLight);
	glPopMatrix();

	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	glCullFace(GL_FRONT);

	glColor4f(1,1,0,0.25f);
	mObjects[MDL_STAR].RenderBuffer(true);
	glCullFace(GL_BACK);
	mObjects[MDL_STAR].RenderBuffer(true);
	glDisable(GL_CULL_FACE);
	glColor4f(1,1,1,1);

	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);
	glDepthMask(GL_TRUE);
	glPopMatrix();

	glDisable(GL_BLEND);
	mShdrMgr.BindProgram(0);

	glActiveTexture(GL_TEXTURE1);
	glDisable(GL_TEXTURE_2D);
	glActiveTexture(GL_TEXTURE0);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_COLOR_MATERIAL);
	glDisable(GL_LIGHTING);
	glDisable(GL_LIGHT0);
	glPopMatrix();
	//glDisable(GL_DEPTH_TEST);
	//text
	UTIL_GL::GL2D::SetOrtho(640,480);
	glPushMatrix();
	glTranslatef(310,110,0);
	char szData[64];
	sprintf(szData,"X%i",miLives>=0?miLives:0);
	mFont1.EnableShadow();
	mFont1.SetColor(1,1,1,1);
	mFont1.SetScale(0.75f,0.75f);
	mFont1.SetAlignment(ALIGN_LEFT);
	mFont1.Print(szData,48,15);

	mFont1.SetScale(0.75f,0.75f);
	sprintf(szData,"X%i",miStarCount);
	mFont1.Print(szData,128,15);
	mFont1.SetScale(0.75f,0.75f);
	sprintf(szData,"X%i",miGemCount);
	mFont1.Print(szData,208,15);
	if(miSelectedStageBall==12)
	{
		mFont1.SetColor(1,1,1,fViewStageAlpha);
		mFont1.SetScale(0.5f,0.5f);
		mFont1.SetAlignment(ALIGN_CENTER);
		bool bGotEnough = false;
		switch(miWorld)
		{
		case 0: if(miStarCount>=15) bGotEnough = true; else	mFont1.PrintClipped("YOU NEED 15 STARS TO ENTER THIS STAGE",140,215,300);		break;
		case 1: if(miStarCount>=20) bGotEnough = true; else mFont1.PrintClipped("YOU NEED 20 STARS TO ENTER THIS STAGE",140,215,300);		break;
		case 2: if(miStarCount>=25) bGotEnough = true; else mFont1.PrintClipped("YOU NEED 25 STARS TO ENTER THIS STAGE",140,215,300);		break;
		case 3: if(miStarCount>=25) bGotEnough = true; else mFont1.PrintClipped("YOU NEED 25 STARS TO ENTER THIS STAGE",140,215,300);		break;
		case 4: if(miStarCount>=27) bGotEnough = true; else mFont1.PrintClipped("YOU NEED 25 STARS TO ENTER THIS STAGE",140,215,300);		break;
		}
			
		if(bGotEnough)
			mFont1.PrintClipped("STAGE IS NOW UNLOCKED",140,215,300);
	}
	glPopMatrix();
	//*************************************
	UTIL_GL::GL2D::SetOrtho(640,480);
	RenderMenus(interp);

	UnBindFBO();
//_ASSERTE( _CrtCheckMemory( ) );
	//fade systems
	if(!mFadeEng.mSystems.empty())
	{
		BindFBO(mFadeFBO,0);
		UTIL_GL::GL2D::SetOrtho(640,480);
		glClearColor(0,0,0,0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glDisable(GL_CULL_FACE);
		mFadeEng.Render(interp);
		UTIL_GL::SetBlend(GL_ONE, GL_ONE);
		mPartEng.Render2D(interp);
		glDisable(GL_BLEND);
		UnBindFBO();

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);

		//fade from the last frame
		glColor3f(1,1,1);
		UTIL_GL::GL2D::SetOrtho(gpEng->winWidth,gpEng->winHeight);
		if(!mbFallBackMode)
		{
		UTIL_GL::BindTexture(GL_TEXTURE_RECTANGLE_ARB, gpEng->mFadeFBO.colortexID[1]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,mFadeFBO.h);					glVertex2f(0,0);
		glTexCoord2f( mFadeFBO.w,mFadeFBO.h);	glVertex2f(gpEng->winWidth,0);
		glTexCoord2f( mFadeFBO.w,0);					glVertex2f(gpEng->winWidth,gpEng->winHeight);
		glTexCoord2f( 0,0);									glVertex2f(0,gpEng->winHeight);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		}
		else
		{
		UTIL_GL::BindTexture(GL_TEXTURE_2D, gpEng->mFadeFBO.colortexID[1]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,1);	glVertex2f(0,0);
		glTexCoord2f( 1,1);	glVertex2f(gpEng->winWidth,0);
		glTexCoord2f( 1,0);	glVertex2f(gpEng->winWidth,gpEng->winHeight);
		glTexCoord2f( 0,0);	glVertex2f(0,gpEng->winHeight);
		glEnd();
		}
		glDisable(GL_TEXTURE_2D);

		//the new frame
		mShdrMgr.BindProgram(mShdrFadeFx1);
		glColor3f(1,1,1);
		UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		if(!mbFallBackMode)
		{
		mShdrMgr.PassSamplerRect("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSamplerRect("fade",1 ,mFadeFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,mMainFBO.h);		glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0);				glVertex2f(0,winHeight);
		glEnd();
		glActiveTexture(GL_TEXTURE1);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		glDisable(GL_TEXTURE_2D);
		}
		else
		{
		mShdrMgr.PassSampler2D("rect",0 ,mMainFBO.colortexID[0]);
		mShdrMgr.PassSampler2D("fade",1 ,mFadeFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glMultiTexCoord2f(GL_TEXTURE0, 0,1); glVertex2f(0,0);
		glMultiTexCoord2f(GL_TEXTURE0, 1,1); glVertex2f(winWidth,0);
		glMultiTexCoord2f(GL_TEXTURE0, 1,0); glVertex2f(winWidth,winHeight);
		glMultiTexCoord2f(GL_TEXTURE0, 0,0); glVertex2f(0,winHeight);
		glEnd();
		glActiveTexture(GL_TEXTURE1);
		glDisable(GL_TEXTURE_2D);
		glActiveTexture(GL_TEXTURE0);
		glDisable(GL_TEXTURE_2D);
		}
		glDisable(GL_BLEND);
		mShdrMgr.BindProgram(0);

		UTIL_GL::GL2D::SetOrtho(640,480);
		glClearColor(1,1,1,1);
		glColor4f(1,1,1,1);
		glDisable(GL_LIGHTING);
		glDisable(GL_LIGHT0);
		glDisable(GL_COLOR_MATERIAL);
		glDisable(GL_DEPTH_TEST);
		glDisable(GL_CULL_FACE);
		UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		mFadeEng.RenderSecondary(interp);
		glDisable(GL_BLEND);//*/

	}
	else //render the scene as normal
	{
		//render the scene
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glDisable(GL_DEPTH_TEST);
		glColor3f(1,1,1);
		UTIL_GL::GL2D::SetOrtho(winWidth,winHeight);
		if(!mbFallBackMode)
		{
		UTIL_GL::BindTexture(GL_TEXTURE_RECTANGLE_ARB, mMainFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,mMainFBO.h);		glVertex2f(0,0);
		glTexCoord2f( mMainFBO.w,mMainFBO.h); glVertex2f(winWidth,0);
		glTexCoord2f( mMainFBO.w,0);			glVertex2f(winWidth,winHeight);
		glTexCoord2f( 0,0);				glVertex2f(0,winHeight);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		}
		else
		{
		UTIL_GL::BindTexture(GL_TEXTURE_2D, mMainFBO.colortexID[0]);
		glBegin(GL_QUADS);
		glTexCoord2f( 0,1);	glVertex2f(0,0);
		glTexCoord2f( 1,1); glVertex2f(winWidth,0);
		glTexCoord2f( 1,0);	glVertex2f(winWidth,winHeight);
		glTexCoord2f( 0,0);	glVertex2f(0,winHeight);
		glEnd();
		}
		glDisable(GL_TEXTURE_2D);
	}

//_ASSERTE( _CrtCheckMemory( ) );
}
