#include "Star.h"
#include "Engine.h"


void Star::Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u)
{
//	gLog.OutPut("Spawning gemstone\n");
	SetDefaultAttribs(p, f,r,u);
	mPos = mOPos = mPos;// + u*0.52f;

	mColor = Vec3(1,0.9f,0);
	mMins = mPos - Vec3(0.25, 0.25, 0.25);
	mMaxs = mPos + Vec3(0.25, 0.25, 0.25);
	iPersistanceID = gpEng->mgPersistanceCounter++;
	pStarPS = new PS_Stars;
	pStarPS->Spawn(mPos,Vec3(0,0,0),Vec2(16,16),Vec3(1,1,1),0,1,1);
	pStarPS->mPos = mPos;
	pStarPS->fStarColor = Vec3(1,0.9f,0);
	gpEng->mPartEng.InsertSystem((ParticleSystem*)pStarPS,false);
	bCollected = false;
}
void Star::Update()
{
	mOPos = mPos;
	mOForward = mForward;
	mORight = mRight;
	mOUp = mUp;

	if(gpEng->mPlayer.mbTimeOut || gpEng->mPlayer.mbStageWon)
		return;

	mForward = ArbitraryRotate(mForward,DEG2RAD(5),mUp);
	mForward = ArbitraryRotate(mForward,DEG2RAD(0),mRight);
	mRight = ArbitraryRotate(mRight,DEG2RAD(5),mUp);
	mRight = ArbitraryRotate(mRight,DEG2RAD(0),mRight);
	mUp = ArbitraryRotate(mUp,DEG2RAD(5),mUp);
	mUp = ArbitraryRotate(mUp,DEG2RAD(0),mRight);
	if(	pStarPS)
	{
		pStarPS->mPos = mPos;
		pStarPS->up = mUp;
	}
	if(!mpPlatform || mpPlatform->bVisible)
	if(gpEng->mPlayer.mPos.x >= mPos.x-1)
	if(gpEng->mPlayer.mPos.x <= mPos.x+1)
	if(gpEng->mPlayer.mPos.y >= mPos.y-1)
	if(gpEng->mPlayer.mPos.y <= mPos.y+1)
	if(gpEng->mPlayer.mPos.z >= mPos.z-1)
	if(gpEng->mPlayer.mPos.z <= mPos.z+1)
	if(gpEng->mPlayer.bJump && Distance(mPos, gpEng->mPlayer.mPos)<0.45 || !gpEng->mPlayer.bJump && Distance(mPos, gpEng->mPlayer.mPos)<0.35)//this could be slow, should do a bounds check first
	{
		gpEng->miCurrentPersistance.push_back(iPersistanceID);
		gpEng->miStageStarCount--;
		PlaySample(CHNL_PICKUP2, gpEng->mSnd[SND_PICKUP2],false);
		if(gpEng->miStageStarCount<=0)//we have collected all the stars for this stage
		{
			gpEng->mfStageTimeEnd = gpEng->mfStageTime - 1;
			gpEng->mfStageTimeEnd = (int)gpEng->mfStageTimeEnd;
			gpEng->mPlayer.mbStageWon = true;
			gpEng->mPlayer.miActionTimer = 0;
			gpEng->mPlayer.iDmgTime = 2;

			//if all gems are collected, show the perfect splash
			if(gpEng->mbCollectedGem)
			if(gpEng->miStageGemCount ==0)
			{
				gpEng->miPerfectTimer = 0;
				gpEng->mbPerfect = true;
			}
		}
		if(!bCollected)
		{
			gpEng->miScore+=500;
			gpEng->miLocalStarCount++;
			gpEng->iHUDStarFlashTime = 50;
			PS_CollectedStar* PS = new PS_CollectedStar;
			Vec2 out = UTIL_GL::GL2D::ProjectPointInWindow(mPos,gpEng->mFrustum.proj, gpEng->mFrustum.model);
			PS->mTarget = Vec3(out.x,out.y,0);//Vec3(105,35,0);
			PS->Spawn(Vec3(out.x,out.y,0),Vec3(0,0,0),Vec2(16,16),Vec3(1,1,0),0,1,2);
			gpEng->mPartEng.InsertSystem(PS,true);
		}
		else
		{
			PS_CollectedStar* PS = new PS_CollectedStar;
			Vec2 out = UTIL_GL::GL2D::ProjectPointInWindow(mPos,gpEng->mFrustum.proj, gpEng->mFrustum.model);
			PS->mTarget = Vec3(out.x,out.y,0);//Vec3(105,35,0);
			PS->Spawn(Vec3(out.x,out.y,0),Vec3(0,0,0),Vec2(16,16),Vec3(1,0.5,0),0,1,2);
			gpEng->mPartEng.InsertSystem(PS,true);
		}
		bRemove = true;
		if(pStarPS)
			pStarPS->bAlive = false;

	}

}
void Star::Render(const float interp, int pass)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
/*	glBegin(GL_LINES);
	glColor3f(1,0,0);
	glVertex3fv((p).v);
	glVertex3fv((p+u*0.5f).v);
//	glColor3f(0,1,0);
//	glVertex3fv((p-r*0.5f).v);
//	glVertex3fv((p+r*0.5f).v);
//	glColor3f(0,0,1);
//	glVertex3fv((p).v);
//	glVertex3fv((p+f*0.5f).v);
	glEnd();
//*/
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	float alpha = 1;
	if(mpPlatform)
		alpha = mpPlatform->iFadeTime>=0?UTIL_Misc::TimeRamp(0,1,0,100,mpPlatform->iFadeTime):0;
	glMultMatrixf(mat);
	glRotatef(-90,1,0,0);
	glScalef(0.15,0.15,0.15);

	if(bCollected)
		glColor4f(0.25f,0.25f,0.25f,alpha);
	else
		glColor4f(mColor.x,mColor.y,mColor.z,alpha);
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDepthMask(GL_FALSE);



	gpEng->mShdrMgr.PassUniform1f("interp",0.5f);
	glEnable(GL_CULL_FACE);
	glCullFace(GL_FRONT);
//	gpEng->mObjects[MDL_GEM].Render(true);
//	gpEng->mObjects[MDL_STAR].RenderBuffer(true);
//	gpEng->mObjects[MDL_GEM].Render(true);
	gpEng->mObjects[MDL_STAR].RenderBuffer(true);
	glCullFace(GL_BACK);
	glDisable(GL_CULL_FACE);

	glPushMatrix();
	glScalef(1.1f,1.1f,1.1f);
	bCollected?
		glColor4f(0.75f,0.75f,0.75f,alpha):
	glColor4f(0.75f,0.75f,0,alpha);
	UTIL_GL::SetBlend(GL_ONE, GL_ONE);
//	gpEng->mObjects[MDL_GEM].Render(true);
	gpEng->mObjects[MDL_STAR].RenderBuffer(true);
	glPopMatrix();
//*/
	glColor4f(1,1,1,1);

	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);

	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);
	glPopMatrix();
}
void Star::RenderShadow(const float interp)
{
//	return;
	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);

	Vec3 pos = p;
	for(int n=0; n<80; n++)
	{
		pos = p + u *((float)n/10.0f);
		if(gpEng->GetMapTile(pos))
		{
			Block* b= gpEng->GetMapTile(pos);
/*			float	X = u.x!=0?
				(u.x<0?(int)pos.x+0.75f:(int)pos.x+0.25f):pos.x;
			float	Y = u.y!=0?
				(u.y<0?(int)pos.y+0.75f:(int)pos.y+0.25f):pos.y;
			float	Z = u.z!=0?
				(u.z<0?(int)pos.z+0.75f:(int)pos.z+0.25f):pos.z;
*/
			float X = u.x!=0?
				(u.x<0?b->pos.x+0.25f:b->pos.x-0.25f):pos.x;
			float Y = u.y!=0?
				(u.y<0?b->pos.y+0.25f:b->pos.y-0.25f):pos.y;
			float Z = u.z!=0?
				(u.z<0?b->pos.z+0.25f:b->pos.z-0.25f):pos.z;

			pos = Vec3(X,Y,Z);//&/
			pos -= u * 0.27f;
			if(b->mbPlatform)
			{
				Vec3 shadOff = UTIL_Misc::Interpolate(b->pPlat->mPos, b->pPlat->mOPos, interp)-b->pPlat->mPos;
				shadOff = Reflect(shadOff,mRight,0);
				shadOff = Reflect(shadOff,mForward,0);
				pos += shadOff;
			}
			break;
		}
	}//*/
	glPushMatrix();
	glTranslatef(pos.x,pos.y,pos.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glScalef(0.15,0.15,0);
	glRotatef(-90,1,0,0);

	gpEng->mObjects[MDL_STAR].RenderBuffer(false);
	glPopMatrix();
}
void Star::RenderDepth(const float interp)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glRotatef(-90,1,0,0);
	glScalef(0.15,0.15,0.15);
	glScalef(1.1f,1.1f,1.1f);
	gpEng->mObjects[MDL_STAR].RenderBuffer(false);
//*/
	glPopMatrix();

}
Entity* Star::Clone() const
{
	return new Star(*this);
}
