#include "Teleporter.h"
#include "Engine.h"

void Teleporter::Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u)
{
//	gLog.OutPut("Spawning switch\n");
	SetDefaultAttribs(p, f,r,u);
	mPos = mOPos = mPos + u*0.45f;

	mMins = mPos - Vec3(0.25, 0.25, 0.25);
	mMaxs = mPos + Vec3(0.25, 0.25, 0.25);
	IsActivated = false;
	iActivatedTime = 0;
	iPulseTime = 0;
}
void Teleporter::Update()
{
	mOPos = mPos;
	mOForward = mForward;
	mORight = mRight;
	mOUp = mUp;

	if(gpEng->mPlayer.mbTimeOut || gpEng->mPlayer.mbStageWon)
		return;

	iPulseTime++;

	if(iActivatedTime>0)
		iActivatedTime--;

	bool DeActivate = true;
	if(!mpPlatform || mpPlatform->bVisible)
	//if(!gpEng->mPlayer.bJump)
	if(gpEng->mPlayer.mPos.x >= mMins.x)
	if(gpEng->mPlayer.mPos.x <= mMaxs.x)
	if(gpEng->mPlayer.mPos.y >= mMins.y)
	if(gpEng->mPlayer.mPos.y <= mMaxs.y)
	if(gpEng->mPlayer.mPos.z >= mMins.z)
	if(gpEng->mPlayer.mPos.z <= mMaxs.z)
	if(Distance(mPos, gpEng->mPlayer.mPos)<0.35)//this could be slow, should do a bounds check first
	{
		if(!IsActivated)
		if(gpEng->mPlayer.iTeleportTimer==0)
		{
			PlaySample(CHNL_TELEPORT, gpEng->mSnd[SND_TELEPORT1],false);
			gpEng->mPlayer.iTeleportTimer = 100;
			gpEng->mPlayer.bTeleport = false;//out
		}
		DeActivate = false;

		if(gpEng->mPlayer.iTeleportTimer==1)
		{
			if(!IsActivated)
			{
				strcpy(gEntName, TargetName);
				gpEng->mGameEnts.remove_if(TriggerEntityByGName);
				PlaySample(CHNL_TELEPORT, gpEng->mSnd[SND_TELEPORT2],false);
			}
		}
		if(gpEng->mPlayer.iTeleportTimer>0 && !gpEng->mPlayer.bTeleport)
		{
			if(Distance((mPos-mUp*0.2f), gpEng->mPlayer.mPos)>0.1)
			gpEng->mPlayer.mPos += ((mPos-mUp*0.2f) - gpEng->mPlayer.mPos) * 0.03f;
		}
	}


	if(DeActivate)
		if(iActivatedTime<=0)
		IsActivated = false;
}
void Teleporter::Trigger()
{
	gpEng->mPlayer.iTeleportTimer = 100;
	gpEng->mPlayer.bTeleport = true;//in
	iActivatedTime = 100;
	IsActivated = true;
	gpEng->mPlayer.bMoving = false;
	gpEng->mPlayer.bJump = false;
	gpEng->mPlayer.bTurnCorner = false;
	gpEng->mPlayer.bSliding = false;
	gpEng->mPlayer.bSlideJump = false;
	gpEng->mPlayer.mSlideMove *= 0;
	//gpEng->mPlayer.iTurnCounter = 4;
	gpEng->KEY_FORWARD.state = RELEASED;
	gpEng->mPlayer.mPos = gpEng->mPlayer.mOPos = mPos - mUp * 0.2f;

	if(mUp != gpEng->mPlayer.mUp)
	{
	float Theta;
	Vec3 Axis;
	if(Dot(gpEng->mPlayer.mUp, mUp) == -1)
	{
		Axis = gpEng->mPlayer.mMoveForward;
		Theta = DEG2RAD(180);
		gpEng->mPlayer.mOUp = gpEng->mPlayer.mUp = gpEng->mPlayer.mMoveUp = mUp;
//		gpEng->mPlayer.mOForward = gpEng->mPlayer.mForward = gpEng->mPlayer.mMoveForward = mForward;
//		gpEng->mPlayer.mORight = gpEng->mPlayer.mRight = gpEng->mPlayer.mMoveRight = mRight;
	}
	else
	{
		Theta = acos(Dot(gpEng->mPlayer.mUp, mUp));
		Axis = Vec3(Cross(gpEng->mPlayer.mUp, mUp));
		gpEng->mPlayer.mOUp = gpEng->mPlayer.mUp = ArbitraryRotate(gpEng->mPlayer.mUp,Theta,Axis);
		gpEng->mPlayer.mMoveUp = ArbitraryRotate(gpEng->mPlayer.mMoveUp,Theta,Axis);
		gpEng->mPlayer.mMoveUp = Vec3((int)gpEng->mPlayer.mMoveUp.x, (int)gpEng->mPlayer.mMoveUp.y, (int)gpEng->mPlayer.mMoveUp.z);
	}

		gpEng->mPlayer.mOForward = gpEng->mPlayer.mForward = ArbitraryRotate(gpEng->mPlayer.mForward,Theta,Axis);
		gpEng->mPlayer.mORight = gpEng->mPlayer.mRight = ArbitraryRotate(gpEng->mPlayer.mRight,Theta,Axis);

		gpEng->mPlayer.mMoveForward = ArbitraryRotate(gpEng->mPlayer.mMoveForward,Theta,Axis);
		gpEng->mPlayer.mMoveRight = ArbitraryRotate(gpEng->mPlayer.mMoveRight,Theta,Axis);
		gpEng->mPlayer.mMoveForward = Vec3((int)gpEng->mPlayer.mMoveForward.x, (int)gpEng->mPlayer.mMoveForward.y, (int)gpEng->mPlayer.mMoveForward.z);
		gpEng->mPlayer.mMoveRight = Vec3((int)gpEng->mPlayer.mMoveRight.x, (int)gpEng->mPlayer.mMoveRight.y, (int)gpEng->mPlayer.mMoveRight.z);
		//gpEng->mPlayer.mMove = ArbitraryRotate(gpEng->mPlayer.mMove,Theta,Axis);
		//gpEng->mPlayer.mMove = Vec3(0,0,0);
		gpEng->mPlayer.mJumpDir = -gpEng->mPlayer.mMoveUp;
		gpEng->mPlayer.mGravity = gpEng->mPlayer.mMoveUp*0.15f;
	}
	gpEng->mOCameraPos = gpEng->mCameraPos = gpEng->mCamTarget = gpEng->mPlayer.mPos - gpEng->mPlayer.mForward * (1.0f*gpEng->mfCamZoom) - gpEng->mPlayer.mUp * (0.25f*gpEng->mfCamVertical);

}
void Teleporter::Render(const float interp, int pass)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
/*	glBegin(GL_LINES);
	glColor3f(1,0,0);
	glVertex3fv((p).v);
	glVertex3fv((p+u*0.5f).v);
//	glColor3f(0,1,0);
//	glVertex3fv((p-r*0.5f).v);
//	glVertex3fv((p+r*0.5f).v);
//	glColor3f(0,0,1);
//	glVertex3fv((p).v);
//	glVertex3fv((p+f*0.5f).v);
	glEnd();
//*/
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	float alpha = 1;
	if(mpPlatform)
		alpha = mpPlatform->iFadeTime>=0?UTIL_Misc::TimeRamp(0,1,0,100,mpPlatform->iFadeTime):0;
	glMultMatrixf(mat);
//	glRotatef(90,1,0,0);
	glScalef(0.15,0.15,0.15);

	glColor4f(1,1,1,alpha);
	UTIL_GL::SetBlend(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
//	glDepthMask(GL_FALSE);
	


	gpEng->mObjects[MDL_TELEPORT].RenderBuffer(true);
//*/

	glDisable(GL_LIGHTING);
//	gpEng->mShdrMgr.BindProgram(0);
	float C = (sin((float)iPulseTime*0.1f)+1)/2;
	glColor4f((1-C)*alpha,C*alpha,0,alpha);
	//glRotatef(iPulseTime*3,0,0,1);
	UTIL_GL::SetBlend(GL_ONE, GL_ONE);
	gpEng->mObjects[MDL_TELEPORT_PAD].RenderBuffer(true);


	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);

	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);
	glEnable(GL_LIGHTING);
	glPopMatrix();
}
void Teleporter::RenderShadow(const float interp)
{
	return;
	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);

	Vec3 pos = p;
	for(int n=0; n<80; n++)
	{
		pos = p + u *((float)n/10.0f);
		if(gpEng->GetMapTile(pos))
		{
			Block* b= gpEng->GetMapTile(pos);
/*			float	X = u.x!=0?
				(u.x<0?(int)pos.x+0.75f:(int)pos.x+0.25f):pos.x;
			float	Y = u.y!=0?
				(u.y<0?(int)pos.y+0.75f:(int)pos.y+0.25f):pos.y;
			float	Z = u.z!=0?
				(u.z<0?(int)pos.z+0.75f:(int)pos.z+0.25f):pos.z;
*/
			float X = u.x!=0?
				(u.x<0?b->pos.x+0.25f:b->pos.x-0.25f):pos.x;
			float Y = u.y!=0?
				(u.y<0?b->pos.y+0.25f:b->pos.y-0.25f):pos.y;
			float Z = u.z!=0?
				(u.z<0?b->pos.z+0.25f:b->pos.z-0.25f):pos.z;

			pos = Vec3(X,Y,Z);//&/
			pos -= u * 0.27f;
			if(b->mbPlatform)
			{
				Vec3 shadOff = UTIL_Misc::Interpolate(b->pPlat->mPos, b->pPlat->mOPos, interp)-b->pPlat->mPos;
				shadOff = Reflect(shadOff,mRight,0);
				shadOff = Reflect(shadOff,mForward,0);
				pos += shadOff;
			}
			break;
		}
	}//*/
	glPushMatrix();
	glTranslatef(pos.x,pos.y,pos.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glScalef(0.15,0.15,0);
	glRotatef(90,1,0,0);

	gpEng->mObjects[MDL_BUTTON].RenderBuffer(false);
	glPopMatrix();
}
void Teleporter::RenderDepth(const float interp)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
//	glRotatef(90,1,0,0);
	glScalef(0.15,0.15,0.15);
	gpEng->mObjects[MDL_TELEPORT].RenderBuffer(false);
//*/
	glPopMatrix();

}
Entity* Teleporter::Clone() const
{
	return new Teleporter(*this);
}
