#include "TextParticle.h"
#include "Engine.h"

bool PruneTextParty(TextParticle& t)
{
	t.Update();
	if(t.fLife <=0)
		return true;
	return false;
}
bool RenderTextParty(TextParticle& t)
{
	t.Render(gpEng->mInterp);
	return false;
}

TextParticle::TextParticle(char* txt, Vec2 p, Vec2 v, float damp, float life, Vec3 col, Vec2 size, int type)
{
	strcpy(szText,txt);
	mPos = mOPos = p;
	mVel = v;
	fDamp = damp;
	fLife = fMaxLife = life;
	Color = col;
	Size = size;
}

void TextParticle::Update()
{
	mOPos = mPos;
	mVel *= fDamp;
	mPos += mVel;
	fLife -= TIME_STEP;
}

void TextParticle::Render(const float interp)
{
	gpEng->mFont1.SetAlignment(ALIGN_CENTER);
	gpEng->mFont1.EnableShadow();
	gpEng->mFont1.SetScale(Size.x, Size.y);
	float Alpha = UTIL_Misc::TimeRamp(1,0,0,fMaxLife,fMaxLife-fLife);
	gpEng->mFont1.SetColor(Color.x, Color.y, Color.z, Alpha);
	Vec2 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	if(interp == 0)
		p = mPos;
	gpEng->mFont1.Print(szText, p.x, p.y);

}