#pragma once
#include <map>
#include <string>


class TextureManager
{
public:
	TextureManager();
	void CleanUp();
	bool GetTextureName(unsigned int id, char* name);
	void FreeTexture(std::string name);
	void GetDimensions(unsigned int ID, unsigned int& w, unsigned int& h);
	unsigned int LoadTexture(bool aniso, std::string dir, std::string name, const unsigned int minfilter, const unsigned int magfilter , const unsigned int wrapX, const unsigned int wrapY );
private:
	unsigned int iNumTextures;
	unsigned int iStartIndex;
	std::map<std::string, unsigned int> mTextures;
	std::map<unsigned int, std::string> mTexNames;
	std::map<unsigned int, std::pair<unsigned int, unsigned int> > mDimensions;
};