#include "Fuzzle.h"
#include "Engine.h"


void Fuzzle::Spawn(Vec3 p, Vec3 f, Vec3 r, Vec3 u)
{
	gLog.OutPut("Spawning Fuzzle\n");
	SetDefaultAttribs(p, f,r,u);
	mPos = mOPos = mPos + u*0.5f;

	mMins = mPos - Vec3(0.25, 0.25, 0.25);
	mMaxs = mPos + Vec3(0.25, 0.25, 0.25);
}
void Fuzzle::Update()
{
	mOPos = mPos;
	mOForward = mForward;
	mORight = mRight;
	mOUp = mUp;
/*	mForward = ArbitraryRotate(mForward,DEG2RAD(5),mUp);
	mForward = ArbitraryRotate(mForward,DEG2RAD(0),mRight);
	mRight = ArbitraryRotate(mRight,DEG2RAD(5),mUp);
	mRight = ArbitraryRotate(mRight,DEG2RAD(0),mRight);
	mUp = ArbitraryRotate(mUp,DEG2RAD(5),mUp);
	mUp = ArbitraryRotate(mUp,DEG2RAD(0),mRight);

	if(!mpPlatform || mpPlatform->bVisible)
	if(gpEng->mPlayer.mPos.x >= mPos.x-1)
	if(gpEng->mPlayer.mPos.x <= mPos.x+1)
	if(gpEng->mPlayer.mPos.y >= mPos.y-1)
	if(gpEng->mPlayer.mPos.y <= mPos.y+1)
	if(gpEng->mPlayer.mPos.z >= mPos.z-1)
	if(gpEng->mPlayer.mPos.z <= mPos.z+1)
	if(Distance(mPos, gpEng->mPlayer.mPos)<0.35)//this could be slow, should do a bounds check first
	{
		bRemove = true;
	}*/

}
void Fuzzle::Render(const float interp, int pass)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;

	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	float alpha = 0.45;
	if(mpPlatform)
		alpha = mpPlatform->iFadeTime>=0?UTIL_Misc::TimeRamp(0,0.45,0,100,mpPlatform->iFadeTime):0;
	glMultMatrixf(mat);
//	glRotatef(90,1,0,0);
	glRotatef(180,0,1,0);
	glScalef(0.15,0.15,0.15);

	glColor4f(mColor.x,mColor.y,mColor.z,alpha);



	glDisable(GL_CULL_FACE);
	glColor4f(mColor.x,mColor.y,mColor.z,1);
	gpEng->mObjects[MDL_FUZZLE].RenderBuffer(true);

	glColor4f(1,1,1,1);

	glPopMatrix();

	gpEng->mSurfaces.push_back(CreateSurfaceEntity((Entity*)this,gpEng->mObjects[MDL_FUZZLE].mMaterials.back().ID,DRAW_FUR,Distance(p,gpEng->mCameraPos)));

}
void Fuzzle::RenderShadow(const float interp)
{
//	return;
	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);

	Vec3 pos = p;
	for(int n=0; n<80; n++)
	{
		pos = p + u *((float)n/10.0f);
		if(gpEng->GetMapTile(pos))
		{
			Block* b= gpEng->GetMapTile(pos);
/*			float	X = u.x!=0?
				(u.x<0?(int)pos.x+0.75f:(int)pos.x+0.25f):pos.x;
			float	Y = u.y!=0?
				(u.y<0?(int)pos.y+0.75f:(int)pos.y+0.25f):pos.y;
			float	Z = u.z!=0?
				(u.z<0?(int)pos.z+0.75f:(int)pos.z+0.25f):pos.z;
*/
			float X = u.x!=0?
				(u.x<0?b->pos.x+0.25f:b->pos.x-0.25f):pos.x;
			float Y = u.y!=0?
				(u.y<0?b->pos.y+0.25f:b->pos.y-0.25f):pos.y;
			float Z = u.z!=0?
				(u.z<0?b->pos.z+0.25f:b->pos.z-0.25f):pos.z;

			pos = Vec3(X,Y,Z);//&/
			pos -= u * 0.27f;
			break;
		}
	}//*/
	glPushMatrix();
	glTranslatef(pos.x,pos.y,pos.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
	glScalef(0.15,0.15,0);
//	glRotatef(90,1,0,0);
	glRotatef(180,0,1,0);

	gpEng->mObjects[MDL_FUZZLE].Render(false);
	glPopMatrix();
}
void Fuzzle::RenderDepth(const float interp)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;
	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	glMultMatrixf(mat);
//	glRotatef(90,1,0,0);
	glRotatef(180,0,1,0);
	glScalef(0.15,0.15,0.15);
	gpEng->mObjects[MDL_FUZZLE].Render(false);
//*/
	glPopMatrix();

}
Entity* Fuzzle::Clone() const
{
	return new Fuzzle(*this);
}

void Fuzzle::RenderFur(const float interp)
{
	if(mpPlatform && !mpPlatform->bVisible)
		return;

	Vec3 p = UTIL_Misc::Interpolate(mPos, mOPos, interp);
	Vec3 f = UTIL_Misc::Interpolate(mForward, mOForward, interp);
	Vec3 r = UTIL_Misc::Interpolate(mRight, mORight, interp);
	Vec3 u = UTIL_Misc::Interpolate(mUp, mOUp, interp);
	if(mpPlatform)
		p += UTIL_Misc::Interpolate(mpPlatform->mPos, mpPlatform->mOPos, interp)-mpPlatform->mPos;

	glPushMatrix();
	glTranslatef(p.x,p.y,p.z);
	float mat[16];
	mat[0] = f.x;
	mat[1] = f.y;
	mat[2] = f.z;
	mat[3] = 0;
	mat[4] = r.x;
	mat[5] = r.y;
	mat[6] = r.z;
	mat[7] = 0;
	mat[8] = u.x;
	mat[9] = u.y;
	mat[10] = u.z;
	mat[11] = 0;
	mat[12] = 0;
	mat[13] = 0;
	mat[14] = 0;
	mat[15] = 1;
	float alpha = 0.45;
	if(mpPlatform)
		alpha = mpPlatform->iFadeTime>=0?UTIL_Misc::TimeRamp(0,0.45,0,100,mpPlatform->iFadeTime):0;
	glMultMatrixf(mat);
//	glRotatef(90,1,0,0);
	glRotatef(180,0,1,0);
	glScalef(0.15,0.15,0.15);

	glColor4f(mColor.x,mColor.y,mColor.z,alpha);
	glDisable(GL_CULL_FACE);
	int lod = Distance(p,gpEng->mCameraPos)/5.0f;
	if(lod<=1)lod=1;
	int numLayers = 30/lod;
	if(numLayers<=0)
		numLayers = 1;
	//fur test
	gpEng->mShdrMgr.BindProgram(gpEng->mShdrFur);
	gpEng->mShdrMgr.PassSampler2D("fur",0,gpEng->mObjects[MDL_FUZZLE].mMaterials[gpEng->mObjects[MDL_FUZZLE].mFaces.front().mattID].pMat->mPass[0].front());
	gpEng->mShdrMgr.PassSampler2D("dis",1,gpEng->mObjects[MDL_FUZZLE].mMaterials[gpEng->mObjects[MDL_FUZZLE].mFaces.front().mattID].pMat->mPass[0].back());
//	gpEng->mShdrMgr.PassUniform1f("time",gpEng->mTimer.GetTime()*0.1f);
	std::list<Surface>::iterator surf;
		float layeralpha = 1;
		for(int n=0; n<numLayers; n++)
		{
			layeralpha = 1.0f - ((float)n/(float)numLayers);
			glColor4f((mColor.x+0.5f)-layeralpha,(mColor.y+0.5f)-layeralpha,(mColor.z+0.5f)-layeralpha,layeralpha);
			glScalef(1.0095f,1.0095f,1.0095f);
//			glRotatef(1,1,0,1);
			gpEng->mObjects[MDL_FUZZLE].RenderBuffer(false);
		}

	glDisable(GL_TEXTURE_2D);
	glEnable(GL_CULL_FACE);
	glPopMatrix();

}
